// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('klipse.lang.clojure.io');
goog.require('cljs.core');
goog.require('cljs.reader');
goog.require('clojure.string');
goog.require('klipse.utils');
goog.require('klipse.lang.clojure.include');
goog.require('clojure.walk');
goog.require('cljs_http.client');
goog.require('cljs_http.util');
goog.require('cljs.core.async');
klipse.lang.clojure.io.edn = (function klipse$lang$clojure$io$edn(json){
return cljs_http.util.transit_decode.call(null,JSON.stringify(cljs.core.clj__GT_js.call(null,json)),new cljs.core.Keyword(null,"json","json",1279968570),null);
});
klipse.lang.clojure.io.macro_suffixes = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [".clj",".cljc"], null);
klipse.lang.clojure.io.cljs_suffixes = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [".cljs",".cljc"], null);
if(typeof klipse.lang.clojure.io.load_ns !== 'undefined'){
} else {
/**
 * 
 *   Each runtime environment provides a different way to load a library.
 *   Received two arguments - a map and a callback function:
 *   The map will have the following keys:
 * 
 *  :name   - the name of the library (a symbol)
 *  :macros - modifier signaling a macros namespace load
 *  :path   - munged relative library path (a string)
 * 
 *  It is up to the implementor to correctly resolve the corresponding .cljs,
 *  .cljc, or .js resource (the order must be respected).
 *  If :macros is true, resolution should only consider .clj or .cljc resources (the order must be respected).
 *   Upon resolution the callback should be invoked with a map containing the following keys:
 * 
 *  :lang       - the language, :clj or :js
 *  :source     - the source of the library (a string)
 *  :file       - optional, the file path, it will be added to AST's :file keyword (but not in :meta)
 *  :cache      - optional, if a :clj namespace has been precompiled to :js, can give an analysis cache for faster loads.
 *  :source-map - optional, if a :clj namespace has been precompiled to :js, can give a V3 source map JSON
 * 
 *  If the resource could not be resolved, the callback should be invoked with
 *  nil.
 */
klipse.lang.clojure.io.load_ns = (function (){var method_table__4382__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4383__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4384__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4385__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4386__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"klipse.lang.clojure.io","load-ns"),((function (method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__,hierarchy__4386__auto__){
return (function (_,p__29152,src_cb){
var map__29153 = p__29152;
var map__29153__$1 = ((((!((map__29153 == null)))?(((((map__29153.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29153.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29153):map__29153);
var name = cljs.core.get.call(null,map__29153__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var macros = cljs.core.get.call(null,map__29153__$1,new cljs.core.Keyword(null,"macros","macros",811339431));
var path = cljs.core.get.call(null,map__29153__$1,new cljs.core.Keyword(null,"path","path",-188191168));
new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [name,macros,path], null);

if(cljs.core.truth_(macros)){
return new cljs.core.Keyword(null,"macro","macro",-867863404);
} else {
if(cljs.core.truth_(cljs.core.re_matches.call(null,/^goog\..*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('')))){
return new cljs.core.Keyword(null,"goog","goog",-1711135452);
} else {
if(cljs.core.truth_(cljs.core.re_matches.call(null,/.*\.gist-.*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('')))){
return new cljs.core.Keyword(null,"gist","gist",96143031);
} else {
return new cljs.core.Keyword(null,"cljs","cljs",1492417629);

}
}
}
});})(method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__,hierarchy__4386__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4386__auto__,method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__));
})();
}
klipse.lang.clojure.io.skip_ns_macros = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Symbol(null,"cljs.analyzer.macros","cljs.analyzer.macros",298494182,null),null,new cljs.core.Symbol(null,"cljs.env.macros","cljs.env.macros",1542748640,null),null,new cljs.core.Symbol(null,"cljs.pprint","cljs.pprint",-966900911,null),null,new cljs.core.Symbol(null,"cljs.compiler.macros","cljs.compiler.macros",750996207,null),null,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null),null,new cljs.core.Symbol(null,"cljs.js","cljs.js",474485962,null),null], null), null);
klipse.lang.clojure.io.the_ns_map = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Symbol(null,"cljs.test","cljs.test",884805483,null),"https://raw.githubusercontent.com/clojure/clojurescript/master/src/main/cljs/",new cljs.core.Symbol(null,"clojure.template","clojure.template",-1162325089,null),"https://raw.githubusercontent.com/viebel/clojure/master/src/clj/"], null);
klipse.lang.clojure.io.skip_ns_cljs = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Symbol(null,"cljs.source-map","cljs.source-map",2108014936,null),null,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null),null,new cljs.core.Symbol(null,"cljs.tools.reader","cljs.tools.reader",-831293977,null),null,new cljs.core.Symbol(null,"cljs.tools.reader.reader-types","cljs.tools.reader.reader-types",-346100821,null),null,new cljs.core.Symbol(null,"cljs.env","cljs.env",-1810013139,null),null], null), null);
klipse.lang.clojure.io.cache_buster_QMARK_ = (function klipse$lang$clojure$io$cache_buster_QMARK_(){
return cljs.core.boolean$.call(null,cljs.reader.read_string.call(null,(function (){var or__3922__auto__ = new cljs.core.Keyword(null,"cache-buster","cache-buster",-1567170482).cljs$core$IFn$_invoke$arity$1(klipse.utils.url_parameters.call(null));
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return "false";
}
})()));
});
klipse.lang.clojure.io.filename_of = (function klipse$lang$clojure$io$filename_of(s,cache_buster_QMARK_){
if(cljs.core.truth_(cache_buster_QMARK_)){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(s),"?",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.call(null))].join('');
} else {
return s;
}
});
/**
 * Tries to load one namespace from filenames.
 *   Will call the src-cb upon first success.
 *   If can-recover? is false, will call src-cb with nil if it cannot load any namespace.
 *   Returns :success if a nampespace was loaded otherwise, returns nil.
 *   
 */
klipse.lang.clojure.io.try_to_load_ns = (function klipse$lang$clojure$io$try_to_load_ns(var_args){
var args__4502__auto__ = [];
var len__4499__auto___29270 = arguments.length;
var i__4500__auto___29271 = (0);
while(true){
if((i__4500__auto___29271 < len__4499__auto___29270)){
args__4502__auto__.push((arguments[i__4500__auto___29271]));

var G__29272 = (i__4500__auto___29271 + (1));
i__4500__auto___29271 = G__29272;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((4) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((4)),(0),null)):null);
return klipse.lang.clojure.io.try_to_load_ns.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),argseq__4503__auto__);
});

klipse.lang.clojure.io.try_to_load_ns.cljs$core$IFn$_invoke$arity$variadic = (function (filenames,lang,src_key,src_cb,p__29160){
var map__29161 = p__29160;
var map__29161__$1 = ((((!((map__29161 == null)))?(((((map__29161.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29161.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29161):map__29161);
var transform = cljs.core.get.call(null,map__29161__$1,new cljs.core.Keyword(null,"transform","transform",1381301764),cljs.core.identity);
var can_recover_QMARK_ = cljs.core.get.call(null,map__29161__$1,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),false);
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("try-to-load-ns ",filenames,lang,src_key);
} else {
}

var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,map__29161,map__29161__$1,transform,can_recover_QMARK_){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,map__29161,map__29161__$1,transform,can_recover_QMARK_){
return (function (state_29227){
var state_val_29228 = (state_29227[(1)]);
if((state_val_29228 === (7))){
var inst_29176 = (state_29227[(7)]);
var inst_29176__$1 = (state_29227[(2)]);
var inst_29178 = (inst_29176__$1 == null);
var inst_29179 = cljs.core.not.call(null,inst_29178);
var state_29227__$1 = (function (){var statearr_29229 = state_29227;
(statearr_29229[(7)] = inst_29176__$1);

return statearr_29229;
})();
if(inst_29179){
var statearr_29230_29273 = state_29227__$1;
(statearr_29230_29273[(1)] = (8));

} else {
var statearr_29231_29274 = state_29227__$1;
(statearr_29231_29274[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (20))){
var state_29227__$1 = state_29227;
var statearr_29232_29275 = state_29227__$1;
(statearr_29232_29275[(2)] = new cljs.core.Keyword(null,"success","success",1890645906));

(statearr_29232_29275[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (1))){
var inst_29163 = filenames;
var state_29227__$1 = (function (){var statearr_29233 = state_29227;
(statearr_29233[(8)] = inst_29163);

return statearr_29233;
})();
var statearr_29234_29276 = state_29227__$1;
(statearr_29234_29276[(2)] = null);

(statearr_29234_29276[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (24))){
var inst_29221 = src_cb.call(null,null);
var state_29227__$1 = state_29227;
var statearr_29235_29277 = state_29227__$1;
(statearr_29235_29277[(2)] = inst_29221);

(statearr_29235_29277[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (4))){
var inst_29168 = (state_29227[(9)]);
var inst_29163 = (state_29227[(8)]);
var inst_29168__$1 = cljs.core.first.call(null,inst_29163);
var inst_29169 = klipse.lang.clojure.io.cache_buster_QMARK_.call(null);
var inst_29170 = klipse.lang.clojure.io.filename_of.call(null,inst_29168__$1,inst_29169);
var inst_29171 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_29172 = [false];
var inst_29173 = cljs.core.PersistentHashMap.fromArrays(inst_29171,inst_29172);
var inst_29174 = cljs_http.client.get.call(null,inst_29170,inst_29173);
var state_29227__$1 = (function (){var statearr_29236 = state_29227;
(statearr_29236[(9)] = inst_29168__$1);

return statearr_29236;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_29227__$1,(7),inst_29174);
} else {
if((state_val_29228 === (15))){
var inst_29176 = (state_29227[(7)]);
var state_29227__$1 = state_29227;
var statearr_29237_29278 = state_29227__$1;
(statearr_29237_29278[(2)] = inst_29176);

(statearr_29237_29278[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (21))){
var state_29227__$1 = state_29227;
if(cljs.core.truth_(can_recover_QMARK_)){
var statearr_29238_29279 = state_29227__$1;
(statearr_29238_29279[(1)] = (23));

} else {
var statearr_29239_29280 = state_29227__$1;
(statearr_29239_29280[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (13))){
var inst_29189 = (state_29227[(2)]);
var state_29227__$1 = state_29227;
var statearr_29240_29281 = state_29227__$1;
(statearr_29240_29281[(2)] = inst_29189);

(statearr_29240_29281[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (22))){
var inst_29225 = (state_29227[(2)]);
var state_29227__$1 = state_29227;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_29227__$1,inst_29225);
} else {
if((state_val_29228 === (6))){
var inst_29214 = (state_29227[(2)]);
var state_29227__$1 = state_29227;
var statearr_29241_29282 = state_29227__$1;
(statearr_29241_29282[(2)] = inst_29214);

(statearr_29241_29282[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (25))){
var inst_29223 = (state_29227[(2)]);
var state_29227__$1 = (function (){var statearr_29242 = state_29227;
(statearr_29242[(10)] = inst_29223);

return statearr_29242;
})();
var statearr_29243_29283 = state_29227__$1;
(statearr_29243_29283[(2)] = false);

(statearr_29243_29283[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (17))){
var inst_29199 = (state_29227[(11)]);
var inst_29168 = (state_29227[(9)]);
var inst_29202 = [new cljs.core.Keyword(null,"lang","lang",-1819677104),src_key,new cljs.core.Keyword(null,"file","file",-1269645878)];
var inst_29203 = transform.call(null,inst_29199);
var inst_29204 = [lang,inst_29203,inst_29168];
var inst_29205 = cljs.core.PersistentHashMap.fromArrays(inst_29202,inst_29204);
var inst_29206 = src_cb.call(null,inst_29205);
var state_29227__$1 = (function (){var statearr_29244 = state_29227;
(statearr_29244[(12)] = inst_29206);

return statearr_29244;
})();
var statearr_29245_29284 = state_29227__$1;
(statearr_29245_29284[(2)] = new cljs.core.Keyword(null,"success","success",1890645906));

(statearr_29245_29284[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (3))){
var inst_29216 = (state_29227[(2)]);
var state_29227__$1 = state_29227;
if(cljs.core.truth_(inst_29216)){
var statearr_29246_29285 = state_29227__$1;
(statearr_29246_29285[(1)] = (20));

} else {
var statearr_29247_29286 = state_29227__$1;
(statearr_29247_29286[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (12))){
var state_29227__$1 = state_29227;
var statearr_29248_29287 = state_29227__$1;
(statearr_29248_29287[(2)] = false);

(statearr_29248_29287[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (2))){
var inst_29163 = (state_29227[(8)]);
var inst_29165 = cljs.core.seq.call(null,inst_29163);
var state_29227__$1 = state_29227;
if(inst_29165){
var statearr_29249_29288 = state_29227__$1;
(statearr_29249_29288[(1)] = (4));

} else {
var statearr_29250_29289 = state_29227__$1;
(statearr_29250_29289[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (23))){
var state_29227__$1 = state_29227;
var statearr_29251_29290 = state_29227__$1;
(statearr_29251_29290[(2)] = null);

(statearr_29251_29290[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (19))){
var inst_29211 = (state_29227[(2)]);
var state_29227__$1 = state_29227;
var statearr_29252_29291 = state_29227__$1;
(statearr_29252_29291[(2)] = inst_29211);

(statearr_29252_29291[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (11))){
var state_29227__$1 = state_29227;
var statearr_29253_29292 = state_29227__$1;
(statearr_29253_29292[(2)] = true);

(statearr_29253_29292[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (9))){
var state_29227__$1 = state_29227;
var statearr_29254_29293 = state_29227__$1;
(statearr_29254_29293[(2)] = false);

(statearr_29254_29293[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (5))){
var state_29227__$1 = state_29227;
var statearr_29255_29294 = state_29227__$1;
(statearr_29255_29294[(2)] = null);

(statearr_29255_29294[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (14))){
var inst_29176 = (state_29227[(7)]);
var inst_29194 = cljs.core.apply.call(null,cljs.core.hash_map,inst_29176);
var state_29227__$1 = state_29227;
var statearr_29256_29295 = state_29227__$1;
(statearr_29256_29295[(2)] = inst_29194);

(statearr_29256_29295[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (16))){
var inst_29197 = (state_29227[(2)]);
var inst_29198 = cljs.core.get.call(null,inst_29197,new cljs.core.Keyword(null,"status","status",-1997798413));
var inst_29199 = cljs.core.get.call(null,inst_29197,new cljs.core.Keyword(null,"body","body",-2049205669));
var inst_29200 = cljs.core._EQ_.call(null,(200),inst_29198);
var state_29227__$1 = (function (){var statearr_29257 = state_29227;
(statearr_29257[(11)] = inst_29199);

return statearr_29257;
})();
if(inst_29200){
var statearr_29258_29296 = state_29227__$1;
(statearr_29258_29296[(1)] = (17));

} else {
var statearr_29259_29297 = state_29227__$1;
(statearr_29259_29297[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (10))){
var inst_29192 = (state_29227[(2)]);
var state_29227__$1 = state_29227;
if(cljs.core.truth_(inst_29192)){
var statearr_29260_29298 = state_29227__$1;
(statearr_29260_29298[(1)] = (14));

} else {
var statearr_29261_29299 = state_29227__$1;
(statearr_29261_29299[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (18))){
var inst_29163 = (state_29227[(8)]);
var inst_29208 = cljs.core.rest.call(null,inst_29163);
var inst_29163__$1 = inst_29208;
var state_29227__$1 = (function (){var statearr_29262 = state_29227;
(statearr_29262[(8)] = inst_29163__$1);

return statearr_29262;
})();
var statearr_29263_29300 = state_29227__$1;
(statearr_29263_29300[(2)] = null);

(statearr_29263_29300[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29228 === (8))){
var inst_29176 = (state_29227[(7)]);
var inst_29181 = inst_29176.cljs$lang$protocol_mask$partition0$;
var inst_29182 = (inst_29181 & (64));
var inst_29183 = inst_29176.cljs$core$ISeq$;
var inst_29184 = (cljs.core.PROTOCOL_SENTINEL === inst_29183);
var inst_29185 = ((inst_29182) || (inst_29184));
var state_29227__$1 = state_29227;
if(cljs.core.truth_(inst_29185)){
var statearr_29264_29301 = state_29227__$1;
(statearr_29264_29301[(1)] = (11));

} else {
var statearr_29265_29302 = state_29227__$1;
(statearr_29265_29302[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__,map__29161,map__29161__$1,transform,can_recover_QMARK_))
;
return ((function (switch__3428__auto__,c__3451__auto__,map__29161,map__29161__$1,transform,can_recover_QMARK_){
return (function() {
var klipse$lang$clojure$io$state_machine__3429__auto__ = null;
var klipse$lang$clojure$io$state_machine__3429__auto____0 = (function (){
var statearr_29266 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_29266[(0)] = klipse$lang$clojure$io$state_machine__3429__auto__);

(statearr_29266[(1)] = (1));

return statearr_29266;
});
var klipse$lang$clojure$io$state_machine__3429__auto____1 = (function (state_29227){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_29227);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e29267){if((e29267 instanceof Object)){
var ex__3432__auto__ = e29267;
var statearr_29268_29303 = state_29227;
(statearr_29268_29303[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_29227);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e29267;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29304 = state_29227;
state_29227 = G__29304;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$lang$clojure$io$state_machine__3429__auto__ = function(state_29227){
switch(arguments.length){
case 0:
return klipse$lang$clojure$io$state_machine__3429__auto____0.call(this);
case 1:
return klipse$lang$clojure$io$state_machine__3429__auto____1.call(this,state_29227);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$lang$clojure$io$state_machine__3429__auto____0;
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$lang$clojure$io$state_machine__3429__auto____1;
return klipse$lang$clojure$io$state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,map__29161,map__29161__$1,transform,can_recover_QMARK_))
})();
var state__3453__auto__ = (function (){var statearr_29269 = f__3452__auto__.call(null);
(statearr_29269[(6)] = c__3451__auto__);

return statearr_29269;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,map__29161,map__29161__$1,transform,can_recover_QMARK_))
);

return c__3451__auto__;
});

klipse.lang.clojure.io.try_to_load_ns.cljs$lang$maxFixedArity = (4);

/** @this {Function} */
klipse.lang.clojure.io.try_to_load_ns.cljs$lang$applyTo = (function (seq29155){
var G__29156 = cljs.core.first.call(null,seq29155);
var seq29155__$1 = cljs.core.next.call(null,seq29155);
var G__29157 = cljs.core.first.call(null,seq29155__$1);
var seq29155__$2 = cljs.core.next.call(null,seq29155__$1);
var G__29158 = cljs.core.first.call(null,seq29155__$2);
var seq29155__$3 = cljs.core.next.call(null,seq29155__$2);
var G__29159 = cljs.core.first.call(null,seq29155__$3);
var seq29155__$4 = cljs.core.next.call(null,seq29155__$3);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__29156,G__29157,G__29158,G__29159,seq29155__$4);
});

/**
 * returns a list of files provided list of external-libs and suffixes
 */
klipse.lang.clojure.io.external_libs_files = (function klipse$lang$clojure$io$external_libs_files(external_libs,suffixes,path){
var iter__4292__auto__ = (function klipse$lang$clojure$io$external_libs_files_$_iter__29305(s__29306){
return (new cljs.core.LazySeq(null,(function (){
var s__29306__$1 = s__29306;
while(true){
var temp__6753__auto__ = cljs.core.seq.call(null,s__29306__$1);
if(temp__6753__auto__){
var xs__7309__auto__ = temp__6753__auto__;
var lib = cljs.core.first.call(null,xs__7309__auto__);
var iterys__4288__auto__ = ((function (s__29306__$1,lib,xs__7309__auto__,temp__6753__auto__){
return (function klipse$lang$clojure$io$external_libs_files_$_iter__29305_$_iter__29307(s__29308){
return (new cljs.core.LazySeq(null,((function (s__29306__$1,lib,xs__7309__auto__,temp__6753__auto__){
return (function (){
var s__29308__$1 = s__29308;
while(true){
var temp__6753__auto____$1 = cljs.core.seq.call(null,s__29308__$1);
if(temp__6753__auto____$1){
var s__29308__$2 = temp__6753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__29308__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__29308__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__29310 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__29309 = (0);
while(true){
if((i__29309 < size__4291__auto__)){
var suffix = cljs.core._nth.call(null,c__4290__auto__,i__29309);
cljs.core.chunk_append.call(null,b__29310,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(suffix)].join(''));

var G__29311 = (i__29309 + (1));
i__29309 = G__29311;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__29310),klipse$lang$clojure$io$external_libs_files_$_iter__29305_$_iter__29307.call(null,cljs.core.chunk_rest.call(null,s__29308__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__29310),null);
}
} else {
var suffix = cljs.core.first.call(null,s__29308__$2);
return cljs.core.cons.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(suffix)].join(''),klipse$lang$clojure$io$external_libs_files_$_iter__29305_$_iter__29307.call(null,cljs.core.rest.call(null,s__29308__$2)));
}
} else {
return null;
}
break;
}
});})(s__29306__$1,lib,xs__7309__auto__,temp__6753__auto__))
,null,null));
});})(s__29306__$1,lib,xs__7309__auto__,temp__6753__auto__))
;
var fs__4289__auto__ = cljs.core.seq.call(null,iterys__4288__auto__.call(null,suffixes));
if(fs__4289__auto__){
return cljs.core.concat.call(null,fs__4289__auto__,klipse$lang$clojure$io$external_libs_files_$_iter__29305.call(null,cljs.core.rest.call(null,s__29306__$1)));
} else {
var G__29312 = cljs.core.rest.call(null,s__29306__$1);
s__29306__$1 = G__29312;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,external_libs);
});
klipse.lang.clojure.io.name__GT_cached_resource = (function klipse$lang$clojure$io$name__GT_cached_resource(name){
return clojure.string.replace.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.munge.call(null,name))].join(''),/\./,"_SLASH_");
});
klipse.lang.clojure.io.cached_ns_root = (function klipse$lang$clojure$io$cached_ns_root(){
return new cljs.core.Keyword(null,"cached_ns_root","cached_ns_root",-1077014575).cljs$core$IFn$_invoke$arity$2(klipse.utils.klipse_settings.call(null),"https://viebel.github.io/klipse/cache-cljs/");
});
klipse.lang.clojure.io.load_ns_from_cache = (function klipse$lang$clojure$io$load_ns_from_cache(name,src_cb,macro_QMARK_){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns-from-cache:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''),"macro: ",macro_QMARK_);
} else {
}

var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__){
return (function (state_29359){
var state_val_29360 = (state_29359[(1)]);
if((state_val_29360 === (1))){
var inst_29314 = klipse.lang.clojure.io.name__GT_cached_resource.call(null,name);
var state_29359__$1 = (function (){var statearr_29361 = state_29359;
(statearr_29361[(7)] = inst_29314);

return statearr_29361;
})();
if(cljs.core.truth_(macro_QMARK_)){
var statearr_29362_29377 = state_29359__$1;
(statearr_29362_29377[(1)] = (2));

} else {
var statearr_29363_29378 = state_29359__$1;
(statearr_29363_29378[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29360 === (2))){
var state_29359__$1 = state_29359;
var statearr_29364_29379 = state_29359__$1;
(statearr_29364_29379[(2)] = "$macros");

(statearr_29364_29379[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29360 === (3))){
var state_29359__$1 = state_29359;
var statearr_29365_29380 = state_29359__$1;
(statearr_29365_29380[(2)] = "");

(statearr_29365_29380[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29360 === (4))){
var inst_29314 = (state_29359[(7)]);
var inst_29320 = (state_29359[(8)]);
var inst_29318 = (state_29359[(9)]);
var inst_29321 = (state_29359[(10)]);
var inst_29318__$1 = (state_29359[(2)]);
var inst_29319 = klipse.lang.clojure.io.cached_ns_root.call(null);
var inst_29320__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29319),"/"].join('');
var inst_29321__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29320__$1),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29314),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29318__$1),".js"].join('');
var inst_29322 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29320__$1),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29314),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29318__$1),".cache.json"].join('');
var inst_29323 = klipse.lang.clojure.io.cache_buster_QMARK_.call(null);
var inst_29324 = klipse.lang.clojure.io.filename_of.call(null,inst_29321__$1,inst_29323);
var inst_29325 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_29326 = [false];
var inst_29327 = cljs.core.PersistentHashMap.fromArrays(inst_29325,inst_29326);
var inst_29328 = cljs_http.client.get.call(null,inst_29324,inst_29327);
var state_29359__$1 = (function (){var statearr_29366 = state_29359;
(statearr_29366[(8)] = inst_29320__$1);

(statearr_29366[(9)] = inst_29318__$1);

(statearr_29366[(10)] = inst_29321__$1);

(statearr_29366[(11)] = inst_29322);

return statearr_29366;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_29359__$1,(5),inst_29328);
} else {
if((state_val_29360 === (5))){
var inst_29322 = (state_29359[(11)]);
var inst_29330 = (state_29359[(2)]);
var inst_29331 = klipse.lang.clojure.io.cache_buster_QMARK_.call(null);
var inst_29332 = klipse.lang.clojure.io.filename_of.call(null,inst_29322,inst_29331);
var inst_29333 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_29334 = [false];
var inst_29335 = cljs.core.PersistentHashMap.fromArrays(inst_29333,inst_29334);
var inst_29336 = cljs_http.client.get.call(null,inst_29332,inst_29335);
var state_29359__$1 = (function (){var statearr_29367 = state_29359;
(statearr_29367[(12)] = inst_29330);

return statearr_29367;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_29359__$1,(6),inst_29336);
} else {
if((state_val_29360 === (6))){
var inst_29314 = (state_29359[(7)]);
var inst_29320 = (state_29359[(8)]);
var inst_29318 = (state_29359[(9)]);
var inst_29330 = (state_29359[(12)]);
var inst_29321 = (state_29359[(10)]);
var inst_29338 = (state_29359[(13)]);
var inst_29322 = (state_29359[(11)]);
var inst_29338__$1 = (state_29359[(2)]);
var inst_29339 = (function (){var nn = inst_29314;
var suffix = inst_29318;
var root = inst_29320;
var src_filename = inst_29321;
var cache_filename = inst_29322;
var src = inst_29330;
var cache = inst_29338__$1;
return ((function (nn,suffix,root,src_filename,cache_filename,src,cache,inst_29314,inst_29320,inst_29318,inst_29330,inst_29321,inst_29338,inst_29322,inst_29338__$1,state_val_29360,c__3451__auto__){
return (function (p1__29313_SHARP_){
return cljs.core._EQ_.call(null,(200),p1__29313_SHARP_);
});
;})(nn,suffix,root,src_filename,cache_filename,src,cache,inst_29314,inst_29320,inst_29318,inst_29330,inst_29321,inst_29338,inst_29322,inst_29338__$1,state_val_29360,c__3451__auto__))
})();
var inst_29340 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29341 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_29338__$1);
var inst_29342 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_29330);
var inst_29343 = [inst_29341,inst_29342];
var inst_29344 = (new cljs.core.PersistentVector(null,2,(5),inst_29340,inst_29343,null));
var inst_29345 = cljs.core.every_QMARK_.call(null,inst_29339,inst_29344);
var state_29359__$1 = (function (){var statearr_29368 = state_29359;
(statearr_29368[(13)] = inst_29338__$1);

return statearr_29368;
})();
if(inst_29345){
var statearr_29369_29381 = state_29359__$1;
(statearr_29369_29381[(1)] = (7));

} else {
var statearr_29370_29382 = state_29359__$1;
(statearr_29370_29382[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29360 === (7))){
var inst_29330 = (state_29359[(12)]);
var inst_29338 = (state_29359[(13)]);
var inst_29347 = [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"cache","cache",-1237023054),new cljs.core.Keyword(null,"source","source",-433931539)];
var inst_29348 = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(inst_29338);
var inst_29349 = klipse.lang.clojure.io.edn.call(null,inst_29348);
var inst_29350 = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(inst_29330);
var inst_29351 = [new cljs.core.Keyword(null,"js","js",1768080579),inst_29349,inst_29350];
var inst_29352 = cljs.core.PersistentHashMap.fromArrays(inst_29347,inst_29351);
var inst_29353 = src_cb.call(null,inst_29352);
var state_29359__$1 = state_29359;
var statearr_29371_29383 = state_29359__$1;
(statearr_29371_29383[(2)] = inst_29353);

(statearr_29371_29383[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29360 === (8))){
var inst_29355 = src_cb.call(null,null);
var state_29359__$1 = state_29359;
var statearr_29372_29384 = state_29359__$1;
(statearr_29372_29384[(2)] = inst_29355);

(statearr_29372_29384[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29360 === (9))){
var inst_29357 = (state_29359[(2)]);
var state_29359__$1 = state_29359;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_29359__$1,inst_29357);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__){
return (function() {
var klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto__ = null;
var klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto____0 = (function (){
var statearr_29373 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_29373[(0)] = klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto__);

(statearr_29373[(1)] = (1));

return statearr_29373;
});
var klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto____1 = (function (state_29359){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_29359);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e29374){if((e29374 instanceof Object)){
var ex__3432__auto__ = e29374;
var statearr_29375_29385 = state_29359;
(statearr_29375_29385[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_29359);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e29374;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29386 = state_29359;
state_29359 = G__29386;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto__ = function(state_29359){
switch(arguments.length){
case 0:
return klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto____1.call(this,state_29359);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto____0;
klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto____1;
return klipse$lang$clojure$io$load_ns_from_cache_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__))
})();
var state__3453__auto__ = (function (){var statearr_29376 = f__3452__auto__.call(null);
(statearr_29376[(6)] = c__3451__auto__);

return statearr_29376;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__))
);

return c__3451__auto__;
});
klipse.lang.clojure.io.cached_macro_ns_regexp = (function klipse$lang$clojure$io$cached_macro_ns_regexp(){
return new cljs.core.Keyword(null,"clojure_cached_macro_ns_regexp","clojure_cached_macro_ns_regexp",-771780299).cljs$core$IFn$_invoke$arity$2(klipse.utils.klipse_settings.call(null),/cljs\.reader|cljs\.core\.[async|match].*|clojure\.math\.macros|gadjett\.core|cljs\.test|clojure.test.check.*|reagent\..*|om\..*|cljs\.spec.*|cljs-time\..*|re-frame\..*|net\.cgrand\.macrovich|reagent-forms\..*|ajax\.macros|poppea/);
});
klipse.lang.clojure.io.cached_macro_ns_QMARK_ = (function klipse$lang$clojure$io$cached_macro_ns_QMARK_(name){
return cljs.core.re_matches.call(null,klipse.lang.clojure.io.cached_macro_ns_regexp.call(null),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
klipse.lang.clojure.io.cached_ns_regexp = (function klipse$lang$clojure$io$cached_ns_regexp(){
return new cljs.core.Keyword(null,"clojure_cached_ns_regexp","clojure_cached_ns_regexp",-1735711110).cljs$core$IFn$_invoke$arity$2(klipse.utils.klipse_settings.call(null),/cljs\.stacktrace|cljs\.core\.[async|match].*|cljs\.spec.*|clojure.math\.combinatorics|clojure.test.check.*|reagent\..*|om\..*|clojure\.data|cljs-time\..*|re-frame\..*|day8\.re-frame\..*|reagent-forms\..*|re-frisk\..*|re-frisk-shell\..*|datafrisk\..*|ajax\..*|cljs\.tools\.reader\..*/);
});
klipse.lang.clojure.io.cached_cljs_ns_QMARK_ = (function klipse$lang$clojure$io$cached_cljs_ns_QMARK_(name){
return cljs.core.re_matches.call(null,klipse.lang.clojure.io.cached_ns_regexp.call(null),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
cljs.core._add_method.call(null,klipse.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"macro","macro",-867863404),(function (external_libs,p__29387,src_cb_original){
var map__29388 = p__29387;
var map__29388__$1 = ((((!((map__29388 == null)))?(((((map__29388.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29388.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29388):map__29388);
var name = cljs.core.get.call(null,map__29388__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var path = cljs.core.get.call(null,map__29388__$1,new cljs.core.Keyword(null,"path","path",-188191168));
var src_cb = ((cljs.core.not_EQ_.call(null,name,new cljs.core.Symbol(null,"cljs.spec.test","cljs.spec.test",723719092,null)))?src_cb_original:((function (map__29388,map__29388__$1,name,path){
return (function() { 
var G__29390__delegate = function (args){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("src-cb: patch cljs.spec.test/eval");
} else {
}

cljs.core.apply.call(null,src_cb_original,args);

return klipse.lang.clojure.include.def_a_var.call(null,new cljs.core.Symbol(null,"cljs.spec.test$macros","cljs.spec.test$macros",-804885435,null),new cljs.core.Symbol(null,"eval","eval",536963622,null),new cljs.core.Symbol(null,"identity","identity",-1007039734,null));
};
var G__29390 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__29391__i = 0, G__29391__a = new Array(arguments.length -  0);
while (G__29391__i < G__29391__a.length) {G__29391__a[G__29391__i] = arguments[G__29391__i + 0]; ++G__29391__i;}
  args = new cljs.core.IndexedSeq(G__29391__a,0,null);
} 
return G__29390__delegate.call(this,args);};
G__29390.cljs$lang$maxFixedArity = 0;
G__29390.cljs$lang$applyTo = (function (arglist__29392){
var args = cljs.core.seq(arglist__29392);
return G__29390__delegate(args);
});
G__29390.cljs$core$IFn$_invoke$arity$variadic = G__29390__delegate;
return G__29390;
})()
;})(map__29388,map__29388__$1,name,path))
);
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :macro :",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

if(cljs.core.truth_(klipse.lang.clojure.io.skip_ns_macros.call(null,name))){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :macro skipping:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
if(cljs.core.truth_(klipse.lang.clojure.io.cached_macro_ns_QMARK_.call(null,name))){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :macro cached:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return klipse.lang.clojure.io.load_ns_from_cache.call(null,name,src_cb,true);
} else {
if(cljs.core.truth_(klipse.lang.clojure.io.the_ns_map.call(null,name))){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :macro known:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

var prefix = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(klipse.lang.clojure.io.the_ns_map.call(null,name)),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path)].join('');
var filenames = cljs.core.map.call(null,cljs.core.partial.call(null,cljs.core.str,prefix),klipse.lang.clojure.io.macro_suffixes);
return klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
} else {
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :macro external-libs:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

var filenames = klipse.lang.clojure.io.external_libs_files.call(null,external_libs,klipse.lang.clojure.io.macro_suffixes,path);
return klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);

}
}
}
}));
klipse.lang.clojure.io.cache_url = "https://storage.googleapis.com/app.klipse.tech/fig/js/";
cljs.core._add_method.call(null,klipse.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"gist","gist",96143031),(function (external_libs,p__29394,src_cb){
var map__29395 = p__29394;
var map__29395__$1 = ((((!((map__29395 == null)))?(((((map__29395.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29395.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29395):map__29395);
var path = cljs.core.get.call(null,map__29395__$1,new cljs.core.Keyword(null,"path","path",-188191168));
var path__$1 = clojure.string.replace.call(null,path,/gist_/,"");
var filenames = cljs.core.map.call(null,((function (path__$1,map__29395,map__29395__$1,path){
return (function (p1__29393_SHARP_){
return ["https://gist.githubusercontent.com/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path__$1),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__29393_SHARP_)].join('');
});})(path__$1,map__29395,map__29395__$1,path))
,klipse.lang.clojure.io.cljs_suffixes);
return klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
}));
klipse.lang.clojure.io.bundled_ns_ignore_regexp = (function klipse$lang$clojure$io$bundled_ns_ignore_regexp(){
return new cljs.core.Keyword(null,"clojure_bundled_ns_ignore_regexp","clojure_bundled_ns_ignore_regexp",-1479622333).cljs$core$IFn$_invoke$arity$1(klipse.utils.klipse_settings.call(null));
});
klipse.lang.clojure.io.custom_bundled_ns_ignore_QMARK_ = (function klipse$lang$clojure$io$custom_bundled_ns_ignore_QMARK_(name){
var temp__6753__auto__ = klipse.lang.clojure.io.bundled_ns_ignore_regexp.call(null);
if(cljs.core.truth_(temp__6753__auto__)){
var regexp = temp__6753__auto__;
return cljs.core.re_matches.call(null,regexp,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
return null;
}
});
klipse.lang.clojure.io.buggy_bundled_ns_ignore_QMARK_ = (function klipse$lang$clojure$io$buggy_bundled_ns_ignore_QMARK_(name){
return cljs.core.re_matches.call(null,/.*reagent.*|cljs.core.async.*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
/**
 * Checks whether a namespace is present at run-time
 */
klipse.lang.clojure.io.bundled_ns_QMARK_ = (function klipse$lang$clojure$io$bundled_ns_QMARK_(name){
if(cljs.core.truth_((function (){var or__3922__auto__ = klipse.lang.clojure.io.buggy_bundled_ns_ignore_QMARK_.call(null,name);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return klipse.lang.clojure.io.custom_bundled_ns_ignore_QMARK_.call(null,name);
}
})())){
return false;
} else {
var obj_SHARP_ = goog;
var fn_SHARP_ = (obj_SHARP_["getObjectByName"]);
return fn_SHARP_.call(obj_SHARP_,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.munge.call(null,name))].join(''));
}
});
klipse.lang.clojure.io.cljsjs_QMARK_ = (function klipse$lang$clojure$io$cljsjs_QMARK_(name){
return cljs.core.re_matches.call(null,/cljsjs\..*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
klipse.lang.clojure.io.cljsjs_libname = (function klipse$lang$clojure$io$cljsjs_libname(name){
var $ = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('');
var $__$1 = cljs.core.re_matches.call(null,/cljsjs\.(.*)/,$);
var $__$2 = cljs.core.second.call(null,$__$1);
return clojure.string.replace.call(null,$__$2,/\./,"-");
});
/**
 * some cljsjs packages are already loaded e.g react in klipse app
 */
klipse.lang.clojure.io.bundled_cljsjs_ns_QMARK_ = (function klipse$lang$clojure$io$bundled_cljsjs_ns_QMARK_(name){
var or__3922__auto__ = (function (){var and__3911__auto__ = cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljsjs.react","cljsjs.react",822859692,null));
if(and__3911__auto__){
return (window["React"]);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
var or__3922__auto____$1 = (function (){var and__3911__auto__ = cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljsjs.react.dom.server","cljsjs.react.dom.server",-1041656528,null));
if(and__3911__auto__){
return (window["ReactDOMServer"]);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(or__3922__auto____$1)){
return or__3922__auto____$1;
} else {
var and__3911__auto__ = cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljsjs.react.dom","cljsjs.react.dom",-1678399696,null));
if(and__3911__auto__){
return (window["ReactDOM"]);
} else {
return and__3911__auto__;
}
}
}
});
/**
 * Try to load the js file corresponding to a cljsjs package.
 *   For that, we have to convert the package name into a full path - hosted on this git repo: https://github.com/viebel/cljsjs-hosted
 *   
 */
klipse.lang.clojure.io.try_to_load_cljsjs_ns = (function klipse$lang$clojure$io$try_to_load_cljsjs_ns(name,src_cb){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.log("load-ns :cljs try-to-load-cljsjs-ns",name);
} else {
}

if(cljs.core.truth_(klipse.lang.clojure.io.bundled_cljsjs_ns_QMARK_.call(null,name))){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns bundled-cljsjs-ns",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
var root_path = (cljs.core.truth_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Symbol(null,"cljsjs.react","cljsjs.react",822859692,null),null,new cljs.core.Symbol(null,"cljsjs.react.dom.server","cljsjs.react.dom.server",-1041656528,null),null,new cljs.core.Symbol(null,"cljsjs.react.dom","cljsjs.react.dom",-1678399696,null),null], null), null).call(null,name))?"https://viebel.github.io/cljsjs-hosted/cljsjs-klipse-only/":"https://viebel.github.io/cljsjs-hosted/cljsjs/");
var lib_name = klipse.lang.clojure.io.cljsjs_libname.call(null,name);
var full_names = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),"/production/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".min.inc.js"].join(''),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),"/production/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".min.inc.js"].join(''),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),"/development/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".inc.js"].join(''),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),"/development/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".inc.js"].join('')], null);
return klipse.lang.clojure.io.try_to_load_ns.call(null,full_names,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
}
});
cljs.core._add_method.call(null,klipse.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"cljs","cljs",1492417629),(function (external_libs,p__29398,src_cb){
var map__29399 = p__29398;
var map__29399__$1 = ((((!((map__29399 == null)))?(((((map__29399.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29399.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29399):map__29399);
var name = cljs.core.get.call(null,map__29399__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var path = cljs.core.get.call(null,map__29399__$1,new cljs.core.Keyword(null,"path","path",-188191168));
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :cljs :",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''),"external-libs: ",external_libs);
} else {
}

if(cljs.core.truth_(klipse.lang.clojure.io.skip_ns_cljs.call(null,name))){
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :cljs skipping",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
if(cljs.core.truth_(klipse.lang.clojure.io.bundled_ns_QMARK_.call(null,name))){
var _ = (cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))?console.log("load-ns :cljs bundled",name):null);
var filenames = cljs.core.map.call(null,((function (_,map__29399,map__29399__$1,name,path){
return (function (p1__29397_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(klipse.lang.clojure.io.cache_url),cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__29397_SHARP_),".cache.json"].join('');
});})(_,map__29399,map__29399__$1,name,path))
,klipse.lang.clojure.io.cljs_suffixes);
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,_,filenames,map__29399,map__29399__$1,name,path){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,_,filenames,map__29399,map__29399__$1,name,path){
return (function (state_29413){
var state_val_29414 = (state_29413[(1)]);
if((state_val_29414 === (1))){
var inst_29401 = klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"cache","cache",-1237023054),src_cb,new cljs.core.Keyword(null,"transform","transform",1381301764),klipse.lang.clojure.io.edn,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),true);
var state_29413__$1 = state_29413;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_29413__$1,(2),inst_29401);
} else {
if((state_val_29414 === (2))){
var inst_29403 = (state_29413[(2)]);
var state_29413__$1 = state_29413;
if(cljs.core.truth_(inst_29403)){
var statearr_29415_29466 = state_29413__$1;
(statearr_29415_29466[(1)] = (3));

} else {
var statearr_29416_29467 = state_29413__$1;
(statearr_29416_29467[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29414 === (3))){
var state_29413__$1 = state_29413;
var statearr_29417_29468 = state_29413__$1;
(statearr_29417_29468[(2)] = null);

(statearr_29417_29468[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29414 === (4))){
var inst_29406 = [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"source","source",-433931539)];
var inst_29407 = [new cljs.core.Keyword(null,"js","js",1768080579),""];
var inst_29408 = cljs.core.PersistentHashMap.fromArrays(inst_29406,inst_29407);
var inst_29409 = src_cb.call(null,inst_29408);
var state_29413__$1 = state_29413;
var statearr_29418_29469 = state_29413__$1;
(statearr_29418_29469[(2)] = inst_29409);

(statearr_29418_29469[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29414 === (5))){
var inst_29411 = (state_29413[(2)]);
var state_29413__$1 = state_29413;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_29413__$1,inst_29411);
} else {
return null;
}
}
}
}
}
});})(c__3451__auto__,_,filenames,map__29399,map__29399__$1,name,path))
;
return ((function (switch__3428__auto__,c__3451__auto__,_,filenames,map__29399,map__29399__$1,name,path){
return (function() {
var klipse$lang$clojure$io$state_machine__3429__auto__ = null;
var klipse$lang$clojure$io$state_machine__3429__auto____0 = (function (){
var statearr_29419 = [null,null,null,null,null,null,null];
(statearr_29419[(0)] = klipse$lang$clojure$io$state_machine__3429__auto__);

(statearr_29419[(1)] = (1));

return statearr_29419;
});
var klipse$lang$clojure$io$state_machine__3429__auto____1 = (function (state_29413){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_29413);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e29420){if((e29420 instanceof Object)){
var ex__3432__auto__ = e29420;
var statearr_29421_29470 = state_29413;
(statearr_29421_29470[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_29413);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e29420;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29471 = state_29413;
state_29413 = G__29471;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$lang$clojure$io$state_machine__3429__auto__ = function(state_29413){
switch(arguments.length){
case 0:
return klipse$lang$clojure$io$state_machine__3429__auto____0.call(this);
case 1:
return klipse$lang$clojure$io$state_machine__3429__auto____1.call(this,state_29413);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$lang$clojure$io$state_machine__3429__auto____0;
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$lang$clojure$io$state_machine__3429__auto____1;
return klipse$lang$clojure$io$state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,_,filenames,map__29399,map__29399__$1,name,path))
})();
var state__3453__auto__ = (function (){var statearr_29422 = f__3452__auto__.call(null);
(statearr_29422[(6)] = c__3451__auto__);

return statearr_29422;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,_,filenames,map__29399,map__29399__$1,name,path))
);

return c__3451__auto__;
} else {
if(cljs.core.truth_(klipse.lang.clojure.io.cached_cljs_ns_QMARK_.call(null,name))){
return klipse.lang.clojure.io.load_ns_from_cache.call(null,name,src_cb,false);
} else {
if(cljs.core.truth_(klipse.lang.clojure.io.cljsjs_QMARK_.call(null,name))){
return klipse.lang.clojure.io.try_to_load_cljsjs_ns.call(null,name,src_cb);
} else {
if(cljs.core.truth_(klipse.lang.clojure.io.the_ns_map.call(null,name))){
var prefix = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(klipse.lang.clojure.io.the_ns_map.call(null,name)),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path)].join('');
var filenames = cljs.core.map.call(null,cljs.core.partial.call(null,cljs.core.str,prefix),klipse.lang.clojure.io.cljs_suffixes);
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :cljs from external libs",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,prefix,filenames,map__29399,map__29399__$1,name,path){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,prefix,filenames,map__29399,map__29399__$1,name,path){
return (function (state_29433){
var state_val_29434 = (state_29433[(1)]);
if((state_val_29434 === (1))){
var inst_29423 = klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),true);
var state_29433__$1 = state_29433;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_29433__$1,(2),inst_29423);
} else {
if((state_val_29434 === (2))){
var inst_29425 = (state_29433[(2)]);
var state_29433__$1 = state_29433;
if(cljs.core.truth_(inst_29425)){
var statearr_29435_29472 = state_29433__$1;
(statearr_29435_29472[(1)] = (3));

} else {
var statearr_29436_29473 = state_29433__$1;
(statearr_29436_29473[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29434 === (3))){
var state_29433__$1 = state_29433;
var statearr_29437_29474 = state_29433__$1;
(statearr_29437_29474[(2)] = null);

(statearr_29437_29474[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29434 === (4))){
var inst_29428 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prefix),".js"].join('');
var inst_29429 = klipse.lang.clojure.io.try_to_load_ns.call(null,inst_29428,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
var state_29433__$1 = state_29433;
var statearr_29438_29475 = state_29433__$1;
(statearr_29438_29475[(2)] = inst_29429);

(statearr_29438_29475[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29434 === (5))){
var inst_29431 = (state_29433[(2)]);
var state_29433__$1 = state_29433;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_29433__$1,inst_29431);
} else {
return null;
}
}
}
}
}
});})(c__3451__auto__,prefix,filenames,map__29399,map__29399__$1,name,path))
;
return ((function (switch__3428__auto__,c__3451__auto__,prefix,filenames,map__29399,map__29399__$1,name,path){
return (function() {
var klipse$lang$clojure$io$state_machine__3429__auto__ = null;
var klipse$lang$clojure$io$state_machine__3429__auto____0 = (function (){
var statearr_29439 = [null,null,null,null,null,null,null];
(statearr_29439[(0)] = klipse$lang$clojure$io$state_machine__3429__auto__);

(statearr_29439[(1)] = (1));

return statearr_29439;
});
var klipse$lang$clojure$io$state_machine__3429__auto____1 = (function (state_29433){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_29433);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e29440){if((e29440 instanceof Object)){
var ex__3432__auto__ = e29440;
var statearr_29441_29476 = state_29433;
(statearr_29441_29476[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_29433);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e29440;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29477 = state_29433;
state_29433 = G__29477;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$lang$clojure$io$state_machine__3429__auto__ = function(state_29433){
switch(arguments.length){
case 0:
return klipse$lang$clojure$io$state_machine__3429__auto____0.call(this);
case 1:
return klipse$lang$clojure$io$state_machine__3429__auto____1.call(this,state_29433);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$lang$clojure$io$state_machine__3429__auto____0;
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$lang$clojure$io$state_machine__3429__auto____1;
return klipse$lang$clojure$io$state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,prefix,filenames,map__29399,map__29399__$1,name,path))
})();
var state__3453__auto__ = (function (){var statearr_29442 = f__3452__auto__.call(null);
(statearr_29442[(6)] = c__3451__auto__);

return statearr_29442;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,prefix,filenames,map__29399,map__29399__$1,name,path))
);

return c__3451__auto__;
} else {
if(cljs.core.seq.call(null,external_libs)){
var filenames = klipse.lang.clojure.io.external_libs_files.call(null,external_libs,klipse.lang.clojure.io.cljs_suffixes,path);
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,filenames,map__29399,map__29399__$1,name,path){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,filenames,map__29399,map__29399__$1,name,path){
return (function (state_29456){
var state_val_29457 = (state_29456[(1)]);
if((state_val_29457 === (1))){
var inst_29443 = klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),true);
var state_29456__$1 = state_29456;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_29456__$1,(2),inst_29443);
} else {
if((state_val_29457 === (2))){
var inst_29445 = (state_29456[(2)]);
var state_29456__$1 = state_29456;
if(cljs.core.truth_(inst_29445)){
var statearr_29458_29478 = state_29456__$1;
(statearr_29458_29478[(1)] = (3));

} else {
var statearr_29459_29479 = state_29456__$1;
(statearr_29459_29479[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29457 === (3))){
var state_29456__$1 = state_29456;
var statearr_29460_29480 = state_29456__$1;
(statearr_29460_29480[(2)] = null);

(statearr_29460_29480[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29457 === (4))){
var inst_29448 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29449 = [".js"];
var inst_29450 = (new cljs.core.PersistentVector(null,1,(5),inst_29448,inst_29449,null));
var inst_29451 = klipse.lang.clojure.io.external_libs_files.call(null,external_libs,inst_29450,path);
var inst_29452 = klipse.lang.clojure.io.try_to_load_ns.call(null,inst_29451,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
var state_29456__$1 = state_29456;
var statearr_29461_29481 = state_29456__$1;
(statearr_29461_29481[(2)] = inst_29452);

(statearr_29461_29481[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29457 === (5))){
var inst_29454 = (state_29456[(2)]);
var state_29456__$1 = state_29456;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_29456__$1,inst_29454);
} else {
return null;
}
}
}
}
}
});})(c__3451__auto__,filenames,map__29399,map__29399__$1,name,path))
;
return ((function (switch__3428__auto__,c__3451__auto__,filenames,map__29399,map__29399__$1,name,path){
return (function() {
var klipse$lang$clojure$io$state_machine__3429__auto__ = null;
var klipse$lang$clojure$io$state_machine__3429__auto____0 = (function (){
var statearr_29462 = [null,null,null,null,null,null,null];
(statearr_29462[(0)] = klipse$lang$clojure$io$state_machine__3429__auto__);

(statearr_29462[(1)] = (1));

return statearr_29462;
});
var klipse$lang$clojure$io$state_machine__3429__auto____1 = (function (state_29456){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_29456);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e29463){if((e29463 instanceof Object)){
var ex__3432__auto__ = e29463;
var statearr_29464_29482 = state_29456;
(statearr_29464_29482[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_29456);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e29463;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29483 = state_29456;
state_29456 = G__29483;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$lang$clojure$io$state_machine__3429__auto__ = function(state_29456){
switch(arguments.length){
case 0:
return klipse$lang$clojure$io$state_machine__3429__auto____0.call(this);
case 1:
return klipse$lang$clojure$io$state_machine__3429__auto____1.call(this,state_29456);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$lang$clojure$io$state_machine__3429__auto____0;
klipse$lang$clojure$io$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$lang$clojure$io$state_machine__3429__auto____1;
return klipse$lang$clojure$io$state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,filenames,map__29399,map__29399__$1,name,path))
})();
var state__3453__auto__ = (function (){var statearr_29465 = f__3452__auto__.call(null);
(statearr_29465[(6)] = c__3451__auto__);

return statearr_29465;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,filenames,map__29399,map__29399__$1,name,path))
);

return c__3451__auto__;
} else {
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("load-ns :cljs nothing can be done",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,null);

}
}
}
}
}
}
}));
klipse.lang.clojure.io.fix_goog_path = (function klipse$lang$clojure$io$fix_goog_path(path){
var parts = clojure.string.split.call(null,path,/\//);
var last_part = cljs.core.last.call(null,parts);
var new_parts = cljs.core.concat.call(null,cljs.core.butlast.call(null,parts),((cljs.core._EQ_.call(null,last_part,clojure.string.lower_case.call(null,last_part)))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [last_part,last_part], null):new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [clojure.string.lower_case.call(null,last_part)], null)));
return clojure.string.join.call(null,"/",new_parts);
});
klipse.lang.clojure.io.simple_goog_path = (function klipse$lang$clojure$io$simple_goog_path(path){
var parts = clojure.string.split.call(null,path,/\//);
var butlast_parts = cljs.core.butlast.call(null,parts);
var new_parts = cljs.core.concat.call(null,butlast_parts,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.last.call(null,butlast_parts)], null));
return clojure.string.join.call(null,"/",new_parts);
});
klipse.lang.clojure.io.another_goog_path = (function klipse$lang$clojure$io$another_goog_path(path){
var parts = clojure.string.split.call(null,path,/\//);
var last_part = cljs.core.last.call(null,parts);
var new_parts = cljs.core.concat.call(null,cljs.core.butlast.call(null,parts),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [clojure.string.join.call(null,"",cljs.core.take_last.call(null,(2),parts))], null));
return clojure.string.join.call(null,"/",new_parts);
});
cljs.core._add_method.call(null,klipse.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"goog","goog",-1711135452),(function (_,p__29485,src_cb){
var map__29486 = p__29485;
var map__29486__$1 = ((((!((map__29486 == null)))?(((((map__29486.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29486.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29486):map__29486);
var name = cljs.core.get.call(null,map__29486__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var path = cljs.core.get.call(null,map__29486__$1,new cljs.core.Keyword(null,"path","path",-188191168));
if(cljs.core.truth_((function (){var obj_SHARP_ = goog;
var fn_SHARP_ = (obj_SHARP_["getObjectByName"]);
return fn_SHARP_.call(obj_SHARP_,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
})())){
return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
var closure_github_path = "https://raw.githubusercontent.com/google/closure-library/v20160713/closure/";
var filenames = cljs.core.map.call(null,((function (closure_github_path,map__29486,map__29486__$1,name,path){
return (function (p1__29484_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(closure_github_path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__29484_SHARP_),".js"].join('');
});})(closure_github_path,map__29486,map__29486__$1,name,path))
,cljs.core.juxt.call(null,klipse.lang.clojure.io.fix_goog_path,cljs.core.identity,klipse.lang.clojure.io.another_goog_path,klipse.lang.clojure.io.simple_goog_path).call(null,path));
return klipse.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);

}
}));

//# sourceMappingURL=io.js.map
