// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('klipse.lang.javascript');
goog.require('cljs.core');
goog.require('klipse.utils');
goog.require('cljs_http.client');
goog.require('clojure.string');
goog.require('cljs.core.async');
goog.require('klipse.common.registry');
klipse.lang.javascript.known_external_libs = new cljs.core.PersistentArrayMap(null, 3, ["immutable","https://cdnjs.cloudflare.com/ajax/libs/immutable/3.8.2/immutable.js","jQuery","https://code.jquery.com/jquery-2.2.4.js","underscore","http://underscorejs.org/underscore-min.js"], null);
klipse.lang.javascript.external_lib_path = (function klipse$lang$javascript$external_lib_path(lib_name_or_url){
return cljs.core.get.call(null,klipse.lang.javascript.known_external_libs,lib_name_or_url,lib_name_or_url);
});
klipse.lang.javascript.beautify = (function klipse$lang$javascript$beautify(js_exp){
try{return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prettyFormat(js_exp))].join('');
}catch (e28527){if((e28527 instanceof Object)){
var o = e28527;
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(js_exp)].join('');
} else {
throw e28527;

}
}});
klipse.lang.javascript.append_to_chan = (function klipse$lang$javascript$append_to_chan(c){
return (function() { 
var G__28528__delegate = function (args){
cljs.core.async.put_BANG_.call(null,c,clojure.string.join.call(null," ",cljs.core.map.call(null,klipse.lang.javascript.beautify,args)));

cljs.core.async.put_BANG_.call(null,c,"\n");

return undefined;
};
var G__28528 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__28529__i = 0, G__28529__a = new Array(arguments.length -  0);
while (G__28529__i < G__28529__a.length) {G__28529__a[G__28529__i] = arguments[G__28529__i + 0]; ++G__28529__i;}
  args = new cljs.core.IndexedSeq(G__28529__a,0,null);
} 
return G__28528__delegate.call(this,args);};
G__28528.cljs$lang$maxFixedArity = 0;
G__28528.cljs$lang$applyTo = (function (arglist__28530){
var args = cljs.core.seq(arglist__28530);
return G__28528__delegate(args);
});
G__28528.cljs$core$IFn$_invoke$arity$variadic = G__28528__delegate;
return G__28528;
})()
;
});
/**
 * Evals an expression where the window.console object is lexically bound to an object that puts the console output on a channel.
 *   Returns the empty string.
 *   It works fine also with asynchronous code.
 */
klipse.lang.javascript.eval_with_logger_BANG_ = (function klipse$lang$javascript$eval_with_logger_BANG_(c,exp){
var logger = klipse.lang.javascript.append_to_chan.call(null,c);
var wrapped_exp = ["(function(console) {",cljs.core.str.cljs$core$IFn$_invoke$arity$1(exp),"}(window.klipse_snippet_console))"].join('');
klipse_snippet_console = ({"log": logger});

klipse.utils.eval_in_global_scope.call(null,wrapped_exp);

return "";
});
klipse.lang.javascript.str_eval_js_async = (function klipse$lang$javascript$str_eval_js_async(exp,p__28531){
var map__28532 = p__28531;
var map__28532__$1 = ((((!((map__28532 == null)))?(((((map__28532.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__28532.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__28532):map__28532);
var async_code_QMARK_ = cljs.core.get.call(null,map__28532__$1,new cljs.core.Keyword(null,"async-code?","async-code?",-832111541),false);
var external_libs = cljs.core.get.call(null,map__28532__$1,new cljs.core.Keyword(null,"external-libs","external-libs",1628481346),null);
var container_id = cljs.core.get.call(null,map__28532__$1,new cljs.core.Keyword(null,"container-id","container-id",1274665684));
var c = cljs.core.async.chan.call(null);
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("[javascript] evaluating",exp);
} else {
}

var c__3451__auto___28616 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto___28616,c,map__28532,map__28532__$1,async_code_QMARK_,external_libs,container_id){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto___28616,c,map__28532,map__28532__$1,async_code_QMARK_,external_libs,container_id){
return (function (state_28587){
var state_val_28588 = (state_28587[(1)]);
if((state_val_28588 === (7))){
var inst_28546 = (state_28587[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_28587,null,null,null,(6));
var inst_28551 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_28546);
var state_28587__$1 = state_28587;
if(inst_28551){
var statearr_28589_28617 = state_28587__$1;
(statearr_28589_28617[(1)] = (8));

} else {
var statearr_28590_28618 = state_28587__$1;
(statearr_28590_28618[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (1))){
var inst_28534 = clojure.string.blank_QMARK_.call(null,exp);
var state_28587__$1 = state_28587;
if(inst_28534){
var statearr_28591_28619 = state_28587__$1;
(statearr_28591_28619[(1)] = (2));

} else {
var statearr_28592_28620 = state_28587__$1;
(statearr_28592_28620[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (4))){
var inst_28585 = (state_28587[(2)]);
var state_28587__$1 = state_28587;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28587__$1,inst_28585);
} else {
if((state_val_28588 === (15))){
var inst_28562 = klipse.lang.javascript.append_to_chan.call(null,c);
var inst_28563 = console.log = inst_28562;
var state_28587__$1 = (function (){var statearr_28593 = state_28587;
(statearr_28593[(8)] = inst_28563);

return statearr_28593;
})();
var statearr_28594_28621 = state_28587__$1;
(statearr_28594_28621[(2)] = null);

(statearr_28594_28621[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (13))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_28587,(12),new cljs.core.Keyword(null,"default","default",-1987822328),null,(11));
var state_28587__$1 = state_28587;
if(cljs.core.truth_(async_code_QMARK_)){
var statearr_28595_28622 = state_28587__$1;
(statearr_28595_28622[(1)] = (14));

} else {
var statearr_28596_28623 = state_28587__$1;
(statearr_28596_28623[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (6))){
var inst_28583 = (state_28587[(2)]);
var state_28587__$1 = state_28587;
var statearr_28597_28624 = state_28587__$1;
(statearr_28597_28624[(2)] = inst_28583);

(statearr_28597_28624[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (17))){
var inst_28572 = (state_28587[(2)]);
var state_28587__$1 = state_28587;
var statearr_28598_28625 = state_28587__$1;
(statearr_28598_28625[(2)] = inst_28572);

(statearr_28598_28625[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (3))){
var inst_28538 = klipse.utils.setup_container_BANG_.call(null,container_id);
var inst_28542 = cljs.core.map.call(null,klipse.lang.javascript.external_lib_path,external_libs);
var inst_28543 = klipse.utils.load_scripts.call(null,inst_28542,new cljs.core.Keyword(null,"secured-eval?","secured-eval?",-922170059),true);
var state_28587__$1 = (function (){var statearr_28599 = state_28587;
(statearr_28599[(9)] = inst_28538);

return statearr_28599;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28587__$1,(5),inst_28543);
} else {
if((state_val_28588 === (12))){
var inst_28553 = (state_28587[(2)]);
var inst_28554 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_28553)].join('');
var state_28587__$1 = state_28587;
var statearr_28600_28626 = state_28587__$1;
(statearr_28600_28626[(2)] = inst_28554);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28587__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (2))){
var inst_28536 = cljs.core.async.put_BANG_.call(null,c,"");
var state_28587__$1 = state_28587;
var statearr_28601_28627 = state_28587__$1;
(statearr_28601_28627[(2)] = inst_28536);

(statearr_28601_28627[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (19))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_28587,null,null,(18),(17));
var inst_28569 = klipse.utils.eval_in_global_scope.call(null,exp);
var inst_28570 = klipse.lang.javascript.beautify.call(null,inst_28569);
var state_28587__$1 = state_28587;
var statearr_28602_28628 = state_28587__$1;
(statearr_28602_28628[(2)] = inst_28570);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28587__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (11))){
var inst_28576 = (state_28587[(2)]);
var state_28587__$1 = state_28587;
var statearr_28603_28629 = state_28587__$1;
(statearr_28603_28629[(2)] = inst_28576);

(statearr_28603_28629[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (9))){
var inst_28547 = (state_28587[(10)]);
var inst_28548 = (state_28587[(11)]);
var inst_28578 = ["//Cannot load script: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_28548),"\n","//Error: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_28547)].join('');
var state_28587__$1 = state_28587;
var statearr_28604_28630 = state_28587__$1;
(statearr_28604_28630[(2)] = inst_28578);

(statearr_28604_28630[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (5))){
var inst_28545 = (state_28587[(2)]);
var inst_28546 = cljs.core.nth.call(null,inst_28545,(0),null);
var inst_28547 = cljs.core.nth.call(null,inst_28545,(1),null);
var inst_28548 = cljs.core.nth.call(null,inst_28545,(2),null);
var state_28587__$1 = (function (){var statearr_28605 = state_28587;
(statearr_28605[(10)] = inst_28547);

(statearr_28605[(11)] = inst_28548);

(statearr_28605[(7)] = inst_28546);

return statearr_28605;
})();
var statearr_28606_28631 = state_28587__$1;
(statearr_28606_28631[(2)] = null);

(statearr_28606_28631[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (14))){
var inst_28559 = klipse.lang.javascript.eval_with_logger_BANG_.call(null,c,exp);
var state_28587__$1 = state_28587;
var statearr_28607_28632 = state_28587__$1;
(statearr_28607_28632[(2)] = inst_28559);

(statearr_28607_28632[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (16))){
var inst_28574 = (state_28587[(2)]);
var state_28587__$1 = state_28587;
var statearr_28608_28633 = state_28587__$1;
(statearr_28608_28633[(2)] = inst_28574);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28587__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (10))){
var inst_28580 = (state_28587[(2)]);
var inst_28581 = cljs.core.async.put_BANG_.call(null,c,inst_28580);
var state_28587__$1 = state_28587;
var statearr_28609_28634 = state_28587__$1;
(statearr_28609_28634[(2)] = inst_28581);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28587__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (18))){
var inst_28564 = (state_28587[(2)]);
var inst_28565 = console.log = console.log;
var state_28587__$1 = (function (){var statearr_28610 = state_28587;
(statearr_28610[(12)] = inst_28564);

(statearr_28610[(13)] = inst_28565);

return statearr_28610;
})();
cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28587__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28588 === (8))){
var state_28587__$1 = state_28587;
var statearr_28611_28635 = state_28587__$1;
(statearr_28611_28635[(2)] = null);

(statearr_28611_28635[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto___28616,c,map__28532,map__28532__$1,async_code_QMARK_,external_libs,container_id))
;
return ((function (switch__3428__auto__,c__3451__auto___28616,c,map__28532,map__28532__$1,async_code_QMARK_,external_libs,container_id){
return (function() {
var klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto__ = null;
var klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto____0 = (function (){
var statearr_28612 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28612[(0)] = klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto__);

(statearr_28612[(1)] = (1));

return statearr_28612;
});
var klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto____1 = (function (state_28587){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_28587);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e28613){if((e28613 instanceof Object)){
var ex__3432__auto__ = e28613;
var statearr_28614_28636 = state_28587;
(statearr_28614_28636[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28587);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28613;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28637 = state_28587;
state_28587 = G__28637;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto__ = function(state_28587){
switch(arguments.length){
case 0:
return klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto____1.call(this,state_28587);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto____0;
klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto____1;
return klipse$lang$javascript$str_eval_js_async_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto___28616,c,map__28532,map__28532__$1,async_code_QMARK_,external_libs,container_id))
})();
var state__3453__auto__ = (function (){var statearr_28615 = f__3452__auto__.call(null);
(statearr_28615[(6)] = c__3451__auto___28616);

return statearr_28615;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto___28616,c,map__28532,map__28532__$1,async_code_QMARK_,external_libs,container_id))
);


return c;
});
klipse.lang.javascript.opts = new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522),"javascript",new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542),"javascript",new cljs.core.Keyword(null,"beautify-output?","beautify-output?",3792957),false,new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294),klipse.lang.javascript.str_eval_js_async,new cljs.core.Keyword(null,"external-scripts","external-scripts",-699280105),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [klipse.common.registry.codemirror_mode_src.call(null,"javascript"),klipse.common.registry.scripts_src.call(null,"pretty_format.js")], null),new cljs.core.Keyword(null,"comment-str","comment-str",130143853),"//"], null);
klipse.common.registry.register_mode.call(null,"eval-javascript","selector_eval_js",klipse.lang.javascript.opts);
klipse.lang.javascript.babel = (function klipse$lang$javascript$babel(src){
return ((function (){var obj_SHARP_ = Babel;
var fn_SHARP_ = (obj_SHARP_["transform"]);
return fn_SHARP_.call(obj_SHARP_,src,({"presets": ["es2017","stage-2","stage-3"]}));
})()["code"]);
});
klipse.lang.javascript.eval_es2017 = (function klipse$lang$javascript$eval_es2017(exp,p__28638){
var map__28639 = p__28638;
var map__28639__$1 = ((((!((map__28639 == null)))?(((((map__28639.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__28639.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__28639):map__28639);
var async_code_QMARK_ = cljs.core.get.call(null,map__28639__$1,new cljs.core.Keyword(null,"async-code?","async-code?",-832111541),false);
var container_id = cljs.core.get.call(null,map__28639__$1,new cljs.core.Keyword(null,"container-id","container-id",1274665684));
var c = cljs.core.async.chan.call(null);
if(cljs.core.truth_(klipse.utils.verbose_QMARK_.call(null))){
console.info("[javascript es2017] evaluating",exp);
} else {
}

try{if(clojure.string.blank_QMARK_.call(null,exp)){
cljs.core.async.put_BANG_.call(null,c,"");
} else {
klipse.utils.setup_container_BANG_.call(null,container_id);

var transpiled_exp_28643 = klipse.lang.javascript.babel.call(null,exp);
cljs.core.async.put_BANG_.call(null,c,(cljs.core.truth_(async_code_QMARK_)?klipse.lang.javascript.eval_with_logger_BANG_.call(null,c,transpiled_exp_28643):(function (){var console_log28642 = console.log;
console.log = klipse.lang.javascript.append_to_chan.call(null,c);

try{return klipse.lang.javascript.beautify.call(null,klipse.utils.eval_in_global_scope.call(null,transpiled_exp_28643));
}finally {console.log = console_log28642;
}})()));
}
}catch (e28641){var o_28644 = e28641;
cljs.core.async.put_BANG_.call(null,c,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(o_28644)].join(''));
}
return c;
});
klipse.lang.javascript.es2017_opts = new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522),"javascript",new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542),"javascript",new cljs.core.Keyword(null,"beautify-output?","beautify-output?",3792957),false,new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294),klipse.lang.javascript.eval_es2017,new cljs.core.Keyword(null,"external-scripts","external-scripts",-699280105),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [klipse.common.registry.codemirror_mode_src.call(null,"javascript"),klipse.common.registry.scripts_src.call(null,"pretty_format.js"),klipse.common.registry.scripts_src.call(null,"babel.min.js"),klipse.common.registry.scripts_src.call(null,"babel_polyfill.min.js")], null),new cljs.core.Keyword(null,"comment-str","comment-str",130143853),"//"], null);
klipse.common.registry.register_mode.call(null,"eval-es2017","selector_es2017",klipse.lang.javascript.es2017_opts);

//# sourceMappingURL=javascript.js.map
