// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('klipse.plugin');
goog.require('cljs.core');
goog.require('klipse.common.registry');
goog.require('klipse.args_from_element');
goog.require('klipse.klipse_editors');
goog.require('klipse.utils');
goog.require('cljs.spec.alpha');
goog.require('clojure.walk');
goog.require('clojure.string');
goog.require('goog.dom');
goog.require('cljs.core.async');
goog.require('gadjett.collections');
klipse.plugin.out_placeholder = "the evaluation will appear here (soon)...";
klipse.plugin.snippet_counter = cljs.core.atom.call(null,(0));
klipse.plugin.snippet_num_BANG_ = (function klipse$plugin$snippet_num_BANG_(){
var res = cljs.core.deref.call(null,klipse.plugin.snippet_counter);
cljs.core.swap_BANG_.call(null,klipse.plugin.snippet_counter,cljs.core.inc);

return res;
});
klipse.plugin.calc_editor_args_from_element = (function klipse$plugin$calc_editor_args_from_element(element,global_idle_msec,min_idle_msec,global_editor_type){
var map__30603 = klipse.args_from_element.editor_args_from_element.call(null,element);
var map__30603__$1 = ((((!((map__30603 == null)))?(((((map__30603.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__30603.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__30603):map__30603);
var idle_msec = cljs.core.get.call(null,map__30603__$1,new cljs.core.Keyword(null,"idle-msec","idle-msec",1257447972),global_idle_msec);
var editor_type = cljs.core.get.call(null,map__30603__$1,new cljs.core.Keyword(null,"editor-type","editor-type",198227301),global_editor_type);
var preamble = cljs.core.get.call(null,map__30603__$1,new cljs.core.Keyword(null,"preamble","preamble",1641040241));
var async_code_QMARK_ = cljs.core.get.call(null,map__30603__$1,new cljs.core.Keyword(null,"async-code?","async-code?",-832111541));
var loop_msec = cljs.core.get.call(null,map__30603__$1,new cljs.core.Keyword(null,"loop-msec","loop-msec",1897277156),null);
return gadjett.collections.compactize_map.call(null,new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"idle-msec","idle-msec",1257447972),(function (){var x__4006__auto__ = min_idle_msec;
var y__4007__auto__ = idle_msec;
return ((x__4006__auto__ > y__4007__auto__) ? x__4006__auto__ : y__4007__auto__);
})(),new cljs.core.Keyword(null,"loop-msec","loop-msec",1897277156),loop_msec,new cljs.core.Keyword(null,"preamble","preamble",1641040241),preamble,new cljs.core.Keyword(null,"async-code?","async-code?",-832111541),async_code_QMARK_,new cljs.core.Keyword(null,"the-editor-type","the-editor-type",-672700480),editor_type], null));
});
klipse.plugin.calc_editor_type = (function klipse$plugin$calc_editor_type(minimalistic_ui_QMARK_,the_type){
if(cljs.core.truth_(minimalistic_ui_QMARK_)){
return new cljs.core.Keyword(null,"dom","dom",-1236537922);
} else {
var G__30605 = the_type;
switch (G__30605) {
case "code-mirror":
return new cljs.core.Keyword(null,"code-mirror","code-mirror",575084768);

break;
case "dom":
return new cljs.core.Keyword(null,"dom","dom",-1236537922);

break;
case "html":
return new cljs.core.Keyword(null,"html","html",-998796897);

break;
default:
return new cljs.core.Keyword(null,"code-mirror","code-mirror",575084768);

}
}
});
klipse.plugin.load_external_scripts = (function klipse$plugin$load_external_scripts(scripts,no_dynamic_scritps_QMARK_){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__){
return (function (state_30636){
var state_val_30637 = (state_30636[(1)]);
if((state_val_30637 === (1))){
var state_30636__$1 = state_30636;
if(cljs.core.truth_(no_dynamic_scritps_QMARK_)){
var statearr_30638_30651 = state_30636__$1;
(statearr_30638_30651[(1)] = (2));

} else {
var statearr_30639_30652 = state_30636__$1;
(statearr_30639_30652[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30637 === (2))){
var inst_30608 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_30609 = [new cljs.core.Keyword(null,"ok","ok",967785236),new cljs.core.Keyword(null,"ok","ok",967785236)];
var inst_30610 = (new cljs.core.PersistentVector(null,2,(5),inst_30608,inst_30609,null));
var state_30636__$1 = state_30636;
var statearr_30640_30653 = state_30636__$1;
(statearr_30640_30653[(2)] = inst_30610);

(statearr_30640_30653[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30637 === (3))){
var inst_30615 = klipse.utils.load_scripts_mem.call(null,scripts);
var state_30636__$1 = state_30636;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30636__$1,(5),inst_30615);
} else {
if((state_val_30637 === (4))){
var inst_30634 = (state_30636[(2)]);
var state_30636__$1 = state_30636;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30636__$1,inst_30634);
} else {
if((state_val_30637 === (5))){
var inst_30617 = (state_30636[(2)]);
var inst_30618 = cljs.core.nth.call(null,inst_30617,(0),null);
var inst_30619 = cljs.core.nth.call(null,inst_30617,(1),null);
var inst_30620 = cljs.core.nth.call(null,inst_30617,(2),null);
var inst_30621 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_30618);
var state_30636__$1 = (function (){var statearr_30641 = state_30636;
(statearr_30641[(7)] = inst_30619);

(statearr_30641[(8)] = inst_30620);

return statearr_30641;
})();
if(inst_30621){
var statearr_30642_30654 = state_30636__$1;
(statearr_30642_30654[(1)] = (6));

} else {
var statearr_30643_30655 = state_30636__$1;
(statearr_30643_30655[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30637 === (6))){
var inst_30623 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_30624 = [new cljs.core.Keyword(null,"ok","ok",967785236),new cljs.core.Keyword(null,"ok","ok",967785236)];
var inst_30625 = (new cljs.core.PersistentVector(null,2,(5),inst_30623,inst_30624,null));
var state_30636__$1 = state_30636;
var statearr_30644_30656 = state_30636__$1;
(statearr_30644_30656[(2)] = inst_30625);

(statearr_30644_30656[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30637 === (7))){
var inst_30619 = (state_30636[(7)]);
var inst_30620 = (state_30636[(8)]);
var inst_30627 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_30628 = ["Cannot load script: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_30620),"\n","Error: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_30619)].join('');
var inst_30629 = [new cljs.core.Keyword(null,"error","error",-978969032),inst_30628];
var inst_30630 = (new cljs.core.PersistentVector(null,2,(5),inst_30627,inst_30629,null));
var state_30636__$1 = state_30636;
var statearr_30645_30657 = state_30636__$1;
(statearr_30645_30657[(2)] = inst_30630);

(statearr_30645_30657[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30637 === (8))){
var inst_30632 = (state_30636[(2)]);
var state_30636__$1 = state_30636;
var statearr_30646_30658 = state_30636__$1;
(statearr_30646_30658[(2)] = inst_30632);

(statearr_30646_30658[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__3451__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__){
return (function() {
var klipse$plugin$load_external_scripts_$_state_machine__3429__auto__ = null;
var klipse$plugin$load_external_scripts_$_state_machine__3429__auto____0 = (function (){
var statearr_30647 = [null,null,null,null,null,null,null,null,null];
(statearr_30647[(0)] = klipse$plugin$load_external_scripts_$_state_machine__3429__auto__);

(statearr_30647[(1)] = (1));

return statearr_30647;
});
var klipse$plugin$load_external_scripts_$_state_machine__3429__auto____1 = (function (state_30636){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30636);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30648){if((e30648 instanceof Object)){
var ex__3432__auto__ = e30648;
var statearr_30649_30659 = state_30636;
(statearr_30649_30659[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30636);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30648;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30660 = state_30636;
state_30636 = G__30660;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$load_external_scripts_$_state_machine__3429__auto__ = function(state_30636){
switch(arguments.length){
case 0:
return klipse$plugin$load_external_scripts_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$load_external_scripts_$_state_machine__3429__auto____1.call(this,state_30636);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$load_external_scripts_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$load_external_scripts_$_state_machine__3429__auto____0;
klipse$plugin$load_external_scripts_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$load_external_scripts_$_state_machine__3429__auto____1;
return klipse$plugin$load_external_scripts_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__))
})();
var state__3453__auto__ = (function (){var statearr_30650 = f__3452__auto__.call(null);
(statearr_30650[(6)] = c__3451__auto__);

return statearr_30650;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__))
);

return c__3451__auto__;
});
/**
 * returns a channel c with a function f.
 *   f returns a channel that will be ready to read when the snippet is evaluated.
 */
klipse.plugin.klipsify_with_opts = (function klipse$plugin$klipsify_with_opts(element,p__30663,p__30664){
var map__30665 = p__30663;
var map__30665__$1 = ((((!((map__30665 == null)))?(((((map__30665.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__30665.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__30665):map__30665);
var no_dynamic_scripts = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"no_dynamic_scripts","no_dynamic_scripts",-730706373));
var eval_idle_msec = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"eval_idle_msec","eval_idle_msec",1104296094),(20));
var minimalistic_ui = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"minimalistic_ui","minimalistic_ui",-944637362),false);
var editor_type = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"editor_type","editor_type",195783179));
var print_length = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"print_length","print_length",2140955911),(1000));
var beautify_strings = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"beautify_strings","beautify_strings",1690445266),false);
var eval_context = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"eval_context","eval_context",1307295352));
var codemirror_options_in = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"codemirror_options_in","codemirror_options_in",-1220877316),cljs.core.PersistentArrayMap.EMPTY);
var codemirror_options_out = cljs.core.get.call(null,map__30665__$1,new cljs.core.Keyword(null,"codemirror_options_out","codemirror_options_out",440175842),cljs.core.PersistentArrayMap.EMPTY);
var map__30666 = p__30664;
var map__30666__$1 = ((((!((map__30666 == null)))?(((((map__30666.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__30666.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__30666):map__30666);
var lang_opts = map__30666__$1;
var eval_fn = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294));
var beautify_output_QMARK_ = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"beautify-output?","beautify-output?",3792957),true);
var no_result = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"no-result","no-result",1702657437));
var default_editor = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"default-editor","default-editor",758164479));
var editor_out_mode = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542));
var beautify_QMARK_ = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"beautify?","beautify?",1909100619),true);
var min_eval_idle_msec = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"min-eval-idle-msec","min-eval-idle-msec",-1547033812),(0));
var comment_str = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"comment-str","comment-str",130143853));
var editor_in_mode = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522));
var external_scripts = cljs.core.get.call(null,map__30666__$1,new cljs.core.Keyword(null,"external-scripts","external-scripts",-699280105),cljs.core.PersistentVector.EMPTY);
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts){
return (function (state_30750){
var state_val_30751 = (state_30750[(1)]);
if((state_val_30751 === (7))){
var state_30750__$1 = state_30750;
var statearr_30752_30800 = state_30750__$1;
(statearr_30752_30800[(2)] = false);

(statearr_30752_30800[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (20))){
var inst_30719 = (state_30750[(7)]);
var state_30750__$1 = state_30750;
var statearr_30753_30801 = state_30750__$1;
(statearr_30753_30801[(2)] = inst_30719);

(statearr_30753_30801[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (27))){
var inst_30718 = (state_30750[(8)]);
var inst_30737 = (state_30750[(2)]);
var inst_30738 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_30718);
var state_30750__$1 = (function (){var statearr_30754 = state_30750;
(statearr_30754[(9)] = inst_30737);

return statearr_30754;
})();
if(inst_30738){
var statearr_30755_30802 = state_30750__$1;
(statearr_30755_30802[(1)] = (28));

} else {
var statearr_30756_30803 = state_30750__$1;
(statearr_30756_30803[(1)] = (29));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (1))){
var state_30750__$1 = state_30750;
if(cljs.core.truth_(element)){
var statearr_30757_30804 = state_30750__$1;
(statearr_30757_30804[(1)] = (2));

} else {
var statearr_30758_30805 = state_30750__$1;
(statearr_30758_30805[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (24))){
var inst_30718 = (state_30750[(8)]);
var inst_30730 = (state_30750[(2)]);
var inst_30731 = klipse.plugin.snippet_num_BANG_.call(null);
var inst_30732 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_30718);
var state_30750__$1 = (function (){var statearr_30759 = state_30750;
(statearr_30759[(10)] = inst_30730);

(statearr_30759[(11)] = inst_30731);

return statearr_30759;
})();
if(inst_30732){
var statearr_30760_30806 = state_30750__$1;
(statearr_30760_30806[(1)] = (25));

} else {
var statearr_30761_30807 = state_30750__$1;
(statearr_30761_30807[(1)] = (26));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (4))){
var inst_30748 = (state_30750[(2)]);
var state_30750__$1 = state_30750;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30750__$1,inst_30748);
} else {
if((state_val_30751 === (15))){
var inst_30705 = (state_30750[(12)]);
var state_30750__$1 = state_30750;
var statearr_30762_30808 = state_30750__$1;
(statearr_30762_30808[(2)] = inst_30705);

(statearr_30762_30808[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (21))){
var inst_30718 = (state_30750[(8)]);
var inst_30725 = (state_30750[(2)]);
var inst_30726 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_30718);
var state_30750__$1 = (function (){var statearr_30763 = state_30750;
(statearr_30763[(13)] = inst_30725);

return statearr_30763;
})();
if(inst_30726){
var statearr_30764_30809 = state_30750__$1;
(statearr_30764_30809[(1)] = (22));

} else {
var statearr_30765_30810 = state_30750__$1;
(statearr_30765_30810[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (13))){
var inst_30682 = (state_30750[(14)]);
var state_30750__$1 = state_30750;
var statearr_30766_30811 = state_30750__$1;
(statearr_30766_30811[(2)] = inst_30682);

(statearr_30766_30811[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (22))){
var state_30750__$1 = state_30750;
var statearr_30767_30812 = state_30750__$1;
(statearr_30767_30812[(2)] = beautify_QMARK_);

(statearr_30767_30812[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (29))){
var state_30750__$1 = state_30750;
var statearr_30768_30813 = state_30750__$1;
(statearr_30768_30813[(2)] = false);

(statearr_30768_30813[(1)] = (30));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (6))){
var inst_30682 = (state_30750[(14)]);
var inst_30687 = inst_30682.cljs$lang$protocol_mask$partition0$;
var inst_30688 = (inst_30687 & (64));
var inst_30689 = inst_30682.cljs$core$ISeq$;
var inst_30690 = (cljs.core.PROTOCOL_SENTINEL === inst_30689);
var inst_30691 = ((inst_30688) || (inst_30690));
var state_30750__$1 = state_30750;
if(cljs.core.truth_(inst_30691)){
var statearr_30769_30814 = state_30750__$1;
(statearr_30769_30814[(1)] = (9));

} else {
var statearr_30770_30815 = state_30750__$1;
(statearr_30770_30815[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (28))){
var state_30750__$1 = state_30750;
var statearr_30771_30816 = state_30750__$1;
(statearr_30771_30816[(2)] = beautify_output_QMARK_);

(statearr_30771_30816[(1)] = (30));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (25))){
var inst_30678 = (state_30750[(15)]);
var state_30750__$1 = state_30750;
var statearr_30772_30817 = state_30750__$1;
(statearr_30772_30817[(2)] = inst_30678);

(statearr_30772_30817[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (17))){
var inst_30712 = (state_30750[(2)]);
var inst_30713 = klipse.plugin.calc_editor_type.call(null,minimalistic_ui,inst_30712);
var inst_30714 = gadjett.collections.collify.call(null,external_scripts);
var inst_30715 = klipse.plugin.load_external_scripts.call(null,inst_30714,no_dynamic_scripts);
var state_30750__$1 = (function (){var statearr_30773 = state_30750;
(statearr_30773[(16)] = inst_30713);

return statearr_30773;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30750__$1,(18),inst_30715);
} else {
if((state_val_30751 === (3))){
var state_30750__$1 = state_30750;
var statearr_30774_30818 = state_30750__$1;
(statearr_30774_30818[(2)] = null);

(statearr_30774_30818[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (12))){
var inst_30682 = (state_30750[(14)]);
var inst_30700 = cljs.core.apply.call(null,cljs.core.hash_map,inst_30682);
var state_30750__$1 = state_30750;
var statearr_30775_30819 = state_30750__$1;
(statearr_30775_30819[(2)] = inst_30700);

(statearr_30775_30819[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (2))){
var inst_30677 = (state_30750[(17)]);
var inst_30674 = [new cljs.core.Keyword(null,"eval-context","eval-context",536255614),new cljs.core.Keyword(null,"print-length","print-length",1931866356),new cljs.core.Keyword(null,"beautify-strings","beautify-strings",-236207479)];
var inst_30675 = [eval_context,print_length,beautify_strings];
var inst_30676 = cljs.core.PersistentHashMap.fromArrays(inst_30674,inst_30675);
var inst_30677__$1 = klipse.args_from_element.eval_args_from_element.call(null,element,inst_30676);
var inst_30678 = (function (){var eval_args = inst_30677__$1;
return ((function (eval_args,inst_30677,inst_30674,inst_30675,inst_30676,inst_30677__$1,state_val_30751,c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts){
return (function (p1__30661_SHARP_,p2__30662_SHARP_){
return eval_fn.call(null,p1__30661_SHARP_,cljs.core.merge.call(null,eval_args,p2__30662_SHARP_));
});
;})(eval_args,inst_30677,inst_30674,inst_30675,inst_30676,inst_30677__$1,state_val_30751,c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts))
})();
var inst_30679 = klipse.args_from_element.content.call(null,element,comment_str);
var state_30750__$1 = (function (){var statearr_30776 = state_30750;
(statearr_30776[(17)] = inst_30677__$1);

(statearr_30776[(15)] = inst_30678);

return statearr_30776;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30750__$1,(5),inst_30679);
} else {
if((state_val_30751 === (23))){
var state_30750__$1 = state_30750;
var statearr_30777_30820 = state_30750__$1;
(statearr_30777_30820[(2)] = false);

(statearr_30777_30820[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (19))){
var state_30750__$1 = state_30750;
var statearr_30778_30821 = state_30750__$1;
(statearr_30778_30821[(2)] = klipse.plugin.out_placeholder);

(statearr_30778_30821[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (11))){
var inst_30695 = (state_30750[(2)]);
var state_30750__$1 = state_30750;
var statearr_30779_30822 = state_30750__$1;
(statearr_30779_30822[(2)] = inst_30695);

(statearr_30779_30822[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (9))){
var state_30750__$1 = state_30750;
var statearr_30780_30823 = state_30750__$1;
(statearr_30780_30823[(2)] = true);

(statearr_30780_30823[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (5))){
var inst_30682 = (state_30750[(14)]);
var inst_30681 = (state_30750[(2)]);
var inst_30682__$1 = klipse.plugin.calc_editor_args_from_element.call(null,element,eval_idle_msec,min_eval_idle_msec,editor_type);
var inst_30684 = (inst_30682__$1 == null);
var inst_30685 = cljs.core.not.call(null,inst_30684);
var state_30750__$1 = (function (){var statearr_30781 = state_30750;
(statearr_30781[(14)] = inst_30682__$1);

(statearr_30781[(18)] = inst_30681);

return statearr_30781;
})();
if(inst_30685){
var statearr_30782_30824 = state_30750__$1;
(statearr_30782_30824[(1)] = (6));

} else {
var statearr_30783_30825 = state_30750__$1;
(statearr_30783_30825[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (14))){
var inst_30703 = (state_30750[(19)]);
var inst_30705 = (state_30750[(12)]);
var inst_30703__$1 = (state_30750[(2)]);
var inst_30704 = cljs.core.get.call(null,inst_30703__$1,new cljs.core.Keyword(null,"idle-msec","idle-msec",1257447972));
var inst_30705__$1 = cljs.core.get.call(null,inst_30703__$1,new cljs.core.Keyword(null,"the-editor-type","the-editor-type",-672700480));
var inst_30706 = cljs.core.get.call(null,inst_30703__$1,new cljs.core.Keyword(null,"loop-msec","loop-msec",1897277156));
var inst_30707 = cljs.core.get.call(null,inst_30703__$1,new cljs.core.Keyword(null,"async-code?","async-code?",-832111541));
var inst_30708 = cljs.core.get.call(null,inst_30703__$1,new cljs.core.Keyword(null,"preamble","preamble",1641040241));
var state_30750__$1 = (function (){var statearr_30784 = state_30750;
(statearr_30784[(20)] = inst_30707);

(statearr_30784[(21)] = inst_30706);

(statearr_30784[(22)] = inst_30704);

(statearr_30784[(19)] = inst_30703__$1);

(statearr_30784[(23)] = inst_30708);

(statearr_30784[(12)] = inst_30705__$1);

return statearr_30784;
})();
if(cljs.core.truth_(inst_30705__$1)){
var statearr_30785_30826 = state_30750__$1;
(statearr_30785_30826[(1)] = (15));

} else {
var statearr_30786_30827 = state_30750__$1;
(statearr_30786_30827[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (26))){
var inst_30707 = (state_30750[(20)]);
var inst_30718 = (state_30750[(8)]);
var inst_30677 = (state_30750[(17)]);
var inst_30706 = (state_30750[(21)]);
var inst_30678 = (state_30750[(15)]);
var inst_30704 = (state_30750[(22)]);
var inst_30719 = (state_30750[(7)]);
var inst_30717 = (state_30750[(24)]);
var inst_30681 = (state_30750[(18)]);
var inst_30703 = (state_30750[(19)]);
var inst_30713 = (state_30750[(16)]);
var inst_30708 = (state_30750[(23)]);
var inst_30735 = (function (){var vec__30671 = inst_30717;
var the_editor_type = inst_30713;
var eval_fn_with_args = inst_30678;
var idle_msec = inst_30704;
var loop_msec = inst_30706;
var load_error = inst_30719;
var async_code_QMARK_ = inst_30707;
var load_status = inst_30718;
var eval_args = inst_30677;
var source_code = inst_30681;
var preamble = inst_30708;
var map__30670 = inst_30703;
return ((function (vec__30671,the_editor_type,eval_fn_with_args,idle_msec,loop_msec,load_error,async_code_QMARK_,load_status,eval_args,source_code,preamble,map__30670,inst_30707,inst_30718,inst_30677,inst_30706,inst_30678,inst_30704,inst_30719,inst_30717,inst_30681,inst_30703,inst_30713,inst_30708,state_val_30751,c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts){
return (function (){
return cljs.core.async.chan.call(null);
});
;})(vec__30671,the_editor_type,eval_fn_with_args,idle_msec,loop_msec,load_error,async_code_QMARK_,load_status,eval_args,source_code,preamble,map__30670,inst_30707,inst_30718,inst_30677,inst_30706,inst_30678,inst_30704,inst_30719,inst_30717,inst_30681,inst_30703,inst_30713,inst_30708,state_val_30751,c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts))
})();
var state_30750__$1 = state_30750;
var statearr_30787_30828 = state_30750__$1;
(statearr_30787_30828[(2)] = inst_30735);

(statearr_30787_30828[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (16))){
var state_30750__$1 = state_30750;
var statearr_30788_30829 = state_30750__$1;
(statearr_30788_30829[(2)] = default_editor);

(statearr_30788_30829[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (30))){
var inst_30707 = (state_30750[(20)]);
var inst_30706 = (state_30750[(21)]);
var inst_30704 = (state_30750[(22)]);
var inst_30730 = (state_30750[(10)]);
var inst_30737 = (state_30750[(9)]);
var inst_30725 = (state_30750[(13)]);
var inst_30681 = (state_30750[(18)]);
var inst_30731 = (state_30750[(11)]);
var inst_30713 = (state_30750[(16)]);
var inst_30720 = (state_30750[(25)]);
var inst_30708 = (state_30750[(23)]);
var inst_30742 = (state_30750[(2)]);
var inst_30743 = [inst_30725,inst_30730,inst_30704,inst_30706,element,editor_out_mode,inst_30707,inst_30681,inst_30708,codemirror_options_out,editor_in_mode,inst_30731,inst_30737,no_result,codemirror_options_in,inst_30742];
var inst_30744 = cljs.core.PersistentHashMap.fromArrays(inst_30720,inst_30743);
var inst_30745 = klipse.klipse_editors.create_editor.call(null,inst_30713,inst_30744);
var state_30750__$1 = state_30750;
var statearr_30789_30830 = state_30750__$1;
(statearr_30789_30830[(2)] = inst_30745);

(statearr_30789_30830[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (10))){
var state_30750__$1 = state_30750;
var statearr_30790_30831 = state_30750__$1;
(statearr_30790_30831[(2)] = false);

(statearr_30790_30831[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (18))){
var inst_30718 = (state_30750[(8)]);
var inst_30717 = (state_30750[(24)]);
var inst_30717__$1 = (state_30750[(2)]);
var inst_30718__$1 = cljs.core.nth.call(null,inst_30717__$1,(0),null);
var inst_30719 = cljs.core.nth.call(null,inst_30717__$1,(1),null);
var inst_30720 = [new cljs.core.Keyword(null,"default-txt","default-txt",27736322),new cljs.core.Keyword(null,"indent?","indent?",1381429379),new cljs.core.Keyword(null,"idle-msec","idle-msec",1257447972),new cljs.core.Keyword(null,"loop-msec","loop-msec",1897277156),new cljs.core.Keyword(null,"element","element",1974019749),new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542),new cljs.core.Keyword(null,"async-code?","async-code?",-832111541),new cljs.core.Keyword(null,"source-code","source-code",-685884337),new cljs.core.Keyword(null,"preamble","preamble",1641040241),new cljs.core.Keyword(null,"codemirror-options-out","codemirror-options-out",1969968980),new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522),new cljs.core.Keyword(null,"snippet-num","snippet-num",-267174090),new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294),new cljs.core.Keyword(null,"no-result","no-result",1702657437),new cljs.core.Keyword(null,"codemirror-options-in","codemirror-options-in",-1261564801),new cljs.core.Keyword(null,"indent-output?","indent-output?",-1299145441)];
var inst_30721 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_30718__$1);
var state_30750__$1 = (function (){var statearr_30791 = state_30750;
(statearr_30791[(8)] = inst_30718__$1);

(statearr_30791[(7)] = inst_30719);

(statearr_30791[(24)] = inst_30717__$1);

(statearr_30791[(25)] = inst_30720);

return statearr_30791;
})();
if(inst_30721){
var statearr_30792_30832 = state_30750__$1;
(statearr_30792_30832[(1)] = (19));

} else {
var statearr_30793_30833 = state_30750__$1;
(statearr_30793_30833[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30751 === (8))){
var inst_30698 = (state_30750[(2)]);
var state_30750__$1 = state_30750;
if(cljs.core.truth_(inst_30698)){
var statearr_30794_30834 = state_30750__$1;
(statearr_30794_30834[(1)] = (12));

} else {
var statearr_30795_30835 = state_30750__$1;
(statearr_30795_30835[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts))
;
return ((function (switch__3428__auto__,c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts){
return (function() {
var klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto__ = null;
var klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto____0 = (function (){
var statearr_30796 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_30796[(0)] = klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto__);

(statearr_30796[(1)] = (1));

return statearr_30796;
});
var klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto____1 = (function (state_30750){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30750);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30797){if((e30797 instanceof Object)){
var ex__3432__auto__ = e30797;
var statearr_30798_30836 = state_30750;
(statearr_30798_30836[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30750);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30797;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30837 = state_30750;
state_30750 = G__30837;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto__ = function(state_30750){
switch(arguments.length){
case 0:
return klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto____1.call(this,state_30750);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto____0;
klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto____1;
return klipse$plugin$klipsify_with_opts_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts))
})();
var state__3453__auto__ = (function (){var statearr_30799 = f__3452__auto__.call(null);
(statearr_30799[(6)] = c__3451__auto__);

return statearr_30799;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,map__30665,map__30665__$1,no_dynamic_scripts,eval_idle_msec,minimalistic_ui,editor_type,print_length,beautify_strings,eval_context,codemirror_options_in,codemirror_options_out,map__30666,map__30666__$1,lang_opts,eval_fn,beautify_output_QMARK_,no_result,default_editor,editor_out_mode,beautify_QMARK_,min_eval_idle_msec,comment_str,editor_in_mode,external_scripts))
);

return c__3451__auto__;
});
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","dom-element","klipse.plugin/dom-element",-271611585),new cljs.core.Symbol("goog.dom","isElement","goog.dom/isElement",-1707224949,null),goog.dom.isElement);
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","editor-in-mode","klipse.plugin/editor-in-mode",-880426851),new cljs.core.Symbol("cljs.core","string?","cljs.core/string?",-2072921719,null),cljs.core.string_QMARK_);
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","editor-out-mode","klipse.plugin/editor-out-mode",724274461),new cljs.core.Symbol("cljs.core","string?","cljs.core/string?",-2072921719,null),cljs.core.string_QMARK_);
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","eval-fn","klipse.plugin/eval-fn",-51358589),new cljs.core.Symbol("cljs.core","fn?","cljs.core/fn?",71876239,null),cljs.core.fn_QMARK_);
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","comment-str","klipse.plugin/comment-str",1428350840),cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","or","cljs.spec.alpha/or",-831679639,null),new cljs.core.Keyword(null,"fn","fn",-1175266204),new cljs.core.Symbol("cljs.core","fn?","cljs.core/fn?",71876239,null),new cljs.core.Keyword(null,"str","str",1089608819),new cljs.core.Symbol("cljs.core","string?","cljs.core/string?",-2072921719,null)),cljs.spec.alpha.or_spec_impl.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"fn","fn",-1175266204),new cljs.core.Keyword(null,"str","str",1089608819)], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol("cljs.core","fn?","cljs.core/fn?",71876239,null),new cljs.core.Symbol("cljs.core","string?","cljs.core/string?",-2072921719,null)], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.fn_QMARK_,cljs.core.string_QMARK_], null),null));
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","eval_idle_msec","klipse.plugin/eval_idle_msec",15935397),new cljs.core.Symbol("cljs.core","integer?","cljs.core/integer?",1710697810,null),cljs.core.integer_QMARK_);
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","minimalistic_ui","klipse.plugin/minimalistic_ui",231935317),cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","or","cljs.core/or",1201033885,null),cljs.core.list(new cljs.core.Symbol("cljs.core","=","cljs.core/=",-1891498332,null),new cljs.core.Symbol(null,"%","%",-950237169,null),true),cljs.core.list(new cljs.core.Symbol("cljs.core","=","cljs.core/=",-1891498332,null),new cljs.core.Symbol(null,"%","%",-950237169,null),false))),(function (p1__30838_SHARP_){
return ((cljs.core._EQ_.call(null,p1__30838_SHARP_,true)) || (cljs.core._EQ_.call(null,p1__30838_SHARP_,false)));
}));
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","options","klipse.plugin/options",1158769650),cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","keys","cljs.spec.alpha/keys",1109346032,null),new cljs.core.Keyword(null,"req-un","req-un",1074571008),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","editor-in-mode","klipse.plugin/editor-in-mode",-880426851),new cljs.core.Keyword("klipse.plugin","editor-out-mode","klipse.plugin/editor-out-mode",724274461),new cljs.core.Keyword("klipse.plugin","eval-fn","klipse.plugin/eval-fn",-51358589),new cljs.core.Keyword("klipse.plugin","comment-str","klipse.plugin/comment-str",1428350840)], null)),cljs.spec.alpha.map_spec_impl.call(null,cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"req-un","req-un",1074571008),new cljs.core.Keyword(null,"opt-un","opt-un",883442496),new cljs.core.Keyword(null,"gfn","gfn",791517474),new cljs.core.Keyword(null,"pred-exprs","pred-exprs",1792271395),new cljs.core.Keyword(null,"keys-pred","keys-pred",858984739),new cljs.core.Keyword(null,"opt-keys","opt-keys",1262688261),new cljs.core.Keyword(null,"req-specs","req-specs",553962313),new cljs.core.Keyword(null,"req","req",-326448303),new cljs.core.Keyword(null,"req-keys","req-keys",514319221),new cljs.core.Keyword(null,"opt-specs","opt-specs",-384905450),new cljs.core.Keyword(null,"pred-forms","pred-forms",172611832),new cljs.core.Keyword(null,"opt","opt",-794706369)],[new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","editor-in-mode","klipse.plugin/editor-in-mode",-880426851),new cljs.core.Keyword("klipse.plugin","editor-out-mode","klipse.plugin/editor-out-mode",724274461),new cljs.core.Keyword("klipse.plugin","eval-fn","klipse.plugin/eval-fn",-51358589),new cljs.core.Keyword("klipse.plugin","comment-str","klipse.plugin/comment-str",1428350840)], null),null,null,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(function (G__30839){
return cljs.core.map_QMARK_.call(null,G__30839);
}),(function (G__30839){
return cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522));
}),(function (G__30839){
return cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542));
}),(function (G__30839){
return cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294));
}),(function (G__30839){
return cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"comment-str","comment-str",130143853));
})], null),(function (G__30839){
return ((cljs.core.map_QMARK_.call(null,G__30839)) && (cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522))) && (cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542))) && (cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294))) && (cljs.core.contains_QMARK_.call(null,G__30839,new cljs.core.Keyword(null,"comment-str","comment-str",130143853))));
}),cljs.core.PersistentVector.EMPTY,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","editor-in-mode","klipse.plugin/editor-in-mode",-880426851),new cljs.core.Keyword("klipse.plugin","editor-out-mode","klipse.plugin/editor-out-mode",724274461),new cljs.core.Keyword("klipse.plugin","eval-fn","klipse.plugin/eval-fn",-51358589),new cljs.core.Keyword("klipse.plugin","comment-str","klipse.plugin/comment-str",1428350840)], null),null,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522),new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542),new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294),new cljs.core.Keyword(null,"comment-str","comment-str",130143853)], null),cljs.core.PersistentVector.EMPTY,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","map?","cljs.core/map?",-1390345523,null),new cljs.core.Symbol(null,"%","%",-950237169,null))),cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","contains?","cljs.core/contains?",-976526835,null),new cljs.core.Symbol(null,"%","%",-950237169,null),new cljs.core.Keyword(null,"editor-in-mode","editor-in-mode",-1964584522))),cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","contains?","cljs.core/contains?",-976526835,null),new cljs.core.Symbol(null,"%","%",-950237169,null),new cljs.core.Keyword(null,"editor-out-mode","editor-out-mode",1749845542))),cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","contains?","cljs.core/contains?",-976526835,null),new cljs.core.Symbol(null,"%","%",-950237169,null),new cljs.core.Keyword(null,"eval-fn","eval-fn",-1111644294))),cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","contains?","cljs.core/contains?",-976526835,null),new cljs.core.Symbol(null,"%","%",-950237169,null),new cljs.core.Keyword(null,"comment-str","comment-str",130143853)))], null),null])));
cljs.spec.alpha.def_impl.call(null,new cljs.core.Keyword("klipse.plugin","klipse-settings","klipse.plugin/klipse-settings",1435250729),cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","keys","cljs.spec.alpha/keys",1109346032,null),new cljs.core.Keyword(null,"opt-un","opt-un",883442496),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","eval_idle_msec","klipse.plugin/eval_idle_msec",15935397),new cljs.core.Keyword("klipse.plugin","minimalistic_ui","klipse.plugin/minimalistic_ui",231935317)], null)),cljs.spec.alpha.map_spec_impl.call(null,cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"req-un","req-un",1074571008),new cljs.core.Keyword(null,"opt-un","opt-un",883442496),new cljs.core.Keyword(null,"gfn","gfn",791517474),new cljs.core.Keyword(null,"pred-exprs","pred-exprs",1792271395),new cljs.core.Keyword(null,"keys-pred","keys-pred",858984739),new cljs.core.Keyword(null,"opt-keys","opt-keys",1262688261),new cljs.core.Keyword(null,"req-specs","req-specs",553962313),new cljs.core.Keyword(null,"req","req",-326448303),new cljs.core.Keyword(null,"req-keys","req-keys",514319221),new cljs.core.Keyword(null,"opt-specs","opt-specs",-384905450),new cljs.core.Keyword(null,"pred-forms","pred-forms",172611832),new cljs.core.Keyword(null,"opt","opt",-794706369)],[null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","eval_idle_msec","klipse.plugin/eval_idle_msec",15935397),new cljs.core.Keyword("klipse.plugin","minimalistic_ui","klipse.plugin/minimalistic_ui",231935317)], null),null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(function (G__30840){
return cljs.core.map_QMARK_.call(null,G__30840);
})], null),(function (G__30840){
return cljs.core.map_QMARK_.call(null,G__30840);
}),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"eval_idle_msec","eval_idle_msec",1104296094),new cljs.core.Keyword(null,"minimalistic_ui","minimalistic_ui",-944637362)], null),cljs.core.PersistentVector.EMPTY,null,cljs.core.PersistentVector.EMPTY,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","eval_idle_msec","klipse.plugin/eval_idle_msec",15935397),new cljs.core.Keyword("klipse.plugin","minimalistic_ui","klipse.plugin/minimalistic_ui",231935317)], null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.list(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"%","%",-950237169,null)], null),cljs.core.list(new cljs.core.Symbol("cljs.core","map?","cljs.core/map?",-1390345523,null),new cljs.core.Symbol(null,"%","%",-950237169,null)))], null),null])));
cljs.spec.alpha.def_impl.call(null,new cljs.core.Symbol("klipse.plugin","klipsify-with-opts","klipse.plugin/klipsify-with-opts",331340081,null),cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","fspec","cljs.spec.alpha/fspec",-1289128341,null),new cljs.core.Keyword(null,"args","args",1315556576),cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","cat","cljs.spec.alpha/cat",-1471398329,null),new cljs.core.Keyword(null,"element","element",1974019749),new cljs.core.Keyword("klipse.plugin","dom-element","klipse.plugin/dom-element",-271611585),new cljs.core.Keyword(null,"settings","settings",1556144875),new cljs.core.Keyword("klipse.plugin","klipse-settings","klipse.plugin/klipse-settings",1435250729),new cljs.core.Keyword(null,"opts","opts",155075701),new cljs.core.Keyword("klipse.plugin","options","klipse.plugin/options",1158769650))),cljs.spec.alpha.fspec_impl.call(null,cljs.spec.alpha.spec_impl.call(null,cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","cat","cljs.spec.alpha/cat",-1471398329,null),new cljs.core.Keyword(null,"element","element",1974019749),new cljs.core.Keyword("klipse.plugin","dom-element","klipse.plugin/dom-element",-271611585),new cljs.core.Keyword(null,"settings","settings",1556144875),new cljs.core.Keyword("klipse.plugin","klipse-settings","klipse.plugin/klipse-settings",1435250729),new cljs.core.Keyword(null,"opts","opts",155075701),new cljs.core.Keyword("klipse.plugin","options","klipse.plugin/options",1158769650)),cljs.spec.alpha.cat_impl.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"element","element",1974019749),new cljs.core.Keyword(null,"settings","settings",1556144875),new cljs.core.Keyword(null,"opts","opts",155075701)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","dom-element","klipse.plugin/dom-element",-271611585),new cljs.core.Keyword("klipse.plugin","klipse-settings","klipse.plugin/klipse-settings",1435250729),new cljs.core.Keyword("klipse.plugin","options","klipse.plugin/options",1158769650)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("klipse.plugin","dom-element","klipse.plugin/dom-element",-271611585),new cljs.core.Keyword("klipse.plugin","klipse-settings","klipse.plugin/klipse-settings",1435250729),new cljs.core.Keyword("klipse.plugin","options","klipse.plugin/options",1158769650)], null)),null,null),cljs.core.list(new cljs.core.Symbol("cljs.spec.alpha","cat","cljs.spec.alpha/cat",-1471398329,null),new cljs.core.Keyword(null,"element","element",1974019749),new cljs.core.Keyword("klipse.plugin","dom-element","klipse.plugin/dom-element",-271611585),new cljs.core.Keyword(null,"settings","settings",1556144875),new cljs.core.Keyword("klipse.plugin","klipse-settings","klipse.plugin/klipse-settings",1435250729),new cljs.core.Keyword(null,"opts","opts",155075701),new cljs.core.Keyword("klipse.plugin","options","klipse.plugin/options",1158769650)),cljs.spec.alpha.spec_impl.call(null,new cljs.core.Symbol("cljs.core","any?","cljs.core/any?",-2068111842,null),cljs.core.any_QMARK_,null,null),new cljs.core.Symbol("cljs.core","any?","cljs.core/any?",-2068111842,null),null,null,null));
/**
 * To be called from outside.
 *   Klipsifies a snippet.
 *   Returns a channel that will be ready when the snippet is evaluated.
 */
klipse.plugin.klipsify = (function klipse$plugin$klipsify(element,general_settings,mode){
var temp__6751__auto__ = cljs.core.deref.call(null,klipse.common.registry.mode_options).call(null,mode);
if(cljs.core.truth_(temp__6751__auto__)){
var opts = temp__6751__auto__;
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,opts,temp__6751__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,opts,temp__6751__auto__){
return (function (state_30848){
var state_val_30849 = (state_30848[(1)]);
if((state_val_30849 === (1))){
var inst_30841 = klipse.plugin.klipsify_with_opts.call(null,element,general_settings,opts);
var state_30848__$1 = state_30848;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30848__$1,(3),inst_30841);
} else {
if((state_val_30849 === (2))){
var inst_30846 = (state_30848[(2)]);
var state_30848__$1 = state_30848;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30848__$1,inst_30846);
} else {
if((state_val_30849 === (3))){
var inst_30843 = (state_30848[(2)]);
var inst_30844 = inst_30843.call(null);
var state_30848__$1 = state_30848;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30848__$1,(2),inst_30844);
} else {
return null;
}
}
}
});})(c__3451__auto__,opts,temp__6751__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__,opts,temp__6751__auto__){
return (function() {
var klipse$plugin$klipsify_$_state_machine__3429__auto__ = null;
var klipse$plugin$klipsify_$_state_machine__3429__auto____0 = (function (){
var statearr_30850 = [null,null,null,null,null,null,null];
(statearr_30850[(0)] = klipse$plugin$klipsify_$_state_machine__3429__auto__);

(statearr_30850[(1)] = (1));

return statearr_30850;
});
var klipse$plugin$klipsify_$_state_machine__3429__auto____1 = (function (state_30848){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30848);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30851){if((e30851 instanceof Object)){
var ex__3432__auto__ = e30851;
var statearr_30852_30864 = state_30848;
(statearr_30852_30864[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30848);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30851;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30865 = state_30848;
state_30848 = G__30865;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$klipsify_$_state_machine__3429__auto__ = function(state_30848){
switch(arguments.length){
case 0:
return klipse$plugin$klipsify_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$klipsify_$_state_machine__3429__auto____1.call(this,state_30848);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$klipsify_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$klipsify_$_state_machine__3429__auto____0;
klipse$plugin$klipsify_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$klipsify_$_state_machine__3429__auto____1;
return klipse$plugin$klipsify_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,opts,temp__6751__auto__))
})();
var state__3453__auto__ = (function (){var statearr_30853 = f__3452__auto__.call(null);
(statearr_30853[(6)] = c__3451__auto__);

return statearr_30853;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,opts,temp__6751__auto__))
);

return c__3451__auto__;
} else {
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,temp__6751__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,temp__6751__auto__){
return (function (state_30858){
var state_val_30859 = (state_30858[(1)]);
if((state_val_30859 === (1))){
var inst_30854 = cljs.core.deref.call(null,klipse.common.registry.mode_options);
var inst_30855 = cljs.core.keys.call(null,inst_30854);
var inst_30856 = console.error("cannot find options for mode: ",mode,". Supported modes: ",inst_30855);
var state_30858__$1 = state_30858;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30858__$1,inst_30856);
} else {
return null;
}
});})(c__3451__auto__,temp__6751__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__,temp__6751__auto__){
return (function() {
var klipse$plugin$klipsify_$_state_machine__3429__auto__ = null;
var klipse$plugin$klipsify_$_state_machine__3429__auto____0 = (function (){
var statearr_30860 = [null,null,null,null,null,null,null];
(statearr_30860[(0)] = klipse$plugin$klipsify_$_state_machine__3429__auto__);

(statearr_30860[(1)] = (1));

return statearr_30860;
});
var klipse$plugin$klipsify_$_state_machine__3429__auto____1 = (function (state_30858){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30858);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30861){if((e30861 instanceof Object)){
var ex__3432__auto__ = e30861;
var statearr_30862_30866 = state_30858;
(statearr_30862_30866[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30858);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30861;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30867 = state_30858;
state_30858 = G__30867;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$klipsify_$_state_machine__3429__auto__ = function(state_30858){
switch(arguments.length){
case 0:
return klipse$plugin$klipsify_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$klipsify_$_state_machine__3429__auto____1.call(this,state_30858);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$klipsify_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$klipsify_$_state_machine__3429__auto____0;
klipse$plugin$klipsify_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$klipsify_$_state_machine__3429__auto____1;
return klipse$plugin$klipsify_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,temp__6751__auto__))
})();
var state__3453__auto__ = (function (){var statearr_30863 = f__3452__auto__.call(null);
(statearr_30863[(6)] = c__3451__auto__);

return statearr_30863;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,temp__6751__auto__))
);

return c__3451__auto__;
}
});
goog.exportSymbol('klipse.plugin.klipsify', klipse.plugin.klipsify);
klipse.plugin.klipsify_no_eval = (function klipse$plugin$klipsify_no_eval(element,general_settings,mode){
var temp__6751__auto__ = cljs.core.deref.call(null,klipse.common.registry.mode_options).call(null,mode);
if(cljs.core.truth_(temp__6751__auto__)){
var opts = temp__6751__auto__;
return klipse.plugin.klipsify_with_opts.call(null,element,general_settings,opts);
} else {
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,temp__6751__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,temp__6751__auto__){
return (function (state_30870){
var state_val_30871 = (state_30870[(1)]);
if((state_val_30871 === (1))){
var inst_30868 = (function (){return ((function (state_val_30871,c__3451__auto__,temp__6751__auto__){
return (function (){
var c__3451__auto____$1 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto____$1,state_val_30871,c__3451__auto__,temp__6751__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto____$1,state_val_30871,c__3451__auto__,temp__6751__auto__){
return (function (state_30876){
var state_val_30877 = (state_30876[(1)]);
if((state_val_30877 === (1))){
var inst_30872 = cljs.core.deref.call(null,klipse.common.registry.mode_options);
var inst_30873 = cljs.core.keys.call(null,inst_30872);
var inst_30874 = console.error("cannot find options for mode: ",mode,". Supported modes: ",inst_30873);
var state_30876__$1 = state_30876;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30876__$1,inst_30874);
} else {
return null;
}
});})(c__3451__auto____$1,state_val_30871,c__3451__auto__,temp__6751__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto____$1,state_val_30871,c__3451__auto__,temp__6751__auto__){
return (function() {
var klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__ = null;
var klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____0 = (function (){
var statearr_30878 = [null,null,null,null,null,null,null];
(statearr_30878[(0)] = klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__);

(statearr_30878[(1)] = (1));

return statearr_30878;
});
var klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____1 = (function (state_30876){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30876);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30879){if((e30879 instanceof Object)){
var ex__3432__auto__ = e30879;
var statearr_30880_30886 = state_30876;
(statearr_30880_30886[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30876);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30879;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30887 = state_30876;
state_30876 = G__30887;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__ = function(state_30876){
switch(arguments.length){
case 0:
return klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____1.call(this,state_30876);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____0;
klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____1;
return klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto____$1,state_val_30871,c__3451__auto__,temp__6751__auto__))
})();
var state__3453__auto__ = (function (){var statearr_30881 = f__3452__auto__.call(null);
(statearr_30881[(6)] = c__3451__auto____$1);

return statearr_30881;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto____$1,state_val_30871,c__3451__auto__,temp__6751__auto__))
);

return c__3451__auto____$1;
});
;})(state_val_30871,c__3451__auto__,temp__6751__auto__))
})();
var state_30870__$1 = state_30870;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30870__$1,inst_30868);
} else {
return null;
}
});})(c__3451__auto__,temp__6751__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__,temp__6751__auto__){
return (function() {
var klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__ = null;
var klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____0 = (function (){
var statearr_30882 = [null,null,null,null,null,null,null];
(statearr_30882[(0)] = klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__);

(statearr_30882[(1)] = (1));

return statearr_30882;
});
var klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____1 = (function (state_30870){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30870);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30883){if((e30883 instanceof Object)){
var ex__3432__auto__ = e30883;
var statearr_30884_30888 = state_30870;
(statearr_30884_30888[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30870);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30883;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30889 = state_30870;
state_30870 = G__30889;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__ = function(state_30870){
switch(arguments.length){
case 0:
return klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____1.call(this,state_30870);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____0;
klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto____1;
return klipse$plugin$klipsify_no_eval_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,temp__6751__auto__))
})();
var state__3453__auto__ = (function (){var statearr_30885 = f__3452__auto__.call(null);
(statearr_30885[(6)] = c__3451__auto__);

return statearr_30885;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,temp__6751__auto__))
);

return c__3451__auto__;
}
});
goog.exportSymbol('klipse.plugin.klipsify_no_eval', klipse.plugin.klipsify_no_eval);
klipse.plugin.edit_elements = (function klipse$plugin$edit_elements(elements,general_settings,modes){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__){
return (function (state_30916){
var state_val_30917 = (state_30916[(1)]);
if((state_val_30917 === (7))){
var inst_30897 = (state_30916[(7)]);
var inst_30896 = (state_30916[(8)]);
var inst_30899 = klipse.plugin.klipsify_no_eval.call(null,inst_30896,general_settings,inst_30897);
var state_30916__$1 = state_30916;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30916__$1,(10),inst_30899);
} else {
if((state_val_30917 === (1))){
var inst_30890 = cljs.core.PersistentVector.EMPTY;
var inst_30891 = elements;
var inst_30892 = inst_30890;
var state_30916__$1 = (function (){var statearr_30918 = state_30916;
(statearr_30918[(9)] = inst_30892);

(statearr_30918[(10)] = inst_30891);

return statearr_30918;
})();
var statearr_30919_30937 = state_30916__$1;
(statearr_30919_30937[(2)] = null);

(statearr_30919_30937[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (4))){
var inst_30897 = (state_30916[(7)]);
var inst_30896 = (state_30916[(8)]);
var inst_30891 = (state_30916[(10)]);
var inst_30896__$1 = cljs.core.first.call(null,inst_30891);
var inst_30897__$1 = modes.call(null,inst_30896__$1);
var state_30916__$1 = (function (){var statearr_30920 = state_30916;
(statearr_30920[(7)] = inst_30897__$1);

(statearr_30920[(8)] = inst_30896__$1);

return statearr_30920;
})();
if(cljs.core.truth_(inst_30897__$1)){
var statearr_30921_30938 = state_30916__$1;
(statearr_30921_30938[(1)] = (7));

} else {
var statearr_30922_30939 = state_30916__$1;
(statearr_30922_30939[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (6))){
var inst_30912 = (state_30916[(2)]);
var state_30916__$1 = state_30916;
var statearr_30923_30940 = state_30916__$1;
(statearr_30923_30940[(2)] = inst_30912);

(statearr_30923_30940[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (3))){
var inst_30914 = (state_30916[(2)]);
var state_30916__$1 = state_30916;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30916__$1,inst_30914);
} else {
if((state_val_30917 === (2))){
var inst_30891 = (state_30916[(10)]);
var inst_30894 = cljs.core.seq.call(null,inst_30891);
var state_30916__$1 = state_30916;
if(inst_30894){
var statearr_30924_30941 = state_30916__$1;
(statearr_30924_30941[(1)] = (4));

} else {
var statearr_30925_30942 = state_30916__$1;
(statearr_30925_30942[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (9))){
var inst_30909 = (state_30916[(2)]);
var state_30916__$1 = state_30916;
var statearr_30926_30943 = state_30916__$1;
(statearr_30926_30943[(2)] = inst_30909);

(statearr_30926_30943[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (5))){
var inst_30892 = (state_30916[(9)]);
var state_30916__$1 = state_30916;
var statearr_30928_30944 = state_30916__$1;
(statearr_30928_30944[(2)] = inst_30892);

(statearr_30928_30944[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (10))){
var inst_30892 = (state_30916[(9)]);
var inst_30891 = (state_30916[(10)]);
var inst_30901 = (state_30916[(2)]);
var inst_30902 = cljs.core.rest.call(null,inst_30891);
var inst_30903 = cljs.core.conj.call(null,inst_30892,inst_30901);
var inst_30891__$1 = inst_30902;
var inst_30892__$1 = inst_30903;
var state_30916__$1 = (function (){var statearr_30929 = state_30916;
(statearr_30929[(9)] = inst_30892__$1);

(statearr_30929[(10)] = inst_30891__$1);

return statearr_30929;
})();
var statearr_30930_30945 = state_30916__$1;
(statearr_30930_30945[(2)] = null);

(statearr_30930_30945[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30917 === (8))){
var inst_30892 = (state_30916[(9)]);
var inst_30891 = (state_30916[(10)]);
var inst_30906 = cljs.core.rest.call(null,inst_30891);
var tmp30927 = inst_30892;
var inst_30891__$1 = inst_30906;
var inst_30892__$1 = tmp30927;
var state_30916__$1 = (function (){var statearr_30931 = state_30916;
(statearr_30931[(9)] = inst_30892__$1);

(statearr_30931[(10)] = inst_30891__$1);

return statearr_30931;
})();
var statearr_30932_30946 = state_30916__$1;
(statearr_30932_30946[(2)] = null);

(statearr_30932_30946[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__){
return (function() {
var klipse$plugin$edit_elements_$_state_machine__3429__auto__ = null;
var klipse$plugin$edit_elements_$_state_machine__3429__auto____0 = (function (){
var statearr_30933 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_30933[(0)] = klipse$plugin$edit_elements_$_state_machine__3429__auto__);

(statearr_30933[(1)] = (1));

return statearr_30933;
});
var klipse$plugin$edit_elements_$_state_machine__3429__auto____1 = (function (state_30916){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30916);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e30934){if((e30934 instanceof Object)){
var ex__3432__auto__ = e30934;
var statearr_30935_30947 = state_30916;
(statearr_30935_30947[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30916);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e30934;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30948 = state_30916;
state_30916 = G__30948;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$edit_elements_$_state_machine__3429__auto__ = function(state_30916){
switch(arguments.length){
case 0:
return klipse$plugin$edit_elements_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$edit_elements_$_state_machine__3429__auto____1.call(this,state_30916);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$edit_elements_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$edit_elements_$_state_machine__3429__auto____0;
klipse$plugin$edit_elements_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$edit_elements_$_state_machine__3429__auto____1;
return klipse$plugin$edit_elements_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__))
})();
var state__3453__auto__ = (function (){var statearr_30936 = f__3452__auto__.call(null);
(statearr_30936[(6)] = c__3451__auto__);

return statearr_30936;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__))
);

return c__3451__auto__;
});
klipse.plugin.klipsify_elements = (function klipse$plugin$klipsify_elements(elements,general_settings,modes){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__){
return (function (state_30997){
var state_val_30998 = (state_30997[(1)]);
if((state_val_30998 === (7))){
var inst_30993 = (state_30997[(2)]);
var state_30997__$1 = state_30997;
var statearr_30999_31025 = state_30997__$1;
(statearr_30999_31025[(2)] = inst_30993);

(statearr_30999_31025[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (1))){
var inst_30949 = klipse.plugin.edit_elements.call(null,elements,general_settings,modes);
var state_30997__$1 = state_30997;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30997__$1,(2),inst_30949);
} else {
if((state_val_30998 === (4))){
var inst_30995 = (state_30997[(2)]);
var state_30997__$1 = state_30997;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_30997__$1,inst_30995);
} else {
if((state_val_30998 === (15))){
var inst_30972 = (state_30997[(7)]);
var inst_30984 = (state_30997[(2)]);
var inst_30985 = cljs.core.next.call(null,inst_30972);
var inst_30957 = inst_30985;
var inst_30958 = null;
var inst_30959 = (0);
var inst_30960 = (0);
var state_30997__$1 = (function (){var statearr_31000 = state_30997;
(statearr_31000[(8)] = inst_30957);

(statearr_31000[(9)] = inst_30984);

(statearr_31000[(10)] = inst_30960);

(statearr_31000[(11)] = inst_30958);

(statearr_31000[(12)] = inst_30959);

return statearr_31000;
})();
var statearr_31001_31026 = state_30997__$1;
(statearr_31001_31026[(2)] = null);

(statearr_31001_31026[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (13))){
var inst_30972 = (state_30997[(7)]);
var inst_30981 = cljs.core.first.call(null,inst_30972);
var inst_30982 = inst_30981.call(null);
var state_30997__$1 = state_30997;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30997__$1,(15),inst_30982);
} else {
if((state_val_30998 === (6))){
var inst_30972 = (state_30997[(7)]);
var inst_30957 = (state_30997[(8)]);
var inst_30972__$1 = cljs.core.seq.call(null,inst_30957);
var state_30997__$1 = (function (){var statearr_31002 = state_30997;
(statearr_31002[(7)] = inst_30972__$1);

return statearr_31002;
})();
if(inst_30972__$1){
var statearr_31003_31027 = state_30997__$1;
(statearr_31003_31027[(1)] = (9));

} else {
var statearr_31004_31028 = state_30997__$1;
(statearr_31004_31028[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (3))){
var inst_30960 = (state_30997[(10)]);
var inst_30959 = (state_30997[(12)]);
var inst_30962 = (inst_30960 < inst_30959);
var inst_30963 = inst_30962;
var state_30997__$1 = state_30997;
if(cljs.core.truth_(inst_30963)){
var statearr_31005_31029 = state_30997__$1;
(statearr_31005_31029[(1)] = (5));

} else {
var statearr_31006_31030 = state_30997__$1;
(statearr_31006_31030[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (12))){
var inst_30972 = (state_30997[(7)]);
var inst_30976 = cljs.core.chunk_first.call(null,inst_30972);
var inst_30977 = cljs.core.chunk_rest.call(null,inst_30972);
var inst_30978 = cljs.core.count.call(null,inst_30976);
var inst_30957 = inst_30977;
var inst_30958 = inst_30976;
var inst_30959 = inst_30978;
var inst_30960 = (0);
var state_30997__$1 = (function (){var statearr_31007 = state_30997;
(statearr_31007[(8)] = inst_30957);

(statearr_31007[(10)] = inst_30960);

(statearr_31007[(11)] = inst_30958);

(statearr_31007[(12)] = inst_30959);

return statearr_31007;
})();
var statearr_31008_31031 = state_30997__$1;
(statearr_31008_31031[(2)] = null);

(statearr_31008_31031[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (2))){
var inst_30951 = (state_30997[(2)]);
var inst_30956 = cljs.core.seq.call(null,inst_30951);
var inst_30957 = inst_30956;
var inst_30958 = null;
var inst_30959 = (0);
var inst_30960 = (0);
var state_30997__$1 = (function (){var statearr_31009 = state_30997;
(statearr_31009[(8)] = inst_30957);

(statearr_31009[(10)] = inst_30960);

(statearr_31009[(11)] = inst_30958);

(statearr_31009[(12)] = inst_30959);

return statearr_31009;
})();
var statearr_31010_31032 = state_30997__$1;
(statearr_31010_31032[(2)] = null);

(statearr_31010_31032[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (11))){
var inst_30991 = (state_30997[(2)]);
var state_30997__$1 = state_30997;
var statearr_31011_31033 = state_30997__$1;
(statearr_31011_31033[(2)] = inst_30991);

(statearr_31011_31033[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (9))){
var inst_30972 = (state_30997[(7)]);
var inst_30974 = cljs.core.chunked_seq_QMARK_.call(null,inst_30972);
var state_30997__$1 = state_30997;
if(inst_30974){
var statearr_31012_31034 = state_30997__$1;
(statearr_31012_31034[(1)] = (12));

} else {
var statearr_31013_31035 = state_30997__$1;
(statearr_31013_31035[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (5))){
var inst_30960 = (state_30997[(10)]);
var inst_30958 = (state_30997[(11)]);
var inst_30965 = cljs.core._nth.call(null,inst_30958,inst_30960);
var inst_30966 = inst_30965.call(null);
var state_30997__$1 = state_30997;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_30997__$1,(8),inst_30966);
} else {
if((state_val_30998 === (14))){
var inst_30988 = (state_30997[(2)]);
var state_30997__$1 = state_30997;
var statearr_31017_31036 = state_30997__$1;
(statearr_31017_31036[(2)] = inst_30988);

(statearr_31017_31036[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (10))){
var state_30997__$1 = state_30997;
var statearr_31018_31037 = state_30997__$1;
(statearr_31018_31037[(2)] = null);

(statearr_31018_31037[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30998 === (8))){
var inst_30957 = (state_30997[(8)]);
var inst_30960 = (state_30997[(10)]);
var inst_30958 = (state_30997[(11)]);
var inst_30959 = (state_30997[(12)]);
var inst_30968 = (state_30997[(2)]);
var inst_30969 = (inst_30960 + (1));
var tmp31014 = inst_30957;
var tmp31015 = inst_30958;
var tmp31016 = inst_30959;
var inst_30957__$1 = tmp31014;
var inst_30958__$1 = tmp31015;
var inst_30959__$1 = tmp31016;
var inst_30960__$1 = inst_30969;
var state_30997__$1 = (function (){var statearr_31019 = state_30997;
(statearr_31019[(13)] = inst_30968);

(statearr_31019[(8)] = inst_30957__$1);

(statearr_31019[(10)] = inst_30960__$1);

(statearr_31019[(11)] = inst_30958__$1);

(statearr_31019[(12)] = inst_30959__$1);

return statearr_31019;
})();
var statearr_31020_31038 = state_30997__$1;
(statearr_31020_31038[(2)] = null);

(statearr_31020_31038[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__){
return (function() {
var klipse$plugin$klipsify_elements_$_state_machine__3429__auto__ = null;
var klipse$plugin$klipsify_elements_$_state_machine__3429__auto____0 = (function (){
var statearr_31021 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_31021[(0)] = klipse$plugin$klipsify_elements_$_state_machine__3429__auto__);

(statearr_31021[(1)] = (1));

return statearr_31021;
});
var klipse$plugin$klipsify_elements_$_state_machine__3429__auto____1 = (function (state_30997){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_30997);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e31022){if((e31022 instanceof Object)){
var ex__3432__auto__ = e31022;
var statearr_31023_31039 = state_30997;
(statearr_31023_31039[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_30997);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e31022;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__31040 = state_30997;
state_30997 = G__31040;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$plugin$klipsify_elements_$_state_machine__3429__auto__ = function(state_30997){
switch(arguments.length){
case 0:
return klipse$plugin$klipsify_elements_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$plugin$klipsify_elements_$_state_machine__3429__auto____1.call(this,state_30997);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$plugin$klipsify_elements_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$plugin$klipsify_elements_$_state_machine__3429__auto____0;
klipse$plugin$klipsify_elements_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$plugin$klipsify_elements_$_state_machine__3429__auto____1;
return klipse$plugin$klipsify_elements_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__))
})();
var state__3453__auto__ = (function (){var statearr_31024 = f__3452__auto__.call(null);
(statearr_31024[(6)] = c__3451__auto__);

return statearr_31024;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__))
);

return c__3451__auto__;
});
klipse.plugin.snippets_selector = (function klipse$plugin$snippets_selector(settings,selector_names){
return clojure.string.join.call(null,",",cljs.core.remove.call(null,cljs.core.nil_QMARK_,cljs.core.map.call(null,settings,selector_names)));
});
klipse.plugin.seq_from_selector = (function klipse$plugin$seq_from_selector(selector){
return cljs.core.array_seq.call(null,document.querySelectorAll(selector));
});
klipse.plugin.elements__GT_mode = (function klipse$plugin$elements__GT_mode(settings){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,(function (){var iter__4292__auto__ = (function klipse$plugin$elements__GT_mode_$_iter__31041(s__31042){
return (new cljs.core.LazySeq(null,(function (){
var s__31042__$1 = s__31042;
while(true){
var temp__6753__auto__ = cljs.core.seq.call(null,s__31042__$1);
if(temp__6753__auto__){
var xs__7309__auto__ = temp__6753__auto__;
var selector_name = cljs.core.first.call(null,xs__7309__auto__);
var selector = settings.call(null,selector_name);
if(cljs.core.truth_(selector)){
var iterys__4288__auto__ = ((function (s__31042__$1,selector,selector_name,xs__7309__auto__,temp__6753__auto__){
return (function klipse$plugin$elements__GT_mode_$_iter__31041_$_iter__31043(s__31044){
return (new cljs.core.LazySeq(null,((function (s__31042__$1,selector,selector_name,xs__7309__auto__,temp__6753__auto__){
return (function (){
var s__31044__$1 = s__31044;
while(true){
var temp__6753__auto____$1 = cljs.core.seq.call(null,s__31044__$1);
if(temp__6753__auto____$1){
var s__31044__$2 = temp__6753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__31044__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__31044__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__31046 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__31045 = (0);
while(true){
if((i__31045 < size__4291__auto__)){
var element = cljs.core._nth.call(null,c__4290__auto__,i__31045);
cljs.core.chunk_append.call(null,b__31046,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [element,cljs.core.deref.call(null,klipse.common.registry.selector__GT_mode).call(null,selector_name)], null));

var G__31047 = (i__31045 + (1));
i__31045 = G__31047;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__31046),klipse$plugin$elements__GT_mode_$_iter__31041_$_iter__31043.call(null,cljs.core.chunk_rest.call(null,s__31044__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__31046),null);
}
} else {
var element = cljs.core.first.call(null,s__31044__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [element,cljs.core.deref.call(null,klipse.common.registry.selector__GT_mode).call(null,selector_name)], null),klipse$plugin$elements__GT_mode_$_iter__31041_$_iter__31043.call(null,cljs.core.rest.call(null,s__31044__$2)));
}
} else {
return null;
}
break;
}
});})(s__31042__$1,selector,selector_name,xs__7309__auto__,temp__6753__auto__))
,null,null));
});})(s__31042__$1,selector,selector_name,xs__7309__auto__,temp__6753__auto__))
;
var fs__4289__auto__ = cljs.core.seq.call(null,iterys__4288__auto__.call(null,klipse.plugin.seq_from_selector.call(null,selector)));
if(fs__4289__auto__){
return cljs.core.concat.call(null,fs__4289__auto__,klipse$plugin$elements__GT_mode_$_iter__31041.call(null,cljs.core.rest.call(null,s__31042__$1)));
} else {
var G__31048 = cljs.core.rest.call(null,s__31042__$1);
s__31042__$1 = G__31048;
continue;
}
} else {
var G__31049 = cljs.core.rest.call(null,s__31042__$1);
s__31042__$1 = G__31049;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,cljs.core.keys.call(null,cljs.core.deref.call(null,klipse.common.registry.selector__GT_mode)));
})());
});
klipse.plugin.init_clj = (function klipse$plugin$init_clj(settings){
var map__31050 = clojure.walk.keywordize_keys.call(null,settings);
var map__31050__$1 = ((((!((map__31050 == null)))?(((((map__31050.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__31050.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__31050):map__31050);
var keywordized_settings = map__31050__$1;
var secured_eval = cljs.core.get.call(null,map__31050__$1,new cljs.core.Keyword(null,"secured_eval","secured_eval",-1577487888));
var security_forbidden_symbols = cljs.core.get.call(null,map__31050__$1,new cljs.core.Keyword(null,"security_forbidden_symbols","security_forbidden_symbols",-1480402500),klipse.utils.default_forbidden_symbols.call(null));
var modes = klipse.plugin.elements__GT_mode.call(null,settings);
var elements = klipse.plugin.seq_from_selector.call(null,klipse.plugin.snippets_selector.call(null,settings,cljs.core.keys.call(null,cljs.core.deref.call(null,klipse.common.registry.selector__GT_mode))));
if(cljs.core.truth_(secured_eval)){
klipse.utils.securize_eval_BANG_.call(null,security_forbidden_symbols);
} else {
}

return klipse.plugin.klipsify_elements.call(null,elements,keywordized_settings,modes);
});
goog.exportSymbol('klipse.plugin.init_clj', klipse.plugin.init_clj);
klipse.plugin.init = (function klipse$plugin$init(js_settings){
return klipse.plugin.init_clj.call(null,cljs.core.js__GT_clj.call(null,js_settings,new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),false));
});
goog.exportSymbol('klipse.plugin.init', klipse.plugin.init);

//# sourceMappingURL=plugin.js.map
