// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('klipse.ui.editors.editor');
goog.require('cljs.core');
goog.require('goog.dom');
goog.require('klipse.dom_utils');
goog.require('gadjett.collections');
cljs.core.load_file("out/cljsjs/codemirror/development/codemirror.inc.js");
cljs.core.load_file("out/cljsjs/codemirror/common/addon/edit/matchbrackets.inc.js");
cljs.core.load_file("out/cljsjs/codemirror/common/addon/edit/closebrackets.inc.js");
goog.require('clojure.string');
klipse.ui.editors.editor.code_mirror = CodeMirror;
klipse.ui.editors.editor.create = (function klipse$ui$editors$editor$create(dom_id,config){
return CodeMirror.fromTextArea(document.getElementById(dom_id),cljs.core.clj__GT_js.call(null,config));
});
klipse.ui.editors.editor.get_value = (function klipse$ui$editors$editor$get_value(editor){
return editor.getValue();
});
klipse.ui.editors.editor.get_selection = (function klipse$ui$editors$editor$get_selection(editor){
return editor.getSelection();
});
klipse.ui.editors.editor.get_selection_or_nil = (function klipse$ui$editors$editor$get_selection_or_nil(editor){
var s = klipse.ui.editors.editor.get_selection.call(null,editor);
if(clojure.string.blank_QMARK_.call(null,s)){
return null;
} else {
return s;
}
});
klipse.ui.editors.editor.get_selection_when_selected = (function klipse$ui$editors$editor$get_selection_when_selected(editor){
var or__3922__auto__ = klipse.ui.editors.editor.get_selection_or_nil.call(null,editor);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return klipse.ui.editors.editor.get_value.call(null,editor);
}
});
klipse.ui.editors.editor.set_value = (function klipse$ui$editors$editor$set_value(editor,value){
editor.setValue(value);

return editor;
});
klipse.ui.editors.editor.on_change = (function klipse$ui$editors$editor$on_change(editor,f){
editor.on("change",f);

return editor;
});
klipse.ui.editors.editor.set_option = (function klipse$ui$editors$editor$set_option(editor,option,value){
editor.setOption(option,value);

return editor;
});
klipse.ui.editors.editor.fix_blank_lines = (function klipse$ui$editors$editor$fix_blank_lines(editor){
return klipse.ui.editors.editor.set_value.call(null,editor,gadjett.collections.fix_blank_lines.call(null,klipse.ui.editors.editor.get_value.call(null,editor)));
});
if(typeof klipse.ui.editors.editor.beautify_language !== 'undefined'){
} else {
klipse.ui.editors.editor.beautify_language = (function (){var method_table__4382__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4383__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4384__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4385__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4386__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"klipse.ui.editors.editor","beautify-language"),((function (method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__,hierarchy__4386__auto__){
return (function (editor,mode){
return mode;
});})(method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__,hierarchy__4386__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4386__auto__,method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__));
})();
}
cljs.core._add_method.call(null,klipse.ui.editors.editor.beautify_language,new cljs.core.Keyword(null,"default","default",-1987822328),(function (editor,_){
return editor;
}));
cljs.core._add_method.call(null,klipse.ui.editors.editor.beautify_language,"text/x-sql",(function (editor,_){
return klipse.ui.editors.editor.set_value.call(null,editor,(function (){var obj_SHARP_ = sqlFormatter;
var fn_SHARP_ = (obj_SHARP_["format"]);
return fn_SHARP_.call(obj_SHARP_,klipse.ui.editors.editor.get_value.call(null,editor));
})());
}));
klipse.ui.editors.editor.fix_comments_lines = (function klipse$ui$editors$editor$fix_comments_lines(editor,mode){
if(cljs.core._EQ_.call(null,"clojure",mode)){
return klipse.ui.editors.editor.set_value.call(null,editor,gadjett.collections.remove_ending_comments.call(null,klipse.ui.editors.editor.get_value.call(null,editor)));
} else {
return editor;
}
});
klipse.ui.editors.editor.do_indent = (function klipse$ui$editors$editor$do_indent(editor){
var obj_SHARP__10681 = editor;
var fn_SHARP__10682 = (obj_SHARP__10681["operation"]);
fn_SHARP__10682.call(obj_SHARP__10681,((function (obj_SHARP__10681,fn_SHARP__10682){
return (function (){
var n__4376__auto__ = (function (){var obj_SHARP___$1 = editor;
var fn_SHARP___$1 = (obj_SHARP___$1["lineCount"]);
return fn_SHARP___$1.call(obj_SHARP___$1);
})();
var line = (0);
while(true){
if((line < n__4376__auto__)){
var obj_SHARP__10683__$1 = editor;
var fn_SHARP__10684__$1 = (obj_SHARP__10683__$1["indentLine"]);
fn_SHARP__10684__$1.call(obj_SHARP__10683__$1,line,"smart");

var G__10685 = (line + (1));
line = G__10685;
continue;
} else {
return null;
}
break;
}
});})(obj_SHARP__10681,fn_SHARP__10682))
);

return editor;
});
klipse.ui.editors.editor.beautify = (function klipse$ui$editors$editor$beautify(editor,mode,p__10686){
var map__10687 = p__10686;
var map__10687__$1 = ((((!((map__10687 == null)))?(((((map__10687.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__10687.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__10687):map__10687);
var indent_QMARK_ = cljs.core.get.call(null,map__10687__$1,new cljs.core.Keyword(null,"indent?","indent?",1381429379));
var remove_ending_comments_QMARK_ = cljs.core.get.call(null,map__10687__$1,new cljs.core.Keyword(null,"remove-ending-comments?","remove-ending-comments?",1247259614));
var $ = editor;
var $__$1 = (cljs.core.truth_(indent_QMARK_)?klipse.ui.editors.editor.do_indent.call(null,$):$);
var $__$2 = klipse.ui.editors.editor.fix_blank_lines.call(null,$__$1);
var $__$3 = (cljs.core.truth_(remove_ending_comments_QMARK_)?klipse.ui.editors.editor.fix_comments_lines.call(null,$__$2,mode):$__$2);
return klipse.ui.editors.editor.beautify_language.call(null,$__$3,mode);
});
klipse.ui.editors.editor.set_value_and_beautify = (function klipse$ui$editors$editor$set_value_and_beautify(editor,mode,value,opts){
return klipse.ui.editors.editor.beautify.call(null,klipse.ui.editors.editor.set_value.call(null,editor,value),mode,opts);
});
klipse.ui.editors.editor.replace_element_by_editor = (function klipse$ui$editors$editor$replace_element_by_editor(var_args){
var args__4502__auto__ = [];
var len__4499__auto___10699 = arguments.length;
var i__4500__auto___10700 = (0);
while(true){
if((i__4500__auto___10700 < len__4499__auto___10699)){
args__4502__auto__.push((arguments[i__4500__auto___10700]));

var G__10701 = (i__4500__auto___10700 + (1));
i__4500__auto___10700 = G__10701;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((3) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((3)),(0),null)):null);
return klipse.ui.editors.editor.replace_element_by_editor.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4503__auto__);
});

klipse.ui.editors.editor.replace_element_by_editor.cljs$core$IFn$_invoke$arity$variadic = (function (element,value,p__10693,p__10694){
var map__10695 = p__10693;
var map__10695__$1 = ((((!((map__10695 == null)))?(((((map__10695.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__10695.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__10695):map__10695);
var opts = map__10695__$1;
var mode = cljs.core.get.call(null,map__10695__$1,new cljs.core.Keyword(null,"mode","mode",654403691));
var map__10696 = p__10694;
var map__10696__$1 = ((((!((map__10696 == null)))?(((((map__10696.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__10696.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__10696):map__10696);
var klass = cljs.core.get.call(null,map__10696__$1,new cljs.core.Keyword(null,"klass","klass",-1386752349));
var indent_QMARK_ = cljs.core.get.call(null,map__10696__$1,new cljs.core.Keyword(null,"indent?","indent?",1381429379),true);
var remove_ending_comments_QMARK_ = cljs.core.get.call(null,map__10696__$1,new cljs.core.Keyword(null,"remove-ending-comments?","remove-ending-comments?",1247259614),true);
var editor = CodeMirror(((function (map__10695,map__10695__$1,opts,mode,map__10696,map__10696__$1,klass,indent_QMARK_,remove_ending_comments_QMARK_){
return (function (elt){
if(cljs.core.not.call(null,klass)){
return goog.dom.replaceNode(elt,element);
} else {
var wrapping_div = goog.dom.createElement("div");
goog.dom.appendChild(wrapping_div,elt);

goog.dom.replaceNode(wrapping_div,element);

return klipse.dom_utils.add_class.call(null,wrapping_div,klass);
}
});})(map__10695,map__10695__$1,opts,mode,map__10696,map__10696__$1,klass,indent_QMARK_,remove_ending_comments_QMARK_))
,cljs.core.clj__GT_js.call(null,opts));
return klipse.ui.editors.editor.beautify.call(null,klipse.ui.editors.editor.set_value.call(null,editor,value),mode,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"indent?","indent?",1381429379),indent_QMARK_,new cljs.core.Keyword(null,"remove-ending-comments?","remove-ending-comments?",1247259614),remove_ending_comments_QMARK_], null));
});

klipse.ui.editors.editor.replace_element_by_editor.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
klipse.ui.editors.editor.replace_element_by_editor.cljs$lang$applyTo = (function (seq10689){
var G__10690 = cljs.core.first.call(null,seq10689);
var seq10689__$1 = cljs.core.next.call(null,seq10689);
var G__10691 = cljs.core.first.call(null,seq10689__$1);
var seq10689__$2 = cljs.core.next.call(null,seq10689__$1);
var G__10692 = cljs.core.first.call(null,seq10689__$2);
var seq10689__$3 = cljs.core.next.call(null,seq10689__$2);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__10690,G__10691,G__10692,seq10689__$3);
});

klipse.ui.editors.editor.replace_id_by_editor = (function klipse$ui$editors$editor$replace_id_by_editor(var_args){
var args__4502__auto__ = [];
var len__4499__auto___10705 = arguments.length;
var i__4500__auto___10706 = (0);
while(true){
if((i__4500__auto___10706 < len__4499__auto___10705)){
args__4502__auto__.push((arguments[i__4500__auto___10706]));

var G__10707 = (i__4500__auto___10706 + (1));
i__4500__auto___10706 = G__10707;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((2) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((2)),(0),null)):null);
return klipse.ui.editors.editor.replace_id_by_editor.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4503__auto__);
});

klipse.ui.editors.editor.replace_id_by_editor.cljs$core$IFn$_invoke$arity$variadic = (function (id,cm_opts,more_opts){
var element = goog.dom.getElement(id);
var value = (element["textContent"]);
return cljs.core.apply.call(null,klipse.ui.editors.editor.replace_element_by_editor,element,value,cm_opts,more_opts);
});

klipse.ui.editors.editor.replace_id_by_editor.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
klipse.ui.editors.editor.replace_id_by_editor.cljs$lang$applyTo = (function (seq10702){
var G__10703 = cljs.core.first.call(null,seq10702);
var seq10702__$1 = cljs.core.next.call(null,seq10702);
var G__10704 = cljs.core.first.call(null,seq10702__$1);
var seq10702__$2 = cljs.core.next.call(null,seq10702__$1);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__10703,G__10704,seq10702__$2);
});

klipse.ui.editors.editor.create_editor_after_element = (function klipse$ui$editors$editor$create_editor_after_element(var_args){
var args__4502__auto__ = [];
var len__4499__auto___10715 = arguments.length;
var i__4500__auto___10716 = (0);
while(true){
if((i__4500__auto___10716 < len__4499__auto___10715)){
args__4502__auto__.push((arguments[i__4500__auto___10716]));

var G__10717 = (i__4500__auto___10716 + (1));
i__4500__auto___10716 = G__10717;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((3) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((3)),(0),null)):null);
return klipse.ui.editors.editor.create_editor_after_element.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4503__auto__);
});

klipse.ui.editors.editor.create_editor_after_element.cljs$core$IFn$_invoke$arity$variadic = (function (element,value,opts,p__10712){
var map__10713 = p__10712;
var map__10713__$1 = ((((!((map__10713 == null)))?(((((map__10713.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__10713.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__10713):map__10713);
var klass = cljs.core.get.call(null,map__10713__$1,new cljs.core.Keyword(null,"klass","klass",-1386752349));
var remove_ending_comments_QMARK_ = cljs.core.get.call(null,map__10713__$1,new cljs.core.Keyword(null,"remove-ending-comments?","remove-ending-comments?",1247259614),false);
var indent_QMARK_ = cljs.core.get.call(null,map__10713__$1,new cljs.core.Keyword(null,"indent?","indent?",1381429379),false);
return klipse.ui.editors.editor.replace_element_by_editor.call(null,klipse.dom_utils.create_div_after.call(null,element,cljs.core.PersistentArrayMap.EMPTY),value,opts,new cljs.core.Keyword(null,"remove-ending-comments?","remove-ending-comments?",1247259614),remove_ending_comments_QMARK_,new cljs.core.Keyword(null,"indent?","indent?",1381429379),indent_QMARK_,new cljs.core.Keyword(null,"klass","klass",-1386752349),klass);
});

klipse.ui.editors.editor.create_editor_after_element.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
klipse.ui.editors.editor.create_editor_after_element.cljs$lang$applyTo = (function (seq10708){
var G__10709 = cljs.core.first.call(null,seq10708);
var seq10708__$1 = cljs.core.next.call(null,seq10708);
var G__10710 = cljs.core.first.call(null,seq10708__$1);
var seq10708__$2 = cljs.core.next.call(null,seq10708__$1);
var G__10711 = cljs.core.first.call(null,seq10708__$2);
var seq10708__$3 = cljs.core.next.call(null,seq10708__$2);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__10709,G__10710,G__10711,seq10708__$3);
});


//# sourceMappingURL=editor.js.map
