// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('klipse.utils');
goog.require('cljs.core');
goog.require('cljs.reader');
goog.require('clojure.walk');
goog.require('cljs_http.client');
goog.require('cljs.core.async');
goog.require('cemerick.url');
klipse.utils.current_url = (function klipse$utils$current_url(){
var temp__6751__auto__ = ((typeof location !== 'undefined')?location:"");
if(cljs.core.truth_(temp__6751__auto__)){
var loc = temp__6751__auto__;
return cemerick.url.url.call(null,(loc["href"]));
} else {
return null;
}
});
klipse.utils.url_parameters_STAR_ = (function klipse$utils$url_parameters_STAR_(){
return clojure.walk.keywordize_keys.call(null,new cljs.core.Keyword(null,"query","query",-1288509510).cljs$core$IFn$_invoke$arity$1(klipse.utils.current_url.call(null)));
});
klipse.utils.url_parameters = cljs.core.memoize.call(null,klipse.utils.url_parameters_STAR_);
/**
 * Returns the current url with an additional parameter.
 *   If the parameter already exists, it is overridden.
 */
klipse.utils.add_url_parameter = (function klipse$utils$add_url_parameter(base_url,key,value){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.assoc_in.call(null,base_url,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"query","query",-1288509510),cljs.core.name.call(null,key)], null),value))].join('');
});
klipse.utils.create_url_with_input = (function klipse$utils$create_url_with_input(base_url,input){
return klipse.utils.add_url_parameter.call(null,(cljs.core.truth_(base_url)?cemerick.url.url.call(null,base_url):klipse.utils.current_url.call(null)),new cljs.core.Keyword(null,"cljs_in","cljs_in",1284321894),input);
});
klipse.utils.debounce = (function klipse$utils$debounce(func,wait_in_ms){
var counter = cljs.core.atom.call(null,(0));
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [((function (counter){
return (function (){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,counter){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,counter){
return (function (state_27908){
var state_val_27909 = (state_27908[(1)]);
if((state_val_27909 === (1))){
var inst_27895 = cljs.core.swap_BANG_.call(null,counter,cljs.core.inc);
var inst_27896 = cljs.core.async.timeout.call(null,wait_in_ms);
var state_27908__$1 = (function (){var statearr_27910 = state_27908;
(statearr_27910[(7)] = inst_27895);

return statearr_27910;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27908__$1,(2),inst_27896);
} else {
if((state_val_27909 === (2))){
var inst_27898 = (state_27908[(2)]);
var inst_27899 = cljs.core.swap_BANG_.call(null,counter,cljs.core.dec);
var inst_27900 = cljs.core.deref.call(null,counter);
var inst_27901 = (inst_27900 === (0));
var state_27908__$1 = (function (){var statearr_27911 = state_27908;
(statearr_27911[(8)] = inst_27898);

(statearr_27911[(9)] = inst_27899);

return statearr_27911;
})();
if(cljs.core.truth_(inst_27901)){
var statearr_27912_27935 = state_27908__$1;
(statearr_27912_27935[(1)] = (3));

} else {
var statearr_27913_27936 = state_27908__$1;
(statearr_27913_27936[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27909 === (3))){
var inst_27903 = func.call(null);
var state_27908__$1 = state_27908;
var statearr_27914_27937 = state_27908__$1;
(statearr_27914_27937[(2)] = inst_27903);

(statearr_27914_27937[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27909 === (4))){
var state_27908__$1 = state_27908;
var statearr_27915_27938 = state_27908__$1;
(statearr_27915_27938[(2)] = null);

(statearr_27915_27938[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27909 === (5))){
var inst_27906 = (state_27908[(2)]);
var state_27908__$1 = state_27908;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27908__$1,inst_27906);
} else {
return null;
}
}
}
}
}
});})(c__3451__auto__,counter))
;
return ((function (switch__3428__auto__,c__3451__auto__,counter){
return (function() {
var klipse$utils$debounce_$_state_machine__3429__auto__ = null;
var klipse$utils$debounce_$_state_machine__3429__auto____0 = (function (){
var statearr_27916 = [null,null,null,null,null,null,null,null,null,null];
(statearr_27916[(0)] = klipse$utils$debounce_$_state_machine__3429__auto__);

(statearr_27916[(1)] = (1));

return statearr_27916;
});
var klipse$utils$debounce_$_state_machine__3429__auto____1 = (function (state_27908){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_27908);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e27917){if((e27917 instanceof Object)){
var ex__3432__auto__ = e27917;
var statearr_27918_27939 = state_27908;
(statearr_27918_27939[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_27908);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e27917;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27940 = state_27908;
state_27908 = G__27940;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$debounce_$_state_machine__3429__auto__ = function(state_27908){
switch(arguments.length){
case 0:
return klipse$utils$debounce_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$debounce_$_state_machine__3429__auto____1.call(this,state_27908);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$debounce_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$debounce_$_state_machine__3429__auto____0;
klipse$utils$debounce_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$debounce_$_state_machine__3429__auto____1;
return klipse$utils$debounce_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,counter))
})();
var state__3453__auto__ = (function (){var statearr_27919 = f__3452__auto__.call(null);
(statearr_27919[(6)] = c__3451__auto__);

return statearr_27919;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,counter))
);

return c__3451__auto__;
});})(counter))
,((function (counter){
return (function (){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,counter){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,counter){
return (function (state_27927){
var state_val_27928 = (state_27927[(1)]);
if((state_val_27928 === (1))){
var inst_27920 = func.call(null);
var inst_27921 = cljs.core.swap_BANG_.call(null,counter,cljs.core.inc);
var inst_27922 = cljs.core.async.timeout.call(null,wait_in_ms);
var state_27927__$1 = (function (){var statearr_27929 = state_27927;
(statearr_27929[(7)] = inst_27921);

(statearr_27929[(8)] = inst_27920);

return statearr_27929;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27927__$1,(2),inst_27922);
} else {
if((state_val_27928 === (2))){
var inst_27924 = (state_27927[(2)]);
var inst_27925 = cljs.core.swap_BANG_.call(null,counter,cljs.core.dec);
var state_27927__$1 = (function (){var statearr_27930 = state_27927;
(statearr_27930[(9)] = inst_27924);

return statearr_27930;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27927__$1,inst_27925);
} else {
return null;
}
}
});})(c__3451__auto__,counter))
;
return ((function (switch__3428__auto__,c__3451__auto__,counter){
return (function() {
var klipse$utils$debounce_$_state_machine__3429__auto__ = null;
var klipse$utils$debounce_$_state_machine__3429__auto____0 = (function (){
var statearr_27931 = [null,null,null,null,null,null,null,null,null,null];
(statearr_27931[(0)] = klipse$utils$debounce_$_state_machine__3429__auto__);

(statearr_27931[(1)] = (1));

return statearr_27931;
});
var klipse$utils$debounce_$_state_machine__3429__auto____1 = (function (state_27927){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_27927);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e27932){if((e27932 instanceof Object)){
var ex__3432__auto__ = e27932;
var statearr_27933_27941 = state_27927;
(statearr_27933_27941[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_27927);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e27932;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27942 = state_27927;
state_27927 = G__27942;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$debounce_$_state_machine__3429__auto__ = function(state_27927){
switch(arguments.length){
case 0:
return klipse$utils$debounce_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$debounce_$_state_machine__3429__auto____1.call(this,state_27927);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$debounce_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$debounce_$_state_machine__3429__auto____0;
klipse$utils$debounce_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$debounce_$_state_machine__3429__auto____1;
return klipse$utils$debounce_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,counter))
})();
var state__3453__auto__ = (function (){var statearr_27934 = f__3452__auto__.call(null);
(statearr_27934[(6)] = c__3451__auto__);

return statearr_27934;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,counter))
);

return c__3451__auto__;
});})(counter))
], null);
});
klipse.utils.gist_path_raw = (function klipse$utils$gist_path_raw(gist_id){
return ["https://gist.githubusercontent.com/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(gist_id),"/raw","?",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.call(null))].join('');
});
klipse.utils.gist_path_page = (function klipse$utils$gist_path_page(gist_id){
return ["https://gist.github.com/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(gist_id)].join('');
});
klipse.utils.read_input_from_gist = (function klipse$utils$read_input_from_gist(gist_id){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__){
return (function (state_27986){
var state_val_27987 = (state_27986[(1)]);
if((state_val_27987 === (7))){
var state_27986__$1 = state_27986;
var statearr_27988_28015 = state_27986__$1;
(statearr_27988_28015[(2)] = false);

(statearr_27988_28015[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (1))){
var state_27986__$1 = state_27986;
if(cljs.core.truth_(gist_id)){
var statearr_27989_28016 = state_27986__$1;
(statearr_27989_28016[(1)] = (2));

} else {
var statearr_27990_28017 = state_27986__$1;
(statearr_27990_28017[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (4))){
var inst_27984 = (state_27986[(2)]);
var state_27986__$1 = state_27986;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27986__$1,inst_27984);
} else {
if((state_val_27987 === (15))){
var inst_27973 = (state_27986[(7)]);
var inst_27945 = (state_27986[(8)]);
var inst_27978 = ["\"","Wrong gist path: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_27945),"\n","gist-id= ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(gist_id),"\n","http status: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_27973),"\""].join('');
var state_27986__$1 = state_27986;
var statearr_27991_28018 = state_27986__$1;
(statearr_27991_28018[(2)] = inst_27978);

(statearr_27991_28018[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (13))){
var inst_27951 = (state_27986[(9)]);
var state_27986__$1 = state_27986;
var statearr_27992_28019 = state_27986__$1;
(statearr_27992_28019[(2)] = inst_27951);

(statearr_27992_28019[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (6))){
var inst_27951 = (state_27986[(9)]);
var inst_27956 = inst_27951.cljs$lang$protocol_mask$partition0$;
var inst_27957 = (inst_27956 & (64));
var inst_27958 = inst_27951.cljs$core$ISeq$;
var inst_27959 = (cljs.core.PROTOCOL_SENTINEL === inst_27958);
var inst_27960 = ((inst_27957) || (inst_27959));
var state_27986__$1 = state_27986;
if(cljs.core.truth_(inst_27960)){
var statearr_27993_28020 = state_27986__$1;
(statearr_27993_28020[(1)] = (9));

} else {
var statearr_27994_28021 = state_27986__$1;
(statearr_27994_28021[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (17))){
var inst_27981 = (state_27986[(2)]);
var state_27986__$1 = state_27986;
var statearr_27995_28022 = state_27986__$1;
(statearr_27995_28022[(2)] = inst_27981);

(statearr_27995_28022[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (3))){
var state_27986__$1 = state_27986;
var statearr_27996_28023 = state_27986__$1;
(statearr_27996_28023[(2)] = null);

(statearr_27996_28023[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (12))){
var inst_27951 = (state_27986[(9)]);
var inst_27969 = cljs.core.apply.call(null,cljs.core.hash_map,inst_27951);
var state_27986__$1 = state_27986;
var statearr_27997_28024 = state_27986__$1;
(statearr_27997_28024[(2)] = inst_27969);

(statearr_27997_28024[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (2))){
var inst_27945 = (state_27986[(8)]);
var inst_27945__$1 = klipse.utils.gist_path_raw.call(null,gist_id);
var inst_27946 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_27947 = [false];
var inst_27948 = cljs.core.PersistentHashMap.fromArrays(inst_27946,inst_27947);
var inst_27949 = cljs_http.client.get.call(null,inst_27945__$1,inst_27948);
var state_27986__$1 = (function (){var statearr_27998 = state_27986;
(statearr_27998[(8)] = inst_27945__$1);

return statearr_27998;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27986__$1,(5),inst_27949);
} else {
if((state_val_27987 === (11))){
var inst_27964 = (state_27986[(2)]);
var state_27986__$1 = state_27986;
var statearr_27999_28025 = state_27986__$1;
(statearr_27999_28025[(2)] = inst_27964);

(statearr_27999_28025[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (9))){
var state_27986__$1 = state_27986;
var statearr_28000_28026 = state_27986__$1;
(statearr_28000_28026[(2)] = true);

(statearr_28000_28026[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (5))){
var inst_27951 = (state_27986[(9)]);
var inst_27951__$1 = (state_27986[(2)]);
var inst_27953 = (inst_27951__$1 == null);
var inst_27954 = cljs.core.not.call(null,inst_27953);
var state_27986__$1 = (function (){var statearr_28001 = state_27986;
(statearr_28001[(9)] = inst_27951__$1);

return statearr_28001;
})();
if(inst_27954){
var statearr_28002_28027 = state_27986__$1;
(statearr_28002_28027[(1)] = (6));

} else {
var statearr_28003_28028 = state_27986__$1;
(statearr_28003_28028[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (14))){
var inst_27973 = (state_27986[(7)]);
var inst_27972 = (state_27986[(2)]);
var inst_27973__$1 = cljs.core.get.call(null,inst_27972,new cljs.core.Keyword(null,"status","status",-1997798413));
var inst_27974 = cljs.core.get.call(null,inst_27972,new cljs.core.Keyword(null,"body","body",-2049205669));
var inst_27975 = cljs.core._EQ_.call(null,inst_27973__$1,(200));
var inst_27976 = !(inst_27975);
var state_27986__$1 = (function (){var statearr_28004 = state_27986;
(statearr_28004[(10)] = inst_27974);

(statearr_28004[(7)] = inst_27973__$1);

return statearr_28004;
})();
if(inst_27976){
var statearr_28005_28029 = state_27986__$1;
(statearr_28005_28029[(1)] = (15));

} else {
var statearr_28006_28030 = state_27986__$1;
(statearr_28006_28030[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (16))){
var inst_27974 = (state_27986[(10)]);
var state_27986__$1 = state_27986;
var statearr_28007_28031 = state_27986__$1;
(statearr_28007_28031[(2)] = inst_27974);

(statearr_28007_28031[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (10))){
var state_27986__$1 = state_27986;
var statearr_28008_28032 = state_27986__$1;
(statearr_28008_28032[(2)] = false);

(statearr_28008_28032[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27987 === (8))){
var inst_27967 = (state_27986[(2)]);
var state_27986__$1 = state_27986;
if(cljs.core.truth_(inst_27967)){
var statearr_28009_28033 = state_27986__$1;
(statearr_28009_28033[(1)] = (12));

} else {
var statearr_28010_28034 = state_27986__$1;
(statearr_28010_28034[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__))
;
return ((function (switch__3428__auto__,c__3451__auto__){
return (function() {
var klipse$utils$read_input_from_gist_$_state_machine__3429__auto__ = null;
var klipse$utils$read_input_from_gist_$_state_machine__3429__auto____0 = (function (){
var statearr_28011 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_28011[(0)] = klipse$utils$read_input_from_gist_$_state_machine__3429__auto__);

(statearr_28011[(1)] = (1));

return statearr_28011;
});
var klipse$utils$read_input_from_gist_$_state_machine__3429__auto____1 = (function (state_27986){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_27986);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e28012){if((e28012 instanceof Object)){
var ex__3432__auto__ = e28012;
var statearr_28013_28035 = state_27986;
(statearr_28013_28035[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_27986);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28012;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28036 = state_27986;
state_27986 = G__28036;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$read_input_from_gist_$_state_machine__3429__auto__ = function(state_27986){
switch(arguments.length){
case 0:
return klipse$utils$read_input_from_gist_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$read_input_from_gist_$_state_machine__3429__auto____1.call(this,state_27986);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$read_input_from_gist_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$read_input_from_gist_$_state_machine__3429__auto____0;
klipse$utils$read_input_from_gist_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$read_input_from_gist_$_state_machine__3429__auto____1;
return klipse$utils$read_input_from_gist_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__))
})();
var state__3453__auto__ = (function (){var statearr_28014 = f__3452__auto__.call(null);
(statearr_28014[(6)] = c__3451__auto__);

return statearr_28014;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__))
);

return c__3451__auto__;
});
klipse.utils.runonce = (function klipse$utils$runonce(f){
var ran = cljs.core.atom.call(null,false);
return ((function (ran){
return (function() { 
var G__28037__delegate = function (args){
if(cljs.core.truth_(cljs.core.deref.call(null,ran))){
return null;
} else {
cljs.core.reset_BANG_.call(null,ran,true);

return cljs.core.apply.call(null,f,args);
}
};
var G__28037 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__28038__i = 0, G__28038__a = new Array(arguments.length -  0);
while (G__28038__i < G__28038__a.length) {G__28038__a[G__28038__i] = arguments[G__28038__i + 0]; ++G__28038__i;}
  args = new cljs.core.IndexedSeq(G__28038__a,0,null);
} 
return G__28037__delegate.call(this,args);};
G__28037.cljs$lang$maxFixedArity = 0;
G__28037.cljs$lang$applyTo = (function (arglist__28039){
var args = cljs.core.seq(arglist__28039);
return G__28037__delegate(args);
});
G__28037.cljs$core$IFn$_invoke$arity$variadic = G__28037__delegate;
return G__28037;
})()
;
;})(ran))
});
/**
 * Returns a function that will run `f` only once.
 *   If `f` succeeds (returns [:ok & args]), on subsequent calls it will return [:ok].
 *   `f` must return a channel.
 */
klipse.utils.runonce_async = (function klipse$utils$runonce_async(f){
var ran = cljs.core.atom.call(null,false);
return ((function (ran){
return (function() { 
var G__28076__delegate = function (args){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,ran){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,ran){
return (function (state_28060){
var state_val_28061 = (state_28060[(1)]);
if((state_val_28061 === (1))){
var inst_28040 = cljs.core.deref.call(null,ran);
var inst_28041 = cljs.core.not.call(null,inst_28040);
var state_28060__$1 = state_28060;
if(inst_28041){
var statearr_28062_28077 = state_28060__$1;
(statearr_28062_28077[(1)] = (2));

} else {
var statearr_28063_28078 = state_28060__$1;
(statearr_28063_28078[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28061 === (2))){
var inst_28043 = cljs.core.apply.call(null,f,args);
var state_28060__$1 = state_28060;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28060__$1,(5),inst_28043);
} else {
if((state_val_28061 === (3))){
var inst_28054 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_28055 = [new cljs.core.Keyword(null,"ok","ok",967785236)];
var inst_28056 = (new cljs.core.PersistentVector(null,1,(5),inst_28054,inst_28055,null));
var state_28060__$1 = state_28060;
var statearr_28064_28079 = state_28060__$1;
(statearr_28064_28079[(2)] = inst_28056);

(statearr_28064_28079[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28061 === (4))){
var inst_28058 = (state_28060[(2)]);
var state_28060__$1 = state_28060;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28060__$1,inst_28058);
} else {
if((state_val_28061 === (5))){
var inst_28045 = (state_28060[(7)]);
var inst_28045__$1 = (state_28060[(2)]);
var inst_28046 = cljs.core.first.call(null,inst_28045__$1);
var inst_28047 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_28046);
var state_28060__$1 = (function (){var statearr_28065 = state_28060;
(statearr_28065[(7)] = inst_28045__$1);

return statearr_28065;
})();
if(inst_28047){
var statearr_28066_28080 = state_28060__$1;
(statearr_28066_28080[(1)] = (6));

} else {
var statearr_28067_28081 = state_28060__$1;
(statearr_28067_28081[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28061 === (6))){
var inst_28049 = cljs.core.reset_BANG_.call(null,ran,true);
var state_28060__$1 = state_28060;
var statearr_28068_28082 = state_28060__$1;
(statearr_28068_28082[(2)] = inst_28049);

(statearr_28068_28082[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28061 === (7))){
var state_28060__$1 = state_28060;
var statearr_28069_28083 = state_28060__$1;
(statearr_28069_28083[(2)] = null);

(statearr_28069_28083[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28061 === (8))){
var inst_28045 = (state_28060[(7)]);
var inst_28052 = (state_28060[(2)]);
var state_28060__$1 = (function (){var statearr_28070 = state_28060;
(statearr_28070[(8)] = inst_28052);

return statearr_28070;
})();
var statearr_28071_28084 = state_28060__$1;
(statearr_28071_28084[(2)] = inst_28045);

(statearr_28071_28084[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__3451__auto__,ran))
;
return ((function (switch__3428__auto__,c__3451__auto__,ran){
return (function() {
var klipse$utils$runonce_async_$_state_machine__3429__auto__ = null;
var klipse$utils$runonce_async_$_state_machine__3429__auto____0 = (function (){
var statearr_28072 = [null,null,null,null,null,null,null,null,null];
(statearr_28072[(0)] = klipse$utils$runonce_async_$_state_machine__3429__auto__);

(statearr_28072[(1)] = (1));

return statearr_28072;
});
var klipse$utils$runonce_async_$_state_machine__3429__auto____1 = (function (state_28060){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_28060);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e28073){if((e28073 instanceof Object)){
var ex__3432__auto__ = e28073;
var statearr_28074_28085 = state_28060;
(statearr_28074_28085[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28060);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28073;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28086 = state_28060;
state_28060 = G__28086;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$runonce_async_$_state_machine__3429__auto__ = function(state_28060){
switch(arguments.length){
case 0:
return klipse$utils$runonce_async_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$runonce_async_$_state_machine__3429__auto____1.call(this,state_28060);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$runonce_async_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$runonce_async_$_state_machine__3429__auto____0;
klipse$utils$runonce_async_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$runonce_async_$_state_machine__3429__auto____1;
return klipse$utils$runonce_async_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,ran))
})();
var state__3453__auto__ = (function (){var statearr_28075 = f__3452__auto__.call(null);
(statearr_28075[(6)] = c__3451__auto__);

return statearr_28075;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,ran))
);

return c__3451__auto__;
};
var G__28076 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__28087__i = 0, G__28087__a = new Array(arguments.length -  0);
while (G__28087__i < G__28087__a.length) {G__28087__a[G__28087__i] = arguments[G__28087__i + 0]; ++G__28087__i;}
  args = new cljs.core.IndexedSeq(G__28087__a,0,null);
} 
return G__28076__delegate.call(this,args);};
G__28076.cljs$lang$maxFixedArity = 0;
G__28076.cljs$lang$applyTo = (function (arglist__28088){
var args = cljs.core.seq(arglist__28088);
return G__28076__delegate(args);
});
G__28076.cljs$core$IFn$_invoke$arity$variadic = G__28076__delegate;
return G__28076;
})()
;
;})(ran))
});
/**
 * Returns a memoized version of f.
 *   If `f` succeeds (returns [:ok & args]), on subsequent calls it will return the cached results.
 *   `f` must return a channel.
 */
klipse.utils.memoize_async = (function klipse$utils$memoize_async(f){
var ran = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
return ((function (ran){
return (function() { 
var G__28125__delegate = function (args){
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,ran){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,ran){
return (function (state_28109){
var state_val_28110 = (state_28109[(1)]);
if((state_val_28110 === (1))){
var inst_28089 = cljs.core.deref.call(null,ran);
var inst_28090 = cljs.core.contains_QMARK_.call(null,inst_28089,args);
var inst_28091 = !(inst_28090);
var state_28109__$1 = state_28109;
if(inst_28091){
var statearr_28111_28126 = state_28109__$1;
(statearr_28111_28126[(1)] = (2));

} else {
var statearr_28112_28127 = state_28109__$1;
(statearr_28112_28127[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28110 === (2))){
var inst_28093 = cljs.core.apply.call(null,f,args);
var state_28109__$1 = state_28109;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28109__$1,(5),inst_28093);
} else {
if((state_val_28110 === (3))){
var inst_28104 = cljs.core.deref.call(null,ran);
var inst_28105 = cljs.core.get.call(null,inst_28104,args);
var state_28109__$1 = state_28109;
var statearr_28113_28128 = state_28109__$1;
(statearr_28113_28128[(2)] = inst_28105);

(statearr_28113_28128[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28110 === (4))){
var inst_28107 = (state_28109[(2)]);
var state_28109__$1 = state_28109;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28109__$1,inst_28107);
} else {
if((state_val_28110 === (5))){
var inst_28095 = (state_28109[(7)]);
var inst_28095__$1 = (state_28109[(2)]);
var inst_28096 = cljs.core.first.call(null,inst_28095__$1);
var inst_28097 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_28096);
var state_28109__$1 = (function (){var statearr_28114 = state_28109;
(statearr_28114[(7)] = inst_28095__$1);

return statearr_28114;
})();
if(inst_28097){
var statearr_28115_28129 = state_28109__$1;
(statearr_28115_28129[(1)] = (6));

} else {
var statearr_28116_28130 = state_28109__$1;
(statearr_28116_28130[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28110 === (6))){
var inst_28095 = (state_28109[(7)]);
var inst_28099 = cljs.core.swap_BANG_.call(null,ran,cljs.core.assoc,args,inst_28095);
var state_28109__$1 = state_28109;
var statearr_28117_28131 = state_28109__$1;
(statearr_28117_28131[(2)] = inst_28099);

(statearr_28117_28131[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28110 === (7))){
var state_28109__$1 = state_28109;
var statearr_28118_28132 = state_28109__$1;
(statearr_28118_28132[(2)] = null);

(statearr_28118_28132[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28110 === (8))){
var inst_28095 = (state_28109[(7)]);
var inst_28102 = (state_28109[(2)]);
var state_28109__$1 = (function (){var statearr_28119 = state_28109;
(statearr_28119[(8)] = inst_28102);

return statearr_28119;
})();
var statearr_28120_28133 = state_28109__$1;
(statearr_28120_28133[(2)] = inst_28095);

(statearr_28120_28133[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__3451__auto__,ran))
;
return ((function (switch__3428__auto__,c__3451__auto__,ran){
return (function() {
var klipse$utils$memoize_async_$_state_machine__3429__auto__ = null;
var klipse$utils$memoize_async_$_state_machine__3429__auto____0 = (function (){
var statearr_28121 = [null,null,null,null,null,null,null,null,null];
(statearr_28121[(0)] = klipse$utils$memoize_async_$_state_machine__3429__auto__);

(statearr_28121[(1)] = (1));

return statearr_28121;
});
var klipse$utils$memoize_async_$_state_machine__3429__auto____1 = (function (state_28109){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_28109);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e28122){if((e28122 instanceof Object)){
var ex__3432__auto__ = e28122;
var statearr_28123_28134 = state_28109;
(statearr_28123_28134[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28109);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28122;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28135 = state_28109;
state_28109 = G__28135;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$memoize_async_$_state_machine__3429__auto__ = function(state_28109){
switch(arguments.length){
case 0:
return klipse$utils$memoize_async_$_state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$memoize_async_$_state_machine__3429__auto____1.call(this,state_28109);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$memoize_async_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$memoize_async_$_state_machine__3429__auto____0;
klipse$utils$memoize_async_$_state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$memoize_async_$_state_machine__3429__auto____1;
return klipse$utils$memoize_async_$_state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,ran))
})();
var state__3453__auto__ = (function (){var statearr_28124 = f__3452__auto__.call(null);
(statearr_28124[(6)] = c__3451__auto__);

return statearr_28124;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,ran))
);

return c__3451__auto__;
};
var G__28125 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__28136__i = 0, G__28136__a = new Array(arguments.length -  0);
while (G__28136__i < G__28136__a.length) {G__28136__a[G__28136__i] = arguments[G__28136__i + 0]; ++G__28136__i;}
  args = new cljs.core.IndexedSeq(G__28136__a,0,null);
} 
return G__28125__delegate.call(this,args);};
G__28125.cljs$lang$maxFixedArity = 0;
G__28125.cljs$lang$applyTo = (function (arglist__28137){
var args = cljs.core.seq(arglist__28137);
return G__28125__delegate(args);
});
G__28125.cljs$core$IFn$_invoke$arity$variadic = G__28125__delegate;
return G__28125;
})()
;
;})(ran))
});
klipse.utils.default_permitted_symbols = (function klipse$utils$default_permitted_symbols(){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, ["console","setTimeout","setInterval","Math","Date"], null);
});
klipse.utils.default_forbidden_symbols = (function klipse$utils$default_forbidden_symbols(){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, ["document","XMLHttpRequest","eval","window","Function"], null);
});
klipse.utils.secured_eval = false;
klipse.utils.eval_in_global_scope = eval;
klipse.utils.securize_eval_BANG__STAR_ = (function klipse$utils$securize_eval_BANG__STAR_(the_forbidden_symbols){
klipse.utils.secured_eval = true;

var original_eval = eval;
var o_SHARP__28138 = window;
(o_SHARP__28138["eval"] = ((function (o_SHARP__28138,original_eval){
return (function (src){
return original_eval.call(null,["with (klipse_eval_sandbox){ ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(src),"}"].join(''));
});})(o_SHARP__28138,original_eval))
);


klipse.utils.eval_in_global_scope = eval;

var o_SHARP__28139 = window;
(o_SHARP__28139["klipse_unsecured_eval"] = original_eval);


var o_SHARP_ = window;
(o_SHARP_["klipse_eval_sandbox"] = cljs.core.clj__GT_js.call(null,cljs.core.zipmap.call(null,the_forbidden_symbols,cljs.core.repeat.call(null,cljs.core.PersistentArrayMap.EMPTY))));

return o_SHARP_;
});
klipse.utils.securize_eval_BANG_ = klipse.utils.runonce.call(null,klipse.utils.securize_eval_BANG__STAR_);
klipse.utils.setup_container_BANG_ = (function klipse$utils$setup_container_BANG_(container_id){
if(klipse.utils.secured_eval){
return null;
} else {
(window["klipse_container"] = document.getElementById(container_id));

return (window["klipse_container_id"] = container_id);
}
});
klipse.utils.unsecured_eval_in_global_scope = (function klipse$utils$unsecured_eval_in_global_scope(s){
return (function (){var or__3922__auto__ = (window["klipse_unsecured_eval"]);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return eval;
}
})().call(null,s);
});
klipse.utils.load_script = (function klipse$utils$load_script(var_args){
var args__4502__auto__ = [];
var len__4499__auto___28227 = arguments.length;
var i__4500__auto___28228 = (0);
while(true){
if((i__4500__auto___28228 < len__4499__auto___28227)){
args__4502__auto__.push((arguments[i__4500__auto___28228]));

var G__28229 = (i__4500__auto___28228 + (1));
i__4500__auto___28228 = G__28229;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((1) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((1)),(0),null)):null);
return klipse.utils.load_script.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4503__auto__);
});

klipse.utils.load_script.cljs$core$IFn$_invoke$arity$variadic = (function (script,p__28142){
var map__28143 = p__28142;
var map__28143__$1 = ((((!((map__28143 == null)))?(((((map__28143.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__28143.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__28143):map__28143);
var secured_eval_QMARK_ = cljs.core.get.call(null,map__28143__$1,new cljs.core.Keyword(null,"secured-eval?","secured-eval?",-922170059),false);
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,map__28143,map__28143__$1,secured_eval_QMARK_){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,map__28143,map__28143__$1,secured_eval_QMARK_){
return (function (state_28196){
var state_val_28197 = (state_28196[(1)]);
if((state_val_28197 === (7))){
var state_28196__$1 = state_28196;
var statearr_28198_28230 = state_28196__$1;
(statearr_28198_28230[(2)] = false);

(statearr_28198_28230[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (1))){
var inst_28145 = console.info("loading:",script);
var inst_28147 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_28148 = [false];
var inst_28149 = cljs.core.PersistentHashMap.fromArrays(inst_28147,inst_28148);
var inst_28150 = cljs_http.client.get.call(null,script,inst_28149);
var state_28196__$1 = (function (){var statearr_28199 = state_28196;
(statearr_28199[(7)] = inst_28145);

return statearr_28199;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28196__$1,(2),inst_28150);
} else {
if((state_val_28197 === (4))){
var state_28196__$1 = state_28196;
var statearr_28200_28231 = state_28196__$1;
(statearr_28200_28231[(2)] = false);

(statearr_28200_28231[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (15))){
var inst_28175 = (state_28196[(8)]);
var inst_28180 = klipse.utils.eval_in_global_scope.call(null,inst_28175);
var state_28196__$1 = state_28196;
var statearr_28201_28232 = state_28196__$1;
(statearr_28201_28232[(2)] = inst_28180);

(statearr_28201_28232[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (13))){
var inst_28174 = (state_28196[(9)]);
var inst_28190 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_28191 = [inst_28174,script];
var inst_28192 = (new cljs.core.PersistentVector(null,2,(5),inst_28190,inst_28191,null));
var state_28196__$1 = state_28196;
var statearr_28202_28233 = state_28196__$1;
(statearr_28202_28233[(2)] = inst_28192);

(statearr_28202_28233[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (6))){
var state_28196__$1 = state_28196;
var statearr_28203_28234 = state_28196__$1;
(statearr_28203_28234[(2)] = true);

(statearr_28203_28234[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (17))){
var inst_28184 = (state_28196[(2)]);
var inst_28185 = console.info("evaluation done:",script);
var inst_28186 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_28187 = [new cljs.core.Keyword(null,"ok","ok",967785236),script];
var inst_28188 = (new cljs.core.PersistentVector(null,2,(5),inst_28186,inst_28187,null));
var state_28196__$1 = (function (){var statearr_28204 = state_28196;
(statearr_28204[(10)] = inst_28185);

(statearr_28204[(11)] = inst_28184);

return statearr_28204;
})();
var statearr_28205_28235 = state_28196__$1;
(statearr_28205_28235[(2)] = inst_28188);

(statearr_28205_28235[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (3))){
var inst_28152 = (state_28196[(12)]);
var inst_28157 = inst_28152.cljs$lang$protocol_mask$partition0$;
var inst_28158 = (inst_28157 & (64));
var inst_28159 = inst_28152.cljs$core$ISeq$;
var inst_28160 = (cljs.core.PROTOCOL_SENTINEL === inst_28159);
var inst_28161 = ((inst_28158) || (inst_28160));
var state_28196__$1 = state_28196;
if(cljs.core.truth_(inst_28161)){
var statearr_28206_28236 = state_28196__$1;
(statearr_28206_28236[(1)] = (6));

} else {
var statearr_28207_28237 = state_28196__$1;
(statearr_28207_28237[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (12))){
var inst_28178 = console.info("evaluating:",script);
var state_28196__$1 = (function (){var statearr_28208 = state_28196;
(statearr_28208[(13)] = inst_28178);

return statearr_28208;
})();
if(cljs.core.truth_(secured_eval_QMARK_)){
var statearr_28209_28238 = state_28196__$1;
(statearr_28209_28238[(1)] = (15));

} else {
var statearr_28210_28239 = state_28196__$1;
(statearr_28210_28239[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (2))){
var inst_28152 = (state_28196[(12)]);
var inst_28152__$1 = (state_28196[(2)]);
var inst_28154 = (inst_28152__$1 == null);
var inst_28155 = cljs.core.not.call(null,inst_28154);
var state_28196__$1 = (function (){var statearr_28211 = state_28196;
(statearr_28211[(12)] = inst_28152__$1);

return statearr_28211;
})();
if(inst_28155){
var statearr_28212_28240 = state_28196__$1;
(statearr_28212_28240[(1)] = (3));

} else {
var statearr_28213_28241 = state_28196__$1;
(statearr_28213_28241[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (11))){
var inst_28174 = (state_28196[(9)]);
var inst_28173 = (state_28196[(2)]);
var inst_28174__$1 = cljs.core.get.call(null,inst_28173,new cljs.core.Keyword(null,"status","status",-1997798413));
var inst_28175 = cljs.core.get.call(null,inst_28173,new cljs.core.Keyword(null,"body","body",-2049205669));
var inst_28176 = cljs.core._EQ_.call(null,(200),inst_28174__$1);
var state_28196__$1 = (function (){var statearr_28214 = state_28196;
(statearr_28214[(8)] = inst_28175);

(statearr_28214[(9)] = inst_28174__$1);

return statearr_28214;
})();
if(inst_28176){
var statearr_28215_28242 = state_28196__$1;
(statearr_28215_28242[(1)] = (12));

} else {
var statearr_28216_28243 = state_28196__$1;
(statearr_28216_28243[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (9))){
var inst_28152 = (state_28196[(12)]);
var inst_28170 = cljs.core.apply.call(null,cljs.core.hash_map,inst_28152);
var state_28196__$1 = state_28196;
var statearr_28217_28244 = state_28196__$1;
(statearr_28217_28244[(2)] = inst_28170);

(statearr_28217_28244[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (5))){
var inst_28168 = (state_28196[(2)]);
var state_28196__$1 = state_28196;
if(cljs.core.truth_(inst_28168)){
var statearr_28218_28245 = state_28196__$1;
(statearr_28218_28245[(1)] = (9));

} else {
var statearr_28219_28246 = state_28196__$1;
(statearr_28219_28246[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (14))){
var inst_28194 = (state_28196[(2)]);
var state_28196__$1 = state_28196;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28196__$1,inst_28194);
} else {
if((state_val_28197 === (16))){
var inst_28175 = (state_28196[(8)]);
var inst_28182 = klipse.utils.unsecured_eval_in_global_scope.call(null,inst_28175);
var state_28196__$1 = state_28196;
var statearr_28220_28247 = state_28196__$1;
(statearr_28220_28247[(2)] = inst_28182);

(statearr_28220_28247[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (10))){
var inst_28152 = (state_28196[(12)]);
var state_28196__$1 = state_28196;
var statearr_28221_28248 = state_28196__$1;
(statearr_28221_28248[(2)] = inst_28152);

(statearr_28221_28248[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28197 === (8))){
var inst_28165 = (state_28196[(2)]);
var state_28196__$1 = state_28196;
var statearr_28222_28249 = state_28196__$1;
(statearr_28222_28249[(2)] = inst_28165);

(statearr_28222_28249[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__,map__28143,map__28143__$1,secured_eval_QMARK_))
;
return ((function (switch__3428__auto__,c__3451__auto__,map__28143,map__28143__$1,secured_eval_QMARK_){
return (function() {
var klipse$utils$state_machine__3429__auto__ = null;
var klipse$utils$state_machine__3429__auto____0 = (function (){
var statearr_28223 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_28223[(0)] = klipse$utils$state_machine__3429__auto__);

(statearr_28223[(1)] = (1));

return statearr_28223;
});
var klipse$utils$state_machine__3429__auto____1 = (function (state_28196){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_28196);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e28224){if((e28224 instanceof Object)){
var ex__3432__auto__ = e28224;
var statearr_28225_28250 = state_28196;
(statearr_28225_28250[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28196);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28224;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28251 = state_28196;
state_28196 = G__28251;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$state_machine__3429__auto__ = function(state_28196){
switch(arguments.length){
case 0:
return klipse$utils$state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$state_machine__3429__auto____1.call(this,state_28196);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$state_machine__3429__auto____0;
klipse$utils$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$state_machine__3429__auto____1;
return klipse$utils$state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,map__28143,map__28143__$1,secured_eval_QMARK_))
})();
var state__3453__auto__ = (function (){var statearr_28226 = f__3452__auto__.call(null);
(statearr_28226[(6)] = c__3451__auto__);

return statearr_28226;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,map__28143,map__28143__$1,secured_eval_QMARK_))
);

return c__3451__auto__;
});

klipse.utils.load_script.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
klipse.utils.load_script.cljs$lang$applyTo = (function (seq28140){
var G__28141 = cljs.core.first.call(null,seq28140);
var seq28140__$1 = cljs.core.next.call(null,seq28140);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__28141,seq28140__$1);
});

klipse.utils.load_script_mem = klipse.utils.memoize_async.call(null,klipse.utils.load_script);
klipse.utils.load_scripts = (function klipse$utils$load_scripts(var_args){
var args__4502__auto__ = [];
var len__4499__auto___28310 = arguments.length;
var i__4500__auto___28311 = (0);
while(true){
if((i__4500__auto___28311 < len__4499__auto___28310)){
args__4502__auto__.push((arguments[i__4500__auto___28311]));

var G__28312 = (i__4500__auto___28311 + (1));
i__4500__auto___28311 = G__28312;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((1) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((1)),(0),null)):null);
return klipse.utils.load_scripts.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4503__auto__);
});

klipse.utils.load_scripts.cljs$core$IFn$_invoke$arity$variadic = (function (scripts,p__28254){
var map__28255 = p__28254;
var map__28255__$1 = ((((!((map__28255 == null)))?(((((map__28255.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__28255.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__28255):map__28255);
var secured_eval_QMARK_ = cljs.core.get.call(null,map__28255__$1,new cljs.core.Keyword(null,"secured-eval?","secured-eval?",-922170059),false);
var c__3451__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3451__auto__,map__28255,map__28255__$1,secured_eval_QMARK_){
return (function (){
var f__3452__auto__ = (function (){var switch__3428__auto__ = ((function (c__3451__auto__,map__28255,map__28255__$1,secured_eval_QMARK_){
return (function (state_28290){
var state_val_28291 = (state_28290[(1)]);
if((state_val_28291 === (7))){
var inst_28269 = (state_28290[(7)]);
var inst_28268 = (state_28290[(2)]);
var inst_28269__$1 = cljs.core.nth.call(null,inst_28268,(0),null);
var inst_28270 = cljs.core.nth.call(null,inst_28268,(1),null);
var inst_28271 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"ok","ok",967785236),inst_28269__$1);
var state_28290__$1 = (function (){var statearr_28292 = state_28290;
(statearr_28292[(7)] = inst_28269__$1);

(statearr_28292[(8)] = inst_28270);

return statearr_28292;
})();
if(inst_28271){
var statearr_28293_28313 = state_28290__$1;
(statearr_28293_28313[(1)] = (8));

} else {
var statearr_28294_28314 = state_28290__$1;
(statearr_28294_28314[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (1))){
var inst_28257 = scripts;
var state_28290__$1 = (function (){var statearr_28295 = state_28290;
(statearr_28295[(9)] = inst_28257);

return statearr_28295;
})();
var statearr_28296_28315 = state_28290__$1;
(statearr_28296_28315[(2)] = null);

(statearr_28296_28315[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (4))){
var inst_28257 = (state_28290[(9)]);
var inst_28264 = cljs.core.first.call(null,inst_28257);
var inst_28265 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_28264)].join('');
var inst_28266 = klipse.utils.load_script_mem.call(null,inst_28265,new cljs.core.Keyword(null,"secured-eval?","secured-eval?",-922170059),secured_eval_QMARK_);
var state_28290__$1 = state_28290;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_28290__$1,(7),inst_28266);
} else {
if((state_val_28291 === (6))){
var inst_28286 = (state_28290[(2)]);
var state_28290__$1 = state_28290;
var statearr_28297_28316 = state_28290__$1;
(statearr_28297_28316[(2)] = inst_28286);

(statearr_28297_28316[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (3))){
var inst_28288 = (state_28290[(2)]);
var state_28290__$1 = state_28290;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_28290__$1,inst_28288);
} else {
if((state_val_28291 === (2))){
var inst_28257 = (state_28290[(9)]);
var inst_28259 = cljs.core.seq.call(null,inst_28257);
var state_28290__$1 = state_28290;
if(inst_28259){
var statearr_28298_28317 = state_28290__$1;
(statearr_28298_28317[(1)] = (4));

} else {
var statearr_28299_28318 = state_28290__$1;
(statearr_28299_28318[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (9))){
var state_28290__$1 = state_28290;
var statearr_28300_28319 = state_28290__$1;
(statearr_28300_28319[(2)] = null);

(statearr_28300_28319[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (5))){
var inst_28282 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_28283 = [new cljs.core.Keyword(null,"ok","ok",967785236)];
var inst_28284 = (new cljs.core.PersistentVector(null,1,(5),inst_28282,inst_28283,null));
var state_28290__$1 = state_28290;
var statearr_28301_28320 = state_28290__$1;
(statearr_28301_28320[(2)] = inst_28284);

(statearr_28301_28320[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (10))){
var inst_28269 = (state_28290[(7)]);
var inst_28270 = (state_28290[(8)]);
var inst_28277 = (state_28290[(2)]);
var inst_28278 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_28279 = [inst_28269,inst_28270];
var inst_28280 = (new cljs.core.PersistentVector(null,2,(5),inst_28278,inst_28279,null));
var state_28290__$1 = (function (){var statearr_28302 = state_28290;
(statearr_28302[(10)] = inst_28277);

return statearr_28302;
})();
var statearr_28303_28321 = state_28290__$1;
(statearr_28303_28321[(2)] = inst_28280);

(statearr_28303_28321[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_28291 === (8))){
var inst_28257 = (state_28290[(9)]);
var inst_28273 = cljs.core.rest.call(null,inst_28257);
var inst_28257__$1 = inst_28273;
var state_28290__$1 = (function (){var statearr_28304 = state_28290;
(statearr_28304[(9)] = inst_28257__$1);

return statearr_28304;
})();
var statearr_28305_28322 = state_28290__$1;
(statearr_28305_28322[(2)] = null);

(statearr_28305_28322[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__3451__auto__,map__28255,map__28255__$1,secured_eval_QMARK_))
;
return ((function (switch__3428__auto__,c__3451__auto__,map__28255,map__28255__$1,secured_eval_QMARK_){
return (function() {
var klipse$utils$state_machine__3429__auto__ = null;
var klipse$utils$state_machine__3429__auto____0 = (function (){
var statearr_28306 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_28306[(0)] = klipse$utils$state_machine__3429__auto__);

(statearr_28306[(1)] = (1));

return statearr_28306;
});
var klipse$utils$state_machine__3429__auto____1 = (function (state_28290){
while(true){
var ret_value__3430__auto__ = (function (){try{while(true){
var result__3431__auto__ = switch__3428__auto__.call(null,state_28290);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3431__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3431__auto__;
}
break;
}
}catch (e28307){if((e28307 instanceof Object)){
var ex__3432__auto__ = e28307;
var statearr_28308_28323 = state_28290;
(statearr_28308_28323[(5)] = ex__3432__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_28290);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e28307;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3430__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__28324 = state_28290;
state_28290 = G__28324;
continue;
} else {
return ret_value__3430__auto__;
}
break;
}
});
klipse$utils$state_machine__3429__auto__ = function(state_28290){
switch(arguments.length){
case 0:
return klipse$utils$state_machine__3429__auto____0.call(this);
case 1:
return klipse$utils$state_machine__3429__auto____1.call(this,state_28290);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse$utils$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$0 = klipse$utils$state_machine__3429__auto____0;
klipse$utils$state_machine__3429__auto__.cljs$core$IFn$_invoke$arity$1 = klipse$utils$state_machine__3429__auto____1;
return klipse$utils$state_machine__3429__auto__;
})()
;})(switch__3428__auto__,c__3451__auto__,map__28255,map__28255__$1,secured_eval_QMARK_))
})();
var state__3453__auto__ = (function (){var statearr_28309 = f__3452__auto__.call(null);
(statearr_28309[(6)] = c__3451__auto__);

return statearr_28309;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3453__auto__);
});})(c__3451__auto__,map__28255,map__28255__$1,secured_eval_QMARK_))
);

return c__3451__auto__;
});

klipse.utils.load_scripts.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
klipse.utils.load_scripts.cljs$lang$applyTo = (function (seq28252){
var G__28253 = cljs.core.first.call(null,seq28252);
var seq28252__$1 = cljs.core.next.call(null,seq28252);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__28253,seq28252__$1);
});

klipse.utils.load_scripts_mem = klipse.utils.memoize_async.call(null,klipse.utils.load_scripts);
klipse.utils.verbose_QMARK_ = (function klipse$utils$verbose_QMARK_(){
return cljs.core.boolean$.call(null,cljs.reader.read_string.call(null,(function (){var or__3922__auto__ = new cljs.core.Keyword(null,"verbose","verbose",1694226060).cljs$core$IFn$_invoke$arity$1(klipse.utils.url_parameters.call(null));
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return "false";
}
})()));
});
klipse.utils.klipse_settings_STAR_ = (function klipse$utils$klipse_settings_STAR_(){
var w = ((typeof window !== 'undefined')?window:({}));
return cljs.core.js__GT_clj.call(null,(w["klipse_settings"]),new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true);
});
klipse.utils.klipse_settings = cljs.core.memoize.call(null,klipse.utils.klipse_settings_STAR_);
klipse.utils.add_script_tag_BANG_ = (function klipse$utils$add_script_tag_BANG_(url){
var c = cljs.core.async.chan.call(null);
var node = document.createElement("script");
var body = (document["body"]);
(node["src"] = url);

(node["onerror"] = ((function (node,body,c){
return (function (){
return cljs.core.async.put_BANG_.call(null,c,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"error","error",-978969032),url], null));
});})(node,body,c))
);

(node["onload"] = ((function (node,body,c){
return (function (){
return cljs.core.async.put_BANG_.call(null,c,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ok","ok",967785236),url], null));
});})(node,body,c))
);

(node["type"] = "text/javascript");

var obj_SHARP__28325 = body;
var fn_SHARP__28326 = (obj_SHARP__28325["appendChild"]);
fn_SHARP__28326.call(obj_SHARP__28325,node);

return c;
});
klipse.utils.add_script_tag_once_BANG_ = klipse.utils.runonce.call(null,klipse.utils.add_script_tag_BANG_);

//# sourceMappingURL=utils.js.map
