// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('klipse_clj.lang.clojure.io');
goog.require('cljs.core');
goog.require('cljs.reader');
goog.require('clojure.string');
goog.require('klipse_clj.lang.clojure.include');
goog.require('clojure.walk');
goog.require('cljs_http.client');
goog.require('cljs_http.util');
goog.require('cljs.core.async');
klipse_clj.lang.clojure.io._STAR_klipse_settings_STAR_ = cljs.core.PersistentArrayMap.EMPTY;
klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_ = false;
klipse_clj.lang.clojure.io._STAR_cache_buster_QMARK__STAR_ = false;
klipse_clj.lang.clojure.io.edn = (function klipse_clj$lang$clojure$io$edn(json){
return cljs_http.util.transit_decode.call(null,JSON.stringify(cljs.core.clj__GT_js.call(null,json)),new cljs.core.Keyword(null,"json","json",1279968570),null);
});
klipse_clj.lang.clojure.io.macro_suffixes = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [".clj",".cljc"], null);
klipse_clj.lang.clojure.io.cljs_suffixes = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [".cljs",".cljc"], null);
if(typeof klipse_clj.lang.clojure.io.load_ns !== 'undefined'){
} else {
/**
 * 
 *   Each runtime environment provides a different way to load a library.
 *   Received two arguments - a map and a callback function:
 *   The map will have the following keys:
 * 
 *  :name   - the name of the library (a symbol)
 *  :macros - modifier signaling a macros namespace load
 *  :path   - munged relative library path (a string)
 * 
 *  It is up to the implementor to correctly resolve the corresponding .cljs,
 *  .cljc, or .js resource (the order must be respected).
 *  If :macros is true, resolution should only consider .clj or .cljc resources (the order must be respected).
 *   Upon resolution the callback should be invoked with a map containing the following keys:
 * 
 *  :lang       - the language, :clj or :js
 *  :source     - the source of the library (a string)
 *  :file       - optional, the file path, it will be added to AST's :file keyword (but not in :meta)
 *  :cache      - optional, if a :clj namespace has been precompiled to :js, can give an analysis cache for faster loads.
 *  :source-map - optional, if a :clj namespace has been precompiled to :js, can give a V3 source map JSON
 * 
 *  If the resource could not be resolved, the callback should be invoked with
 *  nil.
 */
klipse_clj.lang.clojure.io.load_ns = (function (){var method_table__4382__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4383__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4384__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4385__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4386__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"klipse-clj.lang.clojure.io","load-ns"),((function (method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__,hierarchy__4386__auto__){
return (function (_,p__4342,src_cb){
var map__4343 = p__4342;
var map__4343__$1 = ((((!((map__4343 == null)))?(((((map__4343.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4343.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4343):map__4343);
var name = cljs.core.get.call(null,map__4343__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var macros = cljs.core.get.call(null,map__4343__$1,new cljs.core.Keyword(null,"macros","macros",811339431));
var path = cljs.core.get.call(null,map__4343__$1,new cljs.core.Keyword(null,"path","path",-188191168));
new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [name,macros,path], null);

if(cljs.core.truth_(macros)){
return new cljs.core.Keyword(null,"macro","macro",-867863404);
} else {
if(cljs.core.truth_(cljs.core.re_matches.call(null,/^goog\..*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('')))){
return new cljs.core.Keyword(null,"goog","goog",-1711135452);
} else {
if(cljs.core.truth_(cljs.core.re_matches.call(null,/.*\.gist-.*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('')))){
return new cljs.core.Keyword(null,"gist","gist",96143031);
} else {
return new cljs.core.Keyword(null,"cljs","cljs",1492417629);

}
}
}
});})(method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__,hierarchy__4386__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4386__auto__,method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__));
})();
}
klipse_clj.lang.clojure.io.skip_ns_macros = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Symbol(null,"cljs.analyzer.macros","cljs.analyzer.macros",298494182,null),null,new cljs.core.Symbol(null,"cljs.env.macros","cljs.env.macros",1542748640,null),null,new cljs.core.Symbol(null,"cljs.pprint","cljs.pprint",-966900911,null),null,new cljs.core.Symbol(null,"cljs.compiler.macros","cljs.compiler.macros",750996207,null),null,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null),null,new cljs.core.Symbol(null,"cljs.js","cljs.js",474485962,null),null], null), null);
klipse_clj.lang.clojure.io.the_ns_map = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Symbol(null,"cljs.test","cljs.test",884805483,null),"https://raw.githubusercontent.com/clojure/clojurescript/master/src/main/cljs/",new cljs.core.Symbol(null,"clojure.template","clojure.template",-1162325089,null),"https://raw.githubusercontent.com/viebel/clojure/master/src/clj/"], null);
klipse_clj.lang.clojure.io.skip_ns_cljs = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Symbol(null,"cljs.source-map","cljs.source-map",2108014936,null),null,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null),null,new cljs.core.Symbol(null,"cljs.tools.reader","cljs.tools.reader",-831293977,null),null,new cljs.core.Symbol(null,"cljs.tools.reader.reader-types","cljs.tools.reader.reader-types",-346100821,null),null,new cljs.core.Symbol(null,"cljs.env","cljs.env",-1810013139,null),null], null), null);
klipse_clj.lang.clojure.io.filename_of = (function klipse_clj$lang$clojure$io$filename_of(s){
if(klipse_clj.lang.clojure.io._STAR_cache_buster_QMARK__STAR_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(s),"?",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.call(null))].join('');
} else {
return s;
}
});
/**
 * Tries to load one namespace from filenames.
 *   Will call the src-cb upon first success.
 *   If can-recover? is false, will call src-cb with nil if it cannot load any namespace.
 *   Returns :success if a nampespace was loaded otherwise, returns nil.
 *   
 */
klipse_clj.lang.clojure.io.try_to_load_ns = (function klipse_clj$lang$clojure$io$try_to_load_ns(var_args){
var args__4502__auto__ = [];
var len__4499__auto___4459 = arguments.length;
var i__4500__auto___4460 = (0);
while(true){
if((i__4500__auto___4460 < len__4499__auto___4459)){
args__4502__auto__.push((arguments[i__4500__auto___4460]));

var G__4461 = (i__4500__auto___4460 + (1));
i__4500__auto___4460 = G__4461;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((4) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((4)),(0),null)):null);
return klipse_clj.lang.clojure.io.try_to_load_ns.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),argseq__4503__auto__);
});

klipse_clj.lang.clojure.io.try_to_load_ns.cljs$core$IFn$_invoke$arity$variadic = (function (filenames,lang,src_key,src_cb,p__4350){
var map__4351 = p__4350;
var map__4351__$1 = ((((!((map__4351 == null)))?(((((map__4351.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4351.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4351):map__4351);
var transform = cljs.core.get.call(null,map__4351__$1,new cljs.core.Keyword(null,"transform","transform",1381301764),cljs.core.identity);
var can_recover_QMARK_ = cljs.core.get.call(null,map__4351__$1,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),false);
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("try-to-load-ns ",filenames,lang,src_key);
} else {
}

var c__3181__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3181__auto__,map__4351,map__4351__$1,transform,can_recover_QMARK_){
return (function (){
var f__3182__auto__ = (function (){var switch__3158__auto__ = ((function (c__3181__auto__,map__4351,map__4351__$1,transform,can_recover_QMARK_){
return (function (state_4416){
var state_val_4417 = (state_4416[(1)]);
if((state_val_4417 === (7))){
var inst_4365 = (state_4416[(7)]);
var inst_4365__$1 = (state_4416[(2)]);
var inst_4367 = (inst_4365__$1 == null);
var inst_4368 = cljs.core.not.call(null,inst_4367);
var state_4416__$1 = (function (){var statearr_4418 = state_4416;
(statearr_4418[(7)] = inst_4365__$1);

return statearr_4418;
})();
if(inst_4368){
var statearr_4419_4462 = state_4416__$1;
(statearr_4419_4462[(1)] = (8));

} else {
var statearr_4420_4463 = state_4416__$1;
(statearr_4420_4463[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (20))){
var state_4416__$1 = state_4416;
var statearr_4421_4464 = state_4416__$1;
(statearr_4421_4464[(2)] = new cljs.core.Keyword(null,"success","success",1890645906));

(statearr_4421_4464[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (1))){
var inst_4353 = filenames;
var state_4416__$1 = (function (){var statearr_4422 = state_4416;
(statearr_4422[(8)] = inst_4353);

return statearr_4422;
})();
var statearr_4423_4465 = state_4416__$1;
(statearr_4423_4465[(2)] = null);

(statearr_4423_4465[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (24))){
var inst_4410 = src_cb.call(null,null);
var state_4416__$1 = state_4416;
var statearr_4424_4466 = state_4416__$1;
(statearr_4424_4466[(2)] = inst_4410);

(statearr_4424_4466[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (4))){
var inst_4358 = (state_4416[(9)]);
var inst_4353 = (state_4416[(8)]);
var inst_4358__$1 = cljs.core.first.call(null,inst_4353);
var inst_4359 = klipse_clj.lang.clojure.io.filename_of.call(null,inst_4358__$1);
var inst_4360 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_4361 = [false];
var inst_4362 = cljs.core.PersistentHashMap.fromArrays(inst_4360,inst_4361);
var inst_4363 = cljs_http.client.get.call(null,inst_4359,inst_4362);
var state_4416__$1 = (function (){var statearr_4425 = state_4416;
(statearr_4425[(9)] = inst_4358__$1);

return statearr_4425;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4416__$1,(7),inst_4363);
} else {
if((state_val_4417 === (15))){
var inst_4365 = (state_4416[(7)]);
var state_4416__$1 = state_4416;
var statearr_4426_4467 = state_4416__$1;
(statearr_4426_4467[(2)] = inst_4365);

(statearr_4426_4467[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (21))){
var state_4416__$1 = state_4416;
if(cljs.core.truth_(can_recover_QMARK_)){
var statearr_4427_4468 = state_4416__$1;
(statearr_4427_4468[(1)] = (23));

} else {
var statearr_4428_4469 = state_4416__$1;
(statearr_4428_4469[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (13))){
var inst_4378 = (state_4416[(2)]);
var state_4416__$1 = state_4416;
var statearr_4429_4470 = state_4416__$1;
(statearr_4429_4470[(2)] = inst_4378);

(statearr_4429_4470[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (22))){
var inst_4414 = (state_4416[(2)]);
var state_4416__$1 = state_4416;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4416__$1,inst_4414);
} else {
if((state_val_4417 === (6))){
var inst_4403 = (state_4416[(2)]);
var state_4416__$1 = state_4416;
var statearr_4430_4471 = state_4416__$1;
(statearr_4430_4471[(2)] = inst_4403);

(statearr_4430_4471[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (25))){
var inst_4412 = (state_4416[(2)]);
var state_4416__$1 = (function (){var statearr_4431 = state_4416;
(statearr_4431[(10)] = inst_4412);

return statearr_4431;
})();
var statearr_4432_4472 = state_4416__$1;
(statearr_4432_4472[(2)] = false);

(statearr_4432_4472[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (17))){
var inst_4388 = (state_4416[(11)]);
var inst_4358 = (state_4416[(9)]);
var inst_4391 = [new cljs.core.Keyword(null,"lang","lang",-1819677104),src_key,new cljs.core.Keyword(null,"file","file",-1269645878)];
var inst_4392 = transform.call(null,inst_4388);
var inst_4393 = [lang,inst_4392,inst_4358];
var inst_4394 = cljs.core.PersistentHashMap.fromArrays(inst_4391,inst_4393);
var inst_4395 = src_cb.call(null,inst_4394);
var state_4416__$1 = (function (){var statearr_4433 = state_4416;
(statearr_4433[(12)] = inst_4395);

return statearr_4433;
})();
var statearr_4434_4473 = state_4416__$1;
(statearr_4434_4473[(2)] = new cljs.core.Keyword(null,"success","success",1890645906));

(statearr_4434_4473[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (3))){
var inst_4405 = (state_4416[(2)]);
var state_4416__$1 = state_4416;
if(cljs.core.truth_(inst_4405)){
var statearr_4435_4474 = state_4416__$1;
(statearr_4435_4474[(1)] = (20));

} else {
var statearr_4436_4475 = state_4416__$1;
(statearr_4436_4475[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (12))){
var state_4416__$1 = state_4416;
var statearr_4437_4476 = state_4416__$1;
(statearr_4437_4476[(2)] = false);

(statearr_4437_4476[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (2))){
var inst_4353 = (state_4416[(8)]);
var inst_4355 = cljs.core.seq.call(null,inst_4353);
var state_4416__$1 = state_4416;
if(inst_4355){
var statearr_4438_4477 = state_4416__$1;
(statearr_4438_4477[(1)] = (4));

} else {
var statearr_4439_4478 = state_4416__$1;
(statearr_4439_4478[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (23))){
var state_4416__$1 = state_4416;
var statearr_4440_4479 = state_4416__$1;
(statearr_4440_4479[(2)] = null);

(statearr_4440_4479[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (19))){
var inst_4400 = (state_4416[(2)]);
var state_4416__$1 = state_4416;
var statearr_4441_4480 = state_4416__$1;
(statearr_4441_4480[(2)] = inst_4400);

(statearr_4441_4480[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (11))){
var state_4416__$1 = state_4416;
var statearr_4442_4481 = state_4416__$1;
(statearr_4442_4481[(2)] = true);

(statearr_4442_4481[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (9))){
var state_4416__$1 = state_4416;
var statearr_4443_4482 = state_4416__$1;
(statearr_4443_4482[(2)] = false);

(statearr_4443_4482[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (5))){
var state_4416__$1 = state_4416;
var statearr_4444_4483 = state_4416__$1;
(statearr_4444_4483[(2)] = null);

(statearr_4444_4483[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (14))){
var inst_4365 = (state_4416[(7)]);
var inst_4383 = cljs.core.apply.call(null,cljs.core.hash_map,inst_4365);
var state_4416__$1 = state_4416;
var statearr_4445_4484 = state_4416__$1;
(statearr_4445_4484[(2)] = inst_4383);

(statearr_4445_4484[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (16))){
var inst_4386 = (state_4416[(2)]);
var inst_4387 = cljs.core.get.call(null,inst_4386,new cljs.core.Keyword(null,"status","status",-1997798413));
var inst_4388 = cljs.core.get.call(null,inst_4386,new cljs.core.Keyword(null,"body","body",-2049205669));
var inst_4389 = cljs.core._EQ_.call(null,(200),inst_4387);
var state_4416__$1 = (function (){var statearr_4446 = state_4416;
(statearr_4446[(11)] = inst_4388);

return statearr_4446;
})();
if(inst_4389){
var statearr_4447_4485 = state_4416__$1;
(statearr_4447_4485[(1)] = (17));

} else {
var statearr_4448_4486 = state_4416__$1;
(statearr_4448_4486[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (10))){
var inst_4381 = (state_4416[(2)]);
var state_4416__$1 = state_4416;
if(cljs.core.truth_(inst_4381)){
var statearr_4449_4487 = state_4416__$1;
(statearr_4449_4487[(1)] = (14));

} else {
var statearr_4450_4488 = state_4416__$1;
(statearr_4450_4488[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (18))){
var inst_4353 = (state_4416[(8)]);
var inst_4397 = cljs.core.rest.call(null,inst_4353);
var inst_4353__$1 = inst_4397;
var state_4416__$1 = (function (){var statearr_4451 = state_4416;
(statearr_4451[(8)] = inst_4353__$1);

return statearr_4451;
})();
var statearr_4452_4489 = state_4416__$1;
(statearr_4452_4489[(2)] = null);

(statearr_4452_4489[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4417 === (8))){
var inst_4365 = (state_4416[(7)]);
var inst_4370 = inst_4365.cljs$lang$protocol_mask$partition0$;
var inst_4371 = (inst_4370 & (64));
var inst_4372 = inst_4365.cljs$core$ISeq$;
var inst_4373 = (cljs.core.PROTOCOL_SENTINEL === inst_4372);
var inst_4374 = ((inst_4371) || (inst_4373));
var state_4416__$1 = state_4416;
if(cljs.core.truth_(inst_4374)){
var statearr_4453_4490 = state_4416__$1;
(statearr_4453_4490[(1)] = (11));

} else {
var statearr_4454_4491 = state_4416__$1;
(statearr_4454_4491[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3181__auto__,map__4351,map__4351__$1,transform,can_recover_QMARK_))
;
return ((function (switch__3158__auto__,c__3181__auto__,map__4351,map__4351__$1,transform,can_recover_QMARK_){
return (function() {
var klipse_clj$lang$clojure$io$state_machine__3159__auto__ = null;
var klipse_clj$lang$clojure$io$state_machine__3159__auto____0 = (function (){
var statearr_4455 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4455[(0)] = klipse_clj$lang$clojure$io$state_machine__3159__auto__);

(statearr_4455[(1)] = (1));

return statearr_4455;
});
var klipse_clj$lang$clojure$io$state_machine__3159__auto____1 = (function (state_4416){
while(true){
var ret_value__3160__auto__ = (function (){try{while(true){
var result__3161__auto__ = switch__3158__auto__.call(null,state_4416);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3161__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3161__auto__;
}
break;
}
}catch (e4456){if((e4456 instanceof Object)){
var ex__3162__auto__ = e4456;
var statearr_4457_4492 = state_4416;
(statearr_4457_4492[(5)] = ex__3162__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4416);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4456;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3160__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4493 = state_4416;
state_4416 = G__4493;
continue;
} else {
return ret_value__3160__auto__;
}
break;
}
});
klipse_clj$lang$clojure$io$state_machine__3159__auto__ = function(state_4416){
switch(arguments.length){
case 0:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____0.call(this);
case 1:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____1.call(this,state_4416);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$0 = klipse_clj$lang$clojure$io$state_machine__3159__auto____0;
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$1 = klipse_clj$lang$clojure$io$state_machine__3159__auto____1;
return klipse_clj$lang$clojure$io$state_machine__3159__auto__;
})()
;})(switch__3158__auto__,c__3181__auto__,map__4351,map__4351__$1,transform,can_recover_QMARK_))
})();
var state__3183__auto__ = (function (){var statearr_4458 = f__3182__auto__.call(null);
(statearr_4458[(6)] = c__3181__auto__);

return statearr_4458;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3183__auto__);
});})(c__3181__auto__,map__4351,map__4351__$1,transform,can_recover_QMARK_))
);

return c__3181__auto__;
});

klipse_clj.lang.clojure.io.try_to_load_ns.cljs$lang$maxFixedArity = (4);

/** @this {Function} */
klipse_clj.lang.clojure.io.try_to_load_ns.cljs$lang$applyTo = (function (seq4345){
var G__4346 = cljs.core.first.call(null,seq4345);
var seq4345__$1 = cljs.core.next.call(null,seq4345);
var G__4347 = cljs.core.first.call(null,seq4345__$1);
var seq4345__$2 = cljs.core.next.call(null,seq4345__$1);
var G__4348 = cljs.core.first.call(null,seq4345__$2);
var seq4345__$3 = cljs.core.next.call(null,seq4345__$2);
var G__4349 = cljs.core.first.call(null,seq4345__$3);
var seq4345__$4 = cljs.core.next.call(null,seq4345__$3);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__4346,G__4347,G__4348,G__4349,seq4345__$4);
});

/**
 * returns a list of files provided list of external-libs and suffixes
 */
klipse_clj.lang.clojure.io.external_libs_files = (function klipse_clj$lang$clojure$io$external_libs_files(external_libs,suffixes,path){
var iter__4292__auto__ = (function klipse_clj$lang$clojure$io$external_libs_files_$_iter__4494(s__4495){
return (new cljs.core.LazySeq(null,(function (){
var s__4495__$1 = s__4495;
while(true){
var temp__6753__auto__ = cljs.core.seq.call(null,s__4495__$1);
if(temp__6753__auto__){
var xs__7309__auto__ = temp__6753__auto__;
var lib = cljs.core.first.call(null,xs__7309__auto__);
var iterys__4288__auto__ = ((function (s__4495__$1,lib,xs__7309__auto__,temp__6753__auto__){
return (function klipse_clj$lang$clojure$io$external_libs_files_$_iter__4494_$_iter__4496(s__4497){
return (new cljs.core.LazySeq(null,((function (s__4495__$1,lib,xs__7309__auto__,temp__6753__auto__){
return (function (){
var s__4497__$1 = s__4497;
while(true){
var temp__6753__auto____$1 = cljs.core.seq.call(null,s__4497__$1);
if(temp__6753__auto____$1){
var s__4497__$2 = temp__6753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__4497__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__4497__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__4499 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__4498 = (0);
while(true){
if((i__4498 < size__4291__auto__)){
var suffix = cljs.core._nth.call(null,c__4290__auto__,i__4498);
cljs.core.chunk_append.call(null,b__4499,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(suffix)].join(''));

var G__4500 = (i__4498 + (1));
i__4498 = G__4500;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4499),klipse_clj$lang$clojure$io$external_libs_files_$_iter__4494_$_iter__4496.call(null,cljs.core.chunk_rest.call(null,s__4497__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4499),null);
}
} else {
var suffix = cljs.core.first.call(null,s__4497__$2);
return cljs.core.cons.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(suffix)].join(''),klipse_clj$lang$clojure$io$external_libs_files_$_iter__4494_$_iter__4496.call(null,cljs.core.rest.call(null,s__4497__$2)));
}
} else {
return null;
}
break;
}
});})(s__4495__$1,lib,xs__7309__auto__,temp__6753__auto__))
,null,null));
});})(s__4495__$1,lib,xs__7309__auto__,temp__6753__auto__))
;
var fs__4289__auto__ = cljs.core.seq.call(null,iterys__4288__auto__.call(null,suffixes));
if(fs__4289__auto__){
return cljs.core.concat.call(null,fs__4289__auto__,klipse_clj$lang$clojure$io$external_libs_files_$_iter__4494.call(null,cljs.core.rest.call(null,s__4495__$1)));
} else {
var G__4501 = cljs.core.rest.call(null,s__4495__$1);
s__4495__$1 = G__4501;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,external_libs);
});
klipse_clj.lang.clojure.io.name__GT_cached_resource = (function klipse_clj$lang$clojure$io$name__GT_cached_resource(name){
return clojure.string.replace.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.munge.call(null,name))].join(''),/\./,"_SLASH_");
});
klipse_clj.lang.clojure.io.cached_ns_root = (function klipse_clj$lang$clojure$io$cached_ns_root(){
return new cljs.core.Keyword(null,"cached_ns_root","cached_ns_root",-1077014575).cljs$core$IFn$_invoke$arity$2(klipse_clj.lang.clojure.io._STAR_klipse_settings_STAR_,"https://viebel.github.io/klipse/cache-cljs/");
});
klipse_clj.lang.clojure.io.load_ns_from_cache = (function klipse_clj$lang$clojure$io$load_ns_from_cache(name,src_cb,macro_QMARK_){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns-from-cache:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''),"macro: ",macro_QMARK_);
} else {
}

var c__3181__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3181__auto__){
return (function (){
var f__3182__auto__ = (function (){var switch__3158__auto__ = ((function (c__3181__auto__){
return (function (state_4546){
var state_val_4547 = (state_4546[(1)]);
if((state_val_4547 === (1))){
var inst_4503 = klipse_clj.lang.clojure.io.name__GT_cached_resource.call(null,name);
var state_4546__$1 = (function (){var statearr_4548 = state_4546;
(statearr_4548[(7)] = inst_4503);

return statearr_4548;
})();
if(cljs.core.truth_(macro_QMARK_)){
var statearr_4549_4564 = state_4546__$1;
(statearr_4549_4564[(1)] = (2));

} else {
var statearr_4550_4565 = state_4546__$1;
(statearr_4550_4565[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4547 === (2))){
var state_4546__$1 = state_4546;
var statearr_4551_4566 = state_4546__$1;
(statearr_4551_4566[(2)] = "$macros");

(statearr_4551_4566[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4547 === (3))){
var state_4546__$1 = state_4546;
var statearr_4552_4567 = state_4546__$1;
(statearr_4552_4567[(2)] = "");

(statearr_4552_4567[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4547 === (4))){
var inst_4503 = (state_4546[(7)]);
var inst_4510 = (state_4546[(8)]);
var inst_4507 = (state_4546[(9)]);
var inst_4509 = (state_4546[(10)]);
var inst_4507__$1 = (state_4546[(2)]);
var inst_4508 = klipse_clj.lang.clojure.io.cached_ns_root.call(null);
var inst_4509__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4508),"/"].join('');
var inst_4510__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4509__$1),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4503),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4507__$1),".js"].join('');
var inst_4511 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4509__$1),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4503),cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_4507__$1),".cache.json"].join('');
var inst_4512 = klipse_clj.lang.clojure.io.filename_of.call(null,inst_4510__$1);
var inst_4513 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_4514 = [false];
var inst_4515 = cljs.core.PersistentHashMap.fromArrays(inst_4513,inst_4514);
var inst_4516 = cljs_http.client.get.call(null,inst_4512,inst_4515);
var state_4546__$1 = (function (){var statearr_4553 = state_4546;
(statearr_4553[(8)] = inst_4510__$1);

(statearr_4553[(9)] = inst_4507__$1);

(statearr_4553[(10)] = inst_4509__$1);

(statearr_4553[(11)] = inst_4511);

return statearr_4553;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4546__$1,(5),inst_4516);
} else {
if((state_val_4547 === (5))){
var inst_4511 = (state_4546[(11)]);
var inst_4518 = (state_4546[(2)]);
var inst_4519 = klipse_clj.lang.clojure.io.filename_of.call(null,inst_4511);
var inst_4520 = [new cljs.core.Keyword(null,"with-credentials?","with-credentials?",-1773202222)];
var inst_4521 = [false];
var inst_4522 = cljs.core.PersistentHashMap.fromArrays(inst_4520,inst_4521);
var inst_4523 = cljs_http.client.get.call(null,inst_4519,inst_4522);
var state_4546__$1 = (function (){var statearr_4554 = state_4546;
(statearr_4554[(12)] = inst_4518);

return statearr_4554;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4546__$1,(6),inst_4523);
} else {
if((state_val_4547 === (6))){
var inst_4503 = (state_4546[(7)]);
var inst_4518 = (state_4546[(12)]);
var inst_4510 = (state_4546[(8)]);
var inst_4507 = (state_4546[(9)]);
var inst_4525 = (state_4546[(13)]);
var inst_4509 = (state_4546[(10)]);
var inst_4511 = (state_4546[(11)]);
var inst_4525__$1 = (state_4546[(2)]);
var inst_4526 = (function (){var nn = inst_4503;
var suffix = inst_4507;
var root = inst_4509;
var src_filename = inst_4510;
var cache_filename = inst_4511;
var src = inst_4518;
var cache = inst_4525__$1;
return ((function (nn,suffix,root,src_filename,cache_filename,src,cache,inst_4503,inst_4518,inst_4510,inst_4507,inst_4525,inst_4509,inst_4511,inst_4525__$1,state_val_4547,c__3181__auto__){
return (function (p1__4502_SHARP_){
return cljs.core._EQ_.call(null,(200),p1__4502_SHARP_);
});
;})(nn,suffix,root,src_filename,cache_filename,src,cache,inst_4503,inst_4518,inst_4510,inst_4507,inst_4525,inst_4509,inst_4511,inst_4525__$1,state_val_4547,c__3181__auto__))
})();
var inst_4527 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_4528 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_4525__$1);
var inst_4529 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_4518);
var inst_4530 = [inst_4528,inst_4529];
var inst_4531 = (new cljs.core.PersistentVector(null,2,(5),inst_4527,inst_4530,null));
var inst_4532 = cljs.core.every_QMARK_.call(null,inst_4526,inst_4531);
var state_4546__$1 = (function (){var statearr_4555 = state_4546;
(statearr_4555[(13)] = inst_4525__$1);

return statearr_4555;
})();
if(inst_4532){
var statearr_4556_4568 = state_4546__$1;
(statearr_4556_4568[(1)] = (7));

} else {
var statearr_4557_4569 = state_4546__$1;
(statearr_4557_4569[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4547 === (7))){
var inst_4518 = (state_4546[(12)]);
var inst_4525 = (state_4546[(13)]);
var inst_4534 = [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"cache","cache",-1237023054),new cljs.core.Keyword(null,"source","source",-433931539)];
var inst_4535 = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(inst_4525);
var inst_4536 = klipse_clj.lang.clojure.io.edn.call(null,inst_4535);
var inst_4537 = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(inst_4518);
var inst_4538 = [new cljs.core.Keyword(null,"js","js",1768080579),inst_4536,inst_4537];
var inst_4539 = cljs.core.PersistentHashMap.fromArrays(inst_4534,inst_4538);
var inst_4540 = src_cb.call(null,inst_4539);
var state_4546__$1 = state_4546;
var statearr_4558_4570 = state_4546__$1;
(statearr_4558_4570[(2)] = inst_4540);

(statearr_4558_4570[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4547 === (8))){
var inst_4542 = src_cb.call(null,null);
var state_4546__$1 = state_4546;
var statearr_4559_4571 = state_4546__$1;
(statearr_4559_4571[(2)] = inst_4542);

(statearr_4559_4571[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4547 === (9))){
var inst_4544 = (state_4546[(2)]);
var state_4546__$1 = state_4546;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4546__$1,inst_4544);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__3181__auto__))
;
return ((function (switch__3158__auto__,c__3181__auto__){
return (function() {
var klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto__ = null;
var klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto____0 = (function (){
var statearr_4560 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4560[(0)] = klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto__);

(statearr_4560[(1)] = (1));

return statearr_4560;
});
var klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto____1 = (function (state_4546){
while(true){
var ret_value__3160__auto__ = (function (){try{while(true){
var result__3161__auto__ = switch__3158__auto__.call(null,state_4546);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3161__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3161__auto__;
}
break;
}
}catch (e4561){if((e4561 instanceof Object)){
var ex__3162__auto__ = e4561;
var statearr_4562_4572 = state_4546;
(statearr_4562_4572[(5)] = ex__3162__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4546);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4561;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3160__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4573 = state_4546;
state_4546 = G__4573;
continue;
} else {
return ret_value__3160__auto__;
}
break;
}
});
klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto__ = function(state_4546){
switch(arguments.length){
case 0:
return klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto____0.call(this);
case 1:
return klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto____1.call(this,state_4546);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$0 = klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto____0;
klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$1 = klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto____1;
return klipse_clj$lang$clojure$io$load_ns_from_cache_$_state_machine__3159__auto__;
})()
;})(switch__3158__auto__,c__3181__auto__))
})();
var state__3183__auto__ = (function (){var statearr_4563 = f__3182__auto__.call(null);
(statearr_4563[(6)] = c__3181__auto__);

return statearr_4563;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3183__auto__);
});})(c__3181__auto__))
);

return c__3181__auto__;
});
klipse_clj.lang.clojure.io.cached_macro_ns_regexp = (function klipse_clj$lang$clojure$io$cached_macro_ns_regexp(){
return new cljs.core.Keyword(null,"clojure_cached_macro_ns_regexp","clojure_cached_macro_ns_regexp",-771780299).cljs$core$IFn$_invoke$arity$2(klipse_clj.lang.clojure.io._STAR_klipse_settings_STAR_,/cljs\.reader|cljs\.core\.[async|match].*|clojure\.math\.macros|gadjett\.core|cljs\.test|clojure.test.check.*|reagent\..*|om\..*|cljs\.spec.*|cljs-time\..*|re-frame\..*|net\.cgrand\.macrovich|reagent-forms\..*|ajax\.macros|poppea/);
});
klipse_clj.lang.clojure.io.cached_macro_ns_QMARK_ = (function klipse_clj$lang$clojure$io$cached_macro_ns_QMARK_(name){
return cljs.core.re_matches.call(null,klipse_clj.lang.clojure.io.cached_macro_ns_regexp.call(null),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
klipse_clj.lang.clojure.io.cached_ns_regexp = (function klipse_clj$lang$clojure$io$cached_ns_regexp(){
return new cljs.core.Keyword(null,"clojure_cached_ns_regexp","clojure_cached_ns_regexp",-1735711110).cljs$core$IFn$_invoke$arity$2(klipse_clj.lang.clojure.io._STAR_klipse_settings_STAR_,/cljs\.stacktrace|cljs\.core\.[async|match].*|cljs\.spec.*|clojure.math\.combinatorics|clojure.test.check.*|reagent\..*|om\..*|clojure\.data|cljs-time\..*|re-frame\..*|day8\.re-frame\..*|reagent-forms\..*|re-frisk\..*|re-frisk-shell\..*|datafrisk\..*|ajax\..*|cljs\.tools\.reader\..*/);
});
klipse_clj.lang.clojure.io.cached_cljs_ns_QMARK_ = (function klipse_clj$lang$clojure$io$cached_cljs_ns_QMARK_(name){
return cljs.core.re_matches.call(null,klipse_clj.lang.clojure.io.cached_ns_regexp.call(null),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
cljs.core._add_method.call(null,klipse_clj.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"macro","macro",-867863404),(function (external_libs,p__4574,src_cb_original){
var map__4575 = p__4574;
var map__4575__$1 = ((((!((map__4575 == null)))?(((((map__4575.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4575.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4575):map__4575);
var name = cljs.core.get.call(null,map__4575__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var path = cljs.core.get.call(null,map__4575__$1,new cljs.core.Keyword(null,"path","path",-188191168));
var src_cb = ((cljs.core.not_EQ_.call(null,name,new cljs.core.Symbol(null,"cljs.spec.test","cljs.spec.test",723719092,null)))?src_cb_original:((function (map__4575,map__4575__$1,name,path){
return (function() { 
var G__4577__delegate = function (args){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("src-cb: patch cljs.spec.test/eval");
} else {
}

cljs.core.apply.call(null,src_cb_original,args);

return klipse_clj.lang.clojure.include.def_a_var.call(null,new cljs.core.Symbol(null,"cljs.spec.test$macros","cljs.spec.test$macros",-804885435,null),new cljs.core.Symbol(null,"eval","eval",536963622,null),new cljs.core.Symbol(null,"identity","identity",-1007039734,null));
};
var G__4577 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__4578__i = 0, G__4578__a = new Array(arguments.length -  0);
while (G__4578__i < G__4578__a.length) {G__4578__a[G__4578__i] = arguments[G__4578__i + 0]; ++G__4578__i;}
  args = new cljs.core.IndexedSeq(G__4578__a,0,null);
} 
return G__4577__delegate.call(this,args);};
G__4577.cljs$lang$maxFixedArity = 0;
G__4577.cljs$lang$applyTo = (function (arglist__4579){
var args = cljs.core.seq(arglist__4579);
return G__4577__delegate(args);
});
G__4577.cljs$core$IFn$_invoke$arity$variadic = G__4577__delegate;
return G__4577;
})()
;})(map__4575,map__4575__$1,name,path))
);
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :macro :",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

if(cljs.core.truth_(klipse_clj.lang.clojure.io.skip_ns_macros.call(null,name))){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :macro skipping:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
if(cljs.core.truth_(klipse_clj.lang.clojure.io.cached_macro_ns_QMARK_.call(null,name))){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :macro cached:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return klipse_clj.lang.clojure.io.load_ns_from_cache.call(null,name,src_cb,true);
} else {
if(cljs.core.truth_(klipse_clj.lang.clojure.io.the_ns_map.call(null,name))){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :macro known:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

var prefix = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(klipse_clj.lang.clojure.io.the_ns_map.call(null,name)),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path)].join('');
var filenames = cljs.core.map.call(null,cljs.core.partial.call(null,cljs.core.str,prefix),klipse_clj.lang.clojure.io.macro_suffixes);
return klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
} else {
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :macro external-libs:",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

var filenames = klipse_clj.lang.clojure.io.external_libs_files.call(null,external_libs,klipse_clj.lang.clojure.io.macro_suffixes,path);
return klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);

}
}
}
}));
klipse_clj.lang.clojure.io.cache_url = "https://storage.googleapis.com/app.klipse.tech/fig/js/";
cljs.core._add_method.call(null,klipse_clj.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"gist","gist",96143031),(function (external_libs,p__4581,src_cb){
var map__4582 = p__4581;
var map__4582__$1 = ((((!((map__4582 == null)))?(((((map__4582.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4582.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4582):map__4582);
var path = cljs.core.get.call(null,map__4582__$1,new cljs.core.Keyword(null,"path","path",-188191168));
var path__$1 = clojure.string.replace.call(null,path,/gist_/,"");
var filenames = cljs.core.map.call(null,((function (path__$1,map__4582,map__4582__$1,path){
return (function (p1__4580_SHARP_){
return ["https://gist.githubusercontent.com/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path__$1),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__4580_SHARP_)].join('');
});})(path__$1,map__4582,map__4582__$1,path))
,klipse_clj.lang.clojure.io.cljs_suffixes);
return klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
}));
klipse_clj.lang.clojure.io.bundled_ns_ignore_regexp = (function klipse_clj$lang$clojure$io$bundled_ns_ignore_regexp(){
return new cljs.core.Keyword(null,"clojure_bundled_ns_ignore_regexp","clojure_bundled_ns_ignore_regexp",-1479622333).cljs$core$IFn$_invoke$arity$1(klipse_clj.lang.clojure.io._STAR_klipse_settings_STAR_);
});
klipse_clj.lang.clojure.io.custom_bundled_ns_ignore_QMARK_ = (function klipse_clj$lang$clojure$io$custom_bundled_ns_ignore_QMARK_(name){
var temp__6753__auto__ = klipse_clj.lang.clojure.io.bundled_ns_ignore_regexp.call(null);
if(cljs.core.truth_(temp__6753__auto__)){
var regexp = temp__6753__auto__;
return cljs.core.re_matches.call(null,regexp,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
return null;
}
});
klipse_clj.lang.clojure.io.buggy_bundled_ns_ignore_QMARK_ = (function klipse_clj$lang$clojure$io$buggy_bundled_ns_ignore_QMARK_(name){
return cljs.core.re_matches.call(null,/.*reagent.*|cljs.core.async.*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
/**
 * Checks whether a namespace is present at run-time
 */
klipse_clj.lang.clojure.io.bundled_ns_QMARK_ = (function klipse_clj$lang$clojure$io$bundled_ns_QMARK_(name){
if(cljs.core.truth_((function (){var or__3922__auto__ = klipse_clj.lang.clojure.io.buggy_bundled_ns_ignore_QMARK_.call(null,name);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return klipse_clj.lang.clojure.io.custom_bundled_ns_ignore_QMARK_.call(null,name);
}
})())){
return false;
} else {
var obj_SHARP_ = goog;
var fn_SHARP_ = (obj_SHARP_["getObjectByName"]);
return fn_SHARP_.call(obj_SHARP_,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.munge.call(null,name))].join(''));
}
});
klipse_clj.lang.clojure.io.cljsjs_QMARK_ = (function klipse_clj$lang$clojure$io$cljsjs_QMARK_(name){
return cljs.core.re_matches.call(null,/cljsjs\..*/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
});
klipse_clj.lang.clojure.io.cljsjs_libname = (function klipse_clj$lang$clojure$io$cljsjs_libname(name){
var $ = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('');
var $__$1 = cljs.core.re_matches.call(null,/cljsjs\.(.*)/,$);
var $__$2 = cljs.core.second.call(null,$__$1);
return clojure.string.replace.call(null,$__$2,/\./,"-");
});
/**
 * some cljsjs packages are already loaded e.g react in klipse app
 */
klipse_clj.lang.clojure.io.bundled_cljsjs_ns_QMARK_ = (function klipse_clj$lang$clojure$io$bundled_cljsjs_ns_QMARK_(name){
var or__3922__auto__ = (function (){var and__3911__auto__ = cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljsjs.react","cljsjs.react",822859692,null));
if(and__3911__auto__){
return (window["React"]);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
var or__3922__auto____$1 = (function (){var and__3911__auto__ = cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljsjs.react.dom.server","cljsjs.react.dom.server",-1041656528,null));
if(and__3911__auto__){
return (window["ReactDOMServer"]);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(or__3922__auto____$1)){
return or__3922__auto____$1;
} else {
var and__3911__auto__ = cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljsjs.react.dom","cljsjs.react.dom",-1678399696,null));
if(and__3911__auto__){
return (window["ReactDOM"]);
} else {
return and__3911__auto__;
}
}
}
});
/**
 * Try to load the js file corresponding to a cljsjs package.
 *   For that, we have to convert the package name into a full path - hosted on this git repo: https://github.com/viebel/cljsjs-hosted
 *   
 */
klipse_clj.lang.clojure.io.try_to_load_cljsjs_ns = (function klipse_clj$lang$clojure$io$try_to_load_cljsjs_ns(name,src_cb){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.log("load-ns :cljs try-to-load-cljsjs-ns",name);
} else {
}

if(cljs.core.truth_(klipse_clj.lang.clojure.io.bundled_cljsjs_ns_QMARK_.call(null,name))){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns bundled-cljsjs-ns",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
var root_path = (cljs.core.truth_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Symbol(null,"cljsjs.react","cljsjs.react",822859692,null),null,new cljs.core.Symbol(null,"cljsjs.react.dom.server","cljsjs.react.dom.server",-1041656528,null),null,new cljs.core.Symbol(null,"cljsjs.react.dom","cljsjs.react.dom",-1678399696,null),null], null), null).call(null,name))?"https://viebel.github.io/cljsjs-hosted/cljsjs-klipse-only/":"https://viebel.github.io/cljsjs-hosted/cljsjs/");
var lib_name = klipse_clj.lang.clojure.io.cljsjs_libname.call(null,name);
var full_names = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),"/production/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".min.inc.js"].join(''),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),"/production/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".min.inc.js"].join(''),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),"/development/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".inc.js"].join(''),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(root_path),"/development/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(lib_name),".inc.js"].join('')], null);
return klipse_clj.lang.clojure.io.try_to_load_ns.call(null,full_names,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
}
});
cljs.core._add_method.call(null,klipse_clj.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"cljs","cljs",1492417629),(function (external_libs,p__4585,src_cb){
var map__4586 = p__4585;
var map__4586__$1 = ((((!((map__4586 == null)))?(((((map__4586.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4586.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4586):map__4586);
var name = cljs.core.get.call(null,map__4586__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var path = cljs.core.get.call(null,map__4586__$1,new cljs.core.Keyword(null,"path","path",-188191168));
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :cljs :",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''),"external-libs: ",external_libs);
} else {
}

if(cljs.core.truth_(klipse_clj.lang.clojure.io.skip_ns_cljs.call(null,name))){
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :cljs skipping",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
if(cljs.core.truth_(klipse_clj.lang.clojure.io.bundled_ns_QMARK_.call(null,name))){
var _ = ((klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_)?console.log("load-ns :cljs bundled",name):null);
var filenames = cljs.core.map.call(null,((function (_,map__4586,map__4586__$1,name,path){
return (function (p1__4584_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(klipse_clj.lang.clojure.io.cache_url),cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__4584_SHARP_),".cache.json"].join('');
});})(_,map__4586,map__4586__$1,name,path))
,klipse_clj.lang.clojure.io.cljs_suffixes);
var c__3181__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3181__auto__,_,filenames,map__4586,map__4586__$1,name,path){
return (function (){
var f__3182__auto__ = (function (){var switch__3158__auto__ = ((function (c__3181__auto__,_,filenames,map__4586,map__4586__$1,name,path){
return (function (state_4600){
var state_val_4601 = (state_4600[(1)]);
if((state_val_4601 === (1))){
var inst_4588 = klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"cache","cache",-1237023054),src_cb,new cljs.core.Keyword(null,"transform","transform",1381301764),klipse_clj.lang.clojure.io.edn,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),true);
var state_4600__$1 = state_4600;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4600__$1,(2),inst_4588);
} else {
if((state_val_4601 === (2))){
var inst_4590 = (state_4600[(2)]);
var state_4600__$1 = state_4600;
if(cljs.core.truth_(inst_4590)){
var statearr_4602_4653 = state_4600__$1;
(statearr_4602_4653[(1)] = (3));

} else {
var statearr_4603_4654 = state_4600__$1;
(statearr_4603_4654[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4601 === (3))){
var state_4600__$1 = state_4600;
var statearr_4604_4655 = state_4600__$1;
(statearr_4604_4655[(2)] = null);

(statearr_4604_4655[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4601 === (4))){
var inst_4593 = [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"source","source",-433931539)];
var inst_4594 = [new cljs.core.Keyword(null,"js","js",1768080579),""];
var inst_4595 = cljs.core.PersistentHashMap.fromArrays(inst_4593,inst_4594);
var inst_4596 = src_cb.call(null,inst_4595);
var state_4600__$1 = state_4600;
var statearr_4605_4656 = state_4600__$1;
(statearr_4605_4656[(2)] = inst_4596);

(statearr_4605_4656[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4601 === (5))){
var inst_4598 = (state_4600[(2)]);
var state_4600__$1 = state_4600;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4600__$1,inst_4598);
} else {
return null;
}
}
}
}
}
});})(c__3181__auto__,_,filenames,map__4586,map__4586__$1,name,path))
;
return ((function (switch__3158__auto__,c__3181__auto__,_,filenames,map__4586,map__4586__$1,name,path){
return (function() {
var klipse_clj$lang$clojure$io$state_machine__3159__auto__ = null;
var klipse_clj$lang$clojure$io$state_machine__3159__auto____0 = (function (){
var statearr_4606 = [null,null,null,null,null,null,null];
(statearr_4606[(0)] = klipse_clj$lang$clojure$io$state_machine__3159__auto__);

(statearr_4606[(1)] = (1));

return statearr_4606;
});
var klipse_clj$lang$clojure$io$state_machine__3159__auto____1 = (function (state_4600){
while(true){
var ret_value__3160__auto__ = (function (){try{while(true){
var result__3161__auto__ = switch__3158__auto__.call(null,state_4600);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3161__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3161__auto__;
}
break;
}
}catch (e4607){if((e4607 instanceof Object)){
var ex__3162__auto__ = e4607;
var statearr_4608_4657 = state_4600;
(statearr_4608_4657[(5)] = ex__3162__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4600);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4607;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3160__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4658 = state_4600;
state_4600 = G__4658;
continue;
} else {
return ret_value__3160__auto__;
}
break;
}
});
klipse_clj$lang$clojure$io$state_machine__3159__auto__ = function(state_4600){
switch(arguments.length){
case 0:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____0.call(this);
case 1:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____1.call(this,state_4600);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$0 = klipse_clj$lang$clojure$io$state_machine__3159__auto____0;
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$1 = klipse_clj$lang$clojure$io$state_machine__3159__auto____1;
return klipse_clj$lang$clojure$io$state_machine__3159__auto__;
})()
;})(switch__3158__auto__,c__3181__auto__,_,filenames,map__4586,map__4586__$1,name,path))
})();
var state__3183__auto__ = (function (){var statearr_4609 = f__3182__auto__.call(null);
(statearr_4609[(6)] = c__3181__auto__);

return statearr_4609;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3183__auto__);
});})(c__3181__auto__,_,filenames,map__4586,map__4586__$1,name,path))
);

return c__3181__auto__;
} else {
if(cljs.core.truth_(klipse_clj.lang.clojure.io.cached_cljs_ns_QMARK_.call(null,name))){
return klipse_clj.lang.clojure.io.load_ns_from_cache.call(null,name,src_cb,false);
} else {
if(cljs.core.truth_(klipse_clj.lang.clojure.io.cljsjs_QMARK_.call(null,name))){
return klipse_clj.lang.clojure.io.try_to_load_cljsjs_ns.call(null,name,src_cb);
} else {
if(cljs.core.truth_(klipse_clj.lang.clojure.io.the_ns_map.call(null,name))){
var prefix = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(klipse_clj.lang.clojure.io.the_ns_map.call(null,name)),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(path)].join('');
var filenames = cljs.core.map.call(null,cljs.core.partial.call(null,cljs.core.str,prefix),klipse_clj.lang.clojure.io.cljs_suffixes);
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :cljs from external libs",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

var c__3181__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3181__auto__,prefix,filenames,map__4586,map__4586__$1,name,path){
return (function (){
var f__3182__auto__ = (function (){var switch__3158__auto__ = ((function (c__3181__auto__,prefix,filenames,map__4586,map__4586__$1,name,path){
return (function (state_4620){
var state_val_4621 = (state_4620[(1)]);
if((state_val_4621 === (1))){
var inst_4610 = klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),true);
var state_4620__$1 = state_4620;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4620__$1,(2),inst_4610);
} else {
if((state_val_4621 === (2))){
var inst_4612 = (state_4620[(2)]);
var state_4620__$1 = state_4620;
if(cljs.core.truth_(inst_4612)){
var statearr_4622_4659 = state_4620__$1;
(statearr_4622_4659[(1)] = (3));

} else {
var statearr_4623_4660 = state_4620__$1;
(statearr_4623_4660[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4621 === (3))){
var state_4620__$1 = state_4620;
var statearr_4624_4661 = state_4620__$1;
(statearr_4624_4661[(2)] = null);

(statearr_4624_4661[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4621 === (4))){
var inst_4615 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prefix),".js"].join('');
var inst_4616 = klipse_clj.lang.clojure.io.try_to_load_ns.call(null,inst_4615,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
var state_4620__$1 = state_4620;
var statearr_4625_4662 = state_4620__$1;
(statearr_4625_4662[(2)] = inst_4616);

(statearr_4625_4662[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4621 === (5))){
var inst_4618 = (state_4620[(2)]);
var state_4620__$1 = state_4620;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4620__$1,inst_4618);
} else {
return null;
}
}
}
}
}
});})(c__3181__auto__,prefix,filenames,map__4586,map__4586__$1,name,path))
;
return ((function (switch__3158__auto__,c__3181__auto__,prefix,filenames,map__4586,map__4586__$1,name,path){
return (function() {
var klipse_clj$lang$clojure$io$state_machine__3159__auto__ = null;
var klipse_clj$lang$clojure$io$state_machine__3159__auto____0 = (function (){
var statearr_4626 = [null,null,null,null,null,null,null];
(statearr_4626[(0)] = klipse_clj$lang$clojure$io$state_machine__3159__auto__);

(statearr_4626[(1)] = (1));

return statearr_4626;
});
var klipse_clj$lang$clojure$io$state_machine__3159__auto____1 = (function (state_4620){
while(true){
var ret_value__3160__auto__ = (function (){try{while(true){
var result__3161__auto__ = switch__3158__auto__.call(null,state_4620);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3161__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3161__auto__;
}
break;
}
}catch (e4627){if((e4627 instanceof Object)){
var ex__3162__auto__ = e4627;
var statearr_4628_4663 = state_4620;
(statearr_4628_4663[(5)] = ex__3162__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4620);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4627;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3160__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4664 = state_4620;
state_4620 = G__4664;
continue;
} else {
return ret_value__3160__auto__;
}
break;
}
});
klipse_clj$lang$clojure$io$state_machine__3159__auto__ = function(state_4620){
switch(arguments.length){
case 0:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____0.call(this);
case 1:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____1.call(this,state_4620);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$0 = klipse_clj$lang$clojure$io$state_machine__3159__auto____0;
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$1 = klipse_clj$lang$clojure$io$state_machine__3159__auto____1;
return klipse_clj$lang$clojure$io$state_machine__3159__auto__;
})()
;})(switch__3158__auto__,c__3181__auto__,prefix,filenames,map__4586,map__4586__$1,name,path))
})();
var state__3183__auto__ = (function (){var statearr_4629 = f__3182__auto__.call(null);
(statearr_4629[(6)] = c__3181__auto__);

return statearr_4629;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3183__auto__);
});})(c__3181__auto__,prefix,filenames,map__4586,map__4586__$1,name,path))
);

return c__3181__auto__;
} else {
if(cljs.core.seq.call(null,external_libs)){
var filenames = klipse_clj.lang.clojure.io.external_libs_files.call(null,external_libs,klipse_clj.lang.clojure.io.cljs_suffixes,path);
var c__3181__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3181__auto__,filenames,map__4586,map__4586__$1,name,path){
return (function (){
var f__3182__auto__ = (function (){var switch__3158__auto__ = ((function (c__3181__auto__,filenames,map__4586,map__4586__$1,name,path){
return (function (state_4643){
var state_val_4644 = (state_4643[(1)]);
if((state_val_4644 === (1))){
var inst_4630 = klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"clj","clj",-660495428),new cljs.core.Keyword(null,"source","source",-433931539),src_cb,new cljs.core.Keyword(null,"can-recover?","can-recover?",855047956),true);
var state_4643__$1 = state_4643;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4643__$1,(2),inst_4630);
} else {
if((state_val_4644 === (2))){
var inst_4632 = (state_4643[(2)]);
var state_4643__$1 = state_4643;
if(cljs.core.truth_(inst_4632)){
var statearr_4645_4665 = state_4643__$1;
(statearr_4645_4665[(1)] = (3));

} else {
var statearr_4646_4666 = state_4643__$1;
(statearr_4646_4666[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4644 === (3))){
var state_4643__$1 = state_4643;
var statearr_4647_4667 = state_4643__$1;
(statearr_4647_4667[(2)] = null);

(statearr_4647_4667[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4644 === (4))){
var inst_4635 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_4636 = [".js"];
var inst_4637 = (new cljs.core.PersistentVector(null,1,(5),inst_4635,inst_4636,null));
var inst_4638 = klipse_clj.lang.clojure.io.external_libs_files.call(null,external_libs,inst_4637,path);
var inst_4639 = klipse_clj.lang.clojure.io.try_to_load_ns.call(null,inst_4638,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);
var state_4643__$1 = state_4643;
var statearr_4648_4668 = state_4643__$1;
(statearr_4648_4668[(2)] = inst_4639);

(statearr_4648_4668[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4644 === (5))){
var inst_4641 = (state_4643[(2)]);
var state_4643__$1 = state_4643;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4643__$1,inst_4641);
} else {
return null;
}
}
}
}
}
});})(c__3181__auto__,filenames,map__4586,map__4586__$1,name,path))
;
return ((function (switch__3158__auto__,c__3181__auto__,filenames,map__4586,map__4586__$1,name,path){
return (function() {
var klipse_clj$lang$clojure$io$state_machine__3159__auto__ = null;
var klipse_clj$lang$clojure$io$state_machine__3159__auto____0 = (function (){
var statearr_4649 = [null,null,null,null,null,null,null];
(statearr_4649[(0)] = klipse_clj$lang$clojure$io$state_machine__3159__auto__);

(statearr_4649[(1)] = (1));

return statearr_4649;
});
var klipse_clj$lang$clojure$io$state_machine__3159__auto____1 = (function (state_4643){
while(true){
var ret_value__3160__auto__ = (function (){try{while(true){
var result__3161__auto__ = switch__3158__auto__.call(null,state_4643);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3161__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3161__auto__;
}
break;
}
}catch (e4650){if((e4650 instanceof Object)){
var ex__3162__auto__ = e4650;
var statearr_4651_4669 = state_4643;
(statearr_4651_4669[(5)] = ex__3162__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4643);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4650;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3160__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4670 = state_4643;
state_4643 = G__4670;
continue;
} else {
return ret_value__3160__auto__;
}
break;
}
});
klipse_clj$lang$clojure$io$state_machine__3159__auto__ = function(state_4643){
switch(arguments.length){
case 0:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____0.call(this);
case 1:
return klipse_clj$lang$clojure$io$state_machine__3159__auto____1.call(this,state_4643);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$0 = klipse_clj$lang$clojure$io$state_machine__3159__auto____0;
klipse_clj$lang$clojure$io$state_machine__3159__auto__.cljs$core$IFn$_invoke$arity$1 = klipse_clj$lang$clojure$io$state_machine__3159__auto____1;
return klipse_clj$lang$clojure$io$state_machine__3159__auto__;
})()
;})(switch__3158__auto__,c__3181__auto__,filenames,map__4586,map__4586__$1,name,path))
})();
var state__3183__auto__ = (function (){var statearr_4652 = f__3182__auto__.call(null);
(statearr_4652[(6)] = c__3181__auto__);

return statearr_4652;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3183__auto__);
});})(c__3181__auto__,filenames,map__4586,map__4586__$1,name,path))
);

return c__3181__auto__;
} else {
if(klipse_clj.lang.clojure.io._STAR_verbose_QMARK__STAR_){
console.info("load-ns :cljs nothing can be done",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
} else {
}

return src_cb.call(null,null);

}
}
}
}
}
}
}));
klipse_clj.lang.clojure.io.fix_goog_path = (function klipse_clj$lang$clojure$io$fix_goog_path(path){
var parts = clojure.string.split.call(null,path,/\//);
var last_part = cljs.core.last.call(null,parts);
var new_parts = cljs.core.concat.call(null,cljs.core.butlast.call(null,parts),((cljs.core._EQ_.call(null,last_part,clojure.string.lower_case.call(null,last_part)))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [last_part,last_part], null):new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [clojure.string.lower_case.call(null,last_part)], null)));
return clojure.string.join.call(null,"/",new_parts);
});
klipse_clj.lang.clojure.io.simple_goog_path = (function klipse_clj$lang$clojure$io$simple_goog_path(path){
var parts = clojure.string.split.call(null,path,/\//);
var butlast_parts = cljs.core.butlast.call(null,parts);
var new_parts = cljs.core.concat.call(null,butlast_parts,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.last.call(null,butlast_parts)], null));
return clojure.string.join.call(null,"/",new_parts);
});
klipse_clj.lang.clojure.io.another_goog_path = (function klipse_clj$lang$clojure$io$another_goog_path(path){
var parts = clojure.string.split.call(null,path,/\//);
var last_part = cljs.core.last.call(null,parts);
var new_parts = cljs.core.concat.call(null,cljs.core.butlast.call(null,parts),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [clojure.string.join.call(null,"",cljs.core.take_last.call(null,(2),parts))], null));
return clojure.string.join.call(null,"/",new_parts);
});
cljs.core._add_method.call(null,klipse_clj.lang.clojure.io.load_ns,new cljs.core.Keyword(null,"goog","goog",-1711135452),(function (_,p__4672,src_cb){
var map__4673 = p__4672;
var map__4673__$1 = ((((!((map__4673 == null)))?(((((map__4673.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4673.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4673):map__4673);
var name = cljs.core.get.call(null,map__4673__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var path = cljs.core.get.call(null,map__4673__$1,new cljs.core.Keyword(null,"path","path",-188191168));
if(cljs.core.truth_((function (){var obj_SHARP_ = goog;
var fn_SHARP_ = (obj_SHARP_["getObjectByName"]);
return fn_SHARP_.call(obj_SHARP_,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''));
})())){
return src_cb.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lang","lang",-1819677104),new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),""], null));
} else {
var closure_github_path = "https://raw.githubusercontent.com/google/closure-library/v20160713/closure/";
var filenames = cljs.core.map.call(null,((function (closure_github_path,map__4673,map__4673__$1,name,path){
return (function (p1__4671_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(closure_github_path),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__4671_SHARP_),".js"].join('');
});})(closure_github_path,map__4673,map__4673__$1,name,path))
,cljs.core.juxt.call(null,klipse_clj.lang.clojure.io.fix_goog_path,cljs.core.identity,klipse_clj.lang.clojure.io.another_goog_path,klipse_clj.lang.clojure.io.simple_goog_path).call(null,path));
return klipse_clj.lang.clojure.io.try_to_load_ns.call(null,filenames,new cljs.core.Keyword(null,"js","js",1768080579),new cljs.core.Keyword(null,"source","source",-433931539),src_cb);

}
}));

//# sourceMappingURL=io.js.map
