// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('parinfer_codemirror.editor');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('parinfer_codemirror.state');
goog.require('parinfer_codemirror.editor_support');
parinfer_codemirror.editor.frame_updates = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
 * Called before any change is applied to the editor.
 */
parinfer_codemirror.editor.before_change = (function parinfer_codemirror$editor$before_change(cm,change){
if(((cljs.core._EQ_.call(null,"setValue",change.origin)) && (cljs.core._EQ_.call(null,cm.getValue(),clojure.string.join.call(null,"\n",change.text))))){
return change.cancel();
} else {
return null;
}
});
/**
 * Called after any change is applied to the editor.
 */
parinfer_codemirror.editor.on_change = (function parinfer_codemirror$editor$on_change(cm,change){
if(cljs.core.not_EQ_.call(null,"setValue",change.origin)){
parinfer_codemirror.editor_support.fix_text_BANG_.call(null,cm,new cljs.core.Keyword(null,"change","change",-1163046502),change);

parinfer_codemirror.editor_support.update_cursor_BANG_.call(null,cm,change);

return parinfer_codemirror.editor_support.set_frame_updated_BANG_.call(null,cm,true);
} else {
return null;
}
});
/**
 * Called after the cursor moves in the editor.
 */
parinfer_codemirror.editor.on_cursor_activity = (function parinfer_codemirror$editor$on_cursor_activity(cm){
if(cljs.core.truth_(parinfer_codemirror.editor_support.frame_updated_QMARK_.call(null,cm))){
} else {
parinfer_codemirror.editor_support.fix_text_BANG_.call(null,cm);
}

return parinfer_codemirror.editor_support.set_frame_updated_BANG_.call(null,cm,false);
});
/**
 * Add parinfer goodness to a codemirror editor
 */
parinfer_codemirror.editor.parinferize_BANG_ = (function parinfer_codemirror$editor$parinferize_BANG_(cm,key_,parinfer_mode,initial_value){
if(cljs.core.truth_(cljs.core.get.call(null,cljs.core.deref.call(null,parinfer_codemirror.state.state),key_))){
return null;
} else {
var initial_state = cljs.core.assoc.call(null,parinfer_codemirror.state.empty_editor_state,new cljs.core.Keyword(null,"mode","mode",654403691),parinfer_mode,new cljs.core.Keyword(null,"text","text",-1790561697),initial_value);
var prev_editor_state = cljs.core.atom.call(null,null);
if(cljs.core.truth_(cljs.core.get.call(null,cljs.core.deref.call(null,parinfer_codemirror.state.state),key_))){
} else {
cljs.core.swap_BANG_.call(null,parinfer_codemirror.editor.frame_updates,cljs.core.assoc,key_,cljs.core.PersistentArrayMap.EMPTY);
}

cljs.core.swap_BANG_.call(null,parinfer_codemirror.state.state,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [key_], null),((function (initial_state,prev_editor_state){
return (function (p1__6226_SHARP_){
return cljs.core.assoc.call(null,(function (){var or__3922__auto__ = p1__6226_SHARP_;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return initial_state;
}
})(),new cljs.core.Keyword(null,"cm","cm",540591536),cm);
});})(initial_state,prev_editor_state))
);

var x6227_6228 = cm;
x6227_6228.parinfer_codemirror$editor_support$IEditor$ = cljs.core.PROTOCOL_SENTINEL;

x6227_6228.parinfer_codemirror$editor_support$IEditor$get_prev_state$arity$1 = ((function (x6227_6228,initial_state,prev_editor_state){
return (function (this$){
var this$__$1 = this;
return prev_editor_state;
});})(x6227_6228,initial_state,prev_editor_state))
;

x6227_6228.parinfer_codemirror$editor_support$IEditor$cm_key$arity$1 = ((function (x6227_6228,initial_state,prev_editor_state){
return (function (this$){
var this$__$1 = this;
return key_;
});})(x6227_6228,initial_state,prev_editor_state))
;

x6227_6228.parinfer_codemirror$editor_support$IEditor$frame_updated_QMARK_$arity$1 = ((function (x6227_6228,initial_state,prev_editor_state){
return (function (this$){
var this$__$1 = this;
return cljs.core.get_in.call(null,cljs.core.deref.call(null,parinfer_codemirror.editor.frame_updates),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [key_,new cljs.core.Keyword(null,"frame-updated?","frame-updated?",-682706815)], null));
});})(x6227_6228,initial_state,prev_editor_state))
;

x6227_6228.parinfer_codemirror$editor_support$IEditor$set_frame_updated_BANG_$arity$2 = ((function (x6227_6228,initial_state,prev_editor_state){
return (function (this$,value){
var this$__$1 = this;
return cljs.core.swap_BANG_.call(null,parinfer_codemirror.editor.frame_updates,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [key_,new cljs.core.Keyword(null,"frame-updated?","frame-updated?",-682706815)], null),value);
});})(x6227_6228,initial_state,prev_editor_state))
;


cm.on("change",parinfer_codemirror.editor.on_change);

cm.on("beforeChange",parinfer_codemirror.editor.before_change);

cm.on("cursorActivity",parinfer_codemirror.editor.on_cursor_activity);

return cm;
}
});
/**
 * Called every time the state changes to sync the code editor.
 */
parinfer_codemirror.editor.on_state_change = (function parinfer_codemirror$editor$on_state_change(_,___$1,old_state,new_state){
var seq__6229 = cljs.core.seq.call(null,new_state);
var chunk__6230 = null;
var count__6231 = (0);
var i__6232 = (0);
while(true){
if((i__6232 < count__6231)){
var vec__6233 = cljs.core._nth.call(null,chunk__6230,i__6232);
var k = cljs.core.nth.call(null,vec__6233,(0),null);
var map__6236 = cljs.core.nth.call(null,vec__6233,(1),null);
var map__6236__$1 = ((((!((map__6236 == null)))?(((((map__6236.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6236.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6236):map__6236);
var cm = cljs.core.get.call(null,map__6236__$1,new cljs.core.Keyword(null,"cm","cm",540591536));
var text = cljs.core.get.call(null,map__6236__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
var changed_QMARK__6243 = cljs.core.not_EQ_.call(null,text,cm.getValue());
if(changed_QMARK__6243){
cm.setValue(text);
} else {
}


var G__6244 = seq__6229;
var G__6245 = chunk__6230;
var G__6246 = count__6231;
var G__6247 = (i__6232 + (1));
seq__6229 = G__6244;
chunk__6230 = G__6245;
count__6231 = G__6246;
i__6232 = G__6247;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__6229);
if(temp__6753__auto__){
var seq__6229__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__6229__$1)){
var c__4319__auto__ = cljs.core.chunk_first.call(null,seq__6229__$1);
var G__6248 = cljs.core.chunk_rest.call(null,seq__6229__$1);
var G__6249 = c__4319__auto__;
var G__6250 = cljs.core.count.call(null,c__4319__auto__);
var G__6251 = (0);
seq__6229 = G__6248;
chunk__6230 = G__6249;
count__6231 = G__6250;
i__6232 = G__6251;
continue;
} else {
var vec__6238 = cljs.core.first.call(null,seq__6229__$1);
var k = cljs.core.nth.call(null,vec__6238,(0),null);
var map__6241 = cljs.core.nth.call(null,vec__6238,(1),null);
var map__6241__$1 = ((((!((map__6241 == null)))?(((((map__6241.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6241.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6241):map__6241);
var cm = cljs.core.get.call(null,map__6241__$1,new cljs.core.Keyword(null,"cm","cm",540591536));
var text = cljs.core.get.call(null,map__6241__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
var changed_QMARK__6252 = cljs.core.not_EQ_.call(null,text,cm.getValue());
if(changed_QMARK__6252){
cm.setValue(text);
} else {
}


var G__6253 = cljs.core.next.call(null,seq__6229__$1);
var G__6254 = null;
var G__6255 = (0);
var G__6256 = (0);
seq__6229 = G__6253;
chunk__6230 = G__6254;
count__6231 = G__6255;
i__6232 = G__6256;
continue;
}
} else {
return null;
}
}
break;
}
});
parinfer_codemirror.editor.force_editor_sync_BANG_ = (function parinfer_codemirror$editor$force_editor_sync_BANG_(){
var seq__6257 = cljs.core.seq.call(null,cljs.core.deref.call(null,parinfer_codemirror.state.state));
var chunk__6258 = null;
var count__6259 = (0);
var i__6260 = (0);
while(true){
if((i__6260 < count__6259)){
var vec__6261 = cljs.core._nth.call(null,chunk__6258,i__6260);
var k = cljs.core.nth.call(null,vec__6261,(0),null);
var map__6264 = cljs.core.nth.call(null,vec__6261,(1),null);
var map__6264__$1 = ((((!((map__6264 == null)))?(((((map__6264.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6264.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6264):map__6264);
var cm = cljs.core.get.call(null,map__6264__$1,new cljs.core.Keyword(null,"cm","cm",540591536));
var text = cljs.core.get.call(null,map__6264__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
cm.setValue(text);


var G__6271 = seq__6257;
var G__6272 = chunk__6258;
var G__6273 = count__6259;
var G__6274 = (i__6260 + (1));
seq__6257 = G__6271;
chunk__6258 = G__6272;
count__6259 = G__6273;
i__6260 = G__6274;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__6257);
if(temp__6753__auto__){
var seq__6257__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__6257__$1)){
var c__4319__auto__ = cljs.core.chunk_first.call(null,seq__6257__$1);
var G__6275 = cljs.core.chunk_rest.call(null,seq__6257__$1);
var G__6276 = c__4319__auto__;
var G__6277 = cljs.core.count.call(null,c__4319__auto__);
var G__6278 = (0);
seq__6257 = G__6275;
chunk__6258 = G__6276;
count__6259 = G__6277;
i__6260 = G__6278;
continue;
} else {
var vec__6266 = cljs.core.first.call(null,seq__6257__$1);
var k = cljs.core.nth.call(null,vec__6266,(0),null);
var map__6269 = cljs.core.nth.call(null,vec__6266,(1),null);
var map__6269__$1 = ((((!((map__6269 == null)))?(((((map__6269.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6269.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6269):map__6269);
var cm = cljs.core.get.call(null,map__6269__$1,new cljs.core.Keyword(null,"cm","cm",540591536));
var text = cljs.core.get.call(null,map__6269__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
cm.setValue(text);


var G__6279 = cljs.core.next.call(null,seq__6257__$1);
var G__6280 = null;
var G__6281 = (0);
var G__6282 = (0);
seq__6257 = G__6279;
chunk__6258 = G__6280;
count__6259 = G__6281;
i__6260 = G__6282;
continue;
}
} else {
return null;
}
}
break;
}
});
parinfer_codemirror.editor.start_editor_sync_BANG_ = (function parinfer_codemirror$editor$start_editor_sync_BANG_(){
cljs.core.add_watch.call(null,parinfer_codemirror.state.state,new cljs.core.Keyword(null,"editor-updater","editor-updater",-323951652),parinfer_codemirror.editor.on_state_change);

return parinfer_codemirror.editor.force_editor_sync_BANG_.call(null);
});
/**
 * Add parinfer goodness to a codemirror editor
 */
parinfer_codemirror.editor.parinferize_and_sync_BANG_ = (function parinfer_codemirror$editor$parinferize_and_sync_BANG_(cm,key_,parinfer_mode,initial_value){
parinfer_codemirror.editor.parinferize_BANG_.call(null,cm,key_,parinfer_mode,initial_value);

return parinfer_codemirror.editor.start_editor_sync_BANG_.call(null);
});
goog.exportSymbol('parinfer_codemirror.editor.parinferize_and_sync_BANG_', parinfer_codemirror.editor.parinferize_and_sync_BANG_);

//# sourceMappingURL=editor.js.map
