// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('cljs.compiler');
goog.require('cljs.core');
goog.require('goog.string');
goog.require('clojure.string');
goog.require('clojure.set');
goog.require('cljs.tools.reader');
goog.require('cljs.env');
goog.require('cljs.analyzer');
goog.require('cljs.source_map');
goog.require('goog.string.StringBuffer');
cljs.compiler.js_reserved = cljs.analyzer.js_reserved;
cljs.compiler.es5_GT__EQ_ = cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,cljs.core.comp.call(null,cljs.core.mapcat.call(null,(function (lang){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [lang,cljs.core.keyword.call(null,clojure.string.replace.call(null,cljs.core.name.call(null,lang),/^ecmascript/,"es"))], null);
}))),new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ecmascript5","ecmascript5",342717552),new cljs.core.Keyword(null,"ecmascript5-strict","ecmascript5-strict",888234811),new cljs.core.Keyword(null,"ecmascript6","ecmascript6",723864898),new cljs.core.Keyword(null,"ecmascript6-strict","ecmascript6-strict",-786049555),new cljs.core.Keyword(null,"ecmascript-2015","ecmascript-2015",-902254444),new cljs.core.Keyword(null,"ecmascript6-typed","ecmascript6-typed",-1978203054),new cljs.core.Keyword(null,"ecmascript-2016","ecmascript-2016",471574729),new cljs.core.Keyword(null,"ecmascript-2017","ecmascript-2017",620145058),new cljs.core.Keyword(null,"ecmascript-next","ecmascript-next",-1935155962)], null));
cljs.compiler._STAR_recompiled_STAR_ = null;
cljs.compiler._STAR_inputs_STAR_ = null;
cljs.compiler._STAR_source_map_data_STAR_ = null;
cljs.compiler._STAR_lexical_renames_STAR_ = cljs.core.PersistentArrayMap.EMPTY;
cljs.compiler.cljs_reserved_file_names = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["deps.cljs",null], null), null);
/**
 * Gets the part up to the first `.` of a namespace.
 * Returns the empty string for nil.
 * Returns the entire string if no `.` in namespace
 */
cljs.compiler.get_first_ns_segment = (function cljs$compiler$get_first_ns_segment(ns){
var ns__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns)].join('');
var idx = ns__$1.indexOf(".");
if(((-1) === idx)){
return ns__$1;
} else {
return cljs.core.subs.call(null,ns__$1,(0),idx);
}
});
cljs.compiler.find_ns_starts_with = (function cljs$compiler$find_ns_starts_with(needle){
return cljs.core.reduce_kv.call(null,(function (xs,ns,_){
if(cljs.core._EQ_.call(null,needle,cljs.compiler.get_first_ns_segment.call(null,ns))){
return cljs.core.reduced.call(null,needle);
} else {
return null;
}
}),null,new cljs.core.Keyword("cljs.analyzer","namespaces","cljs.analyzer/namespaces",-260788927).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
});
cljs.compiler.shadow_depth = (function cljs$compiler$shadow_depth(s){
var map__7960 = s;
var map__7960__$1 = ((((!((map__7960 == null)))?(((((map__7960.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__7960.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__7960):map__7960);
var name = cljs.core.get.call(null,map__7960__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var info = cljs.core.get.call(null,map__7960__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var d = (0);
var G__7963 = info;
var map__7964 = G__7963;
var map__7964__$1 = ((((!((map__7964 == null)))?(((((map__7964.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__7964.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__7964):map__7964);
var shadow = cljs.core.get.call(null,map__7964__$1,new cljs.core.Keyword(null,"shadow","shadow",873231803));
var d__$1 = d;
var G__7963__$1 = G__7963;
while(true){
var d__$2 = d__$1;
var map__7966 = G__7963__$1;
var map__7966__$1 = ((((!((map__7966 == null)))?(((((map__7966.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__7966.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__7966):map__7966);
var shadow__$1 = cljs.core.get.call(null,map__7966__$1,new cljs.core.Keyword(null,"shadow","shadow",873231803));
if(cljs.core.truth_(shadow__$1)){
var G__7968 = (d__$2 + (1));
var G__7969 = shadow__$1;
d__$1 = G__7968;
G__7963__$1 = G__7969;
continue;
} else {
if(cljs.core.truth_(cljs.compiler.find_ns_starts_with.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('')))){
return (d__$2 + (1));
} else {
return d__$2;

}
}
break;
}
});
cljs.compiler.hash_scope = (function cljs$compiler$hash_scope(s){
return cljs.core.hash_combine.call(null,cljs.core._hash.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(s)),cljs.compiler.shadow_depth.call(null,s));
});
cljs.compiler.fn_self_name = (function cljs$compiler$fn_self_name(p__7970){
var map__7971 = p__7970;
var map__7971__$1 = ((((!((map__7971 == null)))?(((((map__7971.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__7971.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__7971):map__7971);
var name_var = map__7971__$1;
var name = cljs.core.get.call(null,map__7971__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var info = cljs.core.get.call(null,map__7971__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var name__$1 = clojure.string.replace.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''),"..","_DOT__DOT_");
var map__7973 = info;
var map__7973__$1 = ((((!((map__7973 == null)))?(((((map__7973.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__7973.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__7973):map__7973);
var ns = cljs.core.get.call(null,map__7973__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
var fn_scope = cljs.core.get.call(null,map__7973__$1,new cljs.core.Keyword(null,"fn-scope","fn-scope",-865664859));
var scoped_name = cljs.core.apply.call(null,cljs.core.str,cljs.core.interpose.call(null,"_$_",cljs.core.concat.call(null,cljs.core.map.call(null,cljs.core.comp.call(null,cljs.core.str,new cljs.core.Keyword(null,"name","name",1843675177)),fn_scope),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [name__$1], null))));
return cljs.core.symbol.call(null,cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.replace.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns)].join(''),".","$")),"$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(scoped_name)].join('')));
});
cljs.compiler.munge_reserved = (function cljs$compiler$munge_reserved(reserved){
return (function (s){
if(!((cljs.core.get.call(null,reserved,s) == null))){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(s),"$"].join('');
} else {
return s;
}
});
});
cljs.compiler.munge = (function cljs$compiler$munge(var_args){
var G__7976 = arguments.length;
switch (G__7976) {
case 1:
return cljs.compiler.munge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.compiler.munge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.compiler.munge.cljs$core$IFn$_invoke$arity$1 = (function (s){
return cljs.compiler.munge.call(null,s,cljs.compiler.js_reserved);
});

cljs.compiler.munge.cljs$core$IFn$_invoke$arity$2 = (function (s,reserved){
if(cljs.analyzer.cljs_map_QMARK_.call(null,s)){
var name_var = s;
var name = new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(name_var);
var field = new cljs.core.Keyword(null,"field","field",-1302436500).cljs$core$IFn$_invoke$arity$1(name_var);
var info = new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(name_var);
if(!((new cljs.core.Keyword(null,"fn-self-name","fn-self-name",1461143531).cljs$core$IFn$_invoke$arity$1(info) == null))){
return cljs.compiler.fn_self_name.call(null,s);
} else {
var depth = cljs.compiler.shadow_depth.call(null,s);
var code = cljs.compiler.hash_scope.call(null,s);
var renamed = cljs.core.get.call(null,cljs.compiler._STAR_lexical_renames_STAR_,code);
var name__$1 = ((field === true)?["self__.",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''):((!((renamed == null)))?renamed:name
));
var munged_name = cljs.compiler.munge.call(null,name__$1,reserved);
if(((field === true) || ((depth === (0))))){
return munged_name;
} else {
return cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(munged_name),"__$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(depth)].join(''));
}
}
} else {
var ss = clojure.string.replace.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(s)].join(''),"..","_DOT__DOT_");
var ss__$1 = clojure.string.replace.call(null,ss,(new RegExp("\\/(.)")),".$1");
var rf = cljs.compiler.munge_reserved.call(null,reserved);
var ss__$2 = cljs.core.map.call(null,rf,clojure.string.split.call(null,ss__$1,/\./));
var ss__$3 = clojure.string.join.call(null,".",ss__$2);
var ms = cljs.core.munge_str.call(null,ss__$3);
if((s instanceof cljs.core.Symbol)){
return cljs.core.symbol.call(null,ms);
} else {
return ms;
}
}
});

cljs.compiler.munge.cljs$lang$maxFixedArity = 2;

cljs.compiler.comma_sep = (function cljs$compiler$comma_sep(xs){
return cljs.core.interpose.call(null,",",xs);
});
cljs.compiler.escape_char = (function cljs$compiler$escape_char(c){
var cp = goog.string.hashCode(c);
var G__7978 = cp;
switch (G__7978) {
case (34):
return "\\\"";

break;
case (92):
return "\\\\";

break;
case (8):
return "\\b";

break;
case (12):
return "\\f";

break;
case (10):
return "\\n";

break;
case (13):
return "\\r";

break;
case (9):
return "\\t";

break;
default:
if(((((31) < cp)) && ((cp < (127))))){
return c;
} else {
var unpadded = cp.toString((16));
var pad = cljs.core.subs.call(null,"0000",unpadded.length);
return ["\\u",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pad),cljs.core.str.cljs$core$IFn$_invoke$arity$1(unpadded)].join('');
}

}
});
cljs.compiler.escape_string = (function cljs$compiler$escape_string(s){
var sb = (new goog.string.StringBuffer());
var seq__7980_7984 = cljs.core.seq.call(null,s);
var chunk__7981_7985 = null;
var count__7982_7986 = (0);
var i__7983_7987 = (0);
while(true){
if((i__7983_7987 < count__7982_7986)){
var c_7988 = cljs.core._nth.call(null,chunk__7981_7985,i__7983_7987);
sb.append(cljs.compiler.escape_char.call(null,c_7988));


var G__7989 = seq__7980_7984;
var G__7990 = chunk__7981_7985;
var G__7991 = count__7982_7986;
var G__7992 = (i__7983_7987 + (1));
seq__7980_7984 = G__7989;
chunk__7981_7985 = G__7990;
count__7982_7986 = G__7991;
i__7983_7987 = G__7992;
continue;
} else {
var temp__6753__auto___7993 = cljs.core.seq.call(null,seq__7980_7984);
if(temp__6753__auto___7993){
var seq__7980_7994__$1 = temp__6753__auto___7993;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__7980_7994__$1)){
var c__4319__auto___7995 = cljs.core.chunk_first.call(null,seq__7980_7994__$1);
var G__7996 = cljs.core.chunk_rest.call(null,seq__7980_7994__$1);
var G__7997 = c__4319__auto___7995;
var G__7998 = cljs.core.count.call(null,c__4319__auto___7995);
var G__7999 = (0);
seq__7980_7984 = G__7996;
chunk__7981_7985 = G__7997;
count__7982_7986 = G__7998;
i__7983_7987 = G__7999;
continue;
} else {
var c_8000 = cljs.core.first.call(null,seq__7980_7994__$1);
sb.append(cljs.compiler.escape_char.call(null,c_8000));


var G__8001 = cljs.core.next.call(null,seq__7980_7994__$1);
var G__8002 = null;
var G__8003 = (0);
var G__8004 = (0);
seq__7980_7984 = G__8001;
chunk__7981_7985 = G__8002;
count__7982_7986 = G__8003;
i__7983_7987 = G__8004;
continue;
}
} else {
}
}
break;
}

return sb.toString();
});
cljs.compiler.wrap_in_double_quotes = (function cljs$compiler$wrap_in_double_quotes(x){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1("\""),cljs.core.str.cljs$core$IFn$_invoke$arity$1(x),cljs.core.str.cljs$core$IFn$_invoke$arity$1("\"")].join('');
});
if(typeof cljs.compiler.emit_STAR_ !== 'undefined'){
} else {
cljs.compiler.emit_STAR_ = (function (){var method_table__4382__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4383__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4384__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4385__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4386__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"cljs.compiler","emit*"),new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4386__auto__,method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__));
})();
}
cljs.compiler.emit = (function cljs$compiler$emit(ast){
var val__3702__auto__ = cljs.env._STAR_compiler_STAR_;
if((val__3702__auto__ == null)){
cljs.env._STAR_compiler_STAR_ = cljs.env.default_compiler_env.call(null);
} else {
}

try{if(cljs.core.truth_(cljs.compiler._STAR_source_map_data_STAR_)){
var map__8005_8010 = ast;
var map__8005_8011__$1 = ((((!((map__8005_8010 == null)))?(((((map__8005_8010.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8005_8010.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8005_8010):map__8005_8010);
var env_8012 = cljs.core.get.call(null,map__8005_8011__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core.truth_(new cljs.core.Keyword(null,"line","line",212345235).cljs$core$IFn$_invoke$arity$1(env_8012))){
var map__8007_8013 = env_8012;
var map__8007_8014__$1 = ((((!((map__8007_8013 == null)))?(((((map__8007_8013.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8007_8013.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8007_8013):map__8007_8013);
var line_8015 = cljs.core.get.call(null,map__8007_8014__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column_8016 = cljs.core.get.call(null,map__8007_8014__$1,new cljs.core.Keyword(null,"column","column",2078222095));
cljs.core.swap_BANG_.call(null,cljs.compiler._STAR_source_map_data_STAR_,((function (map__8007_8013,map__8007_8014__$1,line_8015,column_8016,map__8005_8010,map__8005_8011__$1,env_8012,val__3702__auto__){
return (function (m){
var minfo = (function (){var G__8009 = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"gcol","gcol",309250807),new cljs.core.Keyword(null,"gen-col","gen-col",1901918303).cljs$core$IFn$_invoke$arity$1(m),new cljs.core.Keyword(null,"gline","gline",-1086242431),new cljs.core.Keyword(null,"gen-line","gen-line",589592125).cljs$core$IFn$_invoke$arity$1(m)], null);
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(ast),new cljs.core.Keyword(null,"var","var",-769682797))){
return cljs.core.assoc.call(null,G__8009,new cljs.core.Keyword(null,"name","name",1843675177),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(ast)))].join(''));
} else {
return G__8009;
}
})();
return cljs.core.update_in.call(null,m,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"source-map","source-map",1706252311),(line_8015 - (1))], null),cljs.core.fnil.call(null,((function (minfo,map__8007_8013,map__8007_8014__$1,line_8015,column_8016,map__8005_8010,map__8005_8011__$1,env_8012,val__3702__auto__){
return (function (line__$1){
return cljs.core.update_in.call(null,line__$1,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.truth_(column_8016)?(column_8016 - (1)):(0))], null),cljs.core.fnil.call(null,((function (minfo,map__8007_8013,map__8007_8014__$1,line_8015,column_8016,map__8005_8010,map__8005_8011__$1,env_8012,val__3702__auto__){
return (function (column__$1){
return cljs.core.conj.call(null,column__$1,minfo);
});})(minfo,map__8007_8013,map__8007_8014__$1,line_8015,column_8016,map__8005_8010,map__8005_8011__$1,env_8012,val__3702__auto__))
,cljs.core.PersistentVector.EMPTY));
});})(minfo,map__8007_8013,map__8007_8014__$1,line_8015,column_8016,map__8005_8010,map__8005_8011__$1,env_8012,val__3702__auto__))
,cljs.core.sorted_map.call(null)));
});})(map__8007_8013,map__8007_8014__$1,line_8015,column_8016,map__8005_8010,map__8005_8011__$1,env_8012,val__3702__auto__))
);
} else {
}
} else {
}

return cljs.compiler.emit_STAR_.call(null,ast);
}finally {if((val__3702__auto__ == null)){
cljs.env._STAR_compiler_STAR_ = null;
} else {
}
}});
cljs.compiler.emits = (function cljs$compiler$emits(var_args){
var args__4502__auto__ = [];
var len__4499__auto___8023 = arguments.length;
var i__4500__auto___8024 = (0);
while(true){
if((i__4500__auto___8024 < len__4499__auto___8023)){
args__4502__auto__.push((arguments[i__4500__auto___8024]));

var G__8025 = (i__4500__auto___8024 + (1));
i__4500__auto___8024 = G__8025;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((0) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((0)),(0),null)):null);
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$variadic(argseq__4503__auto__);
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$variadic = (function (xs){
var seq__8019_8026 = cljs.core.seq.call(null,xs);
var chunk__8020_8027 = null;
var count__8021_8028 = (0);
var i__8022_8029 = (0);
while(true){
if((i__8022_8029 < count__8021_8028)){
var x_8030 = cljs.core._nth.call(null,chunk__8020_8027,i__8022_8029);
if((x_8030 == null)){
} else {
if(cljs.analyzer.cljs_map_QMARK_.call(null,x_8030)){
cljs.compiler.emit.call(null,x_8030);
} else {
if(cljs.analyzer.cljs_seq_QMARK_.call(null,x_8030)){
cljs.core.apply.call(null,cljs.compiler.emits,x_8030);
} else {
if(goog.isFunction(x_8030)){
x_8030.call(null);
} else {
var s_8031 = cljs.core.print_str.call(null,x_8030);
if((cljs.compiler._STAR_source_map_data_STAR_ == null)){
} else {
cljs.core.swap_BANG_.call(null,cljs.compiler._STAR_source_map_data_STAR_,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"gen-col","gen-col",1901918303)], null),((function (seq__8019_8026,chunk__8020_8027,count__8021_8028,i__8022_8029,s_8031,x_8030){
return (function (p1__8017_SHARP_){
return (p1__8017_SHARP_ + cljs.core.count.call(null,s_8031));
});})(seq__8019_8026,chunk__8020_8027,count__8021_8028,i__8022_8029,s_8031,x_8030))
);
}

cljs.core.print.call(null,s_8031);

}
}
}
}


var G__8032 = seq__8019_8026;
var G__8033 = chunk__8020_8027;
var G__8034 = count__8021_8028;
var G__8035 = (i__8022_8029 + (1));
seq__8019_8026 = G__8032;
chunk__8020_8027 = G__8033;
count__8021_8028 = G__8034;
i__8022_8029 = G__8035;
continue;
} else {
var temp__6753__auto___8036 = cljs.core.seq.call(null,seq__8019_8026);
if(temp__6753__auto___8036){
var seq__8019_8037__$1 = temp__6753__auto___8036;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8019_8037__$1)){
var c__4319__auto___8038 = cljs.core.chunk_first.call(null,seq__8019_8037__$1);
var G__8039 = cljs.core.chunk_rest.call(null,seq__8019_8037__$1);
var G__8040 = c__4319__auto___8038;
var G__8041 = cljs.core.count.call(null,c__4319__auto___8038);
var G__8042 = (0);
seq__8019_8026 = G__8039;
chunk__8020_8027 = G__8040;
count__8021_8028 = G__8041;
i__8022_8029 = G__8042;
continue;
} else {
var x_8043 = cljs.core.first.call(null,seq__8019_8037__$1);
if((x_8043 == null)){
} else {
if(cljs.analyzer.cljs_map_QMARK_.call(null,x_8043)){
cljs.compiler.emit.call(null,x_8043);
} else {
if(cljs.analyzer.cljs_seq_QMARK_.call(null,x_8043)){
cljs.core.apply.call(null,cljs.compiler.emits,x_8043);
} else {
if(goog.isFunction(x_8043)){
x_8043.call(null);
} else {
var s_8044 = cljs.core.print_str.call(null,x_8043);
if((cljs.compiler._STAR_source_map_data_STAR_ == null)){
} else {
cljs.core.swap_BANG_.call(null,cljs.compiler._STAR_source_map_data_STAR_,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"gen-col","gen-col",1901918303)], null),((function (seq__8019_8026,chunk__8020_8027,count__8021_8028,i__8022_8029,s_8044,x_8043,seq__8019_8037__$1,temp__6753__auto___8036){
return (function (p1__8017_SHARP_){
return (p1__8017_SHARP_ + cljs.core.count.call(null,s_8044));
});})(seq__8019_8026,chunk__8020_8027,count__8021_8028,i__8022_8029,s_8044,x_8043,seq__8019_8037__$1,temp__6753__auto___8036))
);
}

cljs.core.print.call(null,s_8044);

}
}
}
}


var G__8045 = cljs.core.next.call(null,seq__8019_8037__$1);
var G__8046 = null;
var G__8047 = (0);
var G__8048 = (0);
seq__8019_8026 = G__8045;
chunk__8020_8027 = G__8046;
count__8021_8028 = G__8047;
i__8022_8029 = G__8048;
continue;
}
} else {
}
}
break;
}

return null;
});

cljs.compiler.emits.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
cljs.compiler.emits.cljs$lang$applyTo = (function (seq8018){
var self__4487__auto__ = this;
return self__4487__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq8018));
});

cljs.compiler.emitln = (function cljs$compiler$emitln(var_args){
var args__4502__auto__ = [];
var len__4499__auto___8054 = arguments.length;
var i__4500__auto___8055 = (0);
while(true){
if((i__4500__auto___8055 < len__4499__auto___8054)){
args__4502__auto__.push((arguments[i__4500__auto___8055]));

var G__8056 = (i__4500__auto___8055 + (1));
i__4500__auto___8055 = G__8056;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((0) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((0)),(0),null)):null);
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$variadic(argseq__4503__auto__);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$variadic = (function (xs){
cljs.core.apply.call(null,cljs.compiler.emits,xs);

var _STAR_flush_on_newline_STAR_8050_8057 = cljs.core._STAR_flush_on_newline_STAR_;
cljs.core._STAR_flush_on_newline_STAR_ = false;

try{cljs.core.println.call(null);
}finally {cljs.core._STAR_flush_on_newline_STAR_ = _STAR_flush_on_newline_STAR_8050_8057;
}
if(cljs.core.truth_(cljs.compiler._STAR_source_map_data_STAR_)){
cljs.core.swap_BANG_.call(null,cljs.compiler._STAR_source_map_data_STAR_,(function (p__8051){
var map__8052 = p__8051;
var map__8052__$1 = ((((!((map__8052 == null)))?(((((map__8052.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8052.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8052):map__8052);
var m = map__8052__$1;
var gen_line = cljs.core.get.call(null,map__8052__$1,new cljs.core.Keyword(null,"gen-line","gen-line",589592125));
return cljs.core.assoc.call(null,m,new cljs.core.Keyword(null,"gen-line","gen-line",589592125),(gen_line + (1)),new cljs.core.Keyword(null,"gen-col","gen-col",1901918303),(0));
}));
} else {
}

return null;
});

cljs.compiler.emitln.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
cljs.compiler.emitln.cljs$lang$applyTo = (function (seq8049){
var self__4487__auto__ = this;
return self__4487__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq8049));
});

cljs.compiler.emit_str = (function cljs$compiler$emit_str(expr){
var sb__4430__auto__ = (new goog.string.StringBuffer());
var _STAR_print_newline_STAR_8058_8060 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_fn_STAR_8059_8061 = cljs.core._STAR_print_fn_STAR_;
cljs.core._STAR_print_newline_STAR_ = true;

cljs.core._STAR_print_fn_STAR_ = ((function (_STAR_print_newline_STAR_8058_8060,_STAR_print_fn_STAR_8059_8061,sb__4430__auto__){
return (function (x__4431__auto__){
return sb__4430__auto__.append(x__4431__auto__);
});})(_STAR_print_newline_STAR_8058_8060,_STAR_print_fn_STAR_8059_8061,sb__4430__auto__))
;

try{cljs.compiler.emit.call(null,expr);
}finally {cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR_8059_8061;

cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR_8058_8060;
}
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(sb__4430__auto__)].join('');
});
if(typeof cljs.compiler.emit_constant !== 'undefined'){
} else {
cljs.compiler.emit_constant = (function (){var method_table__4382__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4383__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4384__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4385__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4386__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"cljs.compiler","emit-constant"),cljs.core.type,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4386__auto__,method_table__4382__auto__,prefer_table__4383__auto__,method_cache__4384__auto__,cached_hierarchy__4385__auto__));
})();
}
cljs.core._add_method.call(null,cljs.compiler.emit_constant,new cljs.core.Keyword(null,"default","default",-1987822328),(function (x){
throw cljs.core.ex_info.call(null,["failed compiling constant: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x),"; ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.type.call(null,x))," is not a valid ClojureScript constant."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"constant","constant",-379609303),x,new cljs.core.Keyword(null,"type","type",1174270348),cljs.core.type.call(null,x)], null));
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,null,(function (x){
return cljs.compiler.emits.call(null,"null");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,Number,(function (x){
if(cljs.core.truth_(isNaN(x))){
return cljs.compiler.emits.call(null,"NaN");
} else {
if(cljs.core.not.call(null,isFinite(x))){
return cljs.compiler.emits.call(null,(((x > (0)))?"Infinity":"-Infinity"));
} else {
return cljs.compiler.emits.call(null,"(",x,")");

}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,String,(function (x){
return cljs.compiler.emits.call(null,cljs.compiler.wrap_in_double_quotes.call(null,cljs.compiler.escape_string.call(null,x)));
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,Boolean,(function (x){
return cljs.compiler.emits.call(null,(cljs.core.truth_(x)?"true":"false"));
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,RegExp,(function (x){
if(cljs.core._EQ_.call(null,"",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''))){
return cljs.compiler.emits.call(null,"(new RegExp(\"\"))");
} else {
var vec__8062 = cljs.core.re_find.call(null,/^(?:\(\?([idmsux]*)\))?(.*)/,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''));
var _ = cljs.core.nth.call(null,vec__8062,(0),null);
var flags = cljs.core.nth.call(null,vec__8062,(1),null);
var pattern = cljs.core.nth.call(null,vec__8062,(2),null);
return cljs.compiler.emits.call(null,pattern);
}
}));
cljs.compiler.emits_keyword = (function cljs$compiler$emits_keyword(kw){
var ns = cljs.core.namespace.call(null,kw);
var name = cljs.core.name.call(null,kw);
cljs.compiler.emits.call(null,"new cljs.core.Keyword(");

cljs.compiler.emit_constant.call(null,ns);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,name);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,(cljs.core.truth_(ns)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''):name));

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,cljs.core.hash.call(null,kw));

return cljs.compiler.emits.call(null,")");
});
cljs.compiler.emits_symbol = (function cljs$compiler$emits_symbol(sym){
var ns = cljs.core.namespace.call(null,sym);
var name = cljs.core.name.call(null,sym);
var symstr = ((!((ns == null)))?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''):name);
cljs.compiler.emits.call(null,"new cljs.core.Symbol(");

cljs.compiler.emit_constant.call(null,ns);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,name);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,symstr);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,cljs.core.hash.call(null,sym));

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,null);

return cljs.compiler.emits.call(null,")");
});
cljs.core._add_method.call(null,cljs.compiler.emit_constant,cljs.core.Keyword,(function (x){
var temp__6751__auto__ = (function (){var and__3911__auto__ = new cljs.core.Keyword(null,"emit-constants","emit-constants",-476585410).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"options","options",99638489).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
if(cljs.core.truth_(and__3911__auto__)){
return x.call(null,new cljs.core.Keyword("cljs.analyzer","constant-table","cljs.analyzer/constant-table",-114131889).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(temp__6751__auto__)){
var value = temp__6751__auto__;
return cljs.compiler.emits.call(null,"cljs.core.",value);
} else {
return cljs.compiler.emits_keyword.call(null,x);
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,cljs.core.Symbol,(function (x){
var temp__6751__auto__ = (function (){var and__3911__auto__ = new cljs.core.Keyword(null,"emit-constants","emit-constants",-476585410).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"options","options",99638489).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
if(cljs.core.truth_(and__3911__auto__)){
return x.call(null,new cljs.core.Keyword("cljs.analyzer","constant-table","cljs.analyzer/constant-table",-114131889).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(temp__6751__auto__)){
var value = temp__6751__auto__;
return cljs.compiler.emits.call(null,"cljs.core.",value);
} else {
return cljs.compiler.emits_symbol.call(null,x);
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,Date,(function (date){
return cljs.compiler.emits.call(null,"new Date(",date.getTime(),")");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant,cljs.core.UUID,(function (uuid){
var uuid_str = uuid.toString();
return cljs.compiler.emits.call(null,"new cljs.core.UUID(\"",uuid_str,"\", ",cljs.core.hash.call(null,uuid_str),")");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"no-op","no-op",-93046065),(function (m){
return null;
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"var","var",-769682797),(function (p__8066){
var map__8067 = p__8066;
var map__8067__$1 = ((((!((map__8067 == null)))?(((((map__8067.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8067.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8067):map__8067);
var ast = map__8067__$1;
var info = cljs.core.get.call(null,map__8067__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var env = cljs.core.get.call(null,map__8067__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var form = cljs.core.get.call(null,map__8067__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var temp__6751__auto__ = new cljs.core.Keyword(null,"const-expr","const-expr",-1379382292).cljs$core$IFn$_invoke$arity$1(ast);
if(cljs.core.truth_(temp__6751__auto__)){
var const_expr = temp__6751__auto__;
return cljs.compiler.emit.call(null,cljs.core.assoc.call(null,const_expr,new cljs.core.Keyword(null,"env","env",-1815813235),env));
} else {
var map__8069 = cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_);
var map__8069__$1 = ((((!((map__8069 == null)))?(((((map__8069.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8069.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8069):map__8069);
var cenv = map__8069__$1;
var options = cljs.core.get.call(null,map__8069__$1,new cljs.core.Keyword(null,"options","options",99638489));
var var_name = new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(info);
var info__$1 = ((cljs.core._EQ_.call(null,cljs.core.namespace.call(null,var_name),"js"))?(function (){var js_module_name = cljs.core.get_in.call(null,cenv,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"js-module-index","js-module-index",2072061931),cljs.core.name.call(null,var_name),new cljs.core.Keyword(null,"name","name",1843675177)], null));
var or__3922__auto__ = js_module_name;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.name.call(null,var_name);
}
})():info);
if(cljs.core.truth_(new cljs.core.Keyword(null,"binding-form?","binding-form?",1728940169).cljs$core$IFn$_invoke$arity$1(ast))){
return cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,ast));
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return null;
} else {
var reserved = (function (){var G__8071 = cljs.compiler.js_reserved;
if(cljs.core.truth_((function (){var and__3911__auto__ = cljs.compiler.es5_GT__EQ_.call(null,new cljs.core.Keyword(null,"language-out","language-out",334619882).cljs$core$IFn$_invoke$arity$1(options));
if(cljs.core.truth_(and__3911__auto__)){
return !((cljs.core.namespace.call(null,var_name) == null));
} else {
return and__3911__auto__;
}
})())){
return clojure.set.difference.call(null,G__8071,cljs.analyzer.es5_allowed);
} else {
return G__8071;
}
})();
var js_module = cljs.core.get_in.call(null,cenv,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"js-namespaces","js-namespaces",-471353612),(function (){var or__3922__auto__ = cljs.core.namespace.call(null,var_name);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.name.call(null,var_name);
}
})()], null));
var info__$2 = (function (){var G__8072 = info__$1;
if(cljs.core.not_EQ_.call(null,form,new cljs.core.Symbol("js","-Infinity","js/-Infinity",958706333,null))){
return cljs.compiler.munge.call(null,G__8072,reserved);
} else {
return G__8072;
}
})();
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

var G__8073_8074 = new cljs.core.Keyword(null,"module-type","module-type",1392760304).cljs$core$IFn$_invoke$arity$1(js_module);
var G__8073_8075__$1 = (((G__8073_8074 instanceof cljs.core.Keyword))?G__8073_8074.fqn:null);
switch (G__8073_8075__$1) {
case "commonjs":
if(cljs.core.truth_(cljs.core.namespace.call(null,var_name))){
cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,cljs.core.namespace.call(null,var_name),reserved),"[\"default\"].",cljs.compiler.munge.call(null,cljs.core.name.call(null,var_name),reserved));
} else {
cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,cljs.core.name.call(null,var_name),reserved),"[\"default\"]");
}

break;
case "es6":
if(cljs.core.truth_((function (){var and__3911__auto__ = cljs.core.namespace.call(null,var_name);
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core._EQ_.call(null,"default",cljs.core.name.call(null,var_name));
} else {
return and__3911__auto__;
}
})())){
cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,cljs.core.namespace.call(null,var_name),reserved),"[\"default\"]");
} else {
cljs.compiler.emits.call(null,info__$2);
}

break;
default:
cljs.compiler.emits.call(null,info__$2);

}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}
}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"var-special","var-special",1131576802),(function (p__8077){
var map__8078 = p__8077;
var map__8078__$1 = ((((!((map__8078 == null)))?(((((map__8078.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8078.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8078):map__8078);
var arg = map__8078__$1;
var env = cljs.core.get.call(null,map__8078__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var var$ = cljs.core.get.call(null,map__8078__$1,new cljs.core.Keyword(null,"var","var",-769682797));
var sym = cljs.core.get.call(null,map__8078__$1,new cljs.core.Keyword(null,"sym","sym",-1444860305));
var meta = cljs.core.get.call(null,map__8078__$1,new cljs.core.Keyword(null,"meta","meta",1499536964));
if(cljs.analyzer.ast_QMARK_.call(null,sym)){
} else {
throw (new Error("Assert failed: (ana/ast? sym)"));
}

if(cljs.analyzer.ast_QMARK_.call(null,meta)){
} else {
throw (new Error("Assert failed: (ana/ast? meta)"));
}

var map__8080 = new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(var$);
var map__8080__$1 = ((((!((map__8080 == null)))?(((((map__8080.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8080.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8080):map__8080);
var name = cljs.core.get.call(null,map__8080__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"new cljs.core.Var(function(){return ",cljs.compiler.munge.call(null,name),";},",sym,",",meta,")");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"meta","meta",1499536964),(function (p__8082){
var map__8083 = p__8082;
var map__8083__$1 = ((((!((map__8083 == null)))?(((((map__8083.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8083.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8083):map__8083);
var expr = cljs.core.get.call(null,map__8083__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
var meta = cljs.core.get.call(null,map__8083__$1,new cljs.core.Keyword(null,"meta","meta",1499536964));
var env = cljs.core.get.call(null,map__8083__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"cljs.core.with_meta(",expr,",",meta,")");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.array_map_threshold = (8);
cljs.compiler.distinct_keys_QMARK_ = (function cljs$compiler$distinct_keys_QMARK_(keys){
return ((cljs.core.every_QMARK_.call(null,(function (p1__8085_SHARP_){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(p1__8085_SHARP_),new cljs.core.Keyword(null,"constant","constant",-379609303));
}),keys)) && (cljs.core._EQ_.call(null,cljs.core.count.call(null,cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,keys)),cljs.core.count.call(null,keys))));
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"map","map",1371690461),(function (p__8086){
var map__8087 = p__8086;
var map__8087__$1 = ((((!((map__8087 == null)))?(((((map__8087.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8087.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8087):map__8087);
var env = cljs.core.get.call(null,map__8087__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var keys = cljs.core.get.call(null,map__8087__$1,new cljs.core.Keyword(null,"keys","keys",1068423698));
var vals = cljs.core.get.call(null,map__8087__$1,new cljs.core.Keyword(null,"vals","vals",768058733));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if((cljs.core.count.call(null,keys) === (0))){
cljs.compiler.emits.call(null,"cljs.core.PersistentArrayMap.EMPTY");
} else {
if((cljs.core.count.call(null,keys) <= cljs.compiler.array_map_threshold)){
if(cljs.core.truth_(cljs.compiler.distinct_keys_QMARK_.call(null,keys))){
cljs.compiler.emits.call(null,"new cljs.core.PersistentArrayMap(null, ",cljs.core.count.call(null,keys),", [",cljs.compiler.comma_sep.call(null,cljs.core.interleave.call(null,keys,vals)),"], null)");
} else {
cljs.compiler.emits.call(null,"cljs.core.PersistentArrayMap.createAsIfByAssoc([",cljs.compiler.comma_sep.call(null,cljs.core.interleave.call(null,keys,vals)),"])");
}
} else {
cljs.compiler.emits.call(null,"cljs.core.PersistentHashMap.fromArrays([",cljs.compiler.comma_sep.call(null,keys),"],[",cljs.compiler.comma_sep.call(null,vals),"])");

}
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"list","list",765357683),(function (p__8089){
var map__8090 = p__8089;
var map__8090__$1 = ((((!((map__8090 == null)))?(((((map__8090.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8090.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8090):map__8090);
var items = cljs.core.get.call(null,map__8090__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var env = cljs.core.get.call(null,map__8090__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.empty_QMARK_.call(null,items)){
cljs.compiler.emits.call(null,"cljs.core.List.EMPTY");
} else {
cljs.compiler.emits.call(null,"cljs.core.list(",cljs.compiler.comma_sep.call(null,items),")");
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"vector","vector",1902966158),(function (p__8092){
var map__8093 = p__8092;
var map__8093__$1 = ((((!((map__8093 == null)))?(((((map__8093.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8093.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8093):map__8093);
var items = cljs.core.get.call(null,map__8093__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var env = cljs.core.get.call(null,map__8093__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.empty_QMARK_.call(null,items)){
cljs.compiler.emits.call(null,"cljs.core.PersistentVector.EMPTY");
} else {
var cnt_8095 = cljs.core.count.call(null,items);
if((cnt_8095 < (32))){
cljs.compiler.emits.call(null,"new cljs.core.PersistentVector(null, ",cnt_8095,", 5, cljs.core.PersistentVector.EMPTY_NODE, [",cljs.compiler.comma_sep.call(null,items),"], null)");
} else {
cljs.compiler.emits.call(null,"cljs.core.PersistentVector.fromArray([",cljs.compiler.comma_sep.call(null,items),"], true)");
}
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.distinct_constants_QMARK_ = (function cljs$compiler$distinct_constants_QMARK_(items){
return ((cljs.core.every_QMARK_.call(null,(function (p1__8096_SHARP_){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(p1__8096_SHARP_),new cljs.core.Keyword(null,"constant","constant",-379609303));
}),items)) && (cljs.core._EQ_.call(null,cljs.core.count.call(null,cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,items)),cljs.core.count.call(null,items))));
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"set","set",304602554),(function (p__8097){
var map__8098 = p__8097;
var map__8098__$1 = ((((!((map__8098 == null)))?(((((map__8098.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8098.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8098):map__8098);
var items = cljs.core.get.call(null,map__8098__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var env = cljs.core.get.call(null,map__8098__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.empty_QMARK_.call(null,items)){
cljs.compiler.emits.call(null,"cljs.core.PersistentHashSet.EMPTY");
} else {
if(cljs.core.truth_(cljs.compiler.distinct_constants_QMARK_.call(null,items))){
cljs.compiler.emits.call(null,"new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, ",cljs.core.count.call(null,items),", [",cljs.compiler.comma_sep.call(null,cljs.core.interleave.call(null,items,cljs.core.repeat.call(null,"null"))),"], null), null)");
} else {
cljs.compiler.emits.call(null,"cljs.core.PersistentHashSet.createAsIfByAssoc([",cljs.compiler.comma_sep.call(null,items),"])");

}
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"js-value","js-value",-758336661),(function (p__8100){
var map__8101 = p__8100;
var map__8101__$1 = ((((!((map__8101 == null)))?(((((map__8101.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8101.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8101):map__8101);
var items = cljs.core.get.call(null,map__8101__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var js_type = cljs.core.get.call(null,map__8101__$1,new cljs.core.Keyword(null,"js-type","js-type",539386702));
var env = cljs.core.get.call(null,map__8101__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core._EQ_.call(null,js_type,new cljs.core.Keyword(null,"object","object",1474613949))){
cljs.compiler.emits.call(null,"({");

var temp__6753__auto___8119 = cljs.core.seq.call(null,items);
if(temp__6753__auto___8119){
var items_8120__$1 = temp__6753__auto___8119;
var vec__8103_8121 = items_8120__$1;
var seq__8104_8122 = cljs.core.seq.call(null,vec__8103_8121);
var first__8105_8123 = cljs.core.first.call(null,seq__8104_8122);
var seq__8104_8124__$1 = cljs.core.next.call(null,seq__8104_8122);
var vec__8106_8125 = first__8105_8123;
var k_8126 = cljs.core.nth.call(null,vec__8106_8125,(0),null);
var v_8127 = cljs.core.nth.call(null,vec__8106_8125,(1),null);
var r_8128 = seq__8104_8124__$1;
cljs.compiler.emits.call(null,"\"",cljs.core.name.call(null,k_8126),"\": ",v_8127);

var seq__8109_8129 = cljs.core.seq.call(null,r_8128);
var chunk__8110_8130 = null;
var count__8111_8131 = (0);
var i__8112_8132 = (0);
while(true){
if((i__8112_8132 < count__8111_8131)){
var vec__8113_8133 = cljs.core._nth.call(null,chunk__8110_8130,i__8112_8132);
var k_8134__$1 = cljs.core.nth.call(null,vec__8113_8133,(0),null);
var v_8135__$1 = cljs.core.nth.call(null,vec__8113_8133,(1),null);
cljs.compiler.emits.call(null,", \"",cljs.core.name.call(null,k_8134__$1),"\": ",v_8135__$1);


var G__8136 = seq__8109_8129;
var G__8137 = chunk__8110_8130;
var G__8138 = count__8111_8131;
var G__8139 = (i__8112_8132 + (1));
seq__8109_8129 = G__8136;
chunk__8110_8130 = G__8137;
count__8111_8131 = G__8138;
i__8112_8132 = G__8139;
continue;
} else {
var temp__6753__auto___8140__$1 = cljs.core.seq.call(null,seq__8109_8129);
if(temp__6753__auto___8140__$1){
var seq__8109_8141__$1 = temp__6753__auto___8140__$1;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8109_8141__$1)){
var c__4319__auto___8142 = cljs.core.chunk_first.call(null,seq__8109_8141__$1);
var G__8143 = cljs.core.chunk_rest.call(null,seq__8109_8141__$1);
var G__8144 = c__4319__auto___8142;
var G__8145 = cljs.core.count.call(null,c__4319__auto___8142);
var G__8146 = (0);
seq__8109_8129 = G__8143;
chunk__8110_8130 = G__8144;
count__8111_8131 = G__8145;
i__8112_8132 = G__8146;
continue;
} else {
var vec__8116_8147 = cljs.core.first.call(null,seq__8109_8141__$1);
var k_8148__$1 = cljs.core.nth.call(null,vec__8116_8147,(0),null);
var v_8149__$1 = cljs.core.nth.call(null,vec__8116_8147,(1),null);
cljs.compiler.emits.call(null,", \"",cljs.core.name.call(null,k_8148__$1),"\": ",v_8149__$1);


var G__8150 = cljs.core.next.call(null,seq__8109_8141__$1);
var G__8151 = null;
var G__8152 = (0);
var G__8153 = (0);
seq__8109_8129 = G__8150;
chunk__8110_8130 = G__8151;
count__8111_8131 = G__8152;
i__8112_8132 = G__8153;
continue;
}
} else {
}
}
break;
}
} else {
}

cljs.compiler.emits.call(null,"})");
} else {
cljs.compiler.emits.call(null,"[",cljs.compiler.comma_sep.call(null,items),"]");
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"record-value","record-value",-367500392),(function (p__8154){
var map__8155 = p__8154;
var map__8155__$1 = ((((!((map__8155 == null)))?(((((map__8155.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8155.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8155):map__8155);
var items = cljs.core.get.call(null,map__8155__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var ns = cljs.core.get.call(null,map__8155__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
var name = cljs.core.get.call(null,map__8155__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var env = cljs.core.get.call(null,map__8155__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,ns,".map__GT_",name,"(",items,")");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"constant","constant",-379609303),(function (p__8157){
var map__8158 = p__8157;
var map__8158__$1 = ((((!((map__8158 == null)))?(((((map__8158.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8158.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8158):map__8158);
var form = cljs.core.get.call(null,map__8158__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var env = cljs.core.get.call(null,map__8158__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return null;
} else {
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_constant.call(null,form);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}
}));
cljs.compiler.truthy_constant_QMARK_ = (function cljs$compiler$truthy_constant_QMARK_(p__8160){
var map__8161 = p__8160;
var map__8161__$1 = ((((!((map__8161 == null)))?(((((map__8161.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8161.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8161):map__8161);
var op = cljs.core.get.call(null,map__8161__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var form = cljs.core.get.call(null,map__8161__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var const_expr = cljs.core.get.call(null,map__8161__$1,new cljs.core.Keyword(null,"const-expr","const-expr",-1379382292));
var or__3922__auto__ = (function (){var and__3911__auto__ = cljs.core._EQ_.call(null,op,new cljs.core.Keyword(null,"constant","constant",-379609303));
if(and__3911__auto__){
var and__3911__auto____$1 = form;
if(cljs.core.truth_(and__3911__auto____$1)){
return !(((((typeof form === 'string') && (cljs.core._EQ_.call(null,form,"")))) || (((typeof form === 'number') && ((form === (0)))))));
} else {
return and__3911__auto____$1;
}
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
var and__3911__auto__ = !((const_expr == null));
if(and__3911__auto__){
return cljs.compiler.truthy_constant_QMARK_.call(null,const_expr);
} else {
return and__3911__auto__;
}
}
});
cljs.compiler.falsey_constant_QMARK_ = (function cljs$compiler$falsey_constant_QMARK_(p__8163){
var map__8164 = p__8163;
var map__8164__$1 = ((((!((map__8164 == null)))?(((((map__8164.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8164.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8164):map__8164);
var op = cljs.core.get.call(null,map__8164__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var form = cljs.core.get.call(null,map__8164__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var const_expr = cljs.core.get.call(null,map__8164__$1,new cljs.core.Keyword(null,"const-expr","const-expr",-1379382292));
var or__3922__auto__ = ((cljs.core._EQ_.call(null,op,new cljs.core.Keyword(null,"constant","constant",-379609303))) && (((form === false) || ((form == null)))));
if(or__3922__auto__){
return or__3922__auto__;
} else {
var and__3911__auto__ = !((const_expr == null));
if(and__3911__auto__){
return cljs.compiler.falsey_constant_QMARK_.call(null,const_expr);
} else {
return and__3911__auto__;
}
}
});
cljs.compiler.safe_test_QMARK_ = (function cljs$compiler$safe_test_QMARK_(env,e){
var tag = cljs.analyzer.infer_tag.call(null,env,e);
var or__3922__auto__ = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Symbol(null,"seq","seq",-177272256,null),null,new cljs.core.Symbol(null,"boolean","boolean",-278886877,null),null], null), null).call(null,tag);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.compiler.truthy_constant_QMARK_.call(null,e);
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"if","if",-458814265),(function (p__8166){
var map__8167 = p__8166;
var map__8167__$1 = ((((!((map__8167 == null)))?(((((map__8167.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8167.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8167):map__8167);
var test = cljs.core.get.call(null,map__8167__$1,new cljs.core.Keyword(null,"test","test",577538877));
var then = cljs.core.get.call(null,map__8167__$1,new cljs.core.Keyword(null,"then","then",460598070));
var else$ = cljs.core.get.call(null,map__8167__$1,new cljs.core.Keyword(null,"else","else",-1508377146));
var env = cljs.core.get.call(null,map__8167__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var unchecked = cljs.core.get.call(null,map__8167__$1,new cljs.core.Keyword(null,"unchecked","unchecked",924418378));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
var checked = cljs.core.not.call(null,(function (){var or__3922__auto__ = unchecked;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.compiler.safe_test_QMARK_.call(null,env,test);
}
})());
if(cljs.core.truth_(cljs.compiler.truthy_constant_QMARK_.call(null,test))){
return cljs.compiler.emitln.call(null,then);
} else {
if(cljs.core.truth_(cljs.compiler.falsey_constant_QMARK_.call(null,test))){
return cljs.compiler.emitln.call(null,else$);
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"(",((checked)?"cljs.core.truth_":null),"(",test,")?",then,":",else$,")");
} else {
if(checked){
cljs.compiler.emitln.call(null,"if(cljs.core.truth_(",test,")){");
} else {
cljs.compiler.emitln.call(null,"if(",test,"){");
}

cljs.compiler.emitln.call(null,then,"} else {");

return cljs.compiler.emitln.call(null,else$,"}");
}

}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"case*","case*",716180697),(function (p__8169){
var map__8170 = p__8169;
var map__8170__$1 = ((((!((map__8170 == null)))?(((((map__8170.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8170.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8170):map__8170);
var v = cljs.core.get.call(null,map__8170__$1,new cljs.core.Keyword(null,"v","v",21465059));
var tests = cljs.core.get.call(null,map__8170__$1,new cljs.core.Keyword(null,"tests","tests",-1041085625));
var thens = cljs.core.get.call(null,map__8170__$1,new cljs.core.Keyword(null,"thens","thens",226631442));
var default$ = cljs.core.get.call(null,map__8170__$1,new cljs.core.Keyword(null,"default","default",-1987822328));
var env = cljs.core.get.call(null,map__8170__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env),new cljs.core.Keyword(null,"expr","expr",745722291))){
cljs.compiler.emitln.call(null,"(function(){");
} else {
}

var gs = cljs.core.gensym.call(null,"caseval__");
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"var ",gs,";");
} else {
}

cljs.compiler.emitln.call(null,"switch (",v,") {");

var seq__8172_8190 = cljs.core.seq.call(null,cljs.core.partition.call(null,(2),cljs.core.interleave.call(null,tests,thens)));
var chunk__8173_8191 = null;
var count__8174_8192 = (0);
var i__8175_8193 = (0);
while(true){
if((i__8175_8193 < count__8174_8192)){
var vec__8176_8194 = cljs.core._nth.call(null,chunk__8173_8191,i__8175_8193);
var ts_8195 = cljs.core.nth.call(null,vec__8176_8194,(0),null);
var then_8196 = cljs.core.nth.call(null,vec__8176_8194,(1),null);
var seq__8179_8197 = cljs.core.seq.call(null,ts_8195);
var chunk__8180_8198 = null;
var count__8181_8199 = (0);
var i__8182_8200 = (0);
while(true){
if((i__8182_8200 < count__8181_8199)){
var test_8201 = cljs.core._nth.call(null,chunk__8180_8198,i__8182_8200);
cljs.compiler.emitln.call(null,"case ",test_8201,":");


var G__8202 = seq__8179_8197;
var G__8203 = chunk__8180_8198;
var G__8204 = count__8181_8199;
var G__8205 = (i__8182_8200 + (1));
seq__8179_8197 = G__8202;
chunk__8180_8198 = G__8203;
count__8181_8199 = G__8204;
i__8182_8200 = G__8205;
continue;
} else {
var temp__6753__auto___8206 = cljs.core.seq.call(null,seq__8179_8197);
if(temp__6753__auto___8206){
var seq__8179_8207__$1 = temp__6753__auto___8206;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8179_8207__$1)){
var c__4319__auto___8208 = cljs.core.chunk_first.call(null,seq__8179_8207__$1);
var G__8209 = cljs.core.chunk_rest.call(null,seq__8179_8207__$1);
var G__8210 = c__4319__auto___8208;
var G__8211 = cljs.core.count.call(null,c__4319__auto___8208);
var G__8212 = (0);
seq__8179_8197 = G__8209;
chunk__8180_8198 = G__8210;
count__8181_8199 = G__8211;
i__8182_8200 = G__8212;
continue;
} else {
var test_8213 = cljs.core.first.call(null,seq__8179_8207__$1);
cljs.compiler.emitln.call(null,"case ",test_8213,":");


var G__8214 = cljs.core.next.call(null,seq__8179_8207__$1);
var G__8215 = null;
var G__8216 = (0);
var G__8217 = (0);
seq__8179_8197 = G__8214;
chunk__8180_8198 = G__8215;
count__8181_8199 = G__8216;
i__8182_8200 = G__8217;
continue;
}
} else {
}
}
break;
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,gs,"=",then_8196);
} else {
cljs.compiler.emitln.call(null,then_8196);
}

cljs.compiler.emitln.call(null,"break;");


var G__8218 = seq__8172_8190;
var G__8219 = chunk__8173_8191;
var G__8220 = count__8174_8192;
var G__8221 = (i__8175_8193 + (1));
seq__8172_8190 = G__8218;
chunk__8173_8191 = G__8219;
count__8174_8192 = G__8220;
i__8175_8193 = G__8221;
continue;
} else {
var temp__6753__auto___8222 = cljs.core.seq.call(null,seq__8172_8190);
if(temp__6753__auto___8222){
var seq__8172_8223__$1 = temp__6753__auto___8222;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8172_8223__$1)){
var c__4319__auto___8224 = cljs.core.chunk_first.call(null,seq__8172_8223__$1);
var G__8225 = cljs.core.chunk_rest.call(null,seq__8172_8223__$1);
var G__8226 = c__4319__auto___8224;
var G__8227 = cljs.core.count.call(null,c__4319__auto___8224);
var G__8228 = (0);
seq__8172_8190 = G__8225;
chunk__8173_8191 = G__8226;
count__8174_8192 = G__8227;
i__8175_8193 = G__8228;
continue;
} else {
var vec__8183_8229 = cljs.core.first.call(null,seq__8172_8223__$1);
var ts_8230 = cljs.core.nth.call(null,vec__8183_8229,(0),null);
var then_8231 = cljs.core.nth.call(null,vec__8183_8229,(1),null);
var seq__8186_8232 = cljs.core.seq.call(null,ts_8230);
var chunk__8187_8233 = null;
var count__8188_8234 = (0);
var i__8189_8235 = (0);
while(true){
if((i__8189_8235 < count__8188_8234)){
var test_8236 = cljs.core._nth.call(null,chunk__8187_8233,i__8189_8235);
cljs.compiler.emitln.call(null,"case ",test_8236,":");


var G__8237 = seq__8186_8232;
var G__8238 = chunk__8187_8233;
var G__8239 = count__8188_8234;
var G__8240 = (i__8189_8235 + (1));
seq__8186_8232 = G__8237;
chunk__8187_8233 = G__8238;
count__8188_8234 = G__8239;
i__8189_8235 = G__8240;
continue;
} else {
var temp__6753__auto___8241__$1 = cljs.core.seq.call(null,seq__8186_8232);
if(temp__6753__auto___8241__$1){
var seq__8186_8242__$1 = temp__6753__auto___8241__$1;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8186_8242__$1)){
var c__4319__auto___8243 = cljs.core.chunk_first.call(null,seq__8186_8242__$1);
var G__8244 = cljs.core.chunk_rest.call(null,seq__8186_8242__$1);
var G__8245 = c__4319__auto___8243;
var G__8246 = cljs.core.count.call(null,c__4319__auto___8243);
var G__8247 = (0);
seq__8186_8232 = G__8244;
chunk__8187_8233 = G__8245;
count__8188_8234 = G__8246;
i__8189_8235 = G__8247;
continue;
} else {
var test_8248 = cljs.core.first.call(null,seq__8186_8242__$1);
cljs.compiler.emitln.call(null,"case ",test_8248,":");


var G__8249 = cljs.core.next.call(null,seq__8186_8242__$1);
var G__8250 = null;
var G__8251 = (0);
var G__8252 = (0);
seq__8186_8232 = G__8249;
chunk__8187_8233 = G__8250;
count__8188_8234 = G__8251;
i__8189_8235 = G__8252;
continue;
}
} else {
}
}
break;
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,gs,"=",then_8231);
} else {
cljs.compiler.emitln.call(null,then_8231);
}

cljs.compiler.emitln.call(null,"break;");


var G__8253 = cljs.core.next.call(null,seq__8172_8223__$1);
var G__8254 = null;
var G__8255 = (0);
var G__8256 = (0);
seq__8172_8190 = G__8253;
chunk__8173_8191 = G__8254;
count__8174_8192 = G__8255;
i__8175_8193 = G__8256;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(default$)){
cljs.compiler.emitln.call(null,"default:");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,gs,"=",default$);
} else {
cljs.compiler.emitln.call(null,default$);
}
} else {
}

cljs.compiler.emitln.call(null,"}");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return cljs.compiler.emitln.call(null,"return ",gs,";})()");
} else {
return null;
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"throw","throw",-1044625833),(function (p__8257){
var map__8258 = p__8257;
var map__8258__$1 = ((((!((map__8258 == null)))?(((((map__8258.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8258.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8258):map__8258);
var throw$ = cljs.core.get.call(null,map__8258__$1,new cljs.core.Keyword(null,"throw","throw",-1044625833));
var env = cljs.core.get.call(null,map__8258__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return cljs.compiler.emits.call(null,"(function(){throw ",throw$,"})()");
} else {
return cljs.compiler.emitln.call(null,"throw ",throw$,";");
}
}));
cljs.compiler.base_types = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 15, ["boolean",null,"object",null,"*",null,"string",null,"Object",null,"Number",null,"null",null,"Date",null,"number",null,"String",null,"RegExp",null,"...*",null,"Array",null,"array",null,"Boolean",null], null), null);
cljs.compiler.mapped_types = new cljs.core.PersistentArrayMap(null, 1, ["nil","null"], null);
cljs.compiler.resolve_type = (function cljs$compiler$resolve_type(env,t){
if(cljs.core.truth_(cljs.core.get.call(null,cljs.compiler.base_types,t))){
return t;
} else {
if(cljs.core.truth_(cljs.core.get.call(null,cljs.compiler.mapped_types,t))){
return cljs.core.get.call(null,cljs.compiler.mapped_types,t);
} else {
if(cljs.core.truth_(goog.string.startsWith(t,"!"))){
return ["!",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.resolve_type.call(null,env,cljs.core.subs.call(null,t,(1))))].join('');
} else {
if(cljs.core.truth_(goog.string.startsWith(t,"{"))){
return t;
} else {
if(cljs.core.truth_(goog.string.startsWith(t,"function"))){
var idx = t.lastIndexOf(":");
var vec__8261 = ((!(((-1) === idx)))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.subs.call(null,t,(0),idx),cljs.core.subs.call(null,t,(idx + (1)),cljs.core.count.call(null,t))], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [t,null], null));
var fstr = cljs.core.nth.call(null,vec__8261,(0),null);
var rstr = cljs.core.nth.call(null,vec__8261,(1),null);
var ret_t = (cljs.core.truth_(rstr)?cljs.compiler.resolve_type.call(null,env,rstr):null);
var axstr = cljs.core.subs.call(null,fstr,(9),(cljs.core.count.call(null,fstr) - (1)));
var args_ts = ((clojure.string.blank_QMARK_.call(null,axstr))?null:cljs.core.map.call(null,cljs.core.comp.call(null,((function (idx,vec__8261,fstr,rstr,ret_t,axstr){
return (function (p1__8260_SHARP_){
return cljs.compiler.resolve_type.call(null,env,p1__8260_SHARP_);
});})(idx,vec__8261,fstr,rstr,ret_t,axstr))
,clojure.string.trim),clojure.string.split.call(null,axstr,/,/)));
var G__8264 = ["function(",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,",",args_ts)),")"].join('');
if(cljs.core.truth_(ret_t)){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__8264),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ret_t)].join('');
} else {
return G__8264;
}
} else {
if(cljs.core.truth_(goog.string.endsWith(t,"="))){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.resolve_type.call(null,env,cljs.core.subs.call(null,t,(0),(cljs.core.count.call(null,t) - (1))))),"="].join('');
} else {
return cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(cljs.analyzer.resolve_var.call(null,env,cljs.core.symbol.call(null,t))))].join(''));

}
}
}
}
}
}
});
cljs.compiler.resolve_types = (function cljs$compiler$resolve_types(env,ts){
var ts__$1 = cljs.core.subs.call(null,clojure.string.trim.call(null,ts),(1),(cljs.core.count.call(null,ts) - (1)));
var xs = clojure.string.split.call(null,ts__$1,/\|/);
return ["{",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,"|",cljs.core.map.call(null,((function (ts__$1,xs){
return (function (p1__8265_SHARP_){
return cljs.compiler.resolve_type.call(null,env,p1__8265_SHARP_);
});})(ts__$1,xs))
,xs))),"}"].join('');
});
cljs.compiler.munge_param_return = (function cljs$compiler$munge_param_return(env,line){
if(cljs.core.truth_(cljs.core.re_find.call(null,/@param/,line))){
var vec__8266 = cljs.core.map.call(null,clojure.string.trim,clojure.string.split.call(null,clojure.string.trim.call(null,line),/ /));
var seq__8267 = cljs.core.seq.call(null,vec__8266);
var first__8268 = cljs.core.first.call(null,seq__8267);
var seq__8267__$1 = cljs.core.next.call(null,seq__8267);
var p = first__8268;
var first__8268__$1 = cljs.core.first.call(null,seq__8267__$1);
var seq__8267__$2 = cljs.core.next.call(null,seq__8267__$1);
var ts = first__8268__$1;
var first__8268__$2 = cljs.core.first.call(null,seq__8267__$2);
var seq__8267__$3 = cljs.core.next.call(null,seq__8267__$2);
var n = first__8268__$2;
var xs = seq__8267__$3;
if(cljs.core.truth_((function (){var and__3911__auto__ = cljs.core._EQ_.call(null,"@param",p);
if(and__3911__auto__){
var and__3911__auto____$1 = ts;
if(cljs.core.truth_(and__3911__auto____$1)){
return goog.string.startsWith(ts,"{");
} else {
return and__3911__auto____$1;
}
} else {
return and__3911__auto__;
}
})())){
return clojure.string.join.call(null," ",cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,cljs.compiler.resolve_types.call(null,env,ts),cljs.compiler.munge.call(null,n)], null),xs));
} else {
return line;
}
} else {
if(cljs.core.truth_(cljs.core.re_find.call(null,/@return/,line))){
var vec__8269 = cljs.core.map.call(null,clojure.string.trim,clojure.string.split.call(null,clojure.string.trim.call(null,line),/ /));
var seq__8270 = cljs.core.seq.call(null,vec__8269);
var first__8271 = cljs.core.first.call(null,seq__8270);
var seq__8270__$1 = cljs.core.next.call(null,seq__8270);
var p = first__8271;
var first__8271__$1 = cljs.core.first.call(null,seq__8270__$1);
var seq__8270__$2 = cljs.core.next.call(null,seq__8270__$1);
var ts = first__8271__$1;
var xs = seq__8270__$2;
if(cljs.core.truth_((function (){var and__3911__auto__ = cljs.core._EQ_.call(null,"@return",p);
if(and__3911__auto__){
var and__3911__auto____$1 = ts;
if(cljs.core.truth_(and__3911__auto____$1)){
return goog.string.startsWith(ts,"{");
} else {
return and__3911__auto____$1;
}
} else {
return and__3911__auto__;
}
})())){
return clojure.string.join.call(null," ",cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,cljs.compiler.resolve_types.call(null,env,ts)], null),xs));
} else {
return line;
}
} else {
return line;

}
}
});
cljs.compiler.checking_types_QMARK_ = (function cljs$compiler$checking_types_QMARK_(){
return new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"warning","warning",-1685650671),null,new cljs.core.Keyword(null,"error","error",-978969032),null], null), null).call(null,cljs.core.get_in.call(null,cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"options","options",99638489),new cljs.core.Keyword(null,"closure-warnings","closure-warnings",1362834211),new cljs.core.Keyword(null,"check-types","check-types",-833794607)], null)));
});
/**
 * Emit a nicely formatted comment string.
 */
cljs.compiler.emit_comment = (function cljs$compiler$emit_comment(var_args){
var G__8274 = arguments.length;
switch (G__8274) {
case 2:
return cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$2 = (function (doc,jsdoc){
return cljs.compiler.emit_comment.call(null,null,doc,jsdoc);
});

cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$3 = (function (env,doc,jsdoc){
var docs = (cljs.core.truth_(doc)?new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [doc], null):null);
var docs__$1 = (cljs.core.truth_(jsdoc)?cljs.core.concat.call(null,docs,jsdoc):docs);
var docs__$2 = cljs.core.remove.call(null,cljs.core.nil_QMARK_,docs__$1);
var print_comment_lines = ((function (docs,docs__$1,docs__$2){
return (function cljs$compiler$print_comment_lines(e){
var vec__8282 = cljs.core.map.call(null,((function (docs,docs__$1,docs__$2){
return (function (p1__8272_SHARP_){
if(cljs.core.truth_(cljs.compiler.checking_types_QMARK_.call(null))){
return cljs.compiler.munge_param_return.call(null,env,p1__8272_SHARP_);
} else {
return p1__8272_SHARP_;
}
});})(docs,docs__$1,docs__$2))
,clojure.string.split_lines.call(null,e));
var seq__8283 = cljs.core.seq.call(null,vec__8282);
var first__8284 = cljs.core.first.call(null,seq__8283);
var seq__8283__$1 = cljs.core.next.call(null,seq__8283);
var x = first__8284;
var ys = seq__8283__$1;
cljs.compiler.emitln.call(null," * ",clojure.string.replace.call(null,x,"*/","* /"));

var seq__8285 = cljs.core.seq.call(null,ys);
var chunk__8286 = null;
var count__8287 = (0);
var i__8288 = (0);
while(true){
if((i__8288 < count__8287)){
var next_line = cljs.core._nth.call(null,chunk__8286,i__8288);
cljs.compiler.emitln.call(null," * ",clojure.string.replace.call(null,clojure.string.replace.call(null,next_line,/^   /,""),"*/","* /"));


var G__8294 = seq__8285;
var G__8295 = chunk__8286;
var G__8296 = count__8287;
var G__8297 = (i__8288 + (1));
seq__8285 = G__8294;
chunk__8286 = G__8295;
count__8287 = G__8296;
i__8288 = G__8297;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__8285);
if(temp__6753__auto__){
var seq__8285__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8285__$1)){
var c__4319__auto__ = cljs.core.chunk_first.call(null,seq__8285__$1);
var G__8298 = cljs.core.chunk_rest.call(null,seq__8285__$1);
var G__8299 = c__4319__auto__;
var G__8300 = cljs.core.count.call(null,c__4319__auto__);
var G__8301 = (0);
seq__8285 = G__8298;
chunk__8286 = G__8299;
count__8287 = G__8300;
i__8288 = G__8301;
continue;
} else {
var next_line = cljs.core.first.call(null,seq__8285__$1);
cljs.compiler.emitln.call(null," * ",clojure.string.replace.call(null,clojure.string.replace.call(null,next_line,/^   /,""),"*/","* /"));


var G__8302 = cljs.core.next.call(null,seq__8285__$1);
var G__8303 = null;
var G__8304 = (0);
var G__8305 = (0);
seq__8285 = G__8302;
chunk__8286 = G__8303;
count__8287 = G__8304;
i__8288 = G__8305;
continue;
}
} else {
return null;
}
}
break;
}
});})(docs,docs__$1,docs__$2))
;
if(cljs.core.seq.call(null,docs__$2)){
cljs.compiler.emitln.call(null,"/**");

var seq__8289_8306 = cljs.core.seq.call(null,docs__$2);
var chunk__8290_8307 = null;
var count__8291_8308 = (0);
var i__8292_8309 = (0);
while(true){
if((i__8292_8309 < count__8291_8308)){
var e_8310 = cljs.core._nth.call(null,chunk__8290_8307,i__8292_8309);
if(cljs.core.truth_(e_8310)){
print_comment_lines.call(null,e_8310);
} else {
}


var G__8311 = seq__8289_8306;
var G__8312 = chunk__8290_8307;
var G__8313 = count__8291_8308;
var G__8314 = (i__8292_8309 + (1));
seq__8289_8306 = G__8311;
chunk__8290_8307 = G__8312;
count__8291_8308 = G__8313;
i__8292_8309 = G__8314;
continue;
} else {
var temp__6753__auto___8315 = cljs.core.seq.call(null,seq__8289_8306);
if(temp__6753__auto___8315){
var seq__8289_8316__$1 = temp__6753__auto___8315;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8289_8316__$1)){
var c__4319__auto___8317 = cljs.core.chunk_first.call(null,seq__8289_8316__$1);
var G__8318 = cljs.core.chunk_rest.call(null,seq__8289_8316__$1);
var G__8319 = c__4319__auto___8317;
var G__8320 = cljs.core.count.call(null,c__4319__auto___8317);
var G__8321 = (0);
seq__8289_8306 = G__8318;
chunk__8290_8307 = G__8319;
count__8291_8308 = G__8320;
i__8292_8309 = G__8321;
continue;
} else {
var e_8322 = cljs.core.first.call(null,seq__8289_8316__$1);
if(cljs.core.truth_(e_8322)){
print_comment_lines.call(null,e_8322);
} else {
}


var G__8323 = cljs.core.next.call(null,seq__8289_8316__$1);
var G__8324 = null;
var G__8325 = (0);
var G__8326 = (0);
seq__8289_8306 = G__8323;
chunk__8290_8307 = G__8324;
count__8291_8308 = G__8325;
i__8292_8309 = G__8326;
continue;
}
} else {
}
}
break;
}

return cljs.compiler.emitln.call(null," */");
} else {
return null;
}
});

cljs.compiler.emit_comment.cljs$lang$maxFixedArity = 3;

cljs.compiler.valid_define_value_QMARK_ = (function cljs$compiler$valid_define_value_QMARK_(x){
return ((typeof x === 'string') || (x === true) || (x === false) || (typeof x === 'number'));
});
cljs.compiler.get_define = (function cljs$compiler$get_define(mname,jsdoc){
var opts = cljs.core.get.call(null,cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_),new cljs.core.Keyword(null,"options","options",99638489));
var and__3911__auto__ = cljs.core.some.call(null,((function (opts){
return (function (p1__8328_SHARP_){
return goog.string.startsWith(p1__8328_SHARP_,"@define");
});})(opts))
,jsdoc);
if(cljs.core.truth_(and__3911__auto__)){
var and__3911__auto____$1 = opts;
if(cljs.core.truth_(and__3911__auto____$1)){
var and__3911__auto____$2 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"optimizations","optimizations",-2047476854).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"none","none",1333468478));
if(and__3911__auto____$2){
var define = cljs.core.get_in.call(null,opts,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"closure-defines","closure-defines",-1213856476),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname)].join('')], null));
if(cljs.core.truth_(cljs.compiler.valid_define_value_QMARK_.call(null,define))){
return cljs.core.pr_str.call(null,define);
} else {
return null;
}
} else {
return and__3911__auto____$2;
}
} else {
return and__3911__auto____$1;
}
} else {
return and__3911__auto__;
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"def","def",-1043430536),(function (p__8329){
var map__8330 = p__8329;
var map__8330__$1 = ((((!((map__8330 == null)))?(((((map__8330.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8330.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8330):map__8330);
var name = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var var$ = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"var","var",-769682797));
var init = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
var env = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var doc = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"doc","doc",1913296891));
var jsdoc = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"jsdoc","jsdoc",1745183516));
var export$ = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"export","export",214356590));
var test = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"test","test",577538877));
var var_ast = cljs.core.get.call(null,map__8330__$1,new cljs.core.Keyword(null,"var-ast","var-ast",1200379319));
if(cljs.core.truth_((function (){var or__3922__auto__ = init;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return new cljs.core.Keyword(null,"def-emits-var","def-emits-var",-1551927320).cljs$core$IFn$_invoke$arity$1(env);
}
})())){
var mname = cljs.compiler.munge.call(null,name);
cljs.compiler.emit_comment.call(null,env,doc,cljs.core.concat.call(null,jsdoc,new cljs.core.Keyword(null,"jsdoc","jsdoc",1745183516).cljs$core$IFn$_invoke$arity$1(init)));

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"return (");
} else {
}

if(cljs.core.truth_(new cljs.core.Keyword(null,"def-emits-var","def-emits-var",-1551927320).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"(function (){");
} else {
}

cljs.compiler.emits.call(null,var$);

if(cljs.core.truth_(init)){
cljs.compiler.emits.call(null," = ",(function (){var temp__6751__auto__ = cljs.compiler.get_define.call(null,mname,jsdoc);
if(cljs.core.truth_(temp__6751__auto__)){
var define = temp__6751__auto__;
return define;
} else {
return init;
}
})());
} else {
}

if(cljs.core.truth_(new cljs.core.Keyword(null,"def-emits-var","def-emits-var",-1551927320).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"; return (");

cljs.compiler.emits.call(null,cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"var-special","var-special",1131576802),new cljs.core.Keyword(null,"env","env",-1815813235),cljs.core.assoc.call(null,env,new cljs.core.Keyword(null,"context","context",-830191113),new cljs.core.Keyword(null,"expr","expr",745722291))], null),var_ast));

cljs.compiler.emitln.call(null,");})()");
} else {
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,")");
} else {
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
} else {
cljs.compiler.emitln.call(null,";");
}

if(cljs.core.truth_(export$)){
cljs.compiler.emitln.call(null,"goog.exportSymbol('",cljs.compiler.munge.call(null,export$),"', ",mname,");");
} else {
}

if(cljs.core.truth_((function (){var and__3911__auto__ = cljs.analyzer._STAR_load_tests_STAR_;
if(and__3911__auto__){
return test;
} else {
return and__3911__auto__;
}
})())){
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,";");
} else {
}

return cljs.compiler.emitln.call(null,var$,".cljs$lang$test = ",test,";");
} else {
return null;
}
} else {
return null;
}
}));
cljs.compiler.emit_apply_to = (function cljs$compiler$emit_apply_to(p__8332){
var map__8333 = p__8332;
var map__8333__$1 = ((((!((map__8333 == null)))?(((((map__8333.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8333.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8333):map__8333);
var name = cljs.core.get.call(null,map__8333__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var params = cljs.core.get.call(null,map__8333__$1,new cljs.core.Keyword(null,"params","params",710516235));
var env = cljs.core.get.call(null,map__8333__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var arglist = cljs.core.gensym.call(null,"arglist__");
var delegate_name = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,name)),"__delegate"].join('');
cljs.compiler.emitln.call(null,"(function (",arglist,"){");

var seq__8335_8353 = cljs.core.seq.call(null,cljs.core.map_indexed.call(null,cljs.core.vector,cljs.core.drop_last.call(null,(2),params)));
var chunk__8336_8354 = null;
var count__8337_8355 = (0);
var i__8338_8356 = (0);
while(true){
if((i__8338_8356 < count__8337_8355)){
var vec__8339_8357 = cljs.core._nth.call(null,chunk__8336_8354,i__8338_8356);
var i_8358 = cljs.core.nth.call(null,vec__8339_8357,(0),null);
var param_8359 = cljs.core.nth.call(null,vec__8339_8357,(1),null);
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,param_8359);

cljs.compiler.emits.call(null," = cljs.core.first(");

cljs.compiler.emitln.call(null,arglist,");");

cljs.compiler.emitln.call(null,arglist," = cljs.core.next(",arglist,");");


var G__8360 = seq__8335_8353;
var G__8361 = chunk__8336_8354;
var G__8362 = count__8337_8355;
var G__8363 = (i__8338_8356 + (1));
seq__8335_8353 = G__8360;
chunk__8336_8354 = G__8361;
count__8337_8355 = G__8362;
i__8338_8356 = G__8363;
continue;
} else {
var temp__6753__auto___8364 = cljs.core.seq.call(null,seq__8335_8353);
if(temp__6753__auto___8364){
var seq__8335_8365__$1 = temp__6753__auto___8364;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8335_8365__$1)){
var c__4319__auto___8366 = cljs.core.chunk_first.call(null,seq__8335_8365__$1);
var G__8367 = cljs.core.chunk_rest.call(null,seq__8335_8365__$1);
var G__8368 = c__4319__auto___8366;
var G__8369 = cljs.core.count.call(null,c__4319__auto___8366);
var G__8370 = (0);
seq__8335_8353 = G__8367;
chunk__8336_8354 = G__8368;
count__8337_8355 = G__8369;
i__8338_8356 = G__8370;
continue;
} else {
var vec__8342_8371 = cljs.core.first.call(null,seq__8335_8365__$1);
var i_8372 = cljs.core.nth.call(null,vec__8342_8371,(0),null);
var param_8373 = cljs.core.nth.call(null,vec__8342_8371,(1),null);
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,param_8373);

cljs.compiler.emits.call(null," = cljs.core.first(");

cljs.compiler.emitln.call(null,arglist,");");

cljs.compiler.emitln.call(null,arglist," = cljs.core.next(",arglist,");");


var G__8374 = cljs.core.next.call(null,seq__8335_8365__$1);
var G__8375 = null;
var G__8376 = (0);
var G__8377 = (0);
seq__8335_8353 = G__8374;
chunk__8336_8354 = G__8375;
count__8337_8355 = G__8376;
i__8338_8356 = G__8377;
continue;
}
} else {
}
}
break;
}

if(((1) < cljs.core.count.call(null,params))){
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,cljs.core.butlast.call(null,params)));

cljs.compiler.emitln.call(null," = cljs.core.first(",arglist,");");

cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,params));

cljs.compiler.emitln.call(null," = cljs.core.rest(",arglist,");");

cljs.compiler.emits.call(null,"return ",delegate_name,"(");

var seq__8345_8378 = cljs.core.seq.call(null,params);
var chunk__8346_8379 = null;
var count__8347_8380 = (0);
var i__8348_8381 = (0);
while(true){
if((i__8348_8381 < count__8347_8380)){
var param_8382 = cljs.core._nth.call(null,chunk__8346_8379,i__8348_8381);
cljs.compiler.emit.call(null,param_8382);

if(cljs.core._EQ_.call(null,param_8382,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8383 = seq__8345_8378;
var G__8384 = chunk__8346_8379;
var G__8385 = count__8347_8380;
var G__8386 = (i__8348_8381 + (1));
seq__8345_8378 = G__8383;
chunk__8346_8379 = G__8384;
count__8347_8380 = G__8385;
i__8348_8381 = G__8386;
continue;
} else {
var temp__6753__auto___8387 = cljs.core.seq.call(null,seq__8345_8378);
if(temp__6753__auto___8387){
var seq__8345_8388__$1 = temp__6753__auto___8387;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8345_8388__$1)){
var c__4319__auto___8389 = cljs.core.chunk_first.call(null,seq__8345_8388__$1);
var G__8390 = cljs.core.chunk_rest.call(null,seq__8345_8388__$1);
var G__8391 = c__4319__auto___8389;
var G__8392 = cljs.core.count.call(null,c__4319__auto___8389);
var G__8393 = (0);
seq__8345_8378 = G__8390;
chunk__8346_8379 = G__8391;
count__8347_8380 = G__8392;
i__8348_8381 = G__8393;
continue;
} else {
var param_8394 = cljs.core.first.call(null,seq__8345_8388__$1);
cljs.compiler.emit.call(null,param_8394);

if(cljs.core._EQ_.call(null,param_8394,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8395 = cljs.core.next.call(null,seq__8345_8388__$1);
var G__8396 = null;
var G__8397 = (0);
var G__8398 = (0);
seq__8345_8378 = G__8395;
chunk__8346_8379 = G__8396;
count__8347_8380 = G__8397;
i__8348_8381 = G__8398;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,");");
} else {
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,params));

cljs.compiler.emitln.call(null," = cljs.core.seq(",arglist,");");

cljs.compiler.emits.call(null,"return ",delegate_name,"(");

var seq__8349_8399 = cljs.core.seq.call(null,params);
var chunk__8350_8400 = null;
var count__8351_8401 = (0);
var i__8352_8402 = (0);
while(true){
if((i__8352_8402 < count__8351_8401)){
var param_8403 = cljs.core._nth.call(null,chunk__8350_8400,i__8352_8402);
cljs.compiler.emit.call(null,param_8403);

if(cljs.core._EQ_.call(null,param_8403,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8404 = seq__8349_8399;
var G__8405 = chunk__8350_8400;
var G__8406 = count__8351_8401;
var G__8407 = (i__8352_8402 + (1));
seq__8349_8399 = G__8404;
chunk__8350_8400 = G__8405;
count__8351_8401 = G__8406;
i__8352_8402 = G__8407;
continue;
} else {
var temp__6753__auto___8408 = cljs.core.seq.call(null,seq__8349_8399);
if(temp__6753__auto___8408){
var seq__8349_8409__$1 = temp__6753__auto___8408;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8349_8409__$1)){
var c__4319__auto___8410 = cljs.core.chunk_first.call(null,seq__8349_8409__$1);
var G__8411 = cljs.core.chunk_rest.call(null,seq__8349_8409__$1);
var G__8412 = c__4319__auto___8410;
var G__8413 = cljs.core.count.call(null,c__4319__auto___8410);
var G__8414 = (0);
seq__8349_8399 = G__8411;
chunk__8350_8400 = G__8412;
count__8351_8401 = G__8413;
i__8352_8402 = G__8414;
continue;
} else {
var param_8415 = cljs.core.first.call(null,seq__8349_8409__$1);
cljs.compiler.emit.call(null,param_8415);

if(cljs.core._EQ_.call(null,param_8415,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8416 = cljs.core.next.call(null,seq__8349_8409__$1);
var G__8417 = null;
var G__8418 = (0);
var G__8419 = (0);
seq__8349_8399 = G__8416;
chunk__8350_8400 = G__8417;
count__8351_8401 = G__8418;
i__8352_8402 = G__8419;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,");");
}

return cljs.compiler.emits.call(null,"})");
});
cljs.compiler.emit_fn_params = (function cljs$compiler$emit_fn_params(params){
var seq__8420 = cljs.core.seq.call(null,params);
var chunk__8421 = null;
var count__8422 = (0);
var i__8423 = (0);
while(true){
if((i__8423 < count__8422)){
var param = cljs.core._nth.call(null,chunk__8421,i__8423);
cljs.compiler.emit.call(null,param);

if(cljs.core._EQ_.call(null,param,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8424 = seq__8420;
var G__8425 = chunk__8421;
var G__8426 = count__8422;
var G__8427 = (i__8423 + (1));
seq__8420 = G__8424;
chunk__8421 = G__8425;
count__8422 = G__8426;
i__8423 = G__8427;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__8420);
if(temp__6753__auto__){
var seq__8420__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8420__$1)){
var c__4319__auto__ = cljs.core.chunk_first.call(null,seq__8420__$1);
var G__8428 = cljs.core.chunk_rest.call(null,seq__8420__$1);
var G__8429 = c__4319__auto__;
var G__8430 = cljs.core.count.call(null,c__4319__auto__);
var G__8431 = (0);
seq__8420 = G__8428;
chunk__8421 = G__8429;
count__8422 = G__8430;
i__8423 = G__8431;
continue;
} else {
var param = cljs.core.first.call(null,seq__8420__$1);
cljs.compiler.emit.call(null,param);

if(cljs.core._EQ_.call(null,param,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8432 = cljs.core.next.call(null,seq__8420__$1);
var G__8433 = null;
var G__8434 = (0);
var G__8435 = (0);
seq__8420 = G__8432;
chunk__8421 = G__8433;
count__8422 = G__8434;
i__8423 = G__8435;
continue;
}
} else {
return null;
}
}
break;
}
});
cljs.compiler.emit_fn_method = (function cljs$compiler$emit_fn_method(p__8436){
var map__8437 = p__8436;
var map__8437__$1 = ((((!((map__8437 == null)))?(((((map__8437.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8437.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8437):map__8437);
var type = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var name = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var variadic = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"variadic","variadic",882626057));
var params = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"params","params",710516235));
var expr = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
var env = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var recurs = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"recurs","recurs",-1959309309));
var max_fixed_arity = cljs.core.get.call(null,map__8437__$1,new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"(function ",cljs.compiler.munge.call(null,name),"(");

cljs.compiler.emit_fn_params.call(null,params);

cljs.compiler.emitln.call(null,"){");

if(cljs.core.truth_(type)){
cljs.compiler.emitln.call(null,"var self__ = this;");
} else {
}

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"while(true){");
} else {
}

cljs.compiler.emits.call(null,expr);

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"break;");

cljs.compiler.emitln.call(null,"}");
} else {
}

cljs.compiler.emits.call(null,"})");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
});
/**
 * Emit code that copies function arguments into an array starting at an index.
 *   Returns name of var holding the array.
 */
cljs.compiler.emit_arguments_to_array = (function cljs$compiler$emit_arguments_to_array(startslice){
if((((startslice >= (0))) && (cljs.core.integer_QMARK_.call(null,startslice)))){
} else {
throw (new Error("Assert failed: (and (>= startslice 0) (integer? startslice))"));
}

var mname = cljs.compiler.munge.call(null,cljs.core.gensym.call(null));
var i = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname),"__i"].join('');
var a = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname),"__a"].join('');
cljs.compiler.emitln.call(null,"var ",i," = 0, ",a," = new Array(arguments.length -  ",startslice,");");

cljs.compiler.emitln.call(null,"while (",i," < ",a,".length) {",a,"[",i,"] = arguments[",i," + ",startslice,"]; ++",i,";}");

return a;
});
cljs.compiler.emit_variadic_fn_method = (function cljs$compiler$emit_variadic_fn_method(p__8439){
var map__8440 = p__8439;
var map__8440__$1 = ((((!((map__8440 == null)))?(((((map__8440.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8440.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8440):map__8440);
var f = map__8440__$1;
var type = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var name = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var variadic = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"variadic","variadic",882626057));
var params = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"params","params",710516235));
var expr = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
var env = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var recurs = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"recurs","recurs",-1959309309));
var max_fixed_arity = cljs.core.get.call(null,map__8440__$1,new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

var name_8450__$1 = (function (){var or__3922__auto__ = name;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.gensym.call(null);
}
})();
var mname_8451 = cljs.compiler.munge.call(null,name_8450__$1);
var delegate_name_8452 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname_8451),"__delegate"].join('');
cljs.compiler.emitln.call(null,"(function() { ");

cljs.compiler.emits.call(null,"var ",delegate_name_8452," = function (");

var seq__8442_8453 = cljs.core.seq.call(null,params);
var chunk__8443_8454 = null;
var count__8444_8455 = (0);
var i__8445_8456 = (0);
while(true){
if((i__8445_8456 < count__8444_8455)){
var param_8457 = cljs.core._nth.call(null,chunk__8443_8454,i__8445_8456);
cljs.compiler.emit.call(null,param_8457);

if(cljs.core._EQ_.call(null,param_8457,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8458 = seq__8442_8453;
var G__8459 = chunk__8443_8454;
var G__8460 = count__8444_8455;
var G__8461 = (i__8445_8456 + (1));
seq__8442_8453 = G__8458;
chunk__8443_8454 = G__8459;
count__8444_8455 = G__8460;
i__8445_8456 = G__8461;
continue;
} else {
var temp__6753__auto___8462 = cljs.core.seq.call(null,seq__8442_8453);
if(temp__6753__auto___8462){
var seq__8442_8463__$1 = temp__6753__auto___8462;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8442_8463__$1)){
var c__4319__auto___8464 = cljs.core.chunk_first.call(null,seq__8442_8463__$1);
var G__8465 = cljs.core.chunk_rest.call(null,seq__8442_8463__$1);
var G__8466 = c__4319__auto___8464;
var G__8467 = cljs.core.count.call(null,c__4319__auto___8464);
var G__8468 = (0);
seq__8442_8453 = G__8465;
chunk__8443_8454 = G__8466;
count__8444_8455 = G__8467;
i__8445_8456 = G__8468;
continue;
} else {
var param_8469 = cljs.core.first.call(null,seq__8442_8463__$1);
cljs.compiler.emit.call(null,param_8469);

if(cljs.core._EQ_.call(null,param_8469,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8470 = cljs.core.next.call(null,seq__8442_8463__$1);
var G__8471 = null;
var G__8472 = (0);
var G__8473 = (0);
seq__8442_8453 = G__8470;
chunk__8443_8454 = G__8471;
count__8444_8455 = G__8472;
i__8445_8456 = G__8473;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"){");

if(cljs.core.truth_(type)){
cljs.compiler.emitln.call(null,"var self__ = this;");
} else {
}

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"while(true){");
} else {
}

cljs.compiler.emits.call(null,expr);

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"break;");

cljs.compiler.emitln.call(null,"}");
} else {
}

cljs.compiler.emitln.call(null,"};");

cljs.compiler.emitln.call(null,"var ",mname_8451," = function (",cljs.compiler.comma_sep.call(null,(cljs.core.truth_(variadic)?cljs.core.concat.call(null,cljs.core.butlast.call(null,params),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"var_args","var_args",1214280389,null)], null)):params)),"){");

if(cljs.core.truth_(type)){
cljs.compiler.emitln.call(null,"var self__ = this;");
} else {
}

if(cljs.core.truth_(variadic)){
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,params));

cljs.compiler.emitln.call(null," = null;");

cljs.compiler.emitln.call(null,"if (arguments.length > ",(cljs.core.count.call(null,params) - (1)),") {");

var a_8474 = cljs.compiler.emit_arguments_to_array.call(null,(cljs.core.count.call(null,params) - (1)));
cljs.compiler.emitln.call(null,"  ",cljs.core.last.call(null,params)," = new cljs.core.IndexedSeq(",a_8474,",0,null);");

cljs.compiler.emitln.call(null,"} ");
} else {
}

cljs.compiler.emits.call(null,"return ",delegate_name_8452,".call(this,");

var seq__8446_8475 = cljs.core.seq.call(null,params);
var chunk__8447_8476 = null;
var count__8448_8477 = (0);
var i__8449_8478 = (0);
while(true){
if((i__8449_8478 < count__8448_8477)){
var param_8479 = cljs.core._nth.call(null,chunk__8447_8476,i__8449_8478);
cljs.compiler.emit.call(null,param_8479);

if(cljs.core._EQ_.call(null,param_8479,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8480 = seq__8446_8475;
var G__8481 = chunk__8447_8476;
var G__8482 = count__8448_8477;
var G__8483 = (i__8449_8478 + (1));
seq__8446_8475 = G__8480;
chunk__8447_8476 = G__8481;
count__8448_8477 = G__8482;
i__8449_8478 = G__8483;
continue;
} else {
var temp__6753__auto___8484 = cljs.core.seq.call(null,seq__8446_8475);
if(temp__6753__auto___8484){
var seq__8446_8485__$1 = temp__6753__auto___8484;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8446_8485__$1)){
var c__4319__auto___8486 = cljs.core.chunk_first.call(null,seq__8446_8485__$1);
var G__8487 = cljs.core.chunk_rest.call(null,seq__8446_8485__$1);
var G__8488 = c__4319__auto___8486;
var G__8489 = cljs.core.count.call(null,c__4319__auto___8486);
var G__8490 = (0);
seq__8446_8475 = G__8487;
chunk__8447_8476 = G__8488;
count__8448_8477 = G__8489;
i__8449_8478 = G__8490;
continue;
} else {
var param_8491 = cljs.core.first.call(null,seq__8446_8485__$1);
cljs.compiler.emit.call(null,param_8491);

if(cljs.core._EQ_.call(null,param_8491,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__8492 = cljs.core.next.call(null,seq__8446_8485__$1);
var G__8493 = null;
var G__8494 = (0);
var G__8495 = (0);
seq__8446_8475 = G__8492;
chunk__8447_8476 = G__8493;
count__8448_8477 = G__8494;
i__8449_8478 = G__8495;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emits.call(null,");");

cljs.compiler.emitln.call(null,"};");

cljs.compiler.emitln.call(null,mname_8451,".cljs$lang$maxFixedArity = ",max_fixed_arity,";");

cljs.compiler.emits.call(null,mname_8451,".cljs$lang$applyTo = ");

cljs.compiler.emit_apply_to.call(null,cljs.core.assoc.call(null,f,new cljs.core.Keyword(null,"name","name",1843675177),name_8450__$1));

cljs.compiler.emitln.call(null,";");

cljs.compiler.emitln.call(null,mname_8451,".cljs$core$IFn$_invoke$arity$variadic = ",delegate_name_8452,";");

cljs.compiler.emitln.call(null,"return ",mname_8451,";");

cljs.compiler.emitln.call(null,"})()");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"fn","fn",-1175266204),(function (p__8499){
var map__8500 = p__8499;
var map__8500__$1 = ((((!((map__8500 == null)))?(((((map__8500.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8500.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8500):map__8500);
var name = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var env = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var methods$ = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"methods","methods",453930866));
var max_fixed_arity = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543));
var variadic = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"variadic","variadic",882626057));
var recur_frames = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"recur-frames","recur-frames",-307205196));
var loop_lets = cljs.core.get.call(null,map__8500__$1,new cljs.core.Keyword(null,"loop-lets","loop-lets",2036794185));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return null;
} else {
var loop_locals = cljs.core.seq.call(null,cljs.core.map.call(null,cljs.compiler.munge,cljs.core.concat.call(null,cljs.core.mapcat.call(null,new cljs.core.Keyword(null,"params","params",710516235),cljs.core.filter.call(null,((function (map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets){
return (function (p1__8496_SHARP_){
var and__3911__auto__ = p1__8496_SHARP_;
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core.deref.call(null,new cljs.core.Keyword(null,"flag","flag",1088647881).cljs$core$IFn$_invoke$arity$1(p1__8496_SHARP_));
} else {
return and__3911__auto__;
}
});})(map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets))
,recur_frames)),cljs.core.mapcat.call(null,new cljs.core.Keyword(null,"params","params",710516235),loop_lets))));
if(loop_locals){
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emitln.call(null,"((function (",cljs.compiler.comma_sep.call(null,cljs.core.map.call(null,cljs.compiler.munge,loop_locals)),"){");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
} else {
cljs.compiler.emits.call(null,"return ");
}
} else {
}

if(cljs.core._EQ_.call(null,(1),cljs.core.count.call(null,methods$))){
if(cljs.core.truth_(variadic)){
cljs.compiler.emit_variadic_fn_method.call(null,cljs.core.assoc.call(null,cljs.core.first.call(null,methods$),new cljs.core.Keyword(null,"name","name",1843675177),name));
} else {
cljs.compiler.emit_fn_method.call(null,cljs.core.assoc.call(null,cljs.core.first.call(null,methods$),new cljs.core.Keyword(null,"name","name",1843675177),name));
}
} else {
var name_8535__$1 = (function (){var or__3922__auto__ = name;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.gensym.call(null);
}
})();
var mname_8536 = cljs.compiler.munge.call(null,name_8535__$1);
var maxparams_8537 = cljs.core.apply.call(null,cljs.core.max_key,cljs.core.count,cljs.core.map.call(null,new cljs.core.Keyword(null,"params","params",710516235),methods$));
var mmap_8538 = cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,cljs.core.map.call(null,((function (name_8535__$1,mname_8536,maxparams_8537,loop_locals,map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets){
return (function (method){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.compiler.munge.call(null,cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname_8536),"__",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(method)))].join(''))),method], null);
});})(name_8535__$1,mname_8536,maxparams_8537,loop_locals,map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets))
,methods$));
var ms_8539 = cljs.core.sort_by.call(null,((function (name_8535__$1,mname_8536,maxparams_8537,mmap_8538,loop_locals,map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets){
return (function (p1__8497_SHARP_){
return cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(cljs.core.second.call(null,p1__8497_SHARP_)));
});})(name_8535__$1,mname_8536,maxparams_8537,mmap_8538,loop_locals,map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets))
,cljs.core.seq.call(null,mmap_8538));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emitln.call(null,"(function() {");

cljs.compiler.emitln.call(null,"var ",mname_8536," = null;");

var seq__8502_8540 = cljs.core.seq.call(null,ms_8539);
var chunk__8503_8541 = null;
var count__8504_8542 = (0);
var i__8505_8543 = (0);
while(true){
if((i__8505_8543 < count__8504_8542)){
var vec__8506_8544 = cljs.core._nth.call(null,chunk__8503_8541,i__8505_8543);
var n_8545 = cljs.core.nth.call(null,vec__8506_8544,(0),null);
var meth_8546 = cljs.core.nth.call(null,vec__8506_8544,(1),null);
cljs.compiler.emits.call(null,"var ",n_8545," = ");

if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(meth_8546))){
cljs.compiler.emit_variadic_fn_method.call(null,meth_8546);
} else {
cljs.compiler.emit_fn_method.call(null,meth_8546);
}

cljs.compiler.emitln.call(null,";");


var G__8547 = seq__8502_8540;
var G__8548 = chunk__8503_8541;
var G__8549 = count__8504_8542;
var G__8550 = (i__8505_8543 + (1));
seq__8502_8540 = G__8547;
chunk__8503_8541 = G__8548;
count__8504_8542 = G__8549;
i__8505_8543 = G__8550;
continue;
} else {
var temp__6753__auto___8551 = cljs.core.seq.call(null,seq__8502_8540);
if(temp__6753__auto___8551){
var seq__8502_8552__$1 = temp__6753__auto___8551;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8502_8552__$1)){
var c__4319__auto___8553 = cljs.core.chunk_first.call(null,seq__8502_8552__$1);
var G__8554 = cljs.core.chunk_rest.call(null,seq__8502_8552__$1);
var G__8555 = c__4319__auto___8553;
var G__8556 = cljs.core.count.call(null,c__4319__auto___8553);
var G__8557 = (0);
seq__8502_8540 = G__8554;
chunk__8503_8541 = G__8555;
count__8504_8542 = G__8556;
i__8505_8543 = G__8557;
continue;
} else {
var vec__8509_8558 = cljs.core.first.call(null,seq__8502_8552__$1);
var n_8559 = cljs.core.nth.call(null,vec__8509_8558,(0),null);
var meth_8560 = cljs.core.nth.call(null,vec__8509_8558,(1),null);
cljs.compiler.emits.call(null,"var ",n_8559," = ");

if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(meth_8560))){
cljs.compiler.emit_variadic_fn_method.call(null,meth_8560);
} else {
cljs.compiler.emit_fn_method.call(null,meth_8560);
}

cljs.compiler.emitln.call(null,";");


var G__8561 = cljs.core.next.call(null,seq__8502_8552__$1);
var G__8562 = null;
var G__8563 = (0);
var G__8564 = (0);
seq__8502_8540 = G__8561;
chunk__8503_8541 = G__8562;
count__8504_8542 = G__8563;
i__8505_8543 = G__8564;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,mname_8536," = function(",cljs.compiler.comma_sep.call(null,(cljs.core.truth_(variadic)?cljs.core.concat.call(null,cljs.core.butlast.call(null,maxparams_8537),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"var_args","var_args",1214280389,null)], null)):maxparams_8537)),"){");

if(cljs.core.truth_(variadic)){
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,maxparams_8537));

cljs.compiler.emitln.call(null," = var_args;");
} else {
}

cljs.compiler.emitln.call(null,"switch(arguments.length){");

var seq__8512_8565 = cljs.core.seq.call(null,ms_8539);
var chunk__8513_8566 = null;
var count__8514_8567 = (0);
var i__8515_8568 = (0);
while(true){
if((i__8515_8568 < count__8514_8567)){
var vec__8516_8569 = cljs.core._nth.call(null,chunk__8513_8566,i__8515_8568);
var n_8570 = cljs.core.nth.call(null,vec__8516_8569,(0),null);
var meth_8571 = cljs.core.nth.call(null,vec__8516_8569,(1),null);
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(meth_8571))){
cljs.compiler.emitln.call(null,"default:");

var restarg_8572 = cljs.compiler.munge.call(null,cljs.core.gensym.call(null));
cljs.compiler.emitln.call(null,"var ",restarg_8572," = null;");

cljs.compiler.emitln.call(null,"if (arguments.length > ",max_fixed_arity,") {");

var a_8573 = cljs.compiler.emit_arguments_to_array.call(null,max_fixed_arity);
cljs.compiler.emitln.call(null,restarg_8572," = new cljs.core.IndexedSeq(",a_8573,",0,null);");

cljs.compiler.emitln.call(null,"}");

cljs.compiler.emitln.call(null,"return ",n_8570,".cljs$core$IFn$_invoke$arity$variadic(",cljs.compiler.comma_sep.call(null,cljs.core.butlast.call(null,maxparams_8537)),(((cljs.core.count.call(null,maxparams_8537) > (1)))?", ":null),restarg_8572,");");
} else {
var pcnt_8574 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_8571));
cljs.compiler.emitln.call(null,"case ",pcnt_8574,":");

cljs.compiler.emitln.call(null,"return ",n_8570,".call(this",(((pcnt_8574 === (0)))?null:(new cljs.core.List(null,",",(new cljs.core.List(null,cljs.compiler.comma_sep.call(null,cljs.core.take.call(null,pcnt_8574,maxparams_8537)),null,(1),null)),(2),null))),");");
}


var G__8575 = seq__8512_8565;
var G__8576 = chunk__8513_8566;
var G__8577 = count__8514_8567;
var G__8578 = (i__8515_8568 + (1));
seq__8512_8565 = G__8575;
chunk__8513_8566 = G__8576;
count__8514_8567 = G__8577;
i__8515_8568 = G__8578;
continue;
} else {
var temp__6753__auto___8579 = cljs.core.seq.call(null,seq__8512_8565);
if(temp__6753__auto___8579){
var seq__8512_8580__$1 = temp__6753__auto___8579;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8512_8580__$1)){
var c__4319__auto___8581 = cljs.core.chunk_first.call(null,seq__8512_8580__$1);
var G__8582 = cljs.core.chunk_rest.call(null,seq__8512_8580__$1);
var G__8583 = c__4319__auto___8581;
var G__8584 = cljs.core.count.call(null,c__4319__auto___8581);
var G__8585 = (0);
seq__8512_8565 = G__8582;
chunk__8513_8566 = G__8583;
count__8514_8567 = G__8584;
i__8515_8568 = G__8585;
continue;
} else {
var vec__8519_8586 = cljs.core.first.call(null,seq__8512_8580__$1);
var n_8587 = cljs.core.nth.call(null,vec__8519_8586,(0),null);
var meth_8588 = cljs.core.nth.call(null,vec__8519_8586,(1),null);
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(meth_8588))){
cljs.compiler.emitln.call(null,"default:");

var restarg_8589 = cljs.compiler.munge.call(null,cljs.core.gensym.call(null));
cljs.compiler.emitln.call(null,"var ",restarg_8589," = null;");

cljs.compiler.emitln.call(null,"if (arguments.length > ",max_fixed_arity,") {");

var a_8590 = cljs.compiler.emit_arguments_to_array.call(null,max_fixed_arity);
cljs.compiler.emitln.call(null,restarg_8589," = new cljs.core.IndexedSeq(",a_8590,",0,null);");

cljs.compiler.emitln.call(null,"}");

cljs.compiler.emitln.call(null,"return ",n_8587,".cljs$core$IFn$_invoke$arity$variadic(",cljs.compiler.comma_sep.call(null,cljs.core.butlast.call(null,maxparams_8537)),(((cljs.core.count.call(null,maxparams_8537) > (1)))?", ":null),restarg_8589,");");
} else {
var pcnt_8591 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_8588));
cljs.compiler.emitln.call(null,"case ",pcnt_8591,":");

cljs.compiler.emitln.call(null,"return ",n_8587,".call(this",(((pcnt_8591 === (0)))?null:(new cljs.core.List(null,",",(new cljs.core.List(null,cljs.compiler.comma_sep.call(null,cljs.core.take.call(null,pcnt_8591,maxparams_8537)),null,(1),null)),(2),null))),");");
}


var G__8592 = cljs.core.next.call(null,seq__8512_8580__$1);
var G__8593 = null;
var G__8594 = (0);
var G__8595 = (0);
seq__8512_8565 = G__8592;
chunk__8513_8566 = G__8593;
count__8514_8567 = G__8594;
i__8515_8568 = G__8595;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"}");

cljs.compiler.emitln.call(null,"throw(new Error('Invalid arity: ' + (arguments.length - 1)));");

cljs.compiler.emitln.call(null,"};");

if(cljs.core.truth_(variadic)){
cljs.compiler.emitln.call(null,mname_8536,".cljs$lang$maxFixedArity = ",max_fixed_arity,";");

cljs.compiler.emitln.call(null,mname_8536,".cljs$lang$applyTo = ",cljs.core.some.call(null,((function (name_8535__$1,mname_8536,maxparams_8537,mmap_8538,ms_8539,loop_locals,map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets){
return (function (p1__8498_SHARP_){
var vec__8522 = p1__8498_SHARP_;
var n = cljs.core.nth.call(null,vec__8522,(0),null);
var m = cljs.core.nth.call(null,vec__8522,(1),null);
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(m))){
return n;
} else {
return null;
}
});})(name_8535__$1,mname_8536,maxparams_8537,mmap_8538,ms_8539,loop_locals,map__8500,map__8500__$1,name,env,methods$,max_fixed_arity,variadic,recur_frames,loop_lets))
,ms_8539),".cljs$lang$applyTo;");
} else {
}

var seq__8525_8596 = cljs.core.seq.call(null,ms_8539);
var chunk__8526_8597 = null;
var count__8527_8598 = (0);
var i__8528_8599 = (0);
while(true){
if((i__8528_8599 < count__8527_8598)){
var vec__8529_8600 = cljs.core._nth.call(null,chunk__8526_8597,i__8528_8599);
var n_8601 = cljs.core.nth.call(null,vec__8529_8600,(0),null);
var meth_8602 = cljs.core.nth.call(null,vec__8529_8600,(1),null);
var c_8603 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_8602));
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(meth_8602))){
cljs.compiler.emitln.call(null,mname_8536,".cljs$core$IFn$_invoke$arity$variadic = ",n_8601,".cljs$core$IFn$_invoke$arity$variadic;");
} else {
cljs.compiler.emitln.call(null,mname_8536,".cljs$core$IFn$_invoke$arity$",c_8603," = ",n_8601,";");
}


var G__8604 = seq__8525_8596;
var G__8605 = chunk__8526_8597;
var G__8606 = count__8527_8598;
var G__8607 = (i__8528_8599 + (1));
seq__8525_8596 = G__8604;
chunk__8526_8597 = G__8605;
count__8527_8598 = G__8606;
i__8528_8599 = G__8607;
continue;
} else {
var temp__6753__auto___8608 = cljs.core.seq.call(null,seq__8525_8596);
if(temp__6753__auto___8608){
var seq__8525_8609__$1 = temp__6753__auto___8608;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8525_8609__$1)){
var c__4319__auto___8610 = cljs.core.chunk_first.call(null,seq__8525_8609__$1);
var G__8611 = cljs.core.chunk_rest.call(null,seq__8525_8609__$1);
var G__8612 = c__4319__auto___8610;
var G__8613 = cljs.core.count.call(null,c__4319__auto___8610);
var G__8614 = (0);
seq__8525_8596 = G__8611;
chunk__8526_8597 = G__8612;
count__8527_8598 = G__8613;
i__8528_8599 = G__8614;
continue;
} else {
var vec__8532_8615 = cljs.core.first.call(null,seq__8525_8609__$1);
var n_8616 = cljs.core.nth.call(null,vec__8532_8615,(0),null);
var meth_8617 = cljs.core.nth.call(null,vec__8532_8615,(1),null);
var c_8618 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_8617));
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(meth_8617))){
cljs.compiler.emitln.call(null,mname_8536,".cljs$core$IFn$_invoke$arity$variadic = ",n_8616,".cljs$core$IFn$_invoke$arity$variadic;");
} else {
cljs.compiler.emitln.call(null,mname_8536,".cljs$core$IFn$_invoke$arity$",c_8618," = ",n_8616,";");
}


var G__8619 = cljs.core.next.call(null,seq__8525_8609__$1);
var G__8620 = null;
var G__8621 = (0);
var G__8622 = (0);
seq__8525_8596 = G__8619;
chunk__8526_8597 = G__8620;
count__8527_8598 = G__8621;
i__8528_8599 = G__8622;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"return ",mname_8536,";");

cljs.compiler.emitln.call(null,"})()");
}

if(loop_locals){
return cljs.compiler.emitln.call(null,";})(",cljs.compiler.comma_sep.call(null,loop_locals),"))");
} else {
return null;
}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"do","do",46310725),(function (p__8623){
var map__8624 = p__8623;
var map__8624__$1 = ((((!((map__8624 == null)))?(((((map__8624.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8624.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8624):map__8624);
var statements = cljs.core.get.call(null,map__8624__$1,new cljs.core.Keyword(null,"statements","statements",600349855));
var ret = cljs.core.get.call(null,map__8624__$1,new cljs.core.Keyword(null,"ret","ret",-468222814));
var env = cljs.core.get.call(null,map__8624__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core.truth_((function (){var and__3911__auto__ = statements;
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context);
} else {
return and__3911__auto__;
}
})())){
cljs.compiler.emitln.call(null,"(function (){");
} else {
}

var seq__8626_8630 = cljs.core.seq.call(null,statements);
var chunk__8627_8631 = null;
var count__8628_8632 = (0);
var i__8629_8633 = (0);
while(true){
if((i__8629_8633 < count__8628_8632)){
var s_8634 = cljs.core._nth.call(null,chunk__8627_8631,i__8629_8633);
cljs.compiler.emitln.call(null,s_8634);


var G__8635 = seq__8626_8630;
var G__8636 = chunk__8627_8631;
var G__8637 = count__8628_8632;
var G__8638 = (i__8629_8633 + (1));
seq__8626_8630 = G__8635;
chunk__8627_8631 = G__8636;
count__8628_8632 = G__8637;
i__8629_8633 = G__8638;
continue;
} else {
var temp__6753__auto___8639 = cljs.core.seq.call(null,seq__8626_8630);
if(temp__6753__auto___8639){
var seq__8626_8640__$1 = temp__6753__auto___8639;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8626_8640__$1)){
var c__4319__auto___8641 = cljs.core.chunk_first.call(null,seq__8626_8640__$1);
var G__8642 = cljs.core.chunk_rest.call(null,seq__8626_8640__$1);
var G__8643 = c__4319__auto___8641;
var G__8644 = cljs.core.count.call(null,c__4319__auto___8641);
var G__8645 = (0);
seq__8626_8630 = G__8642;
chunk__8627_8631 = G__8643;
count__8628_8632 = G__8644;
i__8629_8633 = G__8645;
continue;
} else {
var s_8646 = cljs.core.first.call(null,seq__8626_8640__$1);
cljs.compiler.emitln.call(null,s_8646);


var G__8647 = cljs.core.next.call(null,seq__8626_8640__$1);
var G__8648 = null;
var G__8649 = (0);
var G__8650 = (0);
seq__8626_8630 = G__8647;
chunk__8627_8631 = G__8648;
count__8628_8632 = G__8649;
i__8629_8633 = G__8650;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emit.call(null,ret);

if(cljs.core.truth_((function (){var and__3911__auto__ = statements;
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context);
} else {
return and__3911__auto__;
}
})())){
return cljs.compiler.emitln.call(null,"})()");
} else {
return null;
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"try","try",1380742522),(function (p__8651){
var map__8652 = p__8651;
var map__8652__$1 = ((((!((map__8652 == null)))?(((((map__8652.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8652.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8652):map__8652);
var env = cljs.core.get.call(null,map__8652__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var try$ = cljs.core.get.call(null,map__8652__$1,new cljs.core.Keyword(null,"try","try",1380742522));
var catch$ = cljs.core.get.call(null,map__8652__$1,new cljs.core.Keyword(null,"catch","catch",1038065524));
var name = cljs.core.get.call(null,map__8652__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var finally$ = cljs.core.get.call(null,map__8652__$1,new cljs.core.Keyword(null,"finally","finally",1589088705));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core.truth_((function (){var or__3922__auto__ = name;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return finally$;
}
})())){
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
cljs.compiler.emits.call(null,"(function (){");
} else {
}

cljs.compiler.emits.call(null,"try{",try$,"}");

if(cljs.core.truth_(name)){
cljs.compiler.emits.call(null,"catch (",cljs.compiler.munge.call(null,name),"){",catch$,"}");
} else {
}

if(cljs.core.truth_(finally$)){
if(cljs.core.not_EQ_.call(null,new cljs.core.Keyword(null,"constant","constant",-379609303),new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(finally$))){
} else {
throw (new Error(["Assert failed: ","finally block cannot contain constant","\n","(not= :constant (:op finally))"].join('')));
}

cljs.compiler.emits.call(null,"finally {",finally$,"}");
} else {
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"})()");
} else {
return null;
}
} else {
return cljs.compiler.emits.call(null,try$);
}
}));
cljs.compiler.emit_let = (function cljs$compiler$emit_let(p__8654,is_loop){
var map__8655 = p__8654;
var map__8655__$1 = ((((!((map__8655 == null)))?(((((map__8655.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8655.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8655):map__8655);
var bindings = cljs.core.get.call(null,map__8655__$1,new cljs.core.Keyword(null,"bindings","bindings",1271397192));
var expr = cljs.core.get.call(null,map__8655__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
var env = cljs.core.get.call(null,map__8655__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
cljs.compiler.emits.call(null,"(function (){");
} else {
}

var _STAR_lexical_renames_STAR_8657_8666 = cljs.compiler._STAR_lexical_renames_STAR_;
cljs.compiler._STAR_lexical_renames_STAR_ = cljs.core.into.call(null,cljs.compiler._STAR_lexical_renames_STAR_,((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),context))?cljs.core.map.call(null,((function (_STAR_lexical_renames_STAR_8657_8666,context,map__8655,map__8655__$1,bindings,expr,env){
return (function (binding){
var name = new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(binding);
return (new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.compiler.hash_scope.call(null,binding),cljs.core.gensym.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"-"].join(''))],null));
});})(_STAR_lexical_renames_STAR_8657_8666,context,map__8655,map__8655__$1,bindings,expr,env))
,bindings):null));

try{var seq__8658_8667 = cljs.core.seq.call(null,bindings);
var chunk__8659_8668 = null;
var count__8660_8669 = (0);
var i__8661_8670 = (0);
while(true){
if((i__8661_8670 < count__8660_8669)){
var map__8662_8671 = cljs.core._nth.call(null,chunk__8659_8668,i__8661_8670);
var map__8662_8672__$1 = ((((!((map__8662_8671 == null)))?(((((map__8662_8671.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8662_8671.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8662_8671):map__8662_8671);
var binding_8673 = map__8662_8672__$1;
var init_8674 = cljs.core.get.call(null,map__8662_8672__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,binding_8673);

cljs.compiler.emitln.call(null," = ",init_8674,";");


var G__8675 = seq__8658_8667;
var G__8676 = chunk__8659_8668;
var G__8677 = count__8660_8669;
var G__8678 = (i__8661_8670 + (1));
seq__8658_8667 = G__8675;
chunk__8659_8668 = G__8676;
count__8660_8669 = G__8677;
i__8661_8670 = G__8678;
continue;
} else {
var temp__6753__auto___8679 = cljs.core.seq.call(null,seq__8658_8667);
if(temp__6753__auto___8679){
var seq__8658_8680__$1 = temp__6753__auto___8679;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8658_8680__$1)){
var c__4319__auto___8681 = cljs.core.chunk_first.call(null,seq__8658_8680__$1);
var G__8682 = cljs.core.chunk_rest.call(null,seq__8658_8680__$1);
var G__8683 = c__4319__auto___8681;
var G__8684 = cljs.core.count.call(null,c__4319__auto___8681);
var G__8685 = (0);
seq__8658_8667 = G__8682;
chunk__8659_8668 = G__8683;
count__8660_8669 = G__8684;
i__8661_8670 = G__8685;
continue;
} else {
var map__8664_8686 = cljs.core.first.call(null,seq__8658_8680__$1);
var map__8664_8687__$1 = ((((!((map__8664_8686 == null)))?(((((map__8664_8686.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8664_8686.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8664_8686):map__8664_8686);
var binding_8688 = map__8664_8687__$1;
var init_8689 = cljs.core.get.call(null,map__8664_8687__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,binding_8688);

cljs.compiler.emitln.call(null," = ",init_8689,";");


var G__8690 = cljs.core.next.call(null,seq__8658_8680__$1);
var G__8691 = null;
var G__8692 = (0);
var G__8693 = (0);
seq__8658_8667 = G__8690;
chunk__8659_8668 = G__8691;
count__8660_8669 = G__8692;
i__8661_8670 = G__8693;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(is_loop)){
cljs.compiler.emitln.call(null,"while(true){");
} else {
}

cljs.compiler.emits.call(null,expr);

if(cljs.core.truth_(is_loop)){
cljs.compiler.emitln.call(null,"break;");

cljs.compiler.emitln.call(null,"}");
} else {
}
}finally {cljs.compiler._STAR_lexical_renames_STAR_ = _STAR_lexical_renames_STAR_8657_8666;
}
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"})()");
} else {
return null;
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"let","let",-1282412701),(function (ast){
return cljs.compiler.emit_let.call(null,ast,false);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"loop","loop",-395552849),(function (ast){
return cljs.compiler.emit_let.call(null,ast,true);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"recur","recur",-437573268),(function (p__8694){
var map__8695 = p__8694;
var map__8695__$1 = ((((!((map__8695 == null)))?(((((map__8695.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8695.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8695):map__8695);
var frame = cljs.core.get.call(null,map__8695__$1,new cljs.core.Keyword(null,"frame","frame",-1711082588));
var exprs = cljs.core.get.call(null,map__8695__$1,new cljs.core.Keyword(null,"exprs","exprs",1795829094));
var env = cljs.core.get.call(null,map__8695__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var temps = cljs.core.vec.call(null,cljs.core.take.call(null,cljs.core.count.call(null,exprs),cljs.core.repeatedly.call(null,cljs.core.gensym)));
var params = new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(frame);
var n__4376__auto___8697 = cljs.core.count.call(null,exprs);
var i_8698 = (0);
while(true){
if((i_8698 < n__4376__auto___8697)){
cljs.compiler.emitln.call(null,"var ",temps.call(null,i_8698)," = ",exprs.call(null,i_8698),";");

var G__8699 = (i_8698 + (1));
i_8698 = G__8699;
continue;
} else {
}
break;
}

var n__4376__auto___8700 = cljs.core.count.call(null,exprs);
var i_8701 = (0);
while(true){
if((i_8701 < n__4376__auto___8700)){
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,params.call(null,i_8701))," = ",temps.call(null,i_8701),";");

var G__8702 = (i_8701 + (1));
i_8701 = G__8702;
continue;
} else {
}
break;
}

return cljs.compiler.emitln.call(null,"continue;");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"letfn","letfn",-2121022354),(function (p__8703){
var map__8704 = p__8703;
var map__8704__$1 = ((((!((map__8704 == null)))?(((((map__8704.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8704.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8704):map__8704);
var bindings = cljs.core.get.call(null,map__8704__$1,new cljs.core.Keyword(null,"bindings","bindings",1271397192));
var expr = cljs.core.get.call(null,map__8704__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
var env = cljs.core.get.call(null,map__8704__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
cljs.compiler.emits.call(null,"(function (){");
} else {
}

var seq__8706_8714 = cljs.core.seq.call(null,bindings);
var chunk__8707_8715 = null;
var count__8708_8716 = (0);
var i__8709_8717 = (0);
while(true){
if((i__8709_8717 < count__8708_8716)){
var map__8710_8718 = cljs.core._nth.call(null,chunk__8707_8715,i__8709_8717);
var map__8710_8719__$1 = ((((!((map__8710_8718 == null)))?(((((map__8710_8718.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8710_8718.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8710_8718):map__8710_8718);
var binding_8720 = map__8710_8719__$1;
var init_8721 = cljs.core.get.call(null,map__8710_8719__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emitln.call(null,"var ",cljs.compiler.munge.call(null,binding_8720)," = ",init_8721,";");


var G__8722 = seq__8706_8714;
var G__8723 = chunk__8707_8715;
var G__8724 = count__8708_8716;
var G__8725 = (i__8709_8717 + (1));
seq__8706_8714 = G__8722;
chunk__8707_8715 = G__8723;
count__8708_8716 = G__8724;
i__8709_8717 = G__8725;
continue;
} else {
var temp__6753__auto___8726 = cljs.core.seq.call(null,seq__8706_8714);
if(temp__6753__auto___8726){
var seq__8706_8727__$1 = temp__6753__auto___8726;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8706_8727__$1)){
var c__4319__auto___8728 = cljs.core.chunk_first.call(null,seq__8706_8727__$1);
var G__8729 = cljs.core.chunk_rest.call(null,seq__8706_8727__$1);
var G__8730 = c__4319__auto___8728;
var G__8731 = cljs.core.count.call(null,c__4319__auto___8728);
var G__8732 = (0);
seq__8706_8714 = G__8729;
chunk__8707_8715 = G__8730;
count__8708_8716 = G__8731;
i__8709_8717 = G__8732;
continue;
} else {
var map__8712_8733 = cljs.core.first.call(null,seq__8706_8727__$1);
var map__8712_8734__$1 = ((((!((map__8712_8733 == null)))?(((((map__8712_8733.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8712_8733.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8712_8733):map__8712_8733);
var binding_8735 = map__8712_8734__$1;
var init_8736 = cljs.core.get.call(null,map__8712_8734__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emitln.call(null,"var ",cljs.compiler.munge.call(null,binding_8735)," = ",init_8736,";");


var G__8737 = cljs.core.next.call(null,seq__8706_8727__$1);
var G__8738 = null;
var G__8739 = (0);
var G__8740 = (0);
seq__8706_8714 = G__8737;
chunk__8707_8715 = G__8738;
count__8708_8716 = G__8739;
i__8709_8717 = G__8740;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emits.call(null,expr);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"})()");
} else {
return null;
}
}));
cljs.compiler.protocol_prefix = (function cljs$compiler$protocol_prefix(psym){
return cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1([cljs.core.str.cljs$core$IFn$_invoke$arity$1(psym)].join('').replace((new RegExp("\\.","g")),"$").replace("/","$")),"$"].join(''));
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"invoke","invoke",1145927159),(function (p__8743){
var map__8744 = p__8743;
var map__8744__$1 = ((((!((map__8744 == null)))?(((((map__8744.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8744.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8744):map__8744);
var expr = map__8744__$1;
var f = cljs.core.get.call(null,map__8744__$1,new cljs.core.Keyword(null,"f","f",-1597136552));
var args = cljs.core.get.call(null,map__8744__$1,new cljs.core.Keyword(null,"args","args",1315556576));
var env = cljs.core.get.call(null,map__8744__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var info = new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(f);
var fn_QMARK_ = (function (){var and__3911__auto__ = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(and__3911__auto__){
var and__3911__auto____$1 = cljs.core.not.call(null,new cljs.core.Keyword(null,"dynamic","dynamic",704819571).cljs$core$IFn$_invoke$arity$1(info));
if(and__3911__auto____$1){
return new cljs.core.Keyword(null,"fn-var","fn-var",1086204730).cljs$core$IFn$_invoke$arity$1(info);
} else {
return and__3911__auto____$1;
}
} else {
return and__3911__auto__;
}
})();
var protocol = new cljs.core.Keyword(null,"protocol","protocol",652470118).cljs$core$IFn$_invoke$arity$1(info);
var tag = cljs.analyzer.infer_tag.call(null,env,cljs.core.first.call(null,new cljs.core.Keyword(null,"args","args",1315556576).cljs$core$IFn$_invoke$arity$1(expr)));
var proto_QMARK_ = (function (){var and__3911__auto__ = protocol;
if(cljs.core.truth_(and__3911__auto__)){
var and__3911__auto____$1 = tag;
if(cljs.core.truth_(and__3911__auto____$1)){
var or__3922__auto__ = (function (){var and__3911__auto____$2 = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(and__3911__auto____$2){
var and__3911__auto____$3 = protocol;
if(cljs.core.truth_(and__3911__auto____$3)){
return cljs.core._EQ_.call(null,tag,new cljs.core.Symbol(null,"not-native","not-native",-236392494,null));
} else {
return and__3911__auto____$3;
}
} else {
return and__3911__auto____$2;
}
})();
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
var and__3911__auto____$2 = (function (){var or__3922__auto____$1 = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(or__3922__auto____$1){
return or__3922__auto____$1;
} else {
return new cljs.core.Keyword(null,"protocol-inline","protocol-inline",1550487556).cljs$core$IFn$_invoke$arity$1(env);
}
})();
if(cljs.core.truth_(and__3911__auto____$2)){
var or__3922__auto____$1 = cljs.core._EQ_.call(null,protocol,tag);
if(or__3922__auto____$1){
return or__3922__auto____$1;
} else {
var and__3911__auto____$3 = !(cljs.core.set_QMARK_.call(null,tag));
if(and__3911__auto____$3){
var and__3911__auto____$4 = cljs.core.not.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 11, [new cljs.core.Symbol(null,"clj","clj",980036099,null),null,new cljs.core.Symbol(null,"boolean","boolean",-278886877,null),null,new cljs.core.Symbol(null,"object","object",-1179821820,null),null,new cljs.core.Symbol(null,"any","any",-948528346,null),null,new cljs.core.Symbol(null,"js","js",-886355190,null),null,new cljs.core.Symbol(null,"number","number",-1084057331,null),null,new cljs.core.Symbol(null,"clj-or-nil","clj-or-nil",-2008798668,null),null,new cljs.core.Symbol(null,"array","array",-440182315,null),null,new cljs.core.Symbol(null,"string","string",-349010059,null),null,new cljs.core.Symbol(null,"function","function",-486723946,null),null,new cljs.core.Symbol(null,"clj-nil","clj-nil",1321798654,null),null], null), null).call(null,tag));
if(and__3911__auto____$4){
var temp__6753__auto__ = new cljs.core.Keyword(null,"protocols","protocols",-5615896).cljs$core$IFn$_invoke$arity$1(cljs.analyzer.resolve_existing_var.call(null,env,tag));
if(cljs.core.truth_(temp__6753__auto__)){
var ps = temp__6753__auto__;
return ps.call(null,protocol);
} else {
return null;
}
} else {
return and__3911__auto____$4;
}
} else {
return and__3911__auto____$3;
}
}
} else {
return and__3911__auto____$2;
}
}
} else {
return and__3911__auto____$1;
}
} else {
return and__3911__auto__;
}
})();
var opt_not_QMARK_ = ((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(info),new cljs.core.Symbol("cljs.core","not","cljs.core/not",100665144,null))) && (cljs.core._EQ_.call(null,cljs.analyzer.infer_tag.call(null,env,cljs.core.first.call(null,new cljs.core.Keyword(null,"args","args",1315556576).cljs$core$IFn$_invoke$arity$1(expr))),new cljs.core.Symbol(null,"boolean","boolean",-278886877,null))));
var ns = new cljs.core.Keyword(null,"ns","ns",441598760).cljs$core$IFn$_invoke$arity$1(info);
var js_QMARK_ = ((cljs.core._EQ_.call(null,ns,new cljs.core.Symbol(null,"js","js",-886355190,null))) || (cljs.core._EQ_.call(null,ns,new cljs.core.Symbol(null,"Math","Math",2033287572,null))));
var goog_QMARK_ = (cljs.core.truth_(ns)?(function (){var or__3922__auto__ = cljs.core._EQ_.call(null,ns,new cljs.core.Symbol(null,"goog","goog",-70603925,null));
if(or__3922__auto__){
return or__3922__auto__;
} else {
var or__3922__auto____$1 = (function (){var temp__6753__auto__ = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns)].join('');
if(cljs.core.truth_(temp__6753__auto__)){
var ns_str = temp__6753__auto__;
return cljs.core._EQ_.call(null,cljs.core.get.call(null,clojure.string.split.call(null,ns_str,/\./),(0),null),"goog");
} else {
return null;
}
})();
if(cljs.core.truth_(or__3922__auto____$1)){
return or__3922__auto____$1;
} else {
return !(cljs.core.contains_QMARK_.call(null,new cljs.core.Keyword("cljs.analyzer","namespaces","cljs.analyzer/namespaces",-260788927).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)),ns));
}
}
})():null);
var keyword_QMARK_ = ((cljs.core._EQ_.call(null,new cljs.core.Symbol("cljs.core","Keyword","cljs.core/Keyword",-451434488,null),cljs.analyzer.infer_tag.call(null,env,f))) || (((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(f),new cljs.core.Keyword(null,"constant","constant",-379609303))) && ((new cljs.core.Keyword(null,"form","form",-1624062471).cljs$core$IFn$_invoke$arity$1(f) instanceof cljs.core.Keyword)))));
var vec__8746 = (cljs.core.truth_(fn_QMARK_)?(function (){var arity = cljs.core.count.call(null,args);
var variadic_QMARK_ = new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(info);
var mps = new cljs.core.Keyword(null,"method-params","method-params",-980792179).cljs$core$IFn$_invoke$arity$1(info);
var mfa = new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543).cljs$core$IFn$_invoke$arity$1(info);
if(((cljs.core.not.call(null,variadic_QMARK_)) && (cljs.core._EQ_.call(null,cljs.core.count.call(null,mps),(1))))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [f,null], null);
} else {
if(cljs.core.truth_((function (){var and__3911__auto__ = variadic_QMARK_;
if(cljs.core.truth_(and__3911__auto__)){
return (arity > mfa);
} else {
return and__3911__auto__;
}
})())){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.update_in.call(null,f,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env){
return (function (info__$1){
return cljs.core.update_in.call(null,cljs.core.assoc.call(null,info__$1,new cljs.core.Keyword(null,"name","name",1843675177),cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,info__$1)),".cljs$core$IFn$_invoke$arity$variadic"].join(''))),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env){
return (function (p1__8741_SHARP_){
return cljs.core.dissoc.call(null,cljs.core.dissoc.call(null,p1__8741_SHARP_,new cljs.core.Keyword(null,"shadow","shadow",873231803)),new cljs.core.Keyword(null,"fn-self-name","fn-self-name",1461143531));
});})(arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env))
);
});})(arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env))
),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543),mfa], null)], null);
} else {
var arities = cljs.core.map.call(null,cljs.core.count,mps);
if(cljs.core.truth_(cljs.core.some.call(null,cljs.core.PersistentHashSet.createAsIfByAssoc([arity]),arities))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.update_in.call(null,f,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env){
return (function (info__$1){
return cljs.core.update_in.call(null,cljs.core.assoc.call(null,info__$1,new cljs.core.Keyword(null,"name","name",1843675177),cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,info__$1)),".cljs$core$IFn$_invoke$arity$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arity)].join(''))),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env){
return (function (p1__8742_SHARP_){
return cljs.core.dissoc.call(null,cljs.core.dissoc.call(null,p1__8742_SHARP_,new cljs.core.Keyword(null,"shadow","shadow",873231803)),new cljs.core.Keyword(null,"fn-self-name","fn-self-name",1461143531));
});})(arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env))
);
});})(arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__8744,map__8744__$1,expr,f,args,env))
),null], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [f,null], null);
}

}
}
})():new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [f,null], null));
var f__$1 = cljs.core.nth.call(null,vec__8746,(0),null);
var variadic_invoke = cljs.core.nth.call(null,vec__8746,(1),null);
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(opt_not_QMARK_){
cljs.compiler.emits.call(null,"!(",cljs.core.first.call(null,args),")");
} else {
if(cljs.core.truth_(proto_QMARK_)){
var pimpl_8749 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,cljs.compiler.protocol_prefix.call(null,protocol))),cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,cljs.core.name.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(info)))),"$arity$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.count.call(null,args))].join('');
cljs.compiler.emits.call(null,cljs.core.first.call(null,args),".",pimpl_8749,"(",cljs.compiler.comma_sep.call(null,cljs.core.cons.call(null,"null",cljs.core.rest.call(null,args))),")");
} else {
if(keyword_QMARK_){
cljs.compiler.emits.call(null,f__$1,".cljs$core$IFn$_invoke$arity$",cljs.core.count.call(null,args),"(",cljs.compiler.comma_sep.call(null,args),")");
} else {
if(cljs.core.truth_(variadic_invoke)){
var mfa_8750 = new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543).cljs$core$IFn$_invoke$arity$1(variadic_invoke);
cljs.compiler.emits.call(null,f__$1,"(",cljs.compiler.comma_sep.call(null,cljs.core.take.call(null,mfa_8750,args)),(((mfa_8750 === (0)))?null:","),"cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([",cljs.compiler.comma_sep.call(null,cljs.core.drop.call(null,mfa_8750,args)),"], 0))");
} else {
if(cljs.core.truth_((function (){var or__3922__auto__ = fn_QMARK_;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
var or__3922__auto____$1 = js_QMARK_;
if(or__3922__auto____$1){
return or__3922__auto____$1;
} else {
return goog_QMARK_;
}
}
})())){
cljs.compiler.emits.call(null,f__$1,"(",cljs.compiler.comma_sep.call(null,args),")");
} else {
if(((cljs.analyzer._STAR_cljs_static_fns_STAR_) && (cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(f__$1),new cljs.core.Keyword(null,"var","var",-769682797))))){
var fprop_8751 = [".cljs$core$IFn$_invoke$arity$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.count.call(null,args))].join('');
if(cljs.analyzer._STAR_fn_invoke_direct_STAR_){
cljs.compiler.emits.call(null,"(",f__$1,fprop_8751," ? ",f__$1,fprop_8751,"(",cljs.compiler.comma_sep.call(null,args),") : ",f__$1,"(",cljs.compiler.comma_sep.call(null,args),"))");
} else {
cljs.compiler.emits.call(null,"(",f__$1,fprop_8751," ? ",f__$1,fprop_8751,"(",cljs.compiler.comma_sep.call(null,args),") : ",f__$1,".call(",cljs.compiler.comma_sep.call(null,cljs.core.cons.call(null,"null",args)),"))");
}
} else {
cljs.compiler.emits.call(null,f__$1,".call(",cljs.compiler.comma_sep.call(null,cljs.core.cons.call(null,"null",args)),")");
}

}
}
}
}
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"new","new",-2085437848),(function (p__8752){
var map__8753 = p__8752;
var map__8753__$1 = ((((!((map__8753 == null)))?(((((map__8753.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8753.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8753):map__8753);
var ctor = cljs.core.get.call(null,map__8753__$1,new cljs.core.Keyword(null,"ctor","ctor",1750864802));
var args = cljs.core.get.call(null,map__8753__$1,new cljs.core.Keyword(null,"args","args",1315556576));
var env = cljs.core.get.call(null,map__8753__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"(new ",ctor,"(",cljs.compiler.comma_sep.call(null,args),"))");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"set!","set!",-1389817006),(function (p__8755){
var map__8756 = p__8755;
var map__8756__$1 = ((((!((map__8756 == null)))?(((((map__8756.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8756.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8756):map__8756);
var target = cljs.core.get.call(null,map__8756__$1,new cljs.core.Keyword(null,"target","target",253001721));
var val = cljs.core.get.call(null,map__8756__$1,new cljs.core.Keyword(null,"val","val",128701612));
var env = cljs.core.get.call(null,map__8756__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,target," = ",val);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.load_libs = (function cljs$compiler$load_libs(libs,seen,reloads,deps,ns_name){
var map__8758 = cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_);
var map__8758__$1 = ((((!((map__8758 == null)))?(((((map__8758.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8758.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8758):map__8758);
var options = cljs.core.get.call(null,map__8758__$1,new cljs.core.Keyword(null,"options","options",99638489));
var js_dependency_index = cljs.core.get.call(null,map__8758__$1,new cljs.core.Keyword(null,"js-dependency-index","js-dependency-index",-1887042131));
var map__8759 = options;
var map__8759__$1 = ((((!((map__8759 == null)))?(((((map__8759.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8759.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8759):map__8759);
var target = cljs.core.get.call(null,map__8759__$1,new cljs.core.Keyword(null,"target","target",253001721));
var optimizations = cljs.core.get.call(null,map__8759__$1,new cljs.core.Keyword(null,"optimizations","optimizations",-2047476854));
var loaded_libs = cljs.compiler.munge.call(null,new cljs.core.Symbol(null,"cljs.core.*loaded-libs*","cljs.core.*loaded-libs*",-1847086525,null));
var loaded_libs_temp = cljs.compiler.munge.call(null,cljs.core.gensym.call(null,new cljs.core.Symbol(null,"cljs.core.*loaded-libs*","cljs.core.*loaded-libs*",-1847086525,null)));
var vec__8760 = (function (){var libs__$1 = cljs.core.remove.call(null,cljs.core.set.call(null,cljs.core.vals.call(null,seen)),cljs.core.filter.call(null,cljs.core.set.call(null,cljs.core.vals.call(null,libs)),deps));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"nodejs","nodejs",321212524),target)){
var map__8765 = cljs.core.group_by.call(null,cljs.analyzer.node_module_dep_QMARK_,libs__$1);
var map__8765__$1 = ((((!((map__8765 == null)))?(((((map__8765.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8765.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8765):map__8765);
var node_libs = cljs.core.get.call(null,map__8765__$1,true);
var libs_to_load = cljs.core.get.call(null,map__8765__$1,false);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [node_libs,libs_to_load], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [null,libs__$1], null);
}
})();
var node_libs = cljs.core.nth.call(null,vec__8760,(0),null);
var libs_to_load = cljs.core.nth.call(null,vec__8760,(1),null);
var global_exports_libs = cljs.core.filter.call(null,cljs.analyzer.dep_has_global_exports_QMARK_,libs_to_load);
if(cljs.core.truth_(new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs)))){
cljs.compiler.emitln.call(null,"if(!COMPILED) ",loaded_libs_temp," = ",loaded_libs," || cljs.core.set([\"cljs.core\"]);");

cljs.compiler.emitln.call(null,"if(!COMPILED) ",loaded_libs," = cljs.core.set([\"cljs.core\"]);");
} else {
}

var seq__8767_8783 = cljs.core.seq.call(null,libs_to_load);
var chunk__8768_8784 = null;
var count__8769_8785 = (0);
var i__8770_8786 = (0);
while(true){
if((i__8770_8786 < count__8769_8785)){
var lib_8787 = cljs.core._nth.call(null,chunk__8768_8784,i__8770_8786);
if(((cljs.analyzer.foreign_dep_QMARK_.call(null,lib_8787)) && (!(cljs.core.keyword_identical_QMARK_.call(null,optimizations,new cljs.core.Keyword(null,"none","none",1333468478)))))){
} else {
if(cljs.core.truth_((function (){var or__3922__auto__ = new cljs.core.Keyword(null,"reload","reload",863702807).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_8787),new cljs.core.Keyword(null,"reload","reload",863702807));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_8787),"', 'reload');");
} else {
if(cljs.core.truth_((function (){var or__3922__auto__ = new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_8787),new cljs.core.Keyword(null,"reload-all","reload-all",761570200));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_8787),"', 'reload-all');");
} else {
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_8787),"');");

}
}
}


var G__8788 = seq__8767_8783;
var G__8789 = chunk__8768_8784;
var G__8790 = count__8769_8785;
var G__8791 = (i__8770_8786 + (1));
seq__8767_8783 = G__8788;
chunk__8768_8784 = G__8789;
count__8769_8785 = G__8790;
i__8770_8786 = G__8791;
continue;
} else {
var temp__6753__auto___8792 = cljs.core.seq.call(null,seq__8767_8783);
if(temp__6753__auto___8792){
var seq__8767_8793__$1 = temp__6753__auto___8792;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8767_8793__$1)){
var c__4319__auto___8794 = cljs.core.chunk_first.call(null,seq__8767_8793__$1);
var G__8795 = cljs.core.chunk_rest.call(null,seq__8767_8793__$1);
var G__8796 = c__4319__auto___8794;
var G__8797 = cljs.core.count.call(null,c__4319__auto___8794);
var G__8798 = (0);
seq__8767_8783 = G__8795;
chunk__8768_8784 = G__8796;
count__8769_8785 = G__8797;
i__8770_8786 = G__8798;
continue;
} else {
var lib_8799 = cljs.core.first.call(null,seq__8767_8793__$1);
if(((cljs.analyzer.foreign_dep_QMARK_.call(null,lib_8799)) && (!(cljs.core.keyword_identical_QMARK_.call(null,optimizations,new cljs.core.Keyword(null,"none","none",1333468478)))))){
} else {
if(cljs.core.truth_((function (){var or__3922__auto__ = new cljs.core.Keyword(null,"reload","reload",863702807).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_8799),new cljs.core.Keyword(null,"reload","reload",863702807));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_8799),"', 'reload');");
} else {
if(cljs.core.truth_((function (){var or__3922__auto__ = new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_8799),new cljs.core.Keyword(null,"reload-all","reload-all",761570200));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_8799),"', 'reload-all');");
} else {
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_8799),"');");

}
}
}


var G__8800 = cljs.core.next.call(null,seq__8767_8793__$1);
var G__8801 = null;
var G__8802 = (0);
var G__8803 = (0);
seq__8767_8783 = G__8800;
chunk__8768_8784 = G__8801;
count__8769_8785 = G__8802;
i__8770_8786 = G__8803;
continue;
}
} else {
}
}
break;
}

var seq__8771_8804 = cljs.core.seq.call(null,node_libs);
var chunk__8772_8805 = null;
var count__8773_8806 = (0);
var i__8774_8807 = (0);
while(true){
if((i__8774_8807 < count__8773_8806)){
var lib_8808 = cljs.core._nth.call(null,chunk__8772_8805,i__8774_8807);
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_node_lib.call(null,lib_8808)," = require('",lib_8808,"');");


var G__8809 = seq__8771_8804;
var G__8810 = chunk__8772_8805;
var G__8811 = count__8773_8806;
var G__8812 = (i__8774_8807 + (1));
seq__8771_8804 = G__8809;
chunk__8772_8805 = G__8810;
count__8773_8806 = G__8811;
i__8774_8807 = G__8812;
continue;
} else {
var temp__6753__auto___8813 = cljs.core.seq.call(null,seq__8771_8804);
if(temp__6753__auto___8813){
var seq__8771_8814__$1 = temp__6753__auto___8813;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8771_8814__$1)){
var c__4319__auto___8815 = cljs.core.chunk_first.call(null,seq__8771_8814__$1);
var G__8816 = cljs.core.chunk_rest.call(null,seq__8771_8814__$1);
var G__8817 = c__4319__auto___8815;
var G__8818 = cljs.core.count.call(null,c__4319__auto___8815);
var G__8819 = (0);
seq__8771_8804 = G__8816;
chunk__8772_8805 = G__8817;
count__8773_8806 = G__8818;
i__8774_8807 = G__8819;
continue;
} else {
var lib_8820 = cljs.core.first.call(null,seq__8771_8814__$1);
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_node_lib.call(null,lib_8820)," = require('",lib_8820,"');");


var G__8821 = cljs.core.next.call(null,seq__8771_8814__$1);
var G__8822 = null;
var G__8823 = (0);
var G__8824 = (0);
seq__8771_8804 = G__8821;
chunk__8772_8805 = G__8822;
count__8773_8806 = G__8823;
i__8774_8807 = G__8824;
continue;
}
} else {
}
}
break;
}

var seq__8775_8825 = cljs.core.seq.call(null,global_exports_libs);
var chunk__8776_8826 = null;
var count__8777_8827 = (0);
var i__8778_8828 = (0);
while(true){
if((i__8778_8828 < count__8777_8827)){
var lib_8829 = cljs.core._nth.call(null,chunk__8776_8826,i__8778_8828);
var map__8779_8830 = cljs.core.get.call(null,js_dependency_index,cljs.core.name.call(null,lib_8829));
var map__8779_8831__$1 = ((((!((map__8779_8830 == null)))?(((((map__8779_8830.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8779_8830.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8779_8830):map__8779_8830);
var global_exports_8832 = cljs.core.get.call(null,map__8779_8831__$1,new cljs.core.Keyword(null,"global-exports","global-exports",-1644865592));
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_global_export.call(null,lib_8829)," = goog.global.",cljs.core.get.call(null,global_exports_8832,cljs.core.symbol.call(null,lib_8829)),";");


var G__8833 = seq__8775_8825;
var G__8834 = chunk__8776_8826;
var G__8835 = count__8777_8827;
var G__8836 = (i__8778_8828 + (1));
seq__8775_8825 = G__8833;
chunk__8776_8826 = G__8834;
count__8777_8827 = G__8835;
i__8778_8828 = G__8836;
continue;
} else {
var temp__6753__auto___8837 = cljs.core.seq.call(null,seq__8775_8825);
if(temp__6753__auto___8837){
var seq__8775_8838__$1 = temp__6753__auto___8837;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8775_8838__$1)){
var c__4319__auto___8839 = cljs.core.chunk_first.call(null,seq__8775_8838__$1);
var G__8840 = cljs.core.chunk_rest.call(null,seq__8775_8838__$1);
var G__8841 = c__4319__auto___8839;
var G__8842 = cljs.core.count.call(null,c__4319__auto___8839);
var G__8843 = (0);
seq__8775_8825 = G__8840;
chunk__8776_8826 = G__8841;
count__8777_8827 = G__8842;
i__8778_8828 = G__8843;
continue;
} else {
var lib_8844 = cljs.core.first.call(null,seq__8775_8838__$1);
var map__8781_8845 = cljs.core.get.call(null,js_dependency_index,cljs.core.name.call(null,lib_8844));
var map__8781_8846__$1 = ((((!((map__8781_8845 == null)))?(((((map__8781_8845.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8781_8845.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8781_8845):map__8781_8845);
var global_exports_8847 = cljs.core.get.call(null,map__8781_8846__$1,new cljs.core.Keyword(null,"global-exports","global-exports",-1644865592));
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_global_export.call(null,lib_8844)," = goog.global.",cljs.core.get.call(null,global_exports_8847,cljs.core.symbol.call(null,lib_8844)),";");


var G__8848 = cljs.core.next.call(null,seq__8775_8838__$1);
var G__8849 = null;
var G__8850 = (0);
var G__8851 = (0);
seq__8775_8825 = G__8848;
chunk__8776_8826 = G__8849;
count__8777_8827 = G__8850;
i__8778_8828 = G__8851;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs)))){
return cljs.compiler.emitln.call(null,"if(!COMPILED) ",loaded_libs," = cljs.core.into(",loaded_libs_temp,", ",loaded_libs,");");
} else {
return null;
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"ns*","ns*",200417856),(function (p__8852){
var map__8853 = p__8852;
var map__8853__$1 = ((((!((map__8853 == null)))?(((((map__8853.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8853.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8853):map__8853);
var name = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var requires = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"requires","requires",-1201390927));
var uses = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"uses","uses",232664692));
var require_macros = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"require-macros","require-macros",707947416));
var reloads = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"reloads","reloads",610698522));
var env = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var deps = cljs.core.get.call(null,map__8853__$1,new cljs.core.Keyword(null,"deps","deps",1883360319));
cljs.compiler.load_libs.call(null,requires,null,new cljs.core.Keyword(null,"require","require",-468001333).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);

cljs.compiler.load_libs.call(null,uses,requires,new cljs.core.Keyword(null,"use","use",-1846382424).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);

if(cljs.core.truth_(new cljs.core.Keyword(null,"repl-env","repl-env",-1976503928).cljs$core$IFn$_invoke$arity$1(env))){
return cljs.compiler.emitln.call(null,"null;");
} else {
return null;
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"ns","ns",441598760),(function (p__8855){
var map__8856 = p__8855;
var map__8856__$1 = ((((!((map__8856 == null)))?(((((map__8856.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8856.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8856):map__8856);
var name = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var requires = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"requires","requires",-1201390927));
var uses = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"uses","uses",232664692));
var require_macros = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"require-macros","require-macros",707947416));
var reloads = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"reloads","reloads",610698522));
var env = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var deps = cljs.core.get.call(null,map__8856__$1,new cljs.core.Keyword(null,"deps","deps",1883360319));
cljs.compiler.emitln.call(null,"goog.provide('",cljs.compiler.munge.call(null,name),"');");

if(cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null))){
} else {
cljs.compiler.emitln.call(null,"goog.require('cljs.core');");

if(cljs.core.truth_(new cljs.core.Keyword(null,"emit-constants","emit-constants",-476585410).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"options","options",99638489).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_))))){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,cljs.analyzer.constants_ns_sym),"');");
} else {
}
}

cljs.compiler.load_libs.call(null,requires,null,new cljs.core.Keyword(null,"require","require",-468001333).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);

return cljs.compiler.load_libs.call(null,uses,requires,new cljs.core.Keyword(null,"use","use",-1846382424).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"deftype*","deftype*",-677871637),(function (p__8858){
var map__8859 = p__8858;
var map__8859__$1 = ((((!((map__8859 == null)))?(((((map__8859.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8859.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8859):map__8859);
var t = cljs.core.get.call(null,map__8859__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var fields = cljs.core.get.call(null,map__8859__$1,new cljs.core.Keyword(null,"fields","fields",-1932066230));
var pmasks = cljs.core.get.call(null,map__8859__$1,new cljs.core.Keyword(null,"pmasks","pmasks",-871416698));
var body = cljs.core.get.call(null,map__8859__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var protocols = cljs.core.get.call(null,map__8859__$1,new cljs.core.Keyword(null,"protocols","protocols",-5615896));
var fields__$1 = cljs.core.map.call(null,cljs.compiler.munge,fields);
cljs.compiler.emitln.call(null,"");

cljs.compiler.emitln.call(null,"/**");

cljs.compiler.emitln.call(null,"* @constructor");

var seq__8861_8879 = cljs.core.seq.call(null,protocols);
var chunk__8862_8880 = null;
var count__8863_8881 = (0);
var i__8864_8882 = (0);
while(true){
if((i__8864_8882 < count__8863_8881)){
var protocol_8883 = cljs.core._nth.call(null,chunk__8862_8880,i__8864_8882);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_8883)].join('')),"}");


var G__8884 = seq__8861_8879;
var G__8885 = chunk__8862_8880;
var G__8886 = count__8863_8881;
var G__8887 = (i__8864_8882 + (1));
seq__8861_8879 = G__8884;
chunk__8862_8880 = G__8885;
count__8863_8881 = G__8886;
i__8864_8882 = G__8887;
continue;
} else {
var temp__6753__auto___8888 = cljs.core.seq.call(null,seq__8861_8879);
if(temp__6753__auto___8888){
var seq__8861_8889__$1 = temp__6753__auto___8888;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8861_8889__$1)){
var c__4319__auto___8890 = cljs.core.chunk_first.call(null,seq__8861_8889__$1);
var G__8891 = cljs.core.chunk_rest.call(null,seq__8861_8889__$1);
var G__8892 = c__4319__auto___8890;
var G__8893 = cljs.core.count.call(null,c__4319__auto___8890);
var G__8894 = (0);
seq__8861_8879 = G__8891;
chunk__8862_8880 = G__8892;
count__8863_8881 = G__8893;
i__8864_8882 = G__8894;
continue;
} else {
var protocol_8895 = cljs.core.first.call(null,seq__8861_8889__$1);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_8895)].join('')),"}");


var G__8896 = cljs.core.next.call(null,seq__8861_8889__$1);
var G__8897 = null;
var G__8898 = (0);
var G__8899 = (0);
seq__8861_8879 = G__8896;
chunk__8862_8880 = G__8897;
count__8863_8881 = G__8898;
i__8864_8882 = G__8899;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"*/");

cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,t)," = (function (",cljs.compiler.comma_sep.call(null,fields__$1),"){");

var seq__8865_8900 = cljs.core.seq.call(null,fields__$1);
var chunk__8866_8901 = null;
var count__8867_8902 = (0);
var i__8868_8903 = (0);
while(true){
if((i__8868_8903 < count__8867_8902)){
var fld_8904 = cljs.core._nth.call(null,chunk__8866_8901,i__8868_8903);
cljs.compiler.emitln.call(null,"this.",fld_8904," = ",fld_8904,";");


var G__8905 = seq__8865_8900;
var G__8906 = chunk__8866_8901;
var G__8907 = count__8867_8902;
var G__8908 = (i__8868_8903 + (1));
seq__8865_8900 = G__8905;
chunk__8866_8901 = G__8906;
count__8867_8902 = G__8907;
i__8868_8903 = G__8908;
continue;
} else {
var temp__6753__auto___8909 = cljs.core.seq.call(null,seq__8865_8900);
if(temp__6753__auto___8909){
var seq__8865_8910__$1 = temp__6753__auto___8909;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8865_8910__$1)){
var c__4319__auto___8911 = cljs.core.chunk_first.call(null,seq__8865_8910__$1);
var G__8912 = cljs.core.chunk_rest.call(null,seq__8865_8910__$1);
var G__8913 = c__4319__auto___8911;
var G__8914 = cljs.core.count.call(null,c__4319__auto___8911);
var G__8915 = (0);
seq__8865_8900 = G__8912;
chunk__8866_8901 = G__8913;
count__8867_8902 = G__8914;
i__8868_8903 = G__8915;
continue;
} else {
var fld_8916 = cljs.core.first.call(null,seq__8865_8910__$1);
cljs.compiler.emitln.call(null,"this.",fld_8916," = ",fld_8916,";");


var G__8917 = cljs.core.next.call(null,seq__8865_8910__$1);
var G__8918 = null;
var G__8919 = (0);
var G__8920 = (0);
seq__8865_8900 = G__8917;
chunk__8866_8901 = G__8918;
count__8867_8902 = G__8919;
i__8868_8903 = G__8920;
continue;
}
} else {
}
}
break;
}

var seq__8869_8921 = cljs.core.seq.call(null,pmasks);
var chunk__8870_8922 = null;
var count__8871_8923 = (0);
var i__8872_8924 = (0);
while(true){
if((i__8872_8924 < count__8871_8923)){
var vec__8873_8925 = cljs.core._nth.call(null,chunk__8870_8922,i__8872_8924);
var pno_8926 = cljs.core.nth.call(null,vec__8873_8925,(0),null);
var pmask_8927 = cljs.core.nth.call(null,vec__8873_8925,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_8926,"$ = ",pmask_8927,";");


var G__8928 = seq__8869_8921;
var G__8929 = chunk__8870_8922;
var G__8930 = count__8871_8923;
var G__8931 = (i__8872_8924 + (1));
seq__8869_8921 = G__8928;
chunk__8870_8922 = G__8929;
count__8871_8923 = G__8930;
i__8872_8924 = G__8931;
continue;
} else {
var temp__6753__auto___8932 = cljs.core.seq.call(null,seq__8869_8921);
if(temp__6753__auto___8932){
var seq__8869_8933__$1 = temp__6753__auto___8932;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8869_8933__$1)){
var c__4319__auto___8934 = cljs.core.chunk_first.call(null,seq__8869_8933__$1);
var G__8935 = cljs.core.chunk_rest.call(null,seq__8869_8933__$1);
var G__8936 = c__4319__auto___8934;
var G__8937 = cljs.core.count.call(null,c__4319__auto___8934);
var G__8938 = (0);
seq__8869_8921 = G__8935;
chunk__8870_8922 = G__8936;
count__8871_8923 = G__8937;
i__8872_8924 = G__8938;
continue;
} else {
var vec__8876_8939 = cljs.core.first.call(null,seq__8869_8933__$1);
var pno_8940 = cljs.core.nth.call(null,vec__8876_8939,(0),null);
var pmask_8941 = cljs.core.nth.call(null,vec__8876_8939,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_8940,"$ = ",pmask_8941,";");


var G__8942 = cljs.core.next.call(null,seq__8869_8933__$1);
var G__8943 = null;
var G__8944 = (0);
var G__8945 = (0);
seq__8869_8921 = G__8942;
chunk__8870_8922 = G__8943;
count__8871_8923 = G__8944;
i__8872_8924 = G__8945;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"});");

return cljs.compiler.emit.call(null,body);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"defrecord*","defrecord*",718069562),(function (p__8946){
var map__8947 = p__8946;
var map__8947__$1 = ((((!((map__8947 == null)))?(((((map__8947.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8947.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__8947):map__8947);
var t = cljs.core.get.call(null,map__8947__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var fields = cljs.core.get.call(null,map__8947__$1,new cljs.core.Keyword(null,"fields","fields",-1932066230));
var pmasks = cljs.core.get.call(null,map__8947__$1,new cljs.core.Keyword(null,"pmasks","pmasks",-871416698));
var body = cljs.core.get.call(null,map__8947__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var protocols = cljs.core.get.call(null,map__8947__$1,new cljs.core.Keyword(null,"protocols","protocols",-5615896));
var fields__$1 = cljs.core.concat.call(null,cljs.core.map.call(null,cljs.compiler.munge,fields),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"__meta","__meta",-946752628,null),new cljs.core.Symbol(null,"__extmap","__extmap",-1435580931,null),new cljs.core.Symbol(null,"__hash","__hash",-1328796629,null)], null));
cljs.compiler.emitln.call(null,"");

cljs.compiler.emitln.call(null,"/**");

cljs.compiler.emitln.call(null,"* @constructor");

var seq__8949_8967 = cljs.core.seq.call(null,protocols);
var chunk__8950_8968 = null;
var count__8951_8969 = (0);
var i__8952_8970 = (0);
while(true){
if((i__8952_8970 < count__8951_8969)){
var protocol_8971 = cljs.core._nth.call(null,chunk__8950_8968,i__8952_8970);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_8971)].join('')),"}");


var G__8972 = seq__8949_8967;
var G__8973 = chunk__8950_8968;
var G__8974 = count__8951_8969;
var G__8975 = (i__8952_8970 + (1));
seq__8949_8967 = G__8972;
chunk__8950_8968 = G__8973;
count__8951_8969 = G__8974;
i__8952_8970 = G__8975;
continue;
} else {
var temp__6753__auto___8976 = cljs.core.seq.call(null,seq__8949_8967);
if(temp__6753__auto___8976){
var seq__8949_8977__$1 = temp__6753__auto___8976;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8949_8977__$1)){
var c__4319__auto___8978 = cljs.core.chunk_first.call(null,seq__8949_8977__$1);
var G__8979 = cljs.core.chunk_rest.call(null,seq__8949_8977__$1);
var G__8980 = c__4319__auto___8978;
var G__8981 = cljs.core.count.call(null,c__4319__auto___8978);
var G__8982 = (0);
seq__8949_8967 = G__8979;
chunk__8950_8968 = G__8980;
count__8951_8969 = G__8981;
i__8952_8970 = G__8982;
continue;
} else {
var protocol_8983 = cljs.core.first.call(null,seq__8949_8977__$1);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_8983)].join('')),"}");


var G__8984 = cljs.core.next.call(null,seq__8949_8977__$1);
var G__8985 = null;
var G__8986 = (0);
var G__8987 = (0);
seq__8949_8967 = G__8984;
chunk__8950_8968 = G__8985;
count__8951_8969 = G__8986;
i__8952_8970 = G__8987;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"*/");

cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,t)," = (function (",cljs.compiler.comma_sep.call(null,fields__$1),"){");

var seq__8953_8988 = cljs.core.seq.call(null,fields__$1);
var chunk__8954_8989 = null;
var count__8955_8990 = (0);
var i__8956_8991 = (0);
while(true){
if((i__8956_8991 < count__8955_8990)){
var fld_8992 = cljs.core._nth.call(null,chunk__8954_8989,i__8956_8991);
cljs.compiler.emitln.call(null,"this.",fld_8992," = ",fld_8992,";");


var G__8993 = seq__8953_8988;
var G__8994 = chunk__8954_8989;
var G__8995 = count__8955_8990;
var G__8996 = (i__8956_8991 + (1));
seq__8953_8988 = G__8993;
chunk__8954_8989 = G__8994;
count__8955_8990 = G__8995;
i__8956_8991 = G__8996;
continue;
} else {
var temp__6753__auto___8997 = cljs.core.seq.call(null,seq__8953_8988);
if(temp__6753__auto___8997){
var seq__8953_8998__$1 = temp__6753__auto___8997;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8953_8998__$1)){
var c__4319__auto___8999 = cljs.core.chunk_first.call(null,seq__8953_8998__$1);
var G__9000 = cljs.core.chunk_rest.call(null,seq__8953_8998__$1);
var G__9001 = c__4319__auto___8999;
var G__9002 = cljs.core.count.call(null,c__4319__auto___8999);
var G__9003 = (0);
seq__8953_8988 = G__9000;
chunk__8954_8989 = G__9001;
count__8955_8990 = G__9002;
i__8956_8991 = G__9003;
continue;
} else {
var fld_9004 = cljs.core.first.call(null,seq__8953_8998__$1);
cljs.compiler.emitln.call(null,"this.",fld_9004," = ",fld_9004,";");


var G__9005 = cljs.core.next.call(null,seq__8953_8998__$1);
var G__9006 = null;
var G__9007 = (0);
var G__9008 = (0);
seq__8953_8988 = G__9005;
chunk__8954_8989 = G__9006;
count__8955_8990 = G__9007;
i__8956_8991 = G__9008;
continue;
}
} else {
}
}
break;
}

var seq__8957_9009 = cljs.core.seq.call(null,pmasks);
var chunk__8958_9010 = null;
var count__8959_9011 = (0);
var i__8960_9012 = (0);
while(true){
if((i__8960_9012 < count__8959_9011)){
var vec__8961_9013 = cljs.core._nth.call(null,chunk__8958_9010,i__8960_9012);
var pno_9014 = cljs.core.nth.call(null,vec__8961_9013,(0),null);
var pmask_9015 = cljs.core.nth.call(null,vec__8961_9013,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_9014,"$ = ",pmask_9015,";");


var G__9016 = seq__8957_9009;
var G__9017 = chunk__8958_9010;
var G__9018 = count__8959_9011;
var G__9019 = (i__8960_9012 + (1));
seq__8957_9009 = G__9016;
chunk__8958_9010 = G__9017;
count__8959_9011 = G__9018;
i__8960_9012 = G__9019;
continue;
} else {
var temp__6753__auto___9020 = cljs.core.seq.call(null,seq__8957_9009);
if(temp__6753__auto___9020){
var seq__8957_9021__$1 = temp__6753__auto___9020;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__8957_9021__$1)){
var c__4319__auto___9022 = cljs.core.chunk_first.call(null,seq__8957_9021__$1);
var G__9023 = cljs.core.chunk_rest.call(null,seq__8957_9021__$1);
var G__9024 = c__4319__auto___9022;
var G__9025 = cljs.core.count.call(null,c__4319__auto___9022);
var G__9026 = (0);
seq__8957_9009 = G__9023;
chunk__8958_9010 = G__9024;
count__8959_9011 = G__9025;
i__8960_9012 = G__9026;
continue;
} else {
var vec__8964_9027 = cljs.core.first.call(null,seq__8957_9021__$1);
var pno_9028 = cljs.core.nth.call(null,vec__8964_9027,(0),null);
var pmask_9029 = cljs.core.nth.call(null,vec__8964_9027,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_9028,"$ = ",pmask_9029,";");


var G__9030 = cljs.core.next.call(null,seq__8957_9021__$1);
var G__9031 = null;
var G__9032 = (0);
var G__9033 = (0);
seq__8957_9009 = G__9030;
chunk__8958_9010 = G__9031;
count__8959_9011 = G__9032;
i__8960_9012 = G__9033;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"});");

return cljs.compiler.emit.call(null,body);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"dot","dot",1442709401),(function (p__9034){
var map__9035 = p__9034;
var map__9035__$1 = ((((!((map__9035 == null)))?(((((map__9035.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__9035.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9035):map__9035);
var target = cljs.core.get.call(null,map__9035__$1,new cljs.core.Keyword(null,"target","target",253001721));
var field = cljs.core.get.call(null,map__9035__$1,new cljs.core.Keyword(null,"field","field",-1302436500));
var method = cljs.core.get.call(null,map__9035__$1,new cljs.core.Keyword(null,"method","method",55703592));
var args = cljs.core.get.call(null,map__9035__$1,new cljs.core.Keyword(null,"args","args",1315556576));
var env = cljs.core.get.call(null,map__9035__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.truth_(field)){
cljs.compiler.emits.call(null,target,".",cljs.compiler.munge.call(null,field,cljs.core.PersistentHashSet.EMPTY));
} else {
cljs.compiler.emits.call(null,target,".",cljs.compiler.munge.call(null,method,cljs.core.PersistentHashSet.EMPTY),"(",cljs.compiler.comma_sep.call(null,args),")");
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"js","js",1768080579),(function (p__9037){
var map__9038 = p__9037;
var map__9038__$1 = ((((!((map__9038 == null)))?(((((map__9038.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__9038.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9038):map__9038);
var op = cljs.core.get.call(null,map__9038__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var env = cljs.core.get.call(null,map__9038__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var code = cljs.core.get.call(null,map__9038__$1,new cljs.core.Keyword(null,"code","code",1586293142));
var segs = cljs.core.get.call(null,map__9038__$1,new cljs.core.Keyword(null,"segs","segs",-1940299576));
var args = cljs.core.get.call(null,map__9038__$1,new cljs.core.Keyword(null,"args","args",1315556576));
if(cljs.core.truth_((function (){var and__3911__auto__ = code;
if(cljs.core.truth_(and__3911__auto__)){
return goog.string.startsWith(clojure.string.trim.call(null,code),"/*");
} else {
return and__3911__auto__;
}
})())){
return cljs.compiler.emits.call(null,code);
} else {
var env__6829__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.truth_(code)){
cljs.compiler.emits.call(null,code);
} else {
cljs.compiler.emits.call(null,cljs.core.interleave.call(null,cljs.core.concat.call(null,segs,cljs.core.repeat.call(null,null)),cljs.core.concat.call(null,args,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [null], null))));
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__6829__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}
}));
cljs.compiler.emit_constants_table = (function cljs$compiler$emit_constants_table(table){
cljs.compiler.emitln.call(null,"goog.provide('",cljs.compiler.munge.call(null,cljs.analyzer.constants_ns_sym),"');");

cljs.compiler.emitln.call(null,"goog.require('cljs.core');");

var seq__9043 = cljs.core.seq.call(null,table);
var chunk__9044 = null;
var count__9045 = (0);
var i__9046 = (0);
while(true){
if((i__9046 < count__9045)){
var vec__9047 = cljs.core._nth.call(null,chunk__9044,i__9046);
var sym = cljs.core.nth.call(null,vec__9047,(0),null);
var value = cljs.core.nth.call(null,vec__9047,(1),null);
var ns_9053 = cljs.core.namespace.call(null,sym);
var name_9054 = cljs.core.name.call(null,sym);
cljs.compiler.emits.call(null,"cljs.core.",value," = ");

if((sym instanceof cljs.core.Keyword)){
cljs.compiler.emits_keyword.call(null,sym);
} else {
if((sym instanceof cljs.core.Symbol)){
cljs.compiler.emits_symbol.call(null,sym);
} else {
throw cljs.core.ex_info.call(null,["Cannot emit constant for type ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.type.call(null,sym))].join(''),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"invalid-constant-type","invalid-constant-type",1294847471)], null));

}
}

cljs.compiler.emits.call(null,";\n");


var G__9055 = seq__9043;
var G__9056 = chunk__9044;
var G__9057 = count__9045;
var G__9058 = (i__9046 + (1));
seq__9043 = G__9055;
chunk__9044 = G__9056;
count__9045 = G__9057;
i__9046 = G__9058;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__9043);
if(temp__6753__auto__){
var seq__9043__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__9043__$1)){
var c__4319__auto__ = cljs.core.chunk_first.call(null,seq__9043__$1);
var G__9059 = cljs.core.chunk_rest.call(null,seq__9043__$1);
var G__9060 = c__4319__auto__;
var G__9061 = cljs.core.count.call(null,c__4319__auto__);
var G__9062 = (0);
seq__9043 = G__9059;
chunk__9044 = G__9060;
count__9045 = G__9061;
i__9046 = G__9062;
continue;
} else {
var vec__9050 = cljs.core.first.call(null,seq__9043__$1);
var sym = cljs.core.nth.call(null,vec__9050,(0),null);
var value = cljs.core.nth.call(null,vec__9050,(1),null);
var ns_9063 = cljs.core.namespace.call(null,sym);
var name_9064 = cljs.core.name.call(null,sym);
cljs.compiler.emits.call(null,"cljs.core.",value," = ");

if((sym instanceof cljs.core.Keyword)){
cljs.compiler.emits_keyword.call(null,sym);
} else {
if((sym instanceof cljs.core.Symbol)){
cljs.compiler.emits_symbol.call(null,sym);
} else {
throw cljs.core.ex_info.call(null,["Cannot emit constant for type ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.type.call(null,sym))].join(''),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"invalid-constant-type","invalid-constant-type",1294847471)], null));

}
}

cljs.compiler.emits.call(null,";\n");


var G__9065 = cljs.core.next.call(null,seq__9043__$1);
var G__9066 = null;
var G__9067 = (0);
var G__9068 = (0);
seq__9043 = G__9065;
chunk__9044 = G__9066;
count__9045 = G__9067;
i__9046 = G__9068;
continue;
}
} else {
return null;
}
}
break;
}
});
cljs.compiler.emit_externs = (function cljs$compiler$emit_externs(var_args){
var G__9070 = arguments.length;
switch (G__9070) {
case 1:
return cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 4:
return cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$1 = (function (externs){
return cljs.compiler.emit_externs.call(null,cljs.core.PersistentVector.EMPTY,externs,cljs.core.atom.call(null,cljs.core.PersistentHashSet.EMPTY),(cljs.core.truth_(cljs.env._STAR_compiler_STAR_)?new cljs.core.Keyword("cljs.analyzer","externs","cljs.analyzer/externs",893359239).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)):null));
});

cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$4 = (function (prefix,externs,top_level,known_externs){
var ks = cljs.core.seq.call(null,cljs.core.keys.call(null,externs));
while(true){
if(ks){
var k_9075 = cljs.core.first.call(null,ks);
var vec__9071_9076 = cljs.core.conj.call(null,prefix,k_9075);
var top_9077 = cljs.core.nth.call(null,vec__9071_9076,(0),null);
var prefix_SINGLEQUOTE__9078 = vec__9071_9076;
if(((cljs.core.not_EQ_.call(null,new cljs.core.Symbol(null,"prototype","prototype",519166522,null),k_9075)) && ((cljs.core.get_in.call(null,known_externs,prefix_SINGLEQUOTE__9078) == null)))){
if(!(((cljs.core.contains_QMARK_.call(null,cljs.core.deref.call(null,top_level),top_9077)) || (cljs.core.contains_QMARK_.call(null,known_externs,top_9077))))){
cljs.compiler.emitln.call(null,"var ",clojure.string.join.call(null,".",cljs.core.map.call(null,cljs.compiler.munge,prefix_SINGLEQUOTE__9078)),";");

cljs.core.swap_BANG_.call(null,top_level,cljs.core.conj,top_9077);
} else {
cljs.compiler.emitln.call(null,clojure.string.join.call(null,".",cljs.core.map.call(null,cljs.compiler.munge,prefix_SINGLEQUOTE__9078)),";");
}
} else {
}

var m_9079 = cljs.core.get.call(null,externs,k_9075);
if(cljs.core.empty_QMARK_.call(null,m_9079)){
} else {
cljs.compiler.emit_externs.call(null,prefix_SINGLEQUOTE__9078,m_9079,top_level,known_externs);
}

var G__9080 = cljs.core.next.call(null,ks);
ks = G__9080;
continue;
} else {
return null;
}
break;
}
});

cljs.compiler.emit_externs.cljs$lang$maxFixedArity = 4;

