// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__13220 = arguments.length;
switch (G__13220) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async13221 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async13221 = (function (f,blockable,meta13222){
this.f = f;
this.blockable = blockable;
this.meta13222 = meta13222;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async13221.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_13223,meta13222__$1){
var self__ = this;
var _13223__$1 = this;
return (new cljs.core.async.t_cljs$core$async13221(self__.f,self__.blockable,meta13222__$1));
});

cljs.core.async.t_cljs$core$async13221.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_13223){
var self__ = this;
var _13223__$1 = this;
return self__.meta13222;
});

cljs.core.async.t_cljs$core$async13221.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async13221.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async13221.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async13221.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async13221.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta13222","meta13222",307198134,null)], null);
});

cljs.core.async.t_cljs$core$async13221.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async13221.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async13221";

cljs.core.async.t_cljs$core$async13221.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async13221");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async13221.
 */
cljs.core.async.__GT_t_cljs$core$async13221 = (function cljs$core$async$__GT_t_cljs$core$async13221(f__$1,blockable__$1,meta13222){
return (new cljs.core.async.t_cljs$core$async13221(f__$1,blockable__$1,meta13222));
});

}

return (new cljs.core.async.t_cljs$core$async13221(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__13227 = arguments.length;
switch (G__13227) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__13230 = arguments.length;
switch (G__13230) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__13233 = arguments.length;
switch (G__13233) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_13235 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_13235);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_13235,ret){
return (function (){
return fn1.call(null,val_13235);
});})(val_13235,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__13237 = arguments.length;
switch (G__13237) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__6751__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__6751__auto__)){
var ret = temp__6751__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__6751__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__6751__auto__)){
var retb = temp__6751__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__6751__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__6751__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4376__auto___13239 = n;
var x_13240 = (0);
while(true){
if((x_13240 < n__4376__auto___13239)){
(a[x_13240] = (0));

var G__13241 = (x_13240 + (1));
x_13240 = G__13241;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__13242 = (i + (1));
i = G__13242;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async13243 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async13243 = (function (flag,meta13244){
this.flag = flag;
this.meta13244 = meta13244;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async13243.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_13245,meta13244__$1){
var self__ = this;
var _13245__$1 = this;
return (new cljs.core.async.t_cljs$core$async13243(self__.flag,meta13244__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async13243.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_13245){
var self__ = this;
var _13245__$1 = this;
return self__.meta13244;
});})(flag))
;

cljs.core.async.t_cljs$core$async13243.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async13243.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async13243.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async13243.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async13243.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta13244","meta13244",1129005964,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async13243.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async13243.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async13243";

cljs.core.async.t_cljs$core$async13243.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async13243");
});})(flag))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async13243.
 */
cljs.core.async.__GT_t_cljs$core$async13243 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async13243(flag__$1,meta13244){
return (new cljs.core.async.t_cljs$core$async13243(flag__$1,meta13244));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async13243(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async13246 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async13246 = (function (flag,cb,meta13247){
this.flag = flag;
this.cb = cb;
this.meta13247 = meta13247;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async13246.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_13248,meta13247__$1){
var self__ = this;
var _13248__$1 = this;
return (new cljs.core.async.t_cljs$core$async13246(self__.flag,self__.cb,meta13247__$1));
});

cljs.core.async.t_cljs$core$async13246.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_13248){
var self__ = this;
var _13248__$1 = this;
return self__.meta13247;
});

cljs.core.async.t_cljs$core$async13246.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async13246.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async13246.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async13246.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async13246.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta13247","meta13247",1419962851,null)], null);
});

cljs.core.async.t_cljs$core$async13246.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async13246.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async13246";

cljs.core.async.t_cljs$core$async13246.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async13246");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async13246.
 */
cljs.core.async.__GT_t_cljs$core$async13246 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async13246(flag__$1,cb__$1,meta13247){
return (new cljs.core.async.t_cljs$core$async13246(flag__$1,cb__$1,meta13247));
});

}

return (new cljs.core.async.t_cljs$core$async13246(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__13249_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__13249_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__13250_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__13250_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__3922__auto__ = wport;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return port;
}
})()], null));
} else {
var G__13251 = (i + (1));
i = G__13251;
continue;
}
} else {
return null;
}
break;
}
})();
var or__3922__auto__ = ret;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__6753__auto__ = (function (){var and__3911__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(temp__6753__auto__)){
var got = temp__6753__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4502__auto__ = [];
var len__4499__auto___13257 = arguments.length;
var i__4500__auto___13258 = (0);
while(true){
if((i__4500__auto___13258 < len__4499__auto___13257)){
args__4502__auto__.push((arguments[i__4500__auto___13258]));

var G__13259 = (i__4500__auto___13258 + (1));
i__4500__auto___13258 = G__13259;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((1) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4503__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__13254){
var map__13255 = p__13254;
var map__13255__$1 = ((((!((map__13255 == null)))?(((((map__13255.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__13255.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__13255):map__13255);
var opts = map__13255__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq13252){
var G__13253 = cljs.core.first.call(null,seq13252);
var seq13252__$1 = cljs.core.next.call(null,seq13252);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__13253,seq13252__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__13261 = arguments.length;
switch (G__13261) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__11296__auto___13307 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___13307){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___13307){
return (function (state_13285){
var state_val_13286 = (state_13285[(1)]);
if((state_val_13286 === (7))){
var inst_13281 = (state_13285[(2)]);
var state_13285__$1 = state_13285;
var statearr_13287_13308 = state_13285__$1;
(statearr_13287_13308[(2)] = inst_13281);

(statearr_13287_13308[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (1))){
var state_13285__$1 = state_13285;
var statearr_13288_13309 = state_13285__$1;
(statearr_13288_13309[(2)] = null);

(statearr_13288_13309[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (4))){
var inst_13264 = (state_13285[(7)]);
var inst_13264__$1 = (state_13285[(2)]);
var inst_13265 = (inst_13264__$1 == null);
var state_13285__$1 = (function (){var statearr_13289 = state_13285;
(statearr_13289[(7)] = inst_13264__$1);

return statearr_13289;
})();
if(cljs.core.truth_(inst_13265)){
var statearr_13290_13310 = state_13285__$1;
(statearr_13290_13310[(1)] = (5));

} else {
var statearr_13291_13311 = state_13285__$1;
(statearr_13291_13311[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (13))){
var state_13285__$1 = state_13285;
var statearr_13292_13312 = state_13285__$1;
(statearr_13292_13312[(2)] = null);

(statearr_13292_13312[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (6))){
var inst_13264 = (state_13285[(7)]);
var state_13285__$1 = state_13285;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13285__$1,(11),to,inst_13264);
} else {
if((state_val_13286 === (3))){
var inst_13283 = (state_13285[(2)]);
var state_13285__$1 = state_13285;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13285__$1,inst_13283);
} else {
if((state_val_13286 === (12))){
var state_13285__$1 = state_13285;
var statearr_13293_13313 = state_13285__$1;
(statearr_13293_13313[(2)] = null);

(statearr_13293_13313[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (2))){
var state_13285__$1 = state_13285;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13285__$1,(4),from);
} else {
if((state_val_13286 === (11))){
var inst_13274 = (state_13285[(2)]);
var state_13285__$1 = state_13285;
if(cljs.core.truth_(inst_13274)){
var statearr_13294_13314 = state_13285__$1;
(statearr_13294_13314[(1)] = (12));

} else {
var statearr_13295_13315 = state_13285__$1;
(statearr_13295_13315[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (9))){
var state_13285__$1 = state_13285;
var statearr_13296_13316 = state_13285__$1;
(statearr_13296_13316[(2)] = null);

(statearr_13296_13316[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (5))){
var state_13285__$1 = state_13285;
if(cljs.core.truth_(close_QMARK_)){
var statearr_13297_13317 = state_13285__$1;
(statearr_13297_13317[(1)] = (8));

} else {
var statearr_13298_13318 = state_13285__$1;
(statearr_13298_13318[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (14))){
var inst_13279 = (state_13285[(2)]);
var state_13285__$1 = state_13285;
var statearr_13299_13319 = state_13285__$1;
(statearr_13299_13319[(2)] = inst_13279);

(statearr_13299_13319[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (10))){
var inst_13271 = (state_13285[(2)]);
var state_13285__$1 = state_13285;
var statearr_13300_13320 = state_13285__$1;
(statearr_13300_13320[(2)] = inst_13271);

(statearr_13300_13320[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13286 === (8))){
var inst_13268 = cljs.core.async.close_BANG_.call(null,to);
var state_13285__$1 = state_13285;
var statearr_13301_13321 = state_13285__$1;
(statearr_13301_13321[(2)] = inst_13268);

(statearr_13301_13321[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___13307))
;
return ((function (switch__11139__auto__,c__11296__auto___13307){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_13302 = [null,null,null,null,null,null,null,null];
(statearr_13302[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_13302[(1)] = (1));

return statearr_13302;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_13285){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13285);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13303){if((e13303 instanceof Object)){
var ex__11143__auto__ = e13303;
var statearr_13304_13322 = state_13285;
(statearr_13304_13322[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13285);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13303;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13323 = state_13285;
state_13285 = G__13323;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_13285){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_13285);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___13307))
})();
var state__11298__auto__ = (function (){var statearr_13305 = f__11297__auto__.call(null);
(statearr_13305[(6)] = c__11296__auto___13307);

return statearr_13305;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___13307))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__13324){
var vec__13325 = p__13324;
var v = cljs.core.nth.call(null,vec__13325,(0),null);
var p = cljs.core.nth.call(null,vec__13325,(1),null);
var job = vec__13325;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__11296__auto___13496 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___13496,res,vec__13325,v,p,job,jobs,results){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___13496,res,vec__13325,v,p,job,jobs,results){
return (function (state_13332){
var state_val_13333 = (state_13332[(1)]);
if((state_val_13333 === (1))){
var state_13332__$1 = state_13332;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13332__$1,(2),res,v);
} else {
if((state_val_13333 === (2))){
var inst_13329 = (state_13332[(2)]);
var inst_13330 = cljs.core.async.close_BANG_.call(null,res);
var state_13332__$1 = (function (){var statearr_13334 = state_13332;
(statearr_13334[(7)] = inst_13329);

return statearr_13334;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13332__$1,inst_13330);
} else {
return null;
}
}
});})(c__11296__auto___13496,res,vec__13325,v,p,job,jobs,results))
;
return ((function (switch__11139__auto__,c__11296__auto___13496,res,vec__13325,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0 = (function (){
var statearr_13335 = [null,null,null,null,null,null,null,null];
(statearr_13335[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__);

(statearr_13335[(1)] = (1));

return statearr_13335;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1 = (function (state_13332){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13332);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13336){if((e13336 instanceof Object)){
var ex__11143__auto__ = e13336;
var statearr_13337_13497 = state_13332;
(statearr_13337_13497[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13332);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13336;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13498 = state_13332;
state_13332 = G__13498;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = function(state_13332){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1.call(this,state_13332);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___13496,res,vec__13325,v,p,job,jobs,results))
})();
var state__11298__auto__ = (function (){var statearr_13338 = f__11297__auto__.call(null);
(statearr_13338[(6)] = c__11296__auto___13496);

return statearr_13338;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___13496,res,vec__13325,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__13339){
var vec__13340 = p__13339;
var v = cljs.core.nth.call(null,vec__13340,(0),null);
var p = cljs.core.nth.call(null,vec__13340,(1),null);
var job = vec__13340;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__4376__auto___13499 = n;
var __13500 = (0);
while(true){
if((__13500 < n__4376__auto___13499)){
var G__13343_13501 = type;
var G__13343_13502__$1 = (((G__13343_13501 instanceof cljs.core.Keyword))?G__13343_13501.fqn:null);
switch (G__13343_13502__$1) {
case "compute":
var c__11296__auto___13504 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__13500,c__11296__auto___13504,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (__13500,c__11296__auto___13504,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async){
return (function (state_13356){
var state_val_13357 = (state_13356[(1)]);
if((state_val_13357 === (1))){
var state_13356__$1 = state_13356;
var statearr_13358_13505 = state_13356__$1;
(statearr_13358_13505[(2)] = null);

(statearr_13358_13505[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13357 === (2))){
var state_13356__$1 = state_13356;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13356__$1,(4),jobs);
} else {
if((state_val_13357 === (3))){
var inst_13354 = (state_13356[(2)]);
var state_13356__$1 = state_13356;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13356__$1,inst_13354);
} else {
if((state_val_13357 === (4))){
var inst_13346 = (state_13356[(2)]);
var inst_13347 = process.call(null,inst_13346);
var state_13356__$1 = state_13356;
if(cljs.core.truth_(inst_13347)){
var statearr_13359_13506 = state_13356__$1;
(statearr_13359_13506[(1)] = (5));

} else {
var statearr_13360_13507 = state_13356__$1;
(statearr_13360_13507[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13357 === (5))){
var state_13356__$1 = state_13356;
var statearr_13361_13508 = state_13356__$1;
(statearr_13361_13508[(2)] = null);

(statearr_13361_13508[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13357 === (6))){
var state_13356__$1 = state_13356;
var statearr_13362_13509 = state_13356__$1;
(statearr_13362_13509[(2)] = null);

(statearr_13362_13509[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13357 === (7))){
var inst_13352 = (state_13356[(2)]);
var state_13356__$1 = state_13356;
var statearr_13363_13510 = state_13356__$1;
(statearr_13363_13510[(2)] = inst_13352);

(statearr_13363_13510[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__13500,c__11296__auto___13504,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async))
;
return ((function (__13500,switch__11139__auto__,c__11296__auto___13504,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0 = (function (){
var statearr_13364 = [null,null,null,null,null,null,null];
(statearr_13364[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__);

(statearr_13364[(1)] = (1));

return statearr_13364;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1 = (function (state_13356){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13356);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13365){if((e13365 instanceof Object)){
var ex__11143__auto__ = e13365;
var statearr_13366_13511 = state_13356;
(statearr_13366_13511[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13356);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13365;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13512 = state_13356;
state_13356 = G__13512;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = function(state_13356){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1.call(this,state_13356);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__;
})()
;})(__13500,switch__11139__auto__,c__11296__auto___13504,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async))
})();
var state__11298__auto__ = (function (){var statearr_13367 = f__11297__auto__.call(null);
(statearr_13367[(6)] = c__11296__auto___13504);

return statearr_13367;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(__13500,c__11296__auto___13504,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async))
);


break;
case "async":
var c__11296__auto___13513 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__13500,c__11296__auto___13513,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (__13500,c__11296__auto___13513,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async){
return (function (state_13380){
var state_val_13381 = (state_13380[(1)]);
if((state_val_13381 === (1))){
var state_13380__$1 = state_13380;
var statearr_13382_13514 = state_13380__$1;
(statearr_13382_13514[(2)] = null);

(statearr_13382_13514[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13381 === (2))){
var state_13380__$1 = state_13380;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13380__$1,(4),jobs);
} else {
if((state_val_13381 === (3))){
var inst_13378 = (state_13380[(2)]);
var state_13380__$1 = state_13380;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13380__$1,inst_13378);
} else {
if((state_val_13381 === (4))){
var inst_13370 = (state_13380[(2)]);
var inst_13371 = async.call(null,inst_13370);
var state_13380__$1 = state_13380;
if(cljs.core.truth_(inst_13371)){
var statearr_13383_13515 = state_13380__$1;
(statearr_13383_13515[(1)] = (5));

} else {
var statearr_13384_13516 = state_13380__$1;
(statearr_13384_13516[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13381 === (5))){
var state_13380__$1 = state_13380;
var statearr_13385_13517 = state_13380__$1;
(statearr_13385_13517[(2)] = null);

(statearr_13385_13517[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13381 === (6))){
var state_13380__$1 = state_13380;
var statearr_13386_13518 = state_13380__$1;
(statearr_13386_13518[(2)] = null);

(statearr_13386_13518[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13381 === (7))){
var inst_13376 = (state_13380[(2)]);
var state_13380__$1 = state_13380;
var statearr_13387_13519 = state_13380__$1;
(statearr_13387_13519[(2)] = inst_13376);

(statearr_13387_13519[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__13500,c__11296__auto___13513,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async))
;
return ((function (__13500,switch__11139__auto__,c__11296__auto___13513,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0 = (function (){
var statearr_13388 = [null,null,null,null,null,null,null];
(statearr_13388[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__);

(statearr_13388[(1)] = (1));

return statearr_13388;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1 = (function (state_13380){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13380);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13389){if((e13389 instanceof Object)){
var ex__11143__auto__ = e13389;
var statearr_13390_13520 = state_13380;
(statearr_13390_13520[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13380);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13389;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13521 = state_13380;
state_13380 = G__13521;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = function(state_13380){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1.call(this,state_13380);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__;
})()
;})(__13500,switch__11139__auto__,c__11296__auto___13513,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async))
})();
var state__11298__auto__ = (function (){var statearr_13391 = f__11297__auto__.call(null);
(statearr_13391[(6)] = c__11296__auto___13513);

return statearr_13391;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(__13500,c__11296__auto___13513,G__13343_13501,G__13343_13502__$1,n__4376__auto___13499,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__13343_13502__$1)].join('')));

}

var G__13522 = (__13500 + (1));
__13500 = G__13522;
continue;
} else {
}
break;
}

var c__11296__auto___13523 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___13523,jobs,results,process,async){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___13523,jobs,results,process,async){
return (function (state_13413){
var state_val_13414 = (state_13413[(1)]);
if((state_val_13414 === (1))){
var state_13413__$1 = state_13413;
var statearr_13415_13524 = state_13413__$1;
(statearr_13415_13524[(2)] = null);

(statearr_13415_13524[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13414 === (2))){
var state_13413__$1 = state_13413;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13413__$1,(4),from);
} else {
if((state_val_13414 === (3))){
var inst_13411 = (state_13413[(2)]);
var state_13413__$1 = state_13413;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13413__$1,inst_13411);
} else {
if((state_val_13414 === (4))){
var inst_13394 = (state_13413[(7)]);
var inst_13394__$1 = (state_13413[(2)]);
var inst_13395 = (inst_13394__$1 == null);
var state_13413__$1 = (function (){var statearr_13416 = state_13413;
(statearr_13416[(7)] = inst_13394__$1);

return statearr_13416;
})();
if(cljs.core.truth_(inst_13395)){
var statearr_13417_13525 = state_13413__$1;
(statearr_13417_13525[(1)] = (5));

} else {
var statearr_13418_13526 = state_13413__$1;
(statearr_13418_13526[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13414 === (5))){
var inst_13397 = cljs.core.async.close_BANG_.call(null,jobs);
var state_13413__$1 = state_13413;
var statearr_13419_13527 = state_13413__$1;
(statearr_13419_13527[(2)] = inst_13397);

(statearr_13419_13527[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13414 === (6))){
var inst_13394 = (state_13413[(7)]);
var inst_13399 = (state_13413[(8)]);
var inst_13399__$1 = cljs.core.async.chan.call(null,(1));
var inst_13400 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_13401 = [inst_13394,inst_13399__$1];
var inst_13402 = (new cljs.core.PersistentVector(null,2,(5),inst_13400,inst_13401,null));
var state_13413__$1 = (function (){var statearr_13420 = state_13413;
(statearr_13420[(8)] = inst_13399__$1);

return statearr_13420;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13413__$1,(8),jobs,inst_13402);
} else {
if((state_val_13414 === (7))){
var inst_13409 = (state_13413[(2)]);
var state_13413__$1 = state_13413;
var statearr_13421_13528 = state_13413__$1;
(statearr_13421_13528[(2)] = inst_13409);

(statearr_13421_13528[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13414 === (8))){
var inst_13399 = (state_13413[(8)]);
var inst_13404 = (state_13413[(2)]);
var state_13413__$1 = (function (){var statearr_13422 = state_13413;
(statearr_13422[(9)] = inst_13404);

return statearr_13422;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13413__$1,(9),results,inst_13399);
} else {
if((state_val_13414 === (9))){
var inst_13406 = (state_13413[(2)]);
var state_13413__$1 = (function (){var statearr_13423 = state_13413;
(statearr_13423[(10)] = inst_13406);

return statearr_13423;
})();
var statearr_13424_13529 = state_13413__$1;
(statearr_13424_13529[(2)] = null);

(statearr_13424_13529[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___13523,jobs,results,process,async))
;
return ((function (switch__11139__auto__,c__11296__auto___13523,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0 = (function (){
var statearr_13425 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_13425[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__);

(statearr_13425[(1)] = (1));

return statearr_13425;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1 = (function (state_13413){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13413);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13426){if((e13426 instanceof Object)){
var ex__11143__auto__ = e13426;
var statearr_13427_13530 = state_13413;
(statearr_13427_13530[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13413);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13426;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13531 = state_13413;
state_13413 = G__13531;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = function(state_13413){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1.call(this,state_13413);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___13523,jobs,results,process,async))
})();
var state__11298__auto__ = (function (){var statearr_13428 = f__11297__auto__.call(null);
(statearr_13428[(6)] = c__11296__auto___13523);

return statearr_13428;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___13523,jobs,results,process,async))
);


var c__11296__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto__,jobs,results,process,async){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto__,jobs,results,process,async){
return (function (state_13466){
var state_val_13467 = (state_13466[(1)]);
if((state_val_13467 === (7))){
var inst_13462 = (state_13466[(2)]);
var state_13466__$1 = state_13466;
var statearr_13468_13532 = state_13466__$1;
(statearr_13468_13532[(2)] = inst_13462);

(statearr_13468_13532[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (20))){
var state_13466__$1 = state_13466;
var statearr_13469_13533 = state_13466__$1;
(statearr_13469_13533[(2)] = null);

(statearr_13469_13533[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (1))){
var state_13466__$1 = state_13466;
var statearr_13470_13534 = state_13466__$1;
(statearr_13470_13534[(2)] = null);

(statearr_13470_13534[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (4))){
var inst_13431 = (state_13466[(7)]);
var inst_13431__$1 = (state_13466[(2)]);
var inst_13432 = (inst_13431__$1 == null);
var state_13466__$1 = (function (){var statearr_13471 = state_13466;
(statearr_13471[(7)] = inst_13431__$1);

return statearr_13471;
})();
if(cljs.core.truth_(inst_13432)){
var statearr_13472_13535 = state_13466__$1;
(statearr_13472_13535[(1)] = (5));

} else {
var statearr_13473_13536 = state_13466__$1;
(statearr_13473_13536[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (15))){
var inst_13444 = (state_13466[(8)]);
var state_13466__$1 = state_13466;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13466__$1,(18),to,inst_13444);
} else {
if((state_val_13467 === (21))){
var inst_13457 = (state_13466[(2)]);
var state_13466__$1 = state_13466;
var statearr_13474_13537 = state_13466__$1;
(statearr_13474_13537[(2)] = inst_13457);

(statearr_13474_13537[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (13))){
var inst_13459 = (state_13466[(2)]);
var state_13466__$1 = (function (){var statearr_13475 = state_13466;
(statearr_13475[(9)] = inst_13459);

return statearr_13475;
})();
var statearr_13476_13538 = state_13466__$1;
(statearr_13476_13538[(2)] = null);

(statearr_13476_13538[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (6))){
var inst_13431 = (state_13466[(7)]);
var state_13466__$1 = state_13466;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13466__$1,(11),inst_13431);
} else {
if((state_val_13467 === (17))){
var inst_13452 = (state_13466[(2)]);
var state_13466__$1 = state_13466;
if(cljs.core.truth_(inst_13452)){
var statearr_13477_13539 = state_13466__$1;
(statearr_13477_13539[(1)] = (19));

} else {
var statearr_13478_13540 = state_13466__$1;
(statearr_13478_13540[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (3))){
var inst_13464 = (state_13466[(2)]);
var state_13466__$1 = state_13466;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13466__$1,inst_13464);
} else {
if((state_val_13467 === (12))){
var inst_13441 = (state_13466[(10)]);
var state_13466__$1 = state_13466;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13466__$1,(14),inst_13441);
} else {
if((state_val_13467 === (2))){
var state_13466__$1 = state_13466;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13466__$1,(4),results);
} else {
if((state_val_13467 === (19))){
var state_13466__$1 = state_13466;
var statearr_13479_13541 = state_13466__$1;
(statearr_13479_13541[(2)] = null);

(statearr_13479_13541[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (11))){
var inst_13441 = (state_13466[(2)]);
var state_13466__$1 = (function (){var statearr_13480 = state_13466;
(statearr_13480[(10)] = inst_13441);

return statearr_13480;
})();
var statearr_13481_13542 = state_13466__$1;
(statearr_13481_13542[(2)] = null);

(statearr_13481_13542[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (9))){
var state_13466__$1 = state_13466;
var statearr_13482_13543 = state_13466__$1;
(statearr_13482_13543[(2)] = null);

(statearr_13482_13543[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (5))){
var state_13466__$1 = state_13466;
if(cljs.core.truth_(close_QMARK_)){
var statearr_13483_13544 = state_13466__$1;
(statearr_13483_13544[(1)] = (8));

} else {
var statearr_13484_13545 = state_13466__$1;
(statearr_13484_13545[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (14))){
var inst_13444 = (state_13466[(8)]);
var inst_13446 = (state_13466[(11)]);
var inst_13444__$1 = (state_13466[(2)]);
var inst_13445 = (inst_13444__$1 == null);
var inst_13446__$1 = cljs.core.not.call(null,inst_13445);
var state_13466__$1 = (function (){var statearr_13485 = state_13466;
(statearr_13485[(8)] = inst_13444__$1);

(statearr_13485[(11)] = inst_13446__$1);

return statearr_13485;
})();
if(inst_13446__$1){
var statearr_13486_13546 = state_13466__$1;
(statearr_13486_13546[(1)] = (15));

} else {
var statearr_13487_13547 = state_13466__$1;
(statearr_13487_13547[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (16))){
var inst_13446 = (state_13466[(11)]);
var state_13466__$1 = state_13466;
var statearr_13488_13548 = state_13466__$1;
(statearr_13488_13548[(2)] = inst_13446);

(statearr_13488_13548[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (10))){
var inst_13438 = (state_13466[(2)]);
var state_13466__$1 = state_13466;
var statearr_13489_13549 = state_13466__$1;
(statearr_13489_13549[(2)] = inst_13438);

(statearr_13489_13549[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (18))){
var inst_13449 = (state_13466[(2)]);
var state_13466__$1 = state_13466;
var statearr_13490_13550 = state_13466__$1;
(statearr_13490_13550[(2)] = inst_13449);

(statearr_13490_13550[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13467 === (8))){
var inst_13435 = cljs.core.async.close_BANG_.call(null,to);
var state_13466__$1 = state_13466;
var statearr_13491_13551 = state_13466__$1;
(statearr_13491_13551[(2)] = inst_13435);

(statearr_13491_13551[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto__,jobs,results,process,async))
;
return ((function (switch__11139__auto__,c__11296__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0 = (function (){
var statearr_13492 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_13492[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__);

(statearr_13492[(1)] = (1));

return statearr_13492;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1 = (function (state_13466){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13466);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13493){if((e13493 instanceof Object)){
var ex__11143__auto__ = e13493;
var statearr_13494_13552 = state_13466;
(statearr_13494_13552[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13466);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13493;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13553 = state_13466;
state_13466 = G__13553;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__ = function(state_13466){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1.call(this,state_13466);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11140__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto__,jobs,results,process,async))
})();
var state__11298__auto__ = (function (){var statearr_13495 = f__11297__auto__.call(null);
(statearr_13495[(6)] = c__11296__auto__);

return statearr_13495;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto__,jobs,results,process,async))
);

return c__11296__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__13555 = arguments.length;
switch (G__13555) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__13558 = arguments.length;
switch (G__13558) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__13561 = arguments.length;
switch (G__13561) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__11296__auto___13610 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___13610,tc,fc){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___13610,tc,fc){
return (function (state_13587){
var state_val_13588 = (state_13587[(1)]);
if((state_val_13588 === (7))){
var inst_13583 = (state_13587[(2)]);
var state_13587__$1 = state_13587;
var statearr_13589_13611 = state_13587__$1;
(statearr_13589_13611[(2)] = inst_13583);

(statearr_13589_13611[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (1))){
var state_13587__$1 = state_13587;
var statearr_13590_13612 = state_13587__$1;
(statearr_13590_13612[(2)] = null);

(statearr_13590_13612[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (4))){
var inst_13564 = (state_13587[(7)]);
var inst_13564__$1 = (state_13587[(2)]);
var inst_13565 = (inst_13564__$1 == null);
var state_13587__$1 = (function (){var statearr_13591 = state_13587;
(statearr_13591[(7)] = inst_13564__$1);

return statearr_13591;
})();
if(cljs.core.truth_(inst_13565)){
var statearr_13592_13613 = state_13587__$1;
(statearr_13592_13613[(1)] = (5));

} else {
var statearr_13593_13614 = state_13587__$1;
(statearr_13593_13614[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (13))){
var state_13587__$1 = state_13587;
var statearr_13594_13615 = state_13587__$1;
(statearr_13594_13615[(2)] = null);

(statearr_13594_13615[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (6))){
var inst_13564 = (state_13587[(7)]);
var inst_13570 = p.call(null,inst_13564);
var state_13587__$1 = state_13587;
if(cljs.core.truth_(inst_13570)){
var statearr_13595_13616 = state_13587__$1;
(statearr_13595_13616[(1)] = (9));

} else {
var statearr_13596_13617 = state_13587__$1;
(statearr_13596_13617[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (3))){
var inst_13585 = (state_13587[(2)]);
var state_13587__$1 = state_13587;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13587__$1,inst_13585);
} else {
if((state_val_13588 === (12))){
var state_13587__$1 = state_13587;
var statearr_13597_13618 = state_13587__$1;
(statearr_13597_13618[(2)] = null);

(statearr_13597_13618[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (2))){
var state_13587__$1 = state_13587;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13587__$1,(4),ch);
} else {
if((state_val_13588 === (11))){
var inst_13564 = (state_13587[(7)]);
var inst_13574 = (state_13587[(2)]);
var state_13587__$1 = state_13587;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13587__$1,(8),inst_13574,inst_13564);
} else {
if((state_val_13588 === (9))){
var state_13587__$1 = state_13587;
var statearr_13598_13619 = state_13587__$1;
(statearr_13598_13619[(2)] = tc);

(statearr_13598_13619[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (5))){
var inst_13567 = cljs.core.async.close_BANG_.call(null,tc);
var inst_13568 = cljs.core.async.close_BANG_.call(null,fc);
var state_13587__$1 = (function (){var statearr_13599 = state_13587;
(statearr_13599[(8)] = inst_13567);

return statearr_13599;
})();
var statearr_13600_13620 = state_13587__$1;
(statearr_13600_13620[(2)] = inst_13568);

(statearr_13600_13620[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (14))){
var inst_13581 = (state_13587[(2)]);
var state_13587__$1 = state_13587;
var statearr_13601_13621 = state_13587__$1;
(statearr_13601_13621[(2)] = inst_13581);

(statearr_13601_13621[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (10))){
var state_13587__$1 = state_13587;
var statearr_13602_13622 = state_13587__$1;
(statearr_13602_13622[(2)] = fc);

(statearr_13602_13622[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13588 === (8))){
var inst_13576 = (state_13587[(2)]);
var state_13587__$1 = state_13587;
if(cljs.core.truth_(inst_13576)){
var statearr_13603_13623 = state_13587__$1;
(statearr_13603_13623[(1)] = (12));

} else {
var statearr_13604_13624 = state_13587__$1;
(statearr_13604_13624[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___13610,tc,fc))
;
return ((function (switch__11139__auto__,c__11296__auto___13610,tc,fc){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_13605 = [null,null,null,null,null,null,null,null,null];
(statearr_13605[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_13605[(1)] = (1));

return statearr_13605;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_13587){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13587);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13606){if((e13606 instanceof Object)){
var ex__11143__auto__ = e13606;
var statearr_13607_13625 = state_13587;
(statearr_13607_13625[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13587);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13606;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13626 = state_13587;
state_13587 = G__13626;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_13587){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_13587);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___13610,tc,fc))
})();
var state__11298__auto__ = (function (){var statearr_13608 = f__11297__auto__.call(null);
(statearr_13608[(6)] = c__11296__auto___13610);

return statearr_13608;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___13610,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__11296__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto__){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto__){
return (function (state_13647){
var state_val_13648 = (state_13647[(1)]);
if((state_val_13648 === (7))){
var inst_13643 = (state_13647[(2)]);
var state_13647__$1 = state_13647;
var statearr_13649_13667 = state_13647__$1;
(statearr_13649_13667[(2)] = inst_13643);

(statearr_13649_13667[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (1))){
var inst_13627 = init;
var state_13647__$1 = (function (){var statearr_13650 = state_13647;
(statearr_13650[(7)] = inst_13627);

return statearr_13650;
})();
var statearr_13651_13668 = state_13647__$1;
(statearr_13651_13668[(2)] = null);

(statearr_13651_13668[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (4))){
var inst_13630 = (state_13647[(8)]);
var inst_13630__$1 = (state_13647[(2)]);
var inst_13631 = (inst_13630__$1 == null);
var state_13647__$1 = (function (){var statearr_13652 = state_13647;
(statearr_13652[(8)] = inst_13630__$1);

return statearr_13652;
})();
if(cljs.core.truth_(inst_13631)){
var statearr_13653_13669 = state_13647__$1;
(statearr_13653_13669[(1)] = (5));

} else {
var statearr_13654_13670 = state_13647__$1;
(statearr_13654_13670[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (6))){
var inst_13630 = (state_13647[(8)]);
var inst_13634 = (state_13647[(9)]);
var inst_13627 = (state_13647[(7)]);
var inst_13634__$1 = f.call(null,inst_13627,inst_13630);
var inst_13635 = cljs.core.reduced_QMARK_.call(null,inst_13634__$1);
var state_13647__$1 = (function (){var statearr_13655 = state_13647;
(statearr_13655[(9)] = inst_13634__$1);

return statearr_13655;
})();
if(inst_13635){
var statearr_13656_13671 = state_13647__$1;
(statearr_13656_13671[(1)] = (8));

} else {
var statearr_13657_13672 = state_13647__$1;
(statearr_13657_13672[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (3))){
var inst_13645 = (state_13647[(2)]);
var state_13647__$1 = state_13647;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13647__$1,inst_13645);
} else {
if((state_val_13648 === (2))){
var state_13647__$1 = state_13647;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13647__$1,(4),ch);
} else {
if((state_val_13648 === (9))){
var inst_13634 = (state_13647[(9)]);
var inst_13627 = inst_13634;
var state_13647__$1 = (function (){var statearr_13658 = state_13647;
(statearr_13658[(7)] = inst_13627);

return statearr_13658;
})();
var statearr_13659_13673 = state_13647__$1;
(statearr_13659_13673[(2)] = null);

(statearr_13659_13673[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (5))){
var inst_13627 = (state_13647[(7)]);
var state_13647__$1 = state_13647;
var statearr_13660_13674 = state_13647__$1;
(statearr_13660_13674[(2)] = inst_13627);

(statearr_13660_13674[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (10))){
var inst_13641 = (state_13647[(2)]);
var state_13647__$1 = state_13647;
var statearr_13661_13675 = state_13647__$1;
(statearr_13661_13675[(2)] = inst_13641);

(statearr_13661_13675[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13648 === (8))){
var inst_13634 = (state_13647[(9)]);
var inst_13637 = cljs.core.deref.call(null,inst_13634);
var state_13647__$1 = state_13647;
var statearr_13662_13676 = state_13647__$1;
(statearr_13662_13676[(2)] = inst_13637);

(statearr_13662_13676[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto__))
;
return ((function (switch__11139__auto__,c__11296__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__11140__auto__ = null;
var cljs$core$async$reduce_$_state_machine__11140__auto____0 = (function (){
var statearr_13663 = [null,null,null,null,null,null,null,null,null,null];
(statearr_13663[(0)] = cljs$core$async$reduce_$_state_machine__11140__auto__);

(statearr_13663[(1)] = (1));

return statearr_13663;
});
var cljs$core$async$reduce_$_state_machine__11140__auto____1 = (function (state_13647){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13647);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13664){if((e13664 instanceof Object)){
var ex__11143__auto__ = e13664;
var statearr_13665_13677 = state_13647;
(statearr_13665_13677[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13647);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13664;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13678 = state_13647;
state_13647 = G__13678;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__11140__auto__ = function(state_13647){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__11140__auto____1.call(this,state_13647);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$reduce_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__11140__auto____0;
cljs$core$async$reduce_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__11140__auto____1;
return cljs$core$async$reduce_$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto__))
})();
var state__11298__auto__ = (function (){var statearr_13666 = f__11297__auto__.call(null);
(statearr_13666[(6)] = c__11296__auto__);

return statearr_13666;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto__))
);

return c__11296__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__11296__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto__,f__$1){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto__,f__$1){
return (function (state_13684){
var state_val_13685 = (state_13684[(1)]);
if((state_val_13685 === (1))){
var inst_13679 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_13684__$1 = state_13684;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13684__$1,(2),inst_13679);
} else {
if((state_val_13685 === (2))){
var inst_13681 = (state_13684[(2)]);
var inst_13682 = f__$1.call(null,inst_13681);
var state_13684__$1 = state_13684;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13684__$1,inst_13682);
} else {
return null;
}
}
});})(c__11296__auto__,f__$1))
;
return ((function (switch__11139__auto__,c__11296__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__11140__auto__ = null;
var cljs$core$async$transduce_$_state_machine__11140__auto____0 = (function (){
var statearr_13686 = [null,null,null,null,null,null,null];
(statearr_13686[(0)] = cljs$core$async$transduce_$_state_machine__11140__auto__);

(statearr_13686[(1)] = (1));

return statearr_13686;
});
var cljs$core$async$transduce_$_state_machine__11140__auto____1 = (function (state_13684){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13684);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13687){if((e13687 instanceof Object)){
var ex__11143__auto__ = e13687;
var statearr_13688_13690 = state_13684;
(statearr_13688_13690[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13684);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13687;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13691 = state_13684;
state_13684 = G__13691;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__11140__auto__ = function(state_13684){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__11140__auto____1.call(this,state_13684);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$transduce_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__11140__auto____0;
cljs$core$async$transduce_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__11140__auto____1;
return cljs$core$async$transduce_$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto__,f__$1))
})();
var state__11298__auto__ = (function (){var statearr_13689 = f__11297__auto__.call(null);
(statearr_13689[(6)] = c__11296__auto__);

return statearr_13689;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto__,f__$1))
);

return c__11296__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__13693 = arguments.length;
switch (G__13693) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__11296__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto__){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto__){
return (function (state_13718){
var state_val_13719 = (state_13718[(1)]);
if((state_val_13719 === (7))){
var inst_13700 = (state_13718[(2)]);
var state_13718__$1 = state_13718;
var statearr_13720_13741 = state_13718__$1;
(statearr_13720_13741[(2)] = inst_13700);

(statearr_13720_13741[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (1))){
var inst_13694 = cljs.core.seq.call(null,coll);
var inst_13695 = inst_13694;
var state_13718__$1 = (function (){var statearr_13721 = state_13718;
(statearr_13721[(7)] = inst_13695);

return statearr_13721;
})();
var statearr_13722_13742 = state_13718__$1;
(statearr_13722_13742[(2)] = null);

(statearr_13722_13742[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (4))){
var inst_13695 = (state_13718[(7)]);
var inst_13698 = cljs.core.first.call(null,inst_13695);
var state_13718__$1 = state_13718;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13718__$1,(7),ch,inst_13698);
} else {
if((state_val_13719 === (13))){
var inst_13712 = (state_13718[(2)]);
var state_13718__$1 = state_13718;
var statearr_13723_13743 = state_13718__$1;
(statearr_13723_13743[(2)] = inst_13712);

(statearr_13723_13743[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (6))){
var inst_13703 = (state_13718[(2)]);
var state_13718__$1 = state_13718;
if(cljs.core.truth_(inst_13703)){
var statearr_13724_13744 = state_13718__$1;
(statearr_13724_13744[(1)] = (8));

} else {
var statearr_13725_13745 = state_13718__$1;
(statearr_13725_13745[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (3))){
var inst_13716 = (state_13718[(2)]);
var state_13718__$1 = state_13718;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13718__$1,inst_13716);
} else {
if((state_val_13719 === (12))){
var state_13718__$1 = state_13718;
var statearr_13726_13746 = state_13718__$1;
(statearr_13726_13746[(2)] = null);

(statearr_13726_13746[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (2))){
var inst_13695 = (state_13718[(7)]);
var state_13718__$1 = state_13718;
if(cljs.core.truth_(inst_13695)){
var statearr_13727_13747 = state_13718__$1;
(statearr_13727_13747[(1)] = (4));

} else {
var statearr_13728_13748 = state_13718__$1;
(statearr_13728_13748[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (11))){
var inst_13709 = cljs.core.async.close_BANG_.call(null,ch);
var state_13718__$1 = state_13718;
var statearr_13729_13749 = state_13718__$1;
(statearr_13729_13749[(2)] = inst_13709);

(statearr_13729_13749[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (9))){
var state_13718__$1 = state_13718;
if(cljs.core.truth_(close_QMARK_)){
var statearr_13730_13750 = state_13718__$1;
(statearr_13730_13750[(1)] = (11));

} else {
var statearr_13731_13751 = state_13718__$1;
(statearr_13731_13751[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (5))){
var inst_13695 = (state_13718[(7)]);
var state_13718__$1 = state_13718;
var statearr_13732_13752 = state_13718__$1;
(statearr_13732_13752[(2)] = inst_13695);

(statearr_13732_13752[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (10))){
var inst_13714 = (state_13718[(2)]);
var state_13718__$1 = state_13718;
var statearr_13733_13753 = state_13718__$1;
(statearr_13733_13753[(2)] = inst_13714);

(statearr_13733_13753[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13719 === (8))){
var inst_13695 = (state_13718[(7)]);
var inst_13705 = cljs.core.next.call(null,inst_13695);
var inst_13695__$1 = inst_13705;
var state_13718__$1 = (function (){var statearr_13734 = state_13718;
(statearr_13734[(7)] = inst_13695__$1);

return statearr_13734;
})();
var statearr_13735_13754 = state_13718__$1;
(statearr_13735_13754[(2)] = null);

(statearr_13735_13754[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto__))
;
return ((function (switch__11139__auto__,c__11296__auto__){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_13736 = [null,null,null,null,null,null,null,null];
(statearr_13736[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_13736[(1)] = (1));

return statearr_13736;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_13718){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13718);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13737){if((e13737 instanceof Object)){
var ex__11143__auto__ = e13737;
var statearr_13738_13755 = state_13718;
(statearr_13738_13755[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13718);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13737;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13756 = state_13718;
state_13718 = G__13756;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_13718){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_13718);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto__))
})();
var state__11298__auto__ = (function (){var statearr_13739 = f__11297__auto__.call(null);
(statearr_13739[(6)] = c__11296__auto__);

return statearr_13739;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto__))
);

return c__11296__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if(((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4211__auto__ = (((_ == null))?null:_);
var m__4212__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,_);
} else {
var m__4212__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__4212__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m);
} else {
var m__4212__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async13757 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async13757 = (function (ch,cs,meta13758){
this.ch = ch;
this.cs = cs;
this.meta13758 = meta13758;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_13759,meta13758__$1){
var self__ = this;
var _13759__$1 = this;
return (new cljs.core.async.t_cljs$core$async13757(self__.ch,self__.cs,meta13758__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_13759){
var self__ = this;
var _13759__$1 = this;
return self__.meta13758;
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta13758","meta13758",221309241,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async13757.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async13757.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async13757";

cljs.core.async.t_cljs$core$async13757.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async13757");
});})(cs))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async13757.
 */
cljs.core.async.__GT_t_cljs$core$async13757 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async13757(ch__$1,cs__$1,meta13758){
return (new cljs.core.async.t_cljs$core$async13757(ch__$1,cs__$1,meta13758));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async13757(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__11296__auto___13979 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___13979,cs,m,dchan,dctr,done){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___13979,cs,m,dchan,dctr,done){
return (function (state_13894){
var state_val_13895 = (state_13894[(1)]);
if((state_val_13895 === (7))){
var inst_13890 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13896_13980 = state_13894__$1;
(statearr_13896_13980[(2)] = inst_13890);

(statearr_13896_13980[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (20))){
var inst_13793 = (state_13894[(7)]);
var inst_13805 = cljs.core.first.call(null,inst_13793);
var inst_13806 = cljs.core.nth.call(null,inst_13805,(0),null);
var inst_13807 = cljs.core.nth.call(null,inst_13805,(1),null);
var state_13894__$1 = (function (){var statearr_13897 = state_13894;
(statearr_13897[(8)] = inst_13806);

return statearr_13897;
})();
if(cljs.core.truth_(inst_13807)){
var statearr_13898_13981 = state_13894__$1;
(statearr_13898_13981[(1)] = (22));

} else {
var statearr_13899_13982 = state_13894__$1;
(statearr_13899_13982[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (27))){
var inst_13837 = (state_13894[(9)]);
var inst_13762 = (state_13894[(10)]);
var inst_13835 = (state_13894[(11)]);
var inst_13842 = (state_13894[(12)]);
var inst_13842__$1 = cljs.core._nth.call(null,inst_13835,inst_13837);
var inst_13843 = cljs.core.async.put_BANG_.call(null,inst_13842__$1,inst_13762,done);
var state_13894__$1 = (function (){var statearr_13900 = state_13894;
(statearr_13900[(12)] = inst_13842__$1);

return statearr_13900;
})();
if(cljs.core.truth_(inst_13843)){
var statearr_13901_13983 = state_13894__$1;
(statearr_13901_13983[(1)] = (30));

} else {
var statearr_13902_13984 = state_13894__$1;
(statearr_13902_13984[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (1))){
var state_13894__$1 = state_13894;
var statearr_13903_13985 = state_13894__$1;
(statearr_13903_13985[(2)] = null);

(statearr_13903_13985[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (24))){
var inst_13793 = (state_13894[(7)]);
var inst_13812 = (state_13894[(2)]);
var inst_13813 = cljs.core.next.call(null,inst_13793);
var inst_13771 = inst_13813;
var inst_13772 = null;
var inst_13773 = (0);
var inst_13774 = (0);
var state_13894__$1 = (function (){var statearr_13904 = state_13894;
(statearr_13904[(13)] = inst_13773);

(statearr_13904[(14)] = inst_13772);

(statearr_13904[(15)] = inst_13774);

(statearr_13904[(16)] = inst_13771);

(statearr_13904[(17)] = inst_13812);

return statearr_13904;
})();
var statearr_13905_13986 = state_13894__$1;
(statearr_13905_13986[(2)] = null);

(statearr_13905_13986[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (39))){
var state_13894__$1 = state_13894;
var statearr_13909_13987 = state_13894__$1;
(statearr_13909_13987[(2)] = null);

(statearr_13909_13987[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (4))){
var inst_13762 = (state_13894[(10)]);
var inst_13762__$1 = (state_13894[(2)]);
var inst_13763 = (inst_13762__$1 == null);
var state_13894__$1 = (function (){var statearr_13910 = state_13894;
(statearr_13910[(10)] = inst_13762__$1);

return statearr_13910;
})();
if(cljs.core.truth_(inst_13763)){
var statearr_13911_13988 = state_13894__$1;
(statearr_13911_13988[(1)] = (5));

} else {
var statearr_13912_13989 = state_13894__$1;
(statearr_13912_13989[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (15))){
var inst_13773 = (state_13894[(13)]);
var inst_13772 = (state_13894[(14)]);
var inst_13774 = (state_13894[(15)]);
var inst_13771 = (state_13894[(16)]);
var inst_13789 = (state_13894[(2)]);
var inst_13790 = (inst_13774 + (1));
var tmp13906 = inst_13773;
var tmp13907 = inst_13772;
var tmp13908 = inst_13771;
var inst_13771__$1 = tmp13908;
var inst_13772__$1 = tmp13907;
var inst_13773__$1 = tmp13906;
var inst_13774__$1 = inst_13790;
var state_13894__$1 = (function (){var statearr_13913 = state_13894;
(statearr_13913[(13)] = inst_13773__$1);

(statearr_13913[(14)] = inst_13772__$1);

(statearr_13913[(15)] = inst_13774__$1);

(statearr_13913[(18)] = inst_13789);

(statearr_13913[(16)] = inst_13771__$1);

return statearr_13913;
})();
var statearr_13914_13990 = state_13894__$1;
(statearr_13914_13990[(2)] = null);

(statearr_13914_13990[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (21))){
var inst_13816 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13918_13991 = state_13894__$1;
(statearr_13918_13991[(2)] = inst_13816);

(statearr_13918_13991[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (31))){
var inst_13842 = (state_13894[(12)]);
var inst_13846 = done.call(null,null);
var inst_13847 = cljs.core.async.untap_STAR_.call(null,m,inst_13842);
var state_13894__$1 = (function (){var statearr_13919 = state_13894;
(statearr_13919[(19)] = inst_13846);

return statearr_13919;
})();
var statearr_13920_13992 = state_13894__$1;
(statearr_13920_13992[(2)] = inst_13847);

(statearr_13920_13992[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (32))){
var inst_13837 = (state_13894[(9)]);
var inst_13834 = (state_13894[(20)]);
var inst_13836 = (state_13894[(21)]);
var inst_13835 = (state_13894[(11)]);
var inst_13849 = (state_13894[(2)]);
var inst_13850 = (inst_13837 + (1));
var tmp13915 = inst_13834;
var tmp13916 = inst_13836;
var tmp13917 = inst_13835;
var inst_13834__$1 = tmp13915;
var inst_13835__$1 = tmp13917;
var inst_13836__$1 = tmp13916;
var inst_13837__$1 = inst_13850;
var state_13894__$1 = (function (){var statearr_13921 = state_13894;
(statearr_13921[(9)] = inst_13837__$1);

(statearr_13921[(20)] = inst_13834__$1);

(statearr_13921[(21)] = inst_13836__$1);

(statearr_13921[(11)] = inst_13835__$1);

(statearr_13921[(22)] = inst_13849);

return statearr_13921;
})();
var statearr_13922_13993 = state_13894__$1;
(statearr_13922_13993[(2)] = null);

(statearr_13922_13993[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (40))){
var inst_13862 = (state_13894[(23)]);
var inst_13866 = done.call(null,null);
var inst_13867 = cljs.core.async.untap_STAR_.call(null,m,inst_13862);
var state_13894__$1 = (function (){var statearr_13923 = state_13894;
(statearr_13923[(24)] = inst_13866);

return statearr_13923;
})();
var statearr_13924_13994 = state_13894__$1;
(statearr_13924_13994[(2)] = inst_13867);

(statearr_13924_13994[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (33))){
var inst_13853 = (state_13894[(25)]);
var inst_13855 = cljs.core.chunked_seq_QMARK_.call(null,inst_13853);
var state_13894__$1 = state_13894;
if(inst_13855){
var statearr_13925_13995 = state_13894__$1;
(statearr_13925_13995[(1)] = (36));

} else {
var statearr_13926_13996 = state_13894__$1;
(statearr_13926_13996[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (13))){
var inst_13783 = (state_13894[(26)]);
var inst_13786 = cljs.core.async.close_BANG_.call(null,inst_13783);
var state_13894__$1 = state_13894;
var statearr_13927_13997 = state_13894__$1;
(statearr_13927_13997[(2)] = inst_13786);

(statearr_13927_13997[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (22))){
var inst_13806 = (state_13894[(8)]);
var inst_13809 = cljs.core.async.close_BANG_.call(null,inst_13806);
var state_13894__$1 = state_13894;
var statearr_13928_13998 = state_13894__$1;
(statearr_13928_13998[(2)] = inst_13809);

(statearr_13928_13998[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (36))){
var inst_13853 = (state_13894[(25)]);
var inst_13857 = cljs.core.chunk_first.call(null,inst_13853);
var inst_13858 = cljs.core.chunk_rest.call(null,inst_13853);
var inst_13859 = cljs.core.count.call(null,inst_13857);
var inst_13834 = inst_13858;
var inst_13835 = inst_13857;
var inst_13836 = inst_13859;
var inst_13837 = (0);
var state_13894__$1 = (function (){var statearr_13929 = state_13894;
(statearr_13929[(9)] = inst_13837);

(statearr_13929[(20)] = inst_13834);

(statearr_13929[(21)] = inst_13836);

(statearr_13929[(11)] = inst_13835);

return statearr_13929;
})();
var statearr_13930_13999 = state_13894__$1;
(statearr_13930_13999[(2)] = null);

(statearr_13930_13999[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (41))){
var inst_13853 = (state_13894[(25)]);
var inst_13869 = (state_13894[(2)]);
var inst_13870 = cljs.core.next.call(null,inst_13853);
var inst_13834 = inst_13870;
var inst_13835 = null;
var inst_13836 = (0);
var inst_13837 = (0);
var state_13894__$1 = (function (){var statearr_13931 = state_13894;
(statearr_13931[(9)] = inst_13837);

(statearr_13931[(20)] = inst_13834);

(statearr_13931[(21)] = inst_13836);

(statearr_13931[(11)] = inst_13835);

(statearr_13931[(27)] = inst_13869);

return statearr_13931;
})();
var statearr_13932_14000 = state_13894__$1;
(statearr_13932_14000[(2)] = null);

(statearr_13932_14000[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (43))){
var state_13894__$1 = state_13894;
var statearr_13933_14001 = state_13894__$1;
(statearr_13933_14001[(2)] = null);

(statearr_13933_14001[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (29))){
var inst_13878 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13934_14002 = state_13894__$1;
(statearr_13934_14002[(2)] = inst_13878);

(statearr_13934_14002[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (44))){
var inst_13887 = (state_13894[(2)]);
var state_13894__$1 = (function (){var statearr_13935 = state_13894;
(statearr_13935[(28)] = inst_13887);

return statearr_13935;
})();
var statearr_13936_14003 = state_13894__$1;
(statearr_13936_14003[(2)] = null);

(statearr_13936_14003[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (6))){
var inst_13826 = (state_13894[(29)]);
var inst_13825 = cljs.core.deref.call(null,cs);
var inst_13826__$1 = cljs.core.keys.call(null,inst_13825);
var inst_13827 = cljs.core.count.call(null,inst_13826__$1);
var inst_13828 = cljs.core.reset_BANG_.call(null,dctr,inst_13827);
var inst_13833 = cljs.core.seq.call(null,inst_13826__$1);
var inst_13834 = inst_13833;
var inst_13835 = null;
var inst_13836 = (0);
var inst_13837 = (0);
var state_13894__$1 = (function (){var statearr_13937 = state_13894;
(statearr_13937[(9)] = inst_13837);

(statearr_13937[(20)] = inst_13834);

(statearr_13937[(30)] = inst_13828);

(statearr_13937[(21)] = inst_13836);

(statearr_13937[(11)] = inst_13835);

(statearr_13937[(29)] = inst_13826__$1);

return statearr_13937;
})();
var statearr_13938_14004 = state_13894__$1;
(statearr_13938_14004[(2)] = null);

(statearr_13938_14004[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (28))){
var inst_13853 = (state_13894[(25)]);
var inst_13834 = (state_13894[(20)]);
var inst_13853__$1 = cljs.core.seq.call(null,inst_13834);
var state_13894__$1 = (function (){var statearr_13939 = state_13894;
(statearr_13939[(25)] = inst_13853__$1);

return statearr_13939;
})();
if(inst_13853__$1){
var statearr_13940_14005 = state_13894__$1;
(statearr_13940_14005[(1)] = (33));

} else {
var statearr_13941_14006 = state_13894__$1;
(statearr_13941_14006[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (25))){
var inst_13837 = (state_13894[(9)]);
var inst_13836 = (state_13894[(21)]);
var inst_13839 = (inst_13837 < inst_13836);
var inst_13840 = inst_13839;
var state_13894__$1 = state_13894;
if(cljs.core.truth_(inst_13840)){
var statearr_13942_14007 = state_13894__$1;
(statearr_13942_14007[(1)] = (27));

} else {
var statearr_13943_14008 = state_13894__$1;
(statearr_13943_14008[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (34))){
var state_13894__$1 = state_13894;
var statearr_13944_14009 = state_13894__$1;
(statearr_13944_14009[(2)] = null);

(statearr_13944_14009[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (17))){
var state_13894__$1 = state_13894;
var statearr_13945_14010 = state_13894__$1;
(statearr_13945_14010[(2)] = null);

(statearr_13945_14010[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (3))){
var inst_13892 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13894__$1,inst_13892);
} else {
if((state_val_13895 === (12))){
var inst_13821 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13946_14011 = state_13894__$1;
(statearr_13946_14011[(2)] = inst_13821);

(statearr_13946_14011[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (2))){
var state_13894__$1 = state_13894;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13894__$1,(4),ch);
} else {
if((state_val_13895 === (23))){
var state_13894__$1 = state_13894;
var statearr_13947_14012 = state_13894__$1;
(statearr_13947_14012[(2)] = null);

(statearr_13947_14012[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (35))){
var inst_13876 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13948_14013 = state_13894__$1;
(statearr_13948_14013[(2)] = inst_13876);

(statearr_13948_14013[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (19))){
var inst_13793 = (state_13894[(7)]);
var inst_13797 = cljs.core.chunk_first.call(null,inst_13793);
var inst_13798 = cljs.core.chunk_rest.call(null,inst_13793);
var inst_13799 = cljs.core.count.call(null,inst_13797);
var inst_13771 = inst_13798;
var inst_13772 = inst_13797;
var inst_13773 = inst_13799;
var inst_13774 = (0);
var state_13894__$1 = (function (){var statearr_13949 = state_13894;
(statearr_13949[(13)] = inst_13773);

(statearr_13949[(14)] = inst_13772);

(statearr_13949[(15)] = inst_13774);

(statearr_13949[(16)] = inst_13771);

return statearr_13949;
})();
var statearr_13950_14014 = state_13894__$1;
(statearr_13950_14014[(2)] = null);

(statearr_13950_14014[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (11))){
var inst_13793 = (state_13894[(7)]);
var inst_13771 = (state_13894[(16)]);
var inst_13793__$1 = cljs.core.seq.call(null,inst_13771);
var state_13894__$1 = (function (){var statearr_13951 = state_13894;
(statearr_13951[(7)] = inst_13793__$1);

return statearr_13951;
})();
if(inst_13793__$1){
var statearr_13952_14015 = state_13894__$1;
(statearr_13952_14015[(1)] = (16));

} else {
var statearr_13953_14016 = state_13894__$1;
(statearr_13953_14016[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (9))){
var inst_13823 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13954_14017 = state_13894__$1;
(statearr_13954_14017[(2)] = inst_13823);

(statearr_13954_14017[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (5))){
var inst_13769 = cljs.core.deref.call(null,cs);
var inst_13770 = cljs.core.seq.call(null,inst_13769);
var inst_13771 = inst_13770;
var inst_13772 = null;
var inst_13773 = (0);
var inst_13774 = (0);
var state_13894__$1 = (function (){var statearr_13955 = state_13894;
(statearr_13955[(13)] = inst_13773);

(statearr_13955[(14)] = inst_13772);

(statearr_13955[(15)] = inst_13774);

(statearr_13955[(16)] = inst_13771);

return statearr_13955;
})();
var statearr_13956_14018 = state_13894__$1;
(statearr_13956_14018[(2)] = null);

(statearr_13956_14018[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (14))){
var state_13894__$1 = state_13894;
var statearr_13957_14019 = state_13894__$1;
(statearr_13957_14019[(2)] = null);

(statearr_13957_14019[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (45))){
var inst_13884 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13958_14020 = state_13894__$1;
(statearr_13958_14020[(2)] = inst_13884);

(statearr_13958_14020[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (26))){
var inst_13826 = (state_13894[(29)]);
var inst_13880 = (state_13894[(2)]);
var inst_13881 = cljs.core.seq.call(null,inst_13826);
var state_13894__$1 = (function (){var statearr_13959 = state_13894;
(statearr_13959[(31)] = inst_13880);

return statearr_13959;
})();
if(inst_13881){
var statearr_13960_14021 = state_13894__$1;
(statearr_13960_14021[(1)] = (42));

} else {
var statearr_13961_14022 = state_13894__$1;
(statearr_13961_14022[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (16))){
var inst_13793 = (state_13894[(7)]);
var inst_13795 = cljs.core.chunked_seq_QMARK_.call(null,inst_13793);
var state_13894__$1 = state_13894;
if(inst_13795){
var statearr_13962_14023 = state_13894__$1;
(statearr_13962_14023[(1)] = (19));

} else {
var statearr_13963_14024 = state_13894__$1;
(statearr_13963_14024[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (38))){
var inst_13873 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13964_14025 = state_13894__$1;
(statearr_13964_14025[(2)] = inst_13873);

(statearr_13964_14025[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (30))){
var state_13894__$1 = state_13894;
var statearr_13965_14026 = state_13894__$1;
(statearr_13965_14026[(2)] = null);

(statearr_13965_14026[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (10))){
var inst_13772 = (state_13894[(14)]);
var inst_13774 = (state_13894[(15)]);
var inst_13782 = cljs.core._nth.call(null,inst_13772,inst_13774);
var inst_13783 = cljs.core.nth.call(null,inst_13782,(0),null);
var inst_13784 = cljs.core.nth.call(null,inst_13782,(1),null);
var state_13894__$1 = (function (){var statearr_13966 = state_13894;
(statearr_13966[(26)] = inst_13783);

return statearr_13966;
})();
if(cljs.core.truth_(inst_13784)){
var statearr_13967_14027 = state_13894__$1;
(statearr_13967_14027[(1)] = (13));

} else {
var statearr_13968_14028 = state_13894__$1;
(statearr_13968_14028[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (18))){
var inst_13819 = (state_13894[(2)]);
var state_13894__$1 = state_13894;
var statearr_13969_14029 = state_13894__$1;
(statearr_13969_14029[(2)] = inst_13819);

(statearr_13969_14029[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (42))){
var state_13894__$1 = state_13894;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13894__$1,(45),dchan);
} else {
if((state_val_13895 === (37))){
var inst_13853 = (state_13894[(25)]);
var inst_13862 = (state_13894[(23)]);
var inst_13762 = (state_13894[(10)]);
var inst_13862__$1 = cljs.core.first.call(null,inst_13853);
var inst_13863 = cljs.core.async.put_BANG_.call(null,inst_13862__$1,inst_13762,done);
var state_13894__$1 = (function (){var statearr_13970 = state_13894;
(statearr_13970[(23)] = inst_13862__$1);

return statearr_13970;
})();
if(cljs.core.truth_(inst_13863)){
var statearr_13971_14030 = state_13894__$1;
(statearr_13971_14030[(1)] = (39));

} else {
var statearr_13972_14031 = state_13894__$1;
(statearr_13972_14031[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13895 === (8))){
var inst_13773 = (state_13894[(13)]);
var inst_13774 = (state_13894[(15)]);
var inst_13776 = (inst_13774 < inst_13773);
var inst_13777 = inst_13776;
var state_13894__$1 = state_13894;
if(cljs.core.truth_(inst_13777)){
var statearr_13973_14032 = state_13894__$1;
(statearr_13973_14032[(1)] = (10));

} else {
var statearr_13974_14033 = state_13894__$1;
(statearr_13974_14033[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___13979,cs,m,dchan,dctr,done))
;
return ((function (switch__11139__auto__,c__11296__auto___13979,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__11140__auto__ = null;
var cljs$core$async$mult_$_state_machine__11140__auto____0 = (function (){
var statearr_13975 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_13975[(0)] = cljs$core$async$mult_$_state_machine__11140__auto__);

(statearr_13975[(1)] = (1));

return statearr_13975;
});
var cljs$core$async$mult_$_state_machine__11140__auto____1 = (function (state_13894){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_13894);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e13976){if((e13976 instanceof Object)){
var ex__11143__auto__ = e13976;
var statearr_13977_14034 = state_13894;
(statearr_13977_14034[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13894);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13976;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14035 = state_13894;
state_13894 = G__14035;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__11140__auto__ = function(state_13894){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__11140__auto____1.call(this,state_13894);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mult_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__11140__auto____0;
cljs$core$async$mult_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__11140__auto____1;
return cljs$core$async$mult_$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___13979,cs,m,dchan,dctr,done))
})();
var state__11298__auto__ = (function (){var statearr_13978 = f__11297__auto__.call(null);
(statearr_13978[(6)] = c__11296__auto___13979);

return statearr_13978;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___13979,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__14037 = arguments.length;
switch (G__14037) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m);
} else {
var m__4212__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,state_map);
} else {
var m__4212__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,mode);
} else {
var m__4212__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4502__auto__ = [];
var len__4499__auto___14049 = arguments.length;
var i__4500__auto___14050 = (0);
while(true){
if((i__4500__auto___14050 < len__4499__auto___14049)){
args__4502__auto__.push((arguments[i__4500__auto___14050]));

var G__14051 = (i__4500__auto___14050 + (1));
i__4500__auto___14050 = G__14051;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((3) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4503__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__14043){
var map__14044 = p__14043;
var map__14044__$1 = ((((!((map__14044 == null)))?(((((map__14044.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__14044.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14044):map__14044);
var opts = map__14044__$1;
var statearr_14046_14052 = state;
(statearr_14046_14052[(1)] = cont_block);


var temp__6753__auto__ = cljs.core.async.do_alts.call(null,((function (map__14044,map__14044__$1,opts){
return (function (val){
var statearr_14047_14053 = state;
(statearr_14047_14053[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__14044,map__14044__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__6753__auto__)){
var cb = temp__6753__auto__;
var statearr_14048_14054 = state;
(statearr_14048_14054[(2)] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq14039){
var G__14040 = cljs.core.first.call(null,seq14039);
var seq14039__$1 = cljs.core.next.call(null,seq14039);
var G__14041 = cljs.core.first.call(null,seq14039__$1);
var seq14039__$2 = cljs.core.next.call(null,seq14039__$1);
var G__14042 = cljs.core.first.call(null,seq14039__$2);
var seq14039__$3 = cljs.core.next.call(null,seq14039__$2);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__14040,G__14041,G__14042,seq14039__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,((((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos)))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async14055 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14055 = (function (out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,meta14056){
this.out = out;
this.cs = cs;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.solo_mode = solo_mode;
this.change = change;
this.changed = changed;
this.pick = pick;
this.calc_state = calc_state;
this.meta14056 = meta14056;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_14057,meta14056__$1){
var self__ = this;
var _14057__$1 = this;
return (new cljs.core.async.t_cljs$core$async14055(self__.out,self__.cs,self__.solo_modes,self__.attrs,self__.solo_mode,self__.change,self__.changed,self__.pick,self__.calc_state,meta14056__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_14057){
var self__ = this;
var _14057__$1 = this;
return self__.meta14056;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join('')),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"meta14056","meta14056",-1652033110,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async14055.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14055.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14055";

cljs.core.async.t_cljs$core$async14055.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async14055");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async14055.
 */
cljs.core.async.__GT_t_cljs$core$async14055 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async14055(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta14056){
return (new cljs.core.async.t_cljs$core$async14055(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta14056));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async14055(out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__11296__auto___14219 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14219,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14219,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_14159){
var state_val_14160 = (state_14159[(1)]);
if((state_val_14160 === (7))){
var inst_14074 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
var statearr_14161_14220 = state_14159__$1;
(statearr_14161_14220[(2)] = inst_14074);

(statearr_14161_14220[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (20))){
var inst_14086 = (state_14159[(7)]);
var state_14159__$1 = state_14159;
var statearr_14162_14221 = state_14159__$1;
(statearr_14162_14221[(2)] = inst_14086);

(statearr_14162_14221[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (27))){
var state_14159__$1 = state_14159;
var statearr_14163_14222 = state_14159__$1;
(statearr_14163_14222[(2)] = null);

(statearr_14163_14222[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (1))){
var inst_14061 = (state_14159[(8)]);
var inst_14061__$1 = calc_state.call(null);
var inst_14063 = (inst_14061__$1 == null);
var inst_14064 = cljs.core.not.call(null,inst_14063);
var state_14159__$1 = (function (){var statearr_14164 = state_14159;
(statearr_14164[(8)] = inst_14061__$1);

return statearr_14164;
})();
if(inst_14064){
var statearr_14165_14223 = state_14159__$1;
(statearr_14165_14223[(1)] = (2));

} else {
var statearr_14166_14224 = state_14159__$1;
(statearr_14166_14224[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (24))){
var inst_14119 = (state_14159[(9)]);
var inst_14133 = (state_14159[(10)]);
var inst_14110 = (state_14159[(11)]);
var inst_14133__$1 = inst_14110.call(null,inst_14119);
var state_14159__$1 = (function (){var statearr_14167 = state_14159;
(statearr_14167[(10)] = inst_14133__$1);

return statearr_14167;
})();
if(cljs.core.truth_(inst_14133__$1)){
var statearr_14168_14225 = state_14159__$1;
(statearr_14168_14225[(1)] = (29));

} else {
var statearr_14169_14226 = state_14159__$1;
(statearr_14169_14226[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (4))){
var inst_14077 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14077)){
var statearr_14170_14227 = state_14159__$1;
(statearr_14170_14227[(1)] = (8));

} else {
var statearr_14171_14228 = state_14159__$1;
(statearr_14171_14228[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (15))){
var inst_14104 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14104)){
var statearr_14172_14229 = state_14159__$1;
(statearr_14172_14229[(1)] = (19));

} else {
var statearr_14173_14230 = state_14159__$1;
(statearr_14173_14230[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (21))){
var inst_14109 = (state_14159[(12)]);
var inst_14109__$1 = (state_14159[(2)]);
var inst_14110 = cljs.core.get.call(null,inst_14109__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_14111 = cljs.core.get.call(null,inst_14109__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_14112 = cljs.core.get.call(null,inst_14109__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_14159__$1 = (function (){var statearr_14174 = state_14159;
(statearr_14174[(12)] = inst_14109__$1);

(statearr_14174[(11)] = inst_14110);

(statearr_14174[(13)] = inst_14111);

return statearr_14174;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_14159__$1,(22),inst_14112);
} else {
if((state_val_14160 === (31))){
var inst_14141 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14141)){
var statearr_14175_14231 = state_14159__$1;
(statearr_14175_14231[(1)] = (32));

} else {
var statearr_14176_14232 = state_14159__$1;
(statearr_14176_14232[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (32))){
var inst_14118 = (state_14159[(14)]);
var state_14159__$1 = state_14159;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14159__$1,(35),out,inst_14118);
} else {
if((state_val_14160 === (33))){
var inst_14109 = (state_14159[(12)]);
var inst_14086 = inst_14109;
var state_14159__$1 = (function (){var statearr_14177 = state_14159;
(statearr_14177[(7)] = inst_14086);

return statearr_14177;
})();
var statearr_14178_14233 = state_14159__$1;
(statearr_14178_14233[(2)] = null);

(statearr_14178_14233[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (13))){
var inst_14086 = (state_14159[(7)]);
var inst_14093 = inst_14086.cljs$lang$protocol_mask$partition0$;
var inst_14094 = (inst_14093 & (64));
var inst_14095 = inst_14086.cljs$core$ISeq$;
var inst_14096 = (cljs.core.PROTOCOL_SENTINEL === inst_14095);
var inst_14097 = ((inst_14094) || (inst_14096));
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14097)){
var statearr_14179_14234 = state_14159__$1;
(statearr_14179_14234[(1)] = (16));

} else {
var statearr_14180_14235 = state_14159__$1;
(statearr_14180_14235[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (22))){
var inst_14119 = (state_14159[(9)]);
var inst_14118 = (state_14159[(14)]);
var inst_14117 = (state_14159[(2)]);
var inst_14118__$1 = cljs.core.nth.call(null,inst_14117,(0),null);
var inst_14119__$1 = cljs.core.nth.call(null,inst_14117,(1),null);
var inst_14120 = (inst_14118__$1 == null);
var inst_14121 = cljs.core._EQ_.call(null,inst_14119__$1,change);
var inst_14122 = ((inst_14120) || (inst_14121));
var state_14159__$1 = (function (){var statearr_14181 = state_14159;
(statearr_14181[(9)] = inst_14119__$1);

(statearr_14181[(14)] = inst_14118__$1);

return statearr_14181;
})();
if(cljs.core.truth_(inst_14122)){
var statearr_14182_14236 = state_14159__$1;
(statearr_14182_14236[(1)] = (23));

} else {
var statearr_14183_14237 = state_14159__$1;
(statearr_14183_14237[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (36))){
var inst_14109 = (state_14159[(12)]);
var inst_14086 = inst_14109;
var state_14159__$1 = (function (){var statearr_14184 = state_14159;
(statearr_14184[(7)] = inst_14086);

return statearr_14184;
})();
var statearr_14185_14238 = state_14159__$1;
(statearr_14185_14238[(2)] = null);

(statearr_14185_14238[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (29))){
var inst_14133 = (state_14159[(10)]);
var state_14159__$1 = state_14159;
var statearr_14186_14239 = state_14159__$1;
(statearr_14186_14239[(2)] = inst_14133);

(statearr_14186_14239[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (6))){
var state_14159__$1 = state_14159;
var statearr_14187_14240 = state_14159__$1;
(statearr_14187_14240[(2)] = false);

(statearr_14187_14240[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (28))){
var inst_14129 = (state_14159[(2)]);
var inst_14130 = calc_state.call(null);
var inst_14086 = inst_14130;
var state_14159__$1 = (function (){var statearr_14188 = state_14159;
(statearr_14188[(15)] = inst_14129);

(statearr_14188[(7)] = inst_14086);

return statearr_14188;
})();
var statearr_14189_14241 = state_14159__$1;
(statearr_14189_14241[(2)] = null);

(statearr_14189_14241[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (25))){
var inst_14155 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
var statearr_14190_14242 = state_14159__$1;
(statearr_14190_14242[(2)] = inst_14155);

(statearr_14190_14242[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (34))){
var inst_14153 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
var statearr_14191_14243 = state_14159__$1;
(statearr_14191_14243[(2)] = inst_14153);

(statearr_14191_14243[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (17))){
var state_14159__$1 = state_14159;
var statearr_14192_14244 = state_14159__$1;
(statearr_14192_14244[(2)] = false);

(statearr_14192_14244[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (3))){
var state_14159__$1 = state_14159;
var statearr_14193_14245 = state_14159__$1;
(statearr_14193_14245[(2)] = false);

(statearr_14193_14245[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (12))){
var inst_14157 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14159__$1,inst_14157);
} else {
if((state_val_14160 === (2))){
var inst_14061 = (state_14159[(8)]);
var inst_14066 = inst_14061.cljs$lang$protocol_mask$partition0$;
var inst_14067 = (inst_14066 & (64));
var inst_14068 = inst_14061.cljs$core$ISeq$;
var inst_14069 = (cljs.core.PROTOCOL_SENTINEL === inst_14068);
var inst_14070 = ((inst_14067) || (inst_14069));
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14070)){
var statearr_14194_14246 = state_14159__$1;
(statearr_14194_14246[(1)] = (5));

} else {
var statearr_14195_14247 = state_14159__$1;
(statearr_14195_14247[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (23))){
var inst_14118 = (state_14159[(14)]);
var inst_14124 = (inst_14118 == null);
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14124)){
var statearr_14196_14248 = state_14159__$1;
(statearr_14196_14248[(1)] = (26));

} else {
var statearr_14197_14249 = state_14159__$1;
(statearr_14197_14249[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (35))){
var inst_14144 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
if(cljs.core.truth_(inst_14144)){
var statearr_14198_14250 = state_14159__$1;
(statearr_14198_14250[(1)] = (36));

} else {
var statearr_14199_14251 = state_14159__$1;
(statearr_14199_14251[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (19))){
var inst_14086 = (state_14159[(7)]);
var inst_14106 = cljs.core.apply.call(null,cljs.core.hash_map,inst_14086);
var state_14159__$1 = state_14159;
var statearr_14200_14252 = state_14159__$1;
(statearr_14200_14252[(2)] = inst_14106);

(statearr_14200_14252[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (11))){
var inst_14086 = (state_14159[(7)]);
var inst_14090 = (inst_14086 == null);
var inst_14091 = cljs.core.not.call(null,inst_14090);
var state_14159__$1 = state_14159;
if(inst_14091){
var statearr_14201_14253 = state_14159__$1;
(statearr_14201_14253[(1)] = (13));

} else {
var statearr_14202_14254 = state_14159__$1;
(statearr_14202_14254[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (9))){
var inst_14061 = (state_14159[(8)]);
var state_14159__$1 = state_14159;
var statearr_14203_14255 = state_14159__$1;
(statearr_14203_14255[(2)] = inst_14061);

(statearr_14203_14255[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (5))){
var state_14159__$1 = state_14159;
var statearr_14204_14256 = state_14159__$1;
(statearr_14204_14256[(2)] = true);

(statearr_14204_14256[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (14))){
var state_14159__$1 = state_14159;
var statearr_14205_14257 = state_14159__$1;
(statearr_14205_14257[(2)] = false);

(statearr_14205_14257[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (26))){
var inst_14119 = (state_14159[(9)]);
var inst_14126 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_14119);
var state_14159__$1 = state_14159;
var statearr_14206_14258 = state_14159__$1;
(statearr_14206_14258[(2)] = inst_14126);

(statearr_14206_14258[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (16))){
var state_14159__$1 = state_14159;
var statearr_14207_14259 = state_14159__$1;
(statearr_14207_14259[(2)] = true);

(statearr_14207_14259[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (38))){
var inst_14149 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
var statearr_14208_14260 = state_14159__$1;
(statearr_14208_14260[(2)] = inst_14149);

(statearr_14208_14260[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (30))){
var inst_14119 = (state_14159[(9)]);
var inst_14110 = (state_14159[(11)]);
var inst_14111 = (state_14159[(13)]);
var inst_14136 = cljs.core.empty_QMARK_.call(null,inst_14110);
var inst_14137 = inst_14111.call(null,inst_14119);
var inst_14138 = cljs.core.not.call(null,inst_14137);
var inst_14139 = ((inst_14136) && (inst_14138));
var state_14159__$1 = state_14159;
var statearr_14209_14261 = state_14159__$1;
(statearr_14209_14261[(2)] = inst_14139);

(statearr_14209_14261[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (10))){
var inst_14061 = (state_14159[(8)]);
var inst_14082 = (state_14159[(2)]);
var inst_14083 = cljs.core.get.call(null,inst_14082,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_14084 = cljs.core.get.call(null,inst_14082,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_14085 = cljs.core.get.call(null,inst_14082,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_14086 = inst_14061;
var state_14159__$1 = (function (){var statearr_14210 = state_14159;
(statearr_14210[(16)] = inst_14085);

(statearr_14210[(7)] = inst_14086);

(statearr_14210[(17)] = inst_14083);

(statearr_14210[(18)] = inst_14084);

return statearr_14210;
})();
var statearr_14211_14262 = state_14159__$1;
(statearr_14211_14262[(2)] = null);

(statearr_14211_14262[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (18))){
var inst_14101 = (state_14159[(2)]);
var state_14159__$1 = state_14159;
var statearr_14212_14263 = state_14159__$1;
(statearr_14212_14263[(2)] = inst_14101);

(statearr_14212_14263[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (37))){
var state_14159__$1 = state_14159;
var statearr_14213_14264 = state_14159__$1;
(statearr_14213_14264[(2)] = null);

(statearr_14213_14264[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14160 === (8))){
var inst_14061 = (state_14159[(8)]);
var inst_14079 = cljs.core.apply.call(null,cljs.core.hash_map,inst_14061);
var state_14159__$1 = state_14159;
var statearr_14214_14265 = state_14159__$1;
(statearr_14214_14265[(2)] = inst_14079);

(statearr_14214_14265[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14219,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__11139__auto__,c__11296__auto___14219,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__11140__auto__ = null;
var cljs$core$async$mix_$_state_machine__11140__auto____0 = (function (){
var statearr_14215 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14215[(0)] = cljs$core$async$mix_$_state_machine__11140__auto__);

(statearr_14215[(1)] = (1));

return statearr_14215;
});
var cljs$core$async$mix_$_state_machine__11140__auto____1 = (function (state_14159){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14159);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14216){if((e14216 instanceof Object)){
var ex__11143__auto__ = e14216;
var statearr_14217_14266 = state_14159;
(statearr_14217_14266[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14159);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14216;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14267 = state_14159;
state_14159 = G__14267;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__11140__auto__ = function(state_14159){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__11140__auto____1.call(this,state_14159);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mix_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__11140__auto____0;
cljs$core$async$mix_$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__11140__auto____1;
return cljs$core$async$mix_$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14219,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__11298__auto__ = (function (){var statearr_14218 = f__11297__auto__.call(null);
(statearr_14218[(6)] = c__11296__auto___14219);

return statearr_14218;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14219,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__4212__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__14269 = arguments.length;
switch (G__14269) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__14273 = arguments.length;
switch (G__14273) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__3922__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__3922__auto__,mults){
return (function (p1__14271_SHARP_){
if(cljs.core.truth_(p1__14271_SHARP_.call(null,topic))){
return p1__14271_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__14271_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__3922__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async14274 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14274 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta14275){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta14275 = meta14275;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_14276,meta14275__$1){
var self__ = this;
var _14276__$1 = this;
return (new cljs.core.async.t_cljs$core$async14274(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta14275__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_14276){
var self__ = this;
var _14276__$1 = this;
return self__.meta14275;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__6753__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__6753__auto__)){
var m = temp__6753__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta14275","meta14275",-1080843087,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async14274.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14274.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14274";

cljs.core.async.t_cljs$core$async14274.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async14274");
});})(mults,ensure_mult))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async14274.
 */
cljs.core.async.__GT_t_cljs$core$async14274 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async14274(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta14275){
return (new cljs.core.async.t_cljs$core$async14274(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta14275));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async14274(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__11296__auto___14394 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14394,mults,ensure_mult,p){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14394,mults,ensure_mult,p){
return (function (state_14348){
var state_val_14349 = (state_14348[(1)]);
if((state_val_14349 === (7))){
var inst_14344 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
var statearr_14350_14395 = state_14348__$1;
(statearr_14350_14395[(2)] = inst_14344);

(statearr_14350_14395[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (20))){
var state_14348__$1 = state_14348;
var statearr_14351_14396 = state_14348__$1;
(statearr_14351_14396[(2)] = null);

(statearr_14351_14396[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (1))){
var state_14348__$1 = state_14348;
var statearr_14352_14397 = state_14348__$1;
(statearr_14352_14397[(2)] = null);

(statearr_14352_14397[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (24))){
var inst_14327 = (state_14348[(7)]);
var inst_14336 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_14327);
var state_14348__$1 = state_14348;
var statearr_14353_14398 = state_14348__$1;
(statearr_14353_14398[(2)] = inst_14336);

(statearr_14353_14398[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (4))){
var inst_14279 = (state_14348[(8)]);
var inst_14279__$1 = (state_14348[(2)]);
var inst_14280 = (inst_14279__$1 == null);
var state_14348__$1 = (function (){var statearr_14354 = state_14348;
(statearr_14354[(8)] = inst_14279__$1);

return statearr_14354;
})();
if(cljs.core.truth_(inst_14280)){
var statearr_14355_14399 = state_14348__$1;
(statearr_14355_14399[(1)] = (5));

} else {
var statearr_14356_14400 = state_14348__$1;
(statearr_14356_14400[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (15))){
var inst_14321 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
var statearr_14357_14401 = state_14348__$1;
(statearr_14357_14401[(2)] = inst_14321);

(statearr_14357_14401[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (21))){
var inst_14341 = (state_14348[(2)]);
var state_14348__$1 = (function (){var statearr_14358 = state_14348;
(statearr_14358[(9)] = inst_14341);

return statearr_14358;
})();
var statearr_14359_14402 = state_14348__$1;
(statearr_14359_14402[(2)] = null);

(statearr_14359_14402[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (13))){
var inst_14303 = (state_14348[(10)]);
var inst_14305 = cljs.core.chunked_seq_QMARK_.call(null,inst_14303);
var state_14348__$1 = state_14348;
if(inst_14305){
var statearr_14360_14403 = state_14348__$1;
(statearr_14360_14403[(1)] = (16));

} else {
var statearr_14361_14404 = state_14348__$1;
(statearr_14361_14404[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (22))){
var inst_14333 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
if(cljs.core.truth_(inst_14333)){
var statearr_14362_14405 = state_14348__$1;
(statearr_14362_14405[(1)] = (23));

} else {
var statearr_14363_14406 = state_14348__$1;
(statearr_14363_14406[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (6))){
var inst_14279 = (state_14348[(8)]);
var inst_14327 = (state_14348[(7)]);
var inst_14329 = (state_14348[(11)]);
var inst_14327__$1 = topic_fn.call(null,inst_14279);
var inst_14328 = cljs.core.deref.call(null,mults);
var inst_14329__$1 = cljs.core.get.call(null,inst_14328,inst_14327__$1);
var state_14348__$1 = (function (){var statearr_14364 = state_14348;
(statearr_14364[(7)] = inst_14327__$1);

(statearr_14364[(11)] = inst_14329__$1);

return statearr_14364;
})();
if(cljs.core.truth_(inst_14329__$1)){
var statearr_14365_14407 = state_14348__$1;
(statearr_14365_14407[(1)] = (19));

} else {
var statearr_14366_14408 = state_14348__$1;
(statearr_14366_14408[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (25))){
var inst_14338 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
var statearr_14367_14409 = state_14348__$1;
(statearr_14367_14409[(2)] = inst_14338);

(statearr_14367_14409[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (17))){
var inst_14303 = (state_14348[(10)]);
var inst_14312 = cljs.core.first.call(null,inst_14303);
var inst_14313 = cljs.core.async.muxch_STAR_.call(null,inst_14312);
var inst_14314 = cljs.core.async.close_BANG_.call(null,inst_14313);
var inst_14315 = cljs.core.next.call(null,inst_14303);
var inst_14289 = inst_14315;
var inst_14290 = null;
var inst_14291 = (0);
var inst_14292 = (0);
var state_14348__$1 = (function (){var statearr_14368 = state_14348;
(statearr_14368[(12)] = inst_14292);

(statearr_14368[(13)] = inst_14289);

(statearr_14368[(14)] = inst_14314);

(statearr_14368[(15)] = inst_14291);

(statearr_14368[(16)] = inst_14290);

return statearr_14368;
})();
var statearr_14369_14410 = state_14348__$1;
(statearr_14369_14410[(2)] = null);

(statearr_14369_14410[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (3))){
var inst_14346 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14348__$1,inst_14346);
} else {
if((state_val_14349 === (12))){
var inst_14323 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
var statearr_14370_14411 = state_14348__$1;
(statearr_14370_14411[(2)] = inst_14323);

(statearr_14370_14411[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (2))){
var state_14348__$1 = state_14348;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14348__$1,(4),ch);
} else {
if((state_val_14349 === (23))){
var state_14348__$1 = state_14348;
var statearr_14371_14412 = state_14348__$1;
(statearr_14371_14412[(2)] = null);

(statearr_14371_14412[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (19))){
var inst_14279 = (state_14348[(8)]);
var inst_14329 = (state_14348[(11)]);
var inst_14331 = cljs.core.async.muxch_STAR_.call(null,inst_14329);
var state_14348__$1 = state_14348;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14348__$1,(22),inst_14331,inst_14279);
} else {
if((state_val_14349 === (11))){
var inst_14303 = (state_14348[(10)]);
var inst_14289 = (state_14348[(13)]);
var inst_14303__$1 = cljs.core.seq.call(null,inst_14289);
var state_14348__$1 = (function (){var statearr_14372 = state_14348;
(statearr_14372[(10)] = inst_14303__$1);

return statearr_14372;
})();
if(inst_14303__$1){
var statearr_14373_14413 = state_14348__$1;
(statearr_14373_14413[(1)] = (13));

} else {
var statearr_14374_14414 = state_14348__$1;
(statearr_14374_14414[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (9))){
var inst_14325 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
var statearr_14375_14415 = state_14348__$1;
(statearr_14375_14415[(2)] = inst_14325);

(statearr_14375_14415[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (5))){
var inst_14286 = cljs.core.deref.call(null,mults);
var inst_14287 = cljs.core.vals.call(null,inst_14286);
var inst_14288 = cljs.core.seq.call(null,inst_14287);
var inst_14289 = inst_14288;
var inst_14290 = null;
var inst_14291 = (0);
var inst_14292 = (0);
var state_14348__$1 = (function (){var statearr_14376 = state_14348;
(statearr_14376[(12)] = inst_14292);

(statearr_14376[(13)] = inst_14289);

(statearr_14376[(15)] = inst_14291);

(statearr_14376[(16)] = inst_14290);

return statearr_14376;
})();
var statearr_14377_14416 = state_14348__$1;
(statearr_14377_14416[(2)] = null);

(statearr_14377_14416[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (14))){
var state_14348__$1 = state_14348;
var statearr_14381_14417 = state_14348__$1;
(statearr_14381_14417[(2)] = null);

(statearr_14381_14417[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (16))){
var inst_14303 = (state_14348[(10)]);
var inst_14307 = cljs.core.chunk_first.call(null,inst_14303);
var inst_14308 = cljs.core.chunk_rest.call(null,inst_14303);
var inst_14309 = cljs.core.count.call(null,inst_14307);
var inst_14289 = inst_14308;
var inst_14290 = inst_14307;
var inst_14291 = inst_14309;
var inst_14292 = (0);
var state_14348__$1 = (function (){var statearr_14382 = state_14348;
(statearr_14382[(12)] = inst_14292);

(statearr_14382[(13)] = inst_14289);

(statearr_14382[(15)] = inst_14291);

(statearr_14382[(16)] = inst_14290);

return statearr_14382;
})();
var statearr_14383_14418 = state_14348__$1;
(statearr_14383_14418[(2)] = null);

(statearr_14383_14418[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (10))){
var inst_14292 = (state_14348[(12)]);
var inst_14289 = (state_14348[(13)]);
var inst_14291 = (state_14348[(15)]);
var inst_14290 = (state_14348[(16)]);
var inst_14297 = cljs.core._nth.call(null,inst_14290,inst_14292);
var inst_14298 = cljs.core.async.muxch_STAR_.call(null,inst_14297);
var inst_14299 = cljs.core.async.close_BANG_.call(null,inst_14298);
var inst_14300 = (inst_14292 + (1));
var tmp14378 = inst_14289;
var tmp14379 = inst_14291;
var tmp14380 = inst_14290;
var inst_14289__$1 = tmp14378;
var inst_14290__$1 = tmp14380;
var inst_14291__$1 = tmp14379;
var inst_14292__$1 = inst_14300;
var state_14348__$1 = (function (){var statearr_14384 = state_14348;
(statearr_14384[(12)] = inst_14292__$1);

(statearr_14384[(13)] = inst_14289__$1);

(statearr_14384[(15)] = inst_14291__$1);

(statearr_14384[(17)] = inst_14299);

(statearr_14384[(16)] = inst_14290__$1);

return statearr_14384;
})();
var statearr_14385_14419 = state_14348__$1;
(statearr_14385_14419[(2)] = null);

(statearr_14385_14419[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (18))){
var inst_14318 = (state_14348[(2)]);
var state_14348__$1 = state_14348;
var statearr_14386_14420 = state_14348__$1;
(statearr_14386_14420[(2)] = inst_14318);

(statearr_14386_14420[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14349 === (8))){
var inst_14292 = (state_14348[(12)]);
var inst_14291 = (state_14348[(15)]);
var inst_14294 = (inst_14292 < inst_14291);
var inst_14295 = inst_14294;
var state_14348__$1 = state_14348;
if(cljs.core.truth_(inst_14295)){
var statearr_14387_14421 = state_14348__$1;
(statearr_14387_14421[(1)] = (10));

} else {
var statearr_14388_14422 = state_14348__$1;
(statearr_14388_14422[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14394,mults,ensure_mult,p))
;
return ((function (switch__11139__auto__,c__11296__auto___14394,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14389 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14389[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14389[(1)] = (1));

return statearr_14389;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14348){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14348);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14390){if((e14390 instanceof Object)){
var ex__11143__auto__ = e14390;
var statearr_14391_14423 = state_14348;
(statearr_14391_14423[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14348);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14390;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14424 = state_14348;
state_14348 = G__14424;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14348){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14348);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14394,mults,ensure_mult,p))
})();
var state__11298__auto__ = (function (){var statearr_14392 = f__11297__auto__.call(null);
(statearr_14392[(6)] = c__11296__auto___14394);

return statearr_14392;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14394,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__14426 = arguments.length;
switch (G__14426) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__14429 = arguments.length;
switch (G__14429) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__14432 = arguments.length;
switch (G__14432) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__11296__auto___14499 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14499,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14499,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_14471){
var state_val_14472 = (state_14471[(1)]);
if((state_val_14472 === (7))){
var state_14471__$1 = state_14471;
var statearr_14473_14500 = state_14471__$1;
(statearr_14473_14500[(2)] = null);

(statearr_14473_14500[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (1))){
var state_14471__$1 = state_14471;
var statearr_14474_14501 = state_14471__$1;
(statearr_14474_14501[(2)] = null);

(statearr_14474_14501[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (4))){
var inst_14435 = (state_14471[(7)]);
var inst_14437 = (inst_14435 < cnt);
var state_14471__$1 = state_14471;
if(cljs.core.truth_(inst_14437)){
var statearr_14475_14502 = state_14471__$1;
(statearr_14475_14502[(1)] = (6));

} else {
var statearr_14476_14503 = state_14471__$1;
(statearr_14476_14503[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (15))){
var inst_14467 = (state_14471[(2)]);
var state_14471__$1 = state_14471;
var statearr_14477_14504 = state_14471__$1;
(statearr_14477_14504[(2)] = inst_14467);

(statearr_14477_14504[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (13))){
var inst_14460 = cljs.core.async.close_BANG_.call(null,out);
var state_14471__$1 = state_14471;
var statearr_14478_14505 = state_14471__$1;
(statearr_14478_14505[(2)] = inst_14460);

(statearr_14478_14505[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (6))){
var state_14471__$1 = state_14471;
var statearr_14479_14506 = state_14471__$1;
(statearr_14479_14506[(2)] = null);

(statearr_14479_14506[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (3))){
var inst_14469 = (state_14471[(2)]);
var state_14471__$1 = state_14471;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14471__$1,inst_14469);
} else {
if((state_val_14472 === (12))){
var inst_14457 = (state_14471[(8)]);
var inst_14457__$1 = (state_14471[(2)]);
var inst_14458 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_14457__$1);
var state_14471__$1 = (function (){var statearr_14480 = state_14471;
(statearr_14480[(8)] = inst_14457__$1);

return statearr_14480;
})();
if(cljs.core.truth_(inst_14458)){
var statearr_14481_14507 = state_14471__$1;
(statearr_14481_14507[(1)] = (13));

} else {
var statearr_14482_14508 = state_14471__$1;
(statearr_14482_14508[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (2))){
var inst_14434 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_14435 = (0);
var state_14471__$1 = (function (){var statearr_14483 = state_14471;
(statearr_14483[(7)] = inst_14435);

(statearr_14483[(9)] = inst_14434);

return statearr_14483;
})();
var statearr_14484_14509 = state_14471__$1;
(statearr_14484_14509[(2)] = null);

(statearr_14484_14509[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (11))){
var inst_14435 = (state_14471[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_14471,(10),Object,null,(9));
var inst_14444 = chs__$1.call(null,inst_14435);
var inst_14445 = done.call(null,inst_14435);
var inst_14446 = cljs.core.async.take_BANG_.call(null,inst_14444,inst_14445);
var state_14471__$1 = state_14471;
var statearr_14485_14510 = state_14471__$1;
(statearr_14485_14510[(2)] = inst_14446);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14471__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (9))){
var inst_14435 = (state_14471[(7)]);
var inst_14448 = (state_14471[(2)]);
var inst_14449 = (inst_14435 + (1));
var inst_14435__$1 = inst_14449;
var state_14471__$1 = (function (){var statearr_14486 = state_14471;
(statearr_14486[(7)] = inst_14435__$1);

(statearr_14486[(10)] = inst_14448);

return statearr_14486;
})();
var statearr_14487_14511 = state_14471__$1;
(statearr_14487_14511[(2)] = null);

(statearr_14487_14511[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (5))){
var inst_14455 = (state_14471[(2)]);
var state_14471__$1 = (function (){var statearr_14488 = state_14471;
(statearr_14488[(11)] = inst_14455);

return statearr_14488;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14471__$1,(12),dchan);
} else {
if((state_val_14472 === (14))){
var inst_14457 = (state_14471[(8)]);
var inst_14462 = cljs.core.apply.call(null,f,inst_14457);
var state_14471__$1 = state_14471;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14471__$1,(16),out,inst_14462);
} else {
if((state_val_14472 === (16))){
var inst_14464 = (state_14471[(2)]);
var state_14471__$1 = (function (){var statearr_14489 = state_14471;
(statearr_14489[(12)] = inst_14464);

return statearr_14489;
})();
var statearr_14490_14512 = state_14471__$1;
(statearr_14490_14512[(2)] = null);

(statearr_14490_14512[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (10))){
var inst_14439 = (state_14471[(2)]);
var inst_14440 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_14471__$1 = (function (){var statearr_14491 = state_14471;
(statearr_14491[(13)] = inst_14439);

return statearr_14491;
})();
var statearr_14492_14513 = state_14471__$1;
(statearr_14492_14513[(2)] = inst_14440);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14471__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14472 === (8))){
var inst_14453 = (state_14471[(2)]);
var state_14471__$1 = state_14471;
var statearr_14493_14514 = state_14471__$1;
(statearr_14493_14514[(2)] = inst_14453);

(statearr_14493_14514[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14499,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__11139__auto__,c__11296__auto___14499,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14494 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14494[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14494[(1)] = (1));

return statearr_14494;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14471){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14471);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14495){if((e14495 instanceof Object)){
var ex__11143__auto__ = e14495;
var statearr_14496_14515 = state_14471;
(statearr_14496_14515[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14471);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14495;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14516 = state_14471;
state_14471 = G__14516;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14471){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14471);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14499,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__11298__auto__ = (function (){var statearr_14497 = f__11297__auto__.call(null);
(statearr_14497[(6)] = c__11296__auto___14499);

return statearr_14497;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14499,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__14519 = arguments.length;
switch (G__14519) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__11296__auto___14573 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14573,out){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14573,out){
return (function (state_14551){
var state_val_14552 = (state_14551[(1)]);
if((state_val_14552 === (7))){
var inst_14531 = (state_14551[(7)]);
var inst_14530 = (state_14551[(8)]);
var inst_14530__$1 = (state_14551[(2)]);
var inst_14531__$1 = cljs.core.nth.call(null,inst_14530__$1,(0),null);
var inst_14532 = cljs.core.nth.call(null,inst_14530__$1,(1),null);
var inst_14533 = (inst_14531__$1 == null);
var state_14551__$1 = (function (){var statearr_14553 = state_14551;
(statearr_14553[(9)] = inst_14532);

(statearr_14553[(7)] = inst_14531__$1);

(statearr_14553[(8)] = inst_14530__$1);

return statearr_14553;
})();
if(cljs.core.truth_(inst_14533)){
var statearr_14554_14574 = state_14551__$1;
(statearr_14554_14574[(1)] = (8));

} else {
var statearr_14555_14575 = state_14551__$1;
(statearr_14555_14575[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (1))){
var inst_14520 = cljs.core.vec.call(null,chs);
var inst_14521 = inst_14520;
var state_14551__$1 = (function (){var statearr_14556 = state_14551;
(statearr_14556[(10)] = inst_14521);

return statearr_14556;
})();
var statearr_14557_14576 = state_14551__$1;
(statearr_14557_14576[(2)] = null);

(statearr_14557_14576[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (4))){
var inst_14521 = (state_14551[(10)]);
var state_14551__$1 = state_14551;
return cljs.core.async.ioc_alts_BANG_.call(null,state_14551__$1,(7),inst_14521);
} else {
if((state_val_14552 === (6))){
var inst_14547 = (state_14551[(2)]);
var state_14551__$1 = state_14551;
var statearr_14558_14577 = state_14551__$1;
(statearr_14558_14577[(2)] = inst_14547);

(statearr_14558_14577[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (3))){
var inst_14549 = (state_14551[(2)]);
var state_14551__$1 = state_14551;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14551__$1,inst_14549);
} else {
if((state_val_14552 === (2))){
var inst_14521 = (state_14551[(10)]);
var inst_14523 = cljs.core.count.call(null,inst_14521);
var inst_14524 = (inst_14523 > (0));
var state_14551__$1 = state_14551;
if(cljs.core.truth_(inst_14524)){
var statearr_14560_14578 = state_14551__$1;
(statearr_14560_14578[(1)] = (4));

} else {
var statearr_14561_14579 = state_14551__$1;
(statearr_14561_14579[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (11))){
var inst_14521 = (state_14551[(10)]);
var inst_14540 = (state_14551[(2)]);
var tmp14559 = inst_14521;
var inst_14521__$1 = tmp14559;
var state_14551__$1 = (function (){var statearr_14562 = state_14551;
(statearr_14562[(11)] = inst_14540);

(statearr_14562[(10)] = inst_14521__$1);

return statearr_14562;
})();
var statearr_14563_14580 = state_14551__$1;
(statearr_14563_14580[(2)] = null);

(statearr_14563_14580[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (9))){
var inst_14531 = (state_14551[(7)]);
var state_14551__$1 = state_14551;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14551__$1,(11),out,inst_14531);
} else {
if((state_val_14552 === (5))){
var inst_14545 = cljs.core.async.close_BANG_.call(null,out);
var state_14551__$1 = state_14551;
var statearr_14564_14581 = state_14551__$1;
(statearr_14564_14581[(2)] = inst_14545);

(statearr_14564_14581[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (10))){
var inst_14543 = (state_14551[(2)]);
var state_14551__$1 = state_14551;
var statearr_14565_14582 = state_14551__$1;
(statearr_14565_14582[(2)] = inst_14543);

(statearr_14565_14582[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14552 === (8))){
var inst_14532 = (state_14551[(9)]);
var inst_14531 = (state_14551[(7)]);
var inst_14521 = (state_14551[(10)]);
var inst_14530 = (state_14551[(8)]);
var inst_14535 = (function (){var cs = inst_14521;
var vec__14526 = inst_14530;
var v = inst_14531;
var c = inst_14532;
return ((function (cs,vec__14526,v,c,inst_14532,inst_14531,inst_14521,inst_14530,state_val_14552,c__11296__auto___14573,out){
return (function (p1__14517_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__14517_SHARP_);
});
;})(cs,vec__14526,v,c,inst_14532,inst_14531,inst_14521,inst_14530,state_val_14552,c__11296__auto___14573,out))
})();
var inst_14536 = cljs.core.filterv.call(null,inst_14535,inst_14521);
var inst_14521__$1 = inst_14536;
var state_14551__$1 = (function (){var statearr_14566 = state_14551;
(statearr_14566[(10)] = inst_14521__$1);

return statearr_14566;
})();
var statearr_14567_14583 = state_14551__$1;
(statearr_14567_14583[(2)] = null);

(statearr_14567_14583[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14573,out))
;
return ((function (switch__11139__auto__,c__11296__auto___14573,out){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14568 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14568[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14568[(1)] = (1));

return statearr_14568;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14551){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14551);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14569){if((e14569 instanceof Object)){
var ex__11143__auto__ = e14569;
var statearr_14570_14584 = state_14551;
(statearr_14570_14584[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14551);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14569;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14585 = state_14551;
state_14551 = G__14585;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14551){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14551);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14573,out))
})();
var state__11298__auto__ = (function (){var statearr_14571 = f__11297__auto__.call(null);
(statearr_14571[(6)] = c__11296__auto___14573);

return statearr_14571;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14573,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__14587 = arguments.length;
switch (G__14587) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__11296__auto___14632 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14632,out){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14632,out){
return (function (state_14611){
var state_val_14612 = (state_14611[(1)]);
if((state_val_14612 === (7))){
var inst_14593 = (state_14611[(7)]);
var inst_14593__$1 = (state_14611[(2)]);
var inst_14594 = (inst_14593__$1 == null);
var inst_14595 = cljs.core.not.call(null,inst_14594);
var state_14611__$1 = (function (){var statearr_14613 = state_14611;
(statearr_14613[(7)] = inst_14593__$1);

return statearr_14613;
})();
if(inst_14595){
var statearr_14614_14633 = state_14611__$1;
(statearr_14614_14633[(1)] = (8));

} else {
var statearr_14615_14634 = state_14611__$1;
(statearr_14615_14634[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (1))){
var inst_14588 = (0);
var state_14611__$1 = (function (){var statearr_14616 = state_14611;
(statearr_14616[(8)] = inst_14588);

return statearr_14616;
})();
var statearr_14617_14635 = state_14611__$1;
(statearr_14617_14635[(2)] = null);

(statearr_14617_14635[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (4))){
var state_14611__$1 = state_14611;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14611__$1,(7),ch);
} else {
if((state_val_14612 === (6))){
var inst_14606 = (state_14611[(2)]);
var state_14611__$1 = state_14611;
var statearr_14618_14636 = state_14611__$1;
(statearr_14618_14636[(2)] = inst_14606);

(statearr_14618_14636[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (3))){
var inst_14608 = (state_14611[(2)]);
var inst_14609 = cljs.core.async.close_BANG_.call(null,out);
var state_14611__$1 = (function (){var statearr_14619 = state_14611;
(statearr_14619[(9)] = inst_14608);

return statearr_14619;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14611__$1,inst_14609);
} else {
if((state_val_14612 === (2))){
var inst_14588 = (state_14611[(8)]);
var inst_14590 = (inst_14588 < n);
var state_14611__$1 = state_14611;
if(cljs.core.truth_(inst_14590)){
var statearr_14620_14637 = state_14611__$1;
(statearr_14620_14637[(1)] = (4));

} else {
var statearr_14621_14638 = state_14611__$1;
(statearr_14621_14638[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (11))){
var inst_14588 = (state_14611[(8)]);
var inst_14598 = (state_14611[(2)]);
var inst_14599 = (inst_14588 + (1));
var inst_14588__$1 = inst_14599;
var state_14611__$1 = (function (){var statearr_14622 = state_14611;
(statearr_14622[(8)] = inst_14588__$1);

(statearr_14622[(10)] = inst_14598);

return statearr_14622;
})();
var statearr_14623_14639 = state_14611__$1;
(statearr_14623_14639[(2)] = null);

(statearr_14623_14639[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (9))){
var state_14611__$1 = state_14611;
var statearr_14624_14640 = state_14611__$1;
(statearr_14624_14640[(2)] = null);

(statearr_14624_14640[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (5))){
var state_14611__$1 = state_14611;
var statearr_14625_14641 = state_14611__$1;
(statearr_14625_14641[(2)] = null);

(statearr_14625_14641[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (10))){
var inst_14603 = (state_14611[(2)]);
var state_14611__$1 = state_14611;
var statearr_14626_14642 = state_14611__$1;
(statearr_14626_14642[(2)] = inst_14603);

(statearr_14626_14642[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14612 === (8))){
var inst_14593 = (state_14611[(7)]);
var state_14611__$1 = state_14611;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14611__$1,(11),out,inst_14593);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14632,out))
;
return ((function (switch__11139__auto__,c__11296__auto___14632,out){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14627 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_14627[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14627[(1)] = (1));

return statearr_14627;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14611){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14611);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14628){if((e14628 instanceof Object)){
var ex__11143__auto__ = e14628;
var statearr_14629_14643 = state_14611;
(statearr_14629_14643[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14611);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14628;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14644 = state_14611;
state_14611 = G__14644;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14611){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14611);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14632,out))
})();
var state__11298__auto__ = (function (){var statearr_14630 = f__11297__auto__.call(null);
(statearr_14630[(6)] = c__11296__auto___14632);

return statearr_14630;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14632,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async14646 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14646 = (function (f,ch,meta14647){
this.f = f;
this.ch = ch;
this.meta14647 = meta14647;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14648,meta14647__$1){
var self__ = this;
var _14648__$1 = this;
return (new cljs.core.async.t_cljs$core$async14646(self__.f,self__.ch,meta14647__$1));
});

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14648){
var self__ = this;
var _14648__$1 = this;
return self__.meta14647;
});

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async14649 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14649 = (function (f,ch,meta14647,_,fn1,meta14650){
this.f = f;
this.ch = ch;
this.meta14647 = meta14647;
this._ = _;
this.fn1 = fn1;
this.meta14650 = meta14650;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async14649.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_14651,meta14650__$1){
var self__ = this;
var _14651__$1 = this;
return (new cljs.core.async.t_cljs$core$async14649(self__.f,self__.ch,self__.meta14647,self__._,self__.fn1,meta14650__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async14649.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_14651){
var self__ = this;
var _14651__$1 = this;
return self__.meta14650;
});})(___$1))
;

cljs.core.async.t_cljs$core$async14649.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14649.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async14649.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async14649.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__14645_SHARP_){
return f1.call(null,(((p1__14645_SHARP_ == null))?null:self__.f.call(null,p1__14645_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async14649.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta14647","meta14647",-1863372000,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async14646","cljs.core.async/t_cljs$core$async14646",1454427050,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta14650","meta14650",-1438671609,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async14649.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14649.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14649";

cljs.core.async.t_cljs$core$async14649.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async14649");
});})(___$1))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async14649.
 */
cljs.core.async.__GT_t_cljs$core$async14649 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async14649(f__$1,ch__$1,meta14647__$1,___$2,fn1__$1,meta14650){
return (new cljs.core.async.t_cljs$core$async14649(f__$1,ch__$1,meta14647__$1,___$2,fn1__$1,meta14650));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async14649(self__.f,self__.ch,self__.meta14647,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__3911__auto__ = ret;
if(cljs.core.truth_(and__3911__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__3911__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14646.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async14646.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta14647","meta14647",-1863372000,null)], null);
});

cljs.core.async.t_cljs$core$async14646.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14646.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14646";

cljs.core.async.t_cljs$core$async14646.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async14646");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async14646.
 */
cljs.core.async.__GT_t_cljs$core$async14646 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async14646(f__$1,ch__$1,meta14647){
return (new cljs.core.async.t_cljs$core$async14646(f__$1,ch__$1,meta14647));
});

}

return (new cljs.core.async.t_cljs$core$async14646(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async14652 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14652 = (function (f,ch,meta14653){
this.f = f;
this.ch = ch;
this.meta14653 = meta14653;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14654,meta14653__$1){
var self__ = this;
var _14654__$1 = this;
return (new cljs.core.async.t_cljs$core$async14652(self__.f,self__.ch,meta14653__$1));
});

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14654){
var self__ = this;
var _14654__$1 = this;
return self__.meta14653;
});

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14652.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async14652.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta14653","meta14653",1896136051,null)], null);
});

cljs.core.async.t_cljs$core$async14652.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14652.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14652";

cljs.core.async.t_cljs$core$async14652.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async14652");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async14652.
 */
cljs.core.async.__GT_t_cljs$core$async14652 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async14652(f__$1,ch__$1,meta14653){
return (new cljs.core.async.t_cljs$core$async14652(f__$1,ch__$1,meta14653));
});

}

return (new cljs.core.async.t_cljs$core$async14652(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async14655 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14655 = (function (p,ch,meta14656){
this.p = p;
this.ch = ch;
this.meta14656 = meta14656;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14657,meta14656__$1){
var self__ = this;
var _14657__$1 = this;
return (new cljs.core.async.t_cljs$core$async14655(self__.p,self__.ch,meta14656__$1));
});

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14657){
var self__ = this;
var _14657__$1 = this;
return self__.meta14656;
});

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14655.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async14655.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta14656","meta14656",1897558091,null)], null);
});

cljs.core.async.t_cljs$core$async14655.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14655.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14655";

cljs.core.async.t_cljs$core$async14655.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async14655");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async14655.
 */
cljs.core.async.__GT_t_cljs$core$async14655 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async14655(p__$1,ch__$1,meta14656){
return (new cljs.core.async.t_cljs$core$async14655(p__$1,ch__$1,meta14656));
});

}

return (new cljs.core.async.t_cljs$core$async14655(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__14659 = arguments.length;
switch (G__14659) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__11296__auto___14699 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14699,out){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14699,out){
return (function (state_14680){
var state_val_14681 = (state_14680[(1)]);
if((state_val_14681 === (7))){
var inst_14676 = (state_14680[(2)]);
var state_14680__$1 = state_14680;
var statearr_14682_14700 = state_14680__$1;
(statearr_14682_14700[(2)] = inst_14676);

(statearr_14682_14700[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (1))){
var state_14680__$1 = state_14680;
var statearr_14683_14701 = state_14680__$1;
(statearr_14683_14701[(2)] = null);

(statearr_14683_14701[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (4))){
var inst_14662 = (state_14680[(7)]);
var inst_14662__$1 = (state_14680[(2)]);
var inst_14663 = (inst_14662__$1 == null);
var state_14680__$1 = (function (){var statearr_14684 = state_14680;
(statearr_14684[(7)] = inst_14662__$1);

return statearr_14684;
})();
if(cljs.core.truth_(inst_14663)){
var statearr_14685_14702 = state_14680__$1;
(statearr_14685_14702[(1)] = (5));

} else {
var statearr_14686_14703 = state_14680__$1;
(statearr_14686_14703[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (6))){
var inst_14662 = (state_14680[(7)]);
var inst_14667 = p.call(null,inst_14662);
var state_14680__$1 = state_14680;
if(cljs.core.truth_(inst_14667)){
var statearr_14687_14704 = state_14680__$1;
(statearr_14687_14704[(1)] = (8));

} else {
var statearr_14688_14705 = state_14680__$1;
(statearr_14688_14705[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (3))){
var inst_14678 = (state_14680[(2)]);
var state_14680__$1 = state_14680;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14680__$1,inst_14678);
} else {
if((state_val_14681 === (2))){
var state_14680__$1 = state_14680;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14680__$1,(4),ch);
} else {
if((state_val_14681 === (11))){
var inst_14670 = (state_14680[(2)]);
var state_14680__$1 = state_14680;
var statearr_14689_14706 = state_14680__$1;
(statearr_14689_14706[(2)] = inst_14670);

(statearr_14689_14706[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (9))){
var state_14680__$1 = state_14680;
var statearr_14690_14707 = state_14680__$1;
(statearr_14690_14707[(2)] = null);

(statearr_14690_14707[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (5))){
var inst_14665 = cljs.core.async.close_BANG_.call(null,out);
var state_14680__$1 = state_14680;
var statearr_14691_14708 = state_14680__$1;
(statearr_14691_14708[(2)] = inst_14665);

(statearr_14691_14708[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (10))){
var inst_14673 = (state_14680[(2)]);
var state_14680__$1 = (function (){var statearr_14692 = state_14680;
(statearr_14692[(8)] = inst_14673);

return statearr_14692;
})();
var statearr_14693_14709 = state_14680__$1;
(statearr_14693_14709[(2)] = null);

(statearr_14693_14709[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (8))){
var inst_14662 = (state_14680[(7)]);
var state_14680__$1 = state_14680;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14680__$1,(11),out,inst_14662);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14699,out))
;
return ((function (switch__11139__auto__,c__11296__auto___14699,out){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14694 = [null,null,null,null,null,null,null,null,null];
(statearr_14694[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14694[(1)] = (1));

return statearr_14694;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14680){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14680);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14695){if((e14695 instanceof Object)){
var ex__11143__auto__ = e14695;
var statearr_14696_14710 = state_14680;
(statearr_14696_14710[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14680);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14695;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14711 = state_14680;
state_14680 = G__14711;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14680){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14680);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14699,out))
})();
var state__11298__auto__ = (function (){var statearr_14697 = f__11297__auto__.call(null);
(statearr_14697[(6)] = c__11296__auto___14699);

return statearr_14697;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14699,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__14713 = arguments.length;
switch (G__14713) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__11296__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto__){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto__){
return (function (state_14776){
var state_val_14777 = (state_14776[(1)]);
if((state_val_14777 === (7))){
var inst_14772 = (state_14776[(2)]);
var state_14776__$1 = state_14776;
var statearr_14778_14816 = state_14776__$1;
(statearr_14778_14816[(2)] = inst_14772);

(statearr_14778_14816[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (20))){
var inst_14742 = (state_14776[(7)]);
var inst_14753 = (state_14776[(2)]);
var inst_14754 = cljs.core.next.call(null,inst_14742);
var inst_14728 = inst_14754;
var inst_14729 = null;
var inst_14730 = (0);
var inst_14731 = (0);
var state_14776__$1 = (function (){var statearr_14779 = state_14776;
(statearr_14779[(8)] = inst_14730);

(statearr_14779[(9)] = inst_14731);

(statearr_14779[(10)] = inst_14728);

(statearr_14779[(11)] = inst_14729);

(statearr_14779[(12)] = inst_14753);

return statearr_14779;
})();
var statearr_14780_14817 = state_14776__$1;
(statearr_14780_14817[(2)] = null);

(statearr_14780_14817[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (1))){
var state_14776__$1 = state_14776;
var statearr_14781_14818 = state_14776__$1;
(statearr_14781_14818[(2)] = null);

(statearr_14781_14818[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (4))){
var inst_14717 = (state_14776[(13)]);
var inst_14717__$1 = (state_14776[(2)]);
var inst_14718 = (inst_14717__$1 == null);
var state_14776__$1 = (function (){var statearr_14782 = state_14776;
(statearr_14782[(13)] = inst_14717__$1);

return statearr_14782;
})();
if(cljs.core.truth_(inst_14718)){
var statearr_14783_14819 = state_14776__$1;
(statearr_14783_14819[(1)] = (5));

} else {
var statearr_14784_14820 = state_14776__$1;
(statearr_14784_14820[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (15))){
var state_14776__$1 = state_14776;
var statearr_14788_14821 = state_14776__$1;
(statearr_14788_14821[(2)] = null);

(statearr_14788_14821[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (21))){
var state_14776__$1 = state_14776;
var statearr_14789_14822 = state_14776__$1;
(statearr_14789_14822[(2)] = null);

(statearr_14789_14822[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (13))){
var inst_14730 = (state_14776[(8)]);
var inst_14731 = (state_14776[(9)]);
var inst_14728 = (state_14776[(10)]);
var inst_14729 = (state_14776[(11)]);
var inst_14738 = (state_14776[(2)]);
var inst_14739 = (inst_14731 + (1));
var tmp14785 = inst_14730;
var tmp14786 = inst_14728;
var tmp14787 = inst_14729;
var inst_14728__$1 = tmp14786;
var inst_14729__$1 = tmp14787;
var inst_14730__$1 = tmp14785;
var inst_14731__$1 = inst_14739;
var state_14776__$1 = (function (){var statearr_14790 = state_14776;
(statearr_14790[(8)] = inst_14730__$1);

(statearr_14790[(9)] = inst_14731__$1);

(statearr_14790[(14)] = inst_14738);

(statearr_14790[(10)] = inst_14728__$1);

(statearr_14790[(11)] = inst_14729__$1);

return statearr_14790;
})();
var statearr_14791_14823 = state_14776__$1;
(statearr_14791_14823[(2)] = null);

(statearr_14791_14823[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (22))){
var state_14776__$1 = state_14776;
var statearr_14792_14824 = state_14776__$1;
(statearr_14792_14824[(2)] = null);

(statearr_14792_14824[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (6))){
var inst_14717 = (state_14776[(13)]);
var inst_14726 = f.call(null,inst_14717);
var inst_14727 = cljs.core.seq.call(null,inst_14726);
var inst_14728 = inst_14727;
var inst_14729 = null;
var inst_14730 = (0);
var inst_14731 = (0);
var state_14776__$1 = (function (){var statearr_14793 = state_14776;
(statearr_14793[(8)] = inst_14730);

(statearr_14793[(9)] = inst_14731);

(statearr_14793[(10)] = inst_14728);

(statearr_14793[(11)] = inst_14729);

return statearr_14793;
})();
var statearr_14794_14825 = state_14776__$1;
(statearr_14794_14825[(2)] = null);

(statearr_14794_14825[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (17))){
var inst_14742 = (state_14776[(7)]);
var inst_14746 = cljs.core.chunk_first.call(null,inst_14742);
var inst_14747 = cljs.core.chunk_rest.call(null,inst_14742);
var inst_14748 = cljs.core.count.call(null,inst_14746);
var inst_14728 = inst_14747;
var inst_14729 = inst_14746;
var inst_14730 = inst_14748;
var inst_14731 = (0);
var state_14776__$1 = (function (){var statearr_14795 = state_14776;
(statearr_14795[(8)] = inst_14730);

(statearr_14795[(9)] = inst_14731);

(statearr_14795[(10)] = inst_14728);

(statearr_14795[(11)] = inst_14729);

return statearr_14795;
})();
var statearr_14796_14826 = state_14776__$1;
(statearr_14796_14826[(2)] = null);

(statearr_14796_14826[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (3))){
var inst_14774 = (state_14776[(2)]);
var state_14776__$1 = state_14776;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14776__$1,inst_14774);
} else {
if((state_val_14777 === (12))){
var inst_14762 = (state_14776[(2)]);
var state_14776__$1 = state_14776;
var statearr_14797_14827 = state_14776__$1;
(statearr_14797_14827[(2)] = inst_14762);

(statearr_14797_14827[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (2))){
var state_14776__$1 = state_14776;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14776__$1,(4),in$);
} else {
if((state_val_14777 === (23))){
var inst_14770 = (state_14776[(2)]);
var state_14776__$1 = state_14776;
var statearr_14798_14828 = state_14776__$1;
(statearr_14798_14828[(2)] = inst_14770);

(statearr_14798_14828[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (19))){
var inst_14757 = (state_14776[(2)]);
var state_14776__$1 = state_14776;
var statearr_14799_14829 = state_14776__$1;
(statearr_14799_14829[(2)] = inst_14757);

(statearr_14799_14829[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (11))){
var inst_14742 = (state_14776[(7)]);
var inst_14728 = (state_14776[(10)]);
var inst_14742__$1 = cljs.core.seq.call(null,inst_14728);
var state_14776__$1 = (function (){var statearr_14800 = state_14776;
(statearr_14800[(7)] = inst_14742__$1);

return statearr_14800;
})();
if(inst_14742__$1){
var statearr_14801_14830 = state_14776__$1;
(statearr_14801_14830[(1)] = (14));

} else {
var statearr_14802_14831 = state_14776__$1;
(statearr_14802_14831[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (9))){
var inst_14764 = (state_14776[(2)]);
var inst_14765 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_14776__$1 = (function (){var statearr_14803 = state_14776;
(statearr_14803[(15)] = inst_14764);

return statearr_14803;
})();
if(cljs.core.truth_(inst_14765)){
var statearr_14804_14832 = state_14776__$1;
(statearr_14804_14832[(1)] = (21));

} else {
var statearr_14805_14833 = state_14776__$1;
(statearr_14805_14833[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (5))){
var inst_14720 = cljs.core.async.close_BANG_.call(null,out);
var state_14776__$1 = state_14776;
var statearr_14806_14834 = state_14776__$1;
(statearr_14806_14834[(2)] = inst_14720);

(statearr_14806_14834[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (14))){
var inst_14742 = (state_14776[(7)]);
var inst_14744 = cljs.core.chunked_seq_QMARK_.call(null,inst_14742);
var state_14776__$1 = state_14776;
if(inst_14744){
var statearr_14807_14835 = state_14776__$1;
(statearr_14807_14835[(1)] = (17));

} else {
var statearr_14808_14836 = state_14776__$1;
(statearr_14808_14836[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (16))){
var inst_14760 = (state_14776[(2)]);
var state_14776__$1 = state_14776;
var statearr_14809_14837 = state_14776__$1;
(statearr_14809_14837[(2)] = inst_14760);

(statearr_14809_14837[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14777 === (10))){
var inst_14731 = (state_14776[(9)]);
var inst_14729 = (state_14776[(11)]);
var inst_14736 = cljs.core._nth.call(null,inst_14729,inst_14731);
var state_14776__$1 = state_14776;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14776__$1,(13),out,inst_14736);
} else {
if((state_val_14777 === (18))){
var inst_14742 = (state_14776[(7)]);
var inst_14751 = cljs.core.first.call(null,inst_14742);
var state_14776__$1 = state_14776;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14776__$1,(20),out,inst_14751);
} else {
if((state_val_14777 === (8))){
var inst_14730 = (state_14776[(8)]);
var inst_14731 = (state_14776[(9)]);
var inst_14733 = (inst_14731 < inst_14730);
var inst_14734 = inst_14733;
var state_14776__$1 = state_14776;
if(cljs.core.truth_(inst_14734)){
var statearr_14810_14838 = state_14776__$1;
(statearr_14810_14838[(1)] = (10));

} else {
var statearr_14811_14839 = state_14776__$1;
(statearr_14811_14839[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto__))
;
return ((function (switch__11139__auto__,c__11296__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__11140__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__11140__auto____0 = (function (){
var statearr_14812 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14812[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__11140__auto__);

(statearr_14812[(1)] = (1));

return statearr_14812;
});
var cljs$core$async$mapcat_STAR__$_state_machine__11140__auto____1 = (function (state_14776){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14776);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14813){if((e14813 instanceof Object)){
var ex__11143__auto__ = e14813;
var statearr_14814_14840 = state_14776;
(statearr_14814_14840[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14776);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14813;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14841 = state_14776;
state_14776 = G__14841;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__11140__auto__ = function(state_14776){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__11140__auto____1.call(this,state_14776);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mapcat_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__11140__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__11140__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto__))
})();
var state__11298__auto__ = (function (){var statearr_14815 = f__11297__auto__.call(null);
(statearr_14815[(6)] = c__11296__auto__);

return statearr_14815;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto__))
);

return c__11296__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__14843 = arguments.length;
switch (G__14843) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__14846 = arguments.length;
switch (G__14846) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__14849 = arguments.length;
switch (G__14849) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__11296__auto___14896 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14896,out){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14896,out){
return (function (state_14873){
var state_val_14874 = (state_14873[(1)]);
if((state_val_14874 === (7))){
var inst_14868 = (state_14873[(2)]);
var state_14873__$1 = state_14873;
var statearr_14875_14897 = state_14873__$1;
(statearr_14875_14897[(2)] = inst_14868);

(statearr_14875_14897[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (1))){
var inst_14850 = null;
var state_14873__$1 = (function (){var statearr_14876 = state_14873;
(statearr_14876[(7)] = inst_14850);

return statearr_14876;
})();
var statearr_14877_14898 = state_14873__$1;
(statearr_14877_14898[(2)] = null);

(statearr_14877_14898[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (4))){
var inst_14853 = (state_14873[(8)]);
var inst_14853__$1 = (state_14873[(2)]);
var inst_14854 = (inst_14853__$1 == null);
var inst_14855 = cljs.core.not.call(null,inst_14854);
var state_14873__$1 = (function (){var statearr_14878 = state_14873;
(statearr_14878[(8)] = inst_14853__$1);

return statearr_14878;
})();
if(inst_14855){
var statearr_14879_14899 = state_14873__$1;
(statearr_14879_14899[(1)] = (5));

} else {
var statearr_14880_14900 = state_14873__$1;
(statearr_14880_14900[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (6))){
var state_14873__$1 = state_14873;
var statearr_14881_14901 = state_14873__$1;
(statearr_14881_14901[(2)] = null);

(statearr_14881_14901[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (3))){
var inst_14870 = (state_14873[(2)]);
var inst_14871 = cljs.core.async.close_BANG_.call(null,out);
var state_14873__$1 = (function (){var statearr_14882 = state_14873;
(statearr_14882[(9)] = inst_14870);

return statearr_14882;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14873__$1,inst_14871);
} else {
if((state_val_14874 === (2))){
var state_14873__$1 = state_14873;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14873__$1,(4),ch);
} else {
if((state_val_14874 === (11))){
var inst_14853 = (state_14873[(8)]);
var inst_14862 = (state_14873[(2)]);
var inst_14850 = inst_14853;
var state_14873__$1 = (function (){var statearr_14883 = state_14873;
(statearr_14883[(10)] = inst_14862);

(statearr_14883[(7)] = inst_14850);

return statearr_14883;
})();
var statearr_14884_14902 = state_14873__$1;
(statearr_14884_14902[(2)] = null);

(statearr_14884_14902[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (9))){
var inst_14853 = (state_14873[(8)]);
var state_14873__$1 = state_14873;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14873__$1,(11),out,inst_14853);
} else {
if((state_val_14874 === (5))){
var inst_14853 = (state_14873[(8)]);
var inst_14850 = (state_14873[(7)]);
var inst_14857 = cljs.core._EQ_.call(null,inst_14853,inst_14850);
var state_14873__$1 = state_14873;
if(inst_14857){
var statearr_14886_14903 = state_14873__$1;
(statearr_14886_14903[(1)] = (8));

} else {
var statearr_14887_14904 = state_14873__$1;
(statearr_14887_14904[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (10))){
var inst_14865 = (state_14873[(2)]);
var state_14873__$1 = state_14873;
var statearr_14888_14905 = state_14873__$1;
(statearr_14888_14905[(2)] = inst_14865);

(statearr_14888_14905[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14874 === (8))){
var inst_14850 = (state_14873[(7)]);
var tmp14885 = inst_14850;
var inst_14850__$1 = tmp14885;
var state_14873__$1 = (function (){var statearr_14889 = state_14873;
(statearr_14889[(7)] = inst_14850__$1);

return statearr_14889;
})();
var statearr_14890_14906 = state_14873__$1;
(statearr_14890_14906[(2)] = null);

(statearr_14890_14906[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14896,out))
;
return ((function (switch__11139__auto__,c__11296__auto___14896,out){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14891 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_14891[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14891[(1)] = (1));

return statearr_14891;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14873){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14873);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14892){if((e14892 instanceof Object)){
var ex__11143__auto__ = e14892;
var statearr_14893_14907 = state_14873;
(statearr_14893_14907[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14873);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14892;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14908 = state_14873;
state_14873 = G__14908;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14873){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14873);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14896,out))
})();
var state__11298__auto__ = (function (){var statearr_14894 = f__11297__auto__.call(null);
(statearr_14894[(6)] = c__11296__auto___14896);

return statearr_14894;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14896,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__14910 = arguments.length;
switch (G__14910) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__11296__auto___14976 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___14976,out){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___14976,out){
return (function (state_14948){
var state_val_14949 = (state_14948[(1)]);
if((state_val_14949 === (7))){
var inst_14944 = (state_14948[(2)]);
var state_14948__$1 = state_14948;
var statearr_14950_14977 = state_14948__$1;
(statearr_14950_14977[(2)] = inst_14944);

(statearr_14950_14977[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (1))){
var inst_14911 = (new Array(n));
var inst_14912 = inst_14911;
var inst_14913 = (0);
var state_14948__$1 = (function (){var statearr_14951 = state_14948;
(statearr_14951[(7)] = inst_14913);

(statearr_14951[(8)] = inst_14912);

return statearr_14951;
})();
var statearr_14952_14978 = state_14948__$1;
(statearr_14952_14978[(2)] = null);

(statearr_14952_14978[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (4))){
var inst_14916 = (state_14948[(9)]);
var inst_14916__$1 = (state_14948[(2)]);
var inst_14917 = (inst_14916__$1 == null);
var inst_14918 = cljs.core.not.call(null,inst_14917);
var state_14948__$1 = (function (){var statearr_14953 = state_14948;
(statearr_14953[(9)] = inst_14916__$1);

return statearr_14953;
})();
if(inst_14918){
var statearr_14954_14979 = state_14948__$1;
(statearr_14954_14979[(1)] = (5));

} else {
var statearr_14955_14980 = state_14948__$1;
(statearr_14955_14980[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (15))){
var inst_14938 = (state_14948[(2)]);
var state_14948__$1 = state_14948;
var statearr_14956_14981 = state_14948__$1;
(statearr_14956_14981[(2)] = inst_14938);

(statearr_14956_14981[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (13))){
var state_14948__$1 = state_14948;
var statearr_14957_14982 = state_14948__$1;
(statearr_14957_14982[(2)] = null);

(statearr_14957_14982[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (6))){
var inst_14913 = (state_14948[(7)]);
var inst_14934 = (inst_14913 > (0));
var state_14948__$1 = state_14948;
if(cljs.core.truth_(inst_14934)){
var statearr_14958_14983 = state_14948__$1;
(statearr_14958_14983[(1)] = (12));

} else {
var statearr_14959_14984 = state_14948__$1;
(statearr_14959_14984[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (3))){
var inst_14946 = (state_14948[(2)]);
var state_14948__$1 = state_14948;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14948__$1,inst_14946);
} else {
if((state_val_14949 === (12))){
var inst_14912 = (state_14948[(8)]);
var inst_14936 = cljs.core.vec.call(null,inst_14912);
var state_14948__$1 = state_14948;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14948__$1,(15),out,inst_14936);
} else {
if((state_val_14949 === (2))){
var state_14948__$1 = state_14948;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14948__$1,(4),ch);
} else {
if((state_val_14949 === (11))){
var inst_14928 = (state_14948[(2)]);
var inst_14929 = (new Array(n));
var inst_14912 = inst_14929;
var inst_14913 = (0);
var state_14948__$1 = (function (){var statearr_14960 = state_14948;
(statearr_14960[(7)] = inst_14913);

(statearr_14960[(8)] = inst_14912);

(statearr_14960[(10)] = inst_14928);

return statearr_14960;
})();
var statearr_14961_14985 = state_14948__$1;
(statearr_14961_14985[(2)] = null);

(statearr_14961_14985[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (9))){
var inst_14912 = (state_14948[(8)]);
var inst_14926 = cljs.core.vec.call(null,inst_14912);
var state_14948__$1 = state_14948;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14948__$1,(11),out,inst_14926);
} else {
if((state_val_14949 === (5))){
var inst_14913 = (state_14948[(7)]);
var inst_14912 = (state_14948[(8)]);
var inst_14921 = (state_14948[(11)]);
var inst_14916 = (state_14948[(9)]);
var inst_14920 = (inst_14912[inst_14913] = inst_14916);
var inst_14921__$1 = (inst_14913 + (1));
var inst_14922 = (inst_14921__$1 < n);
var state_14948__$1 = (function (){var statearr_14962 = state_14948;
(statearr_14962[(12)] = inst_14920);

(statearr_14962[(11)] = inst_14921__$1);

return statearr_14962;
})();
if(cljs.core.truth_(inst_14922)){
var statearr_14963_14986 = state_14948__$1;
(statearr_14963_14986[(1)] = (8));

} else {
var statearr_14964_14987 = state_14948__$1;
(statearr_14964_14987[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (14))){
var inst_14941 = (state_14948[(2)]);
var inst_14942 = cljs.core.async.close_BANG_.call(null,out);
var state_14948__$1 = (function (){var statearr_14966 = state_14948;
(statearr_14966[(13)] = inst_14941);

return statearr_14966;
})();
var statearr_14967_14988 = state_14948__$1;
(statearr_14967_14988[(2)] = inst_14942);

(statearr_14967_14988[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (10))){
var inst_14932 = (state_14948[(2)]);
var state_14948__$1 = state_14948;
var statearr_14968_14989 = state_14948__$1;
(statearr_14968_14989[(2)] = inst_14932);

(statearr_14968_14989[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14949 === (8))){
var inst_14912 = (state_14948[(8)]);
var inst_14921 = (state_14948[(11)]);
var tmp14965 = inst_14912;
var inst_14912__$1 = tmp14965;
var inst_14913 = inst_14921;
var state_14948__$1 = (function (){var statearr_14969 = state_14948;
(statearr_14969[(7)] = inst_14913);

(statearr_14969[(8)] = inst_14912__$1);

return statearr_14969;
})();
var statearr_14970_14990 = state_14948__$1;
(statearr_14970_14990[(2)] = null);

(statearr_14970_14990[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___14976,out))
;
return ((function (switch__11139__auto__,c__11296__auto___14976,out){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_14971 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14971[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_14971[(1)] = (1));

return statearr_14971;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_14948){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_14948);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e14972){if((e14972 instanceof Object)){
var ex__11143__auto__ = e14972;
var statearr_14973_14991 = state_14948;
(statearr_14973_14991[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14948);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14972;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14992 = state_14948;
state_14948 = G__14992;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_14948){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_14948);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___14976,out))
})();
var state__11298__auto__ = (function (){var statearr_14974 = f__11297__auto__.call(null);
(statearr_14974[(6)] = c__11296__auto___14976);

return statearr_14974;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___14976,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__14994 = arguments.length;
switch (G__14994) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__11296__auto___15064 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__11296__auto___15064,out){
return (function (){
var f__11297__auto__ = (function (){var switch__11139__auto__ = ((function (c__11296__auto___15064,out){
return (function (state_15036){
var state_val_15037 = (state_15036[(1)]);
if((state_val_15037 === (7))){
var inst_15032 = (state_15036[(2)]);
var state_15036__$1 = state_15036;
var statearr_15038_15065 = state_15036__$1;
(statearr_15038_15065[(2)] = inst_15032);

(statearr_15038_15065[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (1))){
var inst_14995 = [];
var inst_14996 = inst_14995;
var inst_14997 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_15036__$1 = (function (){var statearr_15039 = state_15036;
(statearr_15039[(7)] = inst_14997);

(statearr_15039[(8)] = inst_14996);

return statearr_15039;
})();
var statearr_15040_15066 = state_15036__$1;
(statearr_15040_15066[(2)] = null);

(statearr_15040_15066[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (4))){
var inst_15000 = (state_15036[(9)]);
var inst_15000__$1 = (state_15036[(2)]);
var inst_15001 = (inst_15000__$1 == null);
var inst_15002 = cljs.core.not.call(null,inst_15001);
var state_15036__$1 = (function (){var statearr_15041 = state_15036;
(statearr_15041[(9)] = inst_15000__$1);

return statearr_15041;
})();
if(inst_15002){
var statearr_15042_15067 = state_15036__$1;
(statearr_15042_15067[(1)] = (5));

} else {
var statearr_15043_15068 = state_15036__$1;
(statearr_15043_15068[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (15))){
var inst_15026 = (state_15036[(2)]);
var state_15036__$1 = state_15036;
var statearr_15044_15069 = state_15036__$1;
(statearr_15044_15069[(2)] = inst_15026);

(statearr_15044_15069[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (13))){
var state_15036__$1 = state_15036;
var statearr_15045_15070 = state_15036__$1;
(statearr_15045_15070[(2)] = null);

(statearr_15045_15070[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (6))){
var inst_14996 = (state_15036[(8)]);
var inst_15021 = inst_14996.length;
var inst_15022 = (inst_15021 > (0));
var state_15036__$1 = state_15036;
if(cljs.core.truth_(inst_15022)){
var statearr_15046_15071 = state_15036__$1;
(statearr_15046_15071[(1)] = (12));

} else {
var statearr_15047_15072 = state_15036__$1;
(statearr_15047_15072[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (3))){
var inst_15034 = (state_15036[(2)]);
var state_15036__$1 = state_15036;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15036__$1,inst_15034);
} else {
if((state_val_15037 === (12))){
var inst_14996 = (state_15036[(8)]);
var inst_15024 = cljs.core.vec.call(null,inst_14996);
var state_15036__$1 = state_15036;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15036__$1,(15),out,inst_15024);
} else {
if((state_val_15037 === (2))){
var state_15036__$1 = state_15036;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15036__$1,(4),ch);
} else {
if((state_val_15037 === (11))){
var inst_15004 = (state_15036[(10)]);
var inst_15000 = (state_15036[(9)]);
var inst_15014 = (state_15036[(2)]);
var inst_15015 = [];
var inst_15016 = inst_15015.push(inst_15000);
var inst_14996 = inst_15015;
var inst_14997 = inst_15004;
var state_15036__$1 = (function (){var statearr_15048 = state_15036;
(statearr_15048[(11)] = inst_15014);

(statearr_15048[(12)] = inst_15016);

(statearr_15048[(7)] = inst_14997);

(statearr_15048[(8)] = inst_14996);

return statearr_15048;
})();
var statearr_15049_15073 = state_15036__$1;
(statearr_15049_15073[(2)] = null);

(statearr_15049_15073[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (9))){
var inst_14996 = (state_15036[(8)]);
var inst_15012 = cljs.core.vec.call(null,inst_14996);
var state_15036__$1 = state_15036;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15036__$1,(11),out,inst_15012);
} else {
if((state_val_15037 === (5))){
var inst_15004 = (state_15036[(10)]);
var inst_14997 = (state_15036[(7)]);
var inst_15000 = (state_15036[(9)]);
var inst_15004__$1 = f.call(null,inst_15000);
var inst_15005 = cljs.core._EQ_.call(null,inst_15004__$1,inst_14997);
var inst_15006 = cljs.core.keyword_identical_QMARK_.call(null,inst_14997,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_15007 = ((inst_15005) || (inst_15006));
var state_15036__$1 = (function (){var statearr_15050 = state_15036;
(statearr_15050[(10)] = inst_15004__$1);

return statearr_15050;
})();
if(cljs.core.truth_(inst_15007)){
var statearr_15051_15074 = state_15036__$1;
(statearr_15051_15074[(1)] = (8));

} else {
var statearr_15052_15075 = state_15036__$1;
(statearr_15052_15075[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (14))){
var inst_15029 = (state_15036[(2)]);
var inst_15030 = cljs.core.async.close_BANG_.call(null,out);
var state_15036__$1 = (function (){var statearr_15054 = state_15036;
(statearr_15054[(13)] = inst_15029);

return statearr_15054;
})();
var statearr_15055_15076 = state_15036__$1;
(statearr_15055_15076[(2)] = inst_15030);

(statearr_15055_15076[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (10))){
var inst_15019 = (state_15036[(2)]);
var state_15036__$1 = state_15036;
var statearr_15056_15077 = state_15036__$1;
(statearr_15056_15077[(2)] = inst_15019);

(statearr_15056_15077[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15037 === (8))){
var inst_15004 = (state_15036[(10)]);
var inst_15000 = (state_15036[(9)]);
var inst_14996 = (state_15036[(8)]);
var inst_15009 = inst_14996.push(inst_15000);
var tmp15053 = inst_14996;
var inst_14996__$1 = tmp15053;
var inst_14997 = inst_15004;
var state_15036__$1 = (function (){var statearr_15057 = state_15036;
(statearr_15057[(14)] = inst_15009);

(statearr_15057[(7)] = inst_14997);

(statearr_15057[(8)] = inst_14996__$1);

return statearr_15057;
})();
var statearr_15058_15078 = state_15036__$1;
(statearr_15058_15078[(2)] = null);

(statearr_15058_15078[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11296__auto___15064,out))
;
return ((function (switch__11139__auto__,c__11296__auto___15064,out){
return (function() {
var cljs$core$async$state_machine__11140__auto__ = null;
var cljs$core$async$state_machine__11140__auto____0 = (function (){
var statearr_15059 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_15059[(0)] = cljs$core$async$state_machine__11140__auto__);

(statearr_15059[(1)] = (1));

return statearr_15059;
});
var cljs$core$async$state_machine__11140__auto____1 = (function (state_15036){
while(true){
var ret_value__11141__auto__ = (function (){try{while(true){
var result__11142__auto__ = switch__11139__auto__.call(null,state_15036);
if(cljs.core.keyword_identical_QMARK_.call(null,result__11142__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11142__auto__;
}
break;
}
}catch (e15060){if((e15060 instanceof Object)){
var ex__11143__auto__ = e15060;
var statearr_15061_15079 = state_15036;
(statearr_15061_15079[(5)] = ex__11143__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15036);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15060;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__11141__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15080 = state_15036;
state_15036 = G__15080;
continue;
} else {
return ret_value__11141__auto__;
}
break;
}
});
cljs$core$async$state_machine__11140__auto__ = function(state_15036){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11140__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11140__auto____1.call(this,state_15036);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11140__auto____0;
cljs$core$async$state_machine__11140__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11140__auto____1;
return cljs$core$async$state_machine__11140__auto__;
})()
;})(switch__11139__auto__,c__11296__auto___15064,out))
})();
var state__11298__auto__ = (function (){var statearr_15062 = f__11297__auto__.call(null);
(statearr_15062[(6)] = c__11296__auto___15064);

return statearr_15062;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__11298__auto__);
});})(c__11296__auto___15064,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

